
Ext.define('Seller.view.commodity.CommodityUnitGrid', function() {

    var myData= Ext.create('Ext.data.Store', {
        fields:['id', 'unitName','sellerId', 'createId', 'createTime','lastUpdateId','lastUpdateTime']

    });

    return {
        extend: 'Ext.grid.Panel',
        xtype: 'commodityUnitGrid',
        store:myData,
        title:'商品单位',

        //columnLines:true,
        bodyStyle:"border-color:#c0c0c0",
        width:1000,
        columns: [
            {
                text : '修改',
                align:'center',
                sortable: false,menuDisabled : true,
                width : 70,
                renderer : function() {
                    return '<a href="#" style="text-decoration: none;color: #007fdb;">修改</a>';
                },
                listeners : {
                    'click': function(grid, cmp, rowIndex,colIndex) {
                        var rec = grid.getStore().getAt(rowIndex);
                        var win=  Ext.create('Ext.window.Window', {
                            id:'commodityUnitAddWin',
                            title: '商品单位',
                            // height: 120,
                            width: 400,
                            modal:true,
                            // layout: 'fit',
                            items: {  // Let's put an empty grid in just to illustrate fit layout
                                xtype: 'commodityUnitAddView',
                                id:'commodityUnitAddViewType'
                            }
                        });
                        win.show();
                        Ext.getCmp('commodityUnitAddViewType').loadData(rec.get('id'));
                    }
                }
            },
            {
                text : '删除',
                sortable: false,menuDisabled : true,
                align:'center',
                width : 70,
                renderer : function() {
                    return '<a href="#" style="text-decoration: none;color: #007fdb;">删除</a>';
                },
                listeners : {
                    'click': function(grid, cmp, rowIndex,colIndex) {
                        Ext.Msg.confirm('提示','您确认需要删除当前记录吗?',function(btn)
                        {
                            // console.log(btn);
                            if(btn=='yes')
                            {
                                var rec = grid.getStore().getAt(rowIndex);
                                UnitInfoDao.delete(rec.get('id'),function(success)
                                {
                                    if(success)
                                    {
                                        Ext.Msg.alert('提示','删除成功',function(){
                                            grid.getStore().removeAt(rowIndex);
                                            Ext.getCmp('commodityUnitListView').loadData();
                                        });
                                    }
                                    else
                                    {
                                        Ext.Msg.alert('提示','删除失败.');
                                    }
                                });
                            }

                        });
                    }
                }
            },
            { text: '单位',flex:3, minWidth:250, sortable: false,menuDisabled : true, dataIndex: 'unitName',align:'left', editor: 'textfield' },
           // { text: '创建者', width: '15%', sortable: false,menuDisabled : true,  dataIndex: 'createId',align:'center', editor: 'textfield' },
            { text: '创建时间', flex:1,minWidth:180, sortable: false,menuDisabled : true,  dataIndex: 'createTime',align:'center', editor: 'textfield' },
           // { text: '最后修改者', width:'15%', sortable: false,menuDisabled : true,  dataIndex: 'lastUpdateId',align:'center', editor: 'textfield' },
            { text: '最后修改时间',flex:1,minWidth:180, sortable: false,menuDisabled : true,  dataIndex: 'lastUpdateTime',align:'center', editor: 'textfield' }
        ]
    };
});



Ext.define('Seller.view.commodity.CommodityUnitListView',{
    extend: 'Ext.container.Container',
    xtype: 'commodityUnitListView',
    id: 'commodityUnitListView',
    width:'100%',
    pageSize: gPageSize, //每页多少记录
    pageIndex: 1, //当前页码
    ttlNum: 0,    //总数量
    layout: {
        type: 'vbox',
       align:'stretch'
    },

    items: [

        {
            xtype: 'panel',
            height:60,
            width: '100%',
            margin:'0 0 15 0',


            border:1,
            layout:'hbox',
            baseCls:'titleBar',

            items:[ {
                xtype: 'fieldset',
                width:'100%',
                // border:1,
                padding:'10 5 10 5',
                style:{
                    backgroundColor:'#ccc',
                    borderRadius:'3px'
                },
                height: '100%',
                margin: 2,
                layout:'hbox',
                cls:'headerBar',

                items: [
                    { xtype: 'textfield', id:'txtName', fieldLabel: '单位',cls:'inputBorderStyle',
                        margin:2,maxLenght:100,height:'100%',emptyText:'商品单位名称',
                        labelStyle:'line-height:23px;text-align:left;',
                        labelWidth:65,
                        enableKeyEvents:true,
                        listeners:{
                            keyup:function (field,e,eopts) {
                                // console.log(field,e,eopts);
                                if(event && event.keyCode == 13){
                                    // var name=Ext.getCmp('txtName').getValue();
                                    // LoadSearchUnitList(name);
                                    var btn=Ext.getCmp('btnSearch');
                                    if(btn!=null)
                                    {
                                        btn.fireEvent('click',btn,e,eopts);
                                    }
                                }
                            }
                        }
                    },
                    { xtype:'button',text:'查询',id:'btnSearch',scale:'medium',width:90, margin:'2 2 2 10',},
                    { xtype:'button',text:'新增',id:'btnAdd',scale:'medium',width:90,margin:'2 2 2 5'},
                ]
            }]
        },
        {
            xtype: 'commodityUnitGrid',
            id:'commodityUnitGrid',
            flex: 1,
            style: {
                backgroundColor: '#ccc',
                // border: "1px solid #b9b6b6",
                borderRadius: '3px'
            },
            dockedItems: [{
                xtype: 'toolbar',
                dock: 'bottom',
                //ui: 'footer',
                id: 'pageTool',
                layout: {
                    type: 'hbox',
                    align: 'middle',
                    pack: 'end',
                },
                defaults: {minHeight: 30},
                items: [
                    {
                        id: 'pageInfo',
                        xtype: 'panel',
                        html: '<div style="align-items: center; margin-top: 2px;">当前 <span id="currentPageIndex">0</span> / <span id="totalPageIndex">0</span>页，共查询到 <span id="totalPageSize">0</span> 条记录，每页显示<input id="showPageSize" type="number" style="width: 50px; align-items::right;" value="20">条</div>',
                    },
                    {
                        id: 'btnFirst',
                        width: 45,
                        xtype: 'button',
                        text: '<<',
                        tooltip: '第一页',
                    },
                    {
                        id: 'btnPrevious',
                        width: 45,
                        xtype: 'button',
                        tooltip: '上一页',
                        text: '<',
                    },
                    {
                        id: 'btnNext',
                        width: 45,
                        xtype: 'button',
                        text: '>',
                        tooltip: '下一页',
                    },
                    {
                        id: 'btnLast',
                        width: 45,
                        xtype: 'button',
                        text: '>>',
                        tooltip: '末页',
                    },
                    {
                        id: 'btnRefresh',
                        width: 45,
                        xtype: 'button',
                        text: '刷新',
                        tooltip: '刷新',

                    },
                ]
            }],

        }
    ],

    loadData : function() {

        if (Ext.getDom('showPageSize') != null) {
            Ext.getDom('showPageSize').value = this.pageSize;
        }
        var me=this;
        var btn = me.down('button#btnSearch');
        if (btn != null) {
            btn.fireEvent('click', btn);
        }
    },

    setPageSize: function () {
        //this.pageSize = nPageSize;
        var pageSize = 1;
        if (Ext.getDom('showPageSize') != null) {
            var tempPageSize = Ext.getDom('showPageSize').value;
            if (!checkNumber(tempPageSize)) {
                pageSize = 1;
            }
            else if (Number(tempPageSize) < 0) {
                pageSize = 1;
            }
            else {
                pageSize = Number(tempPageSize);
            }
        }
        this.pageSize = pageSize;
    },

    getPageSize: function () {
        return this.pageSize;
    },

    setPageIndex: function (nPageIndex) {
        //console.log('nindex:'+nPageIndex);
        if (nPageIndex > 0)
            this.pageIndex = nPageIndex;
        else
            this.pageIndex = 1;


    },
    getPageIndex: function () {
        return this.pageIndex;
    },

    setTTLNum: function (nTTlNum) {
        if (nTTlNum > 0)
            this.ttlNum = nTTlNum;
        else
            this.ttlNum = 0;
    },

    getTTLNum: function () {
        return this.ttlNum;
    },

    setPageMsg: function () {
        Ext.getCmp('btnFirst').setDisabled(false);
        Ext.getCmp('btnPrevious').setDisabled(false);
        Ext.getCmp('btnNext').setDisabled(false);
        Ext.getCmp('btnLast').setDisabled(false);

        var nTTLPage = Math.ceil(this.ttlNum / this.pageSize);
        //console.log('ttL:'+nTTLPage);
        //console.log('index:'+this.pageIndex);
        if (nTTLPage == 0) {
            //console.log('a');
            Ext.getCmp('btnFirst').setDisabled(true);
            Ext.getCmp('btnPrevious').setDisabled(true);
            Ext.getCmp('btnNext').setDisabled(true);
            Ext.getCmp('btnLast').setDisabled(true);
        }
        else if (this.pageIndex == 1 && nTTLPage == 1) {
            //console.log('c');
            Ext.getCmp('btnFirst').setDisabled(false);
            Ext.getCmp('btnPrevious').setDisabled(true);
            Ext.getCmp('btnNext').setDisabled(true);
            Ext.getCmp('btnLast').setDisabled(true);
        }
        else if (this.pageIndex == nTTLPage) {
            //console.log('b');
            Ext.getCmp('btnFirst').setDisabled(false);
            Ext.getCmp('btnPrevious').setDisabled(false);
            Ext.getCmp('btnNext').setDisabled(true);
            Ext.getCmp('btnLast').setDisabled(false);
        }
        else if (this.pageIndex == 1) {
            //console.log('d');
            Ext.getCmp('btnFirst').setDisabled(false);
            Ext.getCmp('btnPrevious').setDisabled(true);
            Ext.getCmp('btnNext').setDisabled(false);
            Ext.getCmp('btnLast').setDisabled(false);
        }

        //Ext.getDom('pageInfoDiv').innerText = "当前 " + (nTTLPage == 0 ? 0 : this.pageIndex) + " / " + nTTLPage + "页，共查询到 " + this.ttlNum + " 条记录，每页" + this.pageSize + "条";

        if (Ext.getDom('currentPageIndex') != null) {
            Ext.getDom('currentPageIndex').innerText = this.pageIndex;
        }
        if (Ext.getDom('totalPageIndex') != null) {
            Ext.getDom('totalPageIndex').innerText = Math.ceil(this.ttlNum / this.pageSize);
        }
        if (Ext.getDom('totalPageSize') != null) {
            Ext.getDom('totalPageSize').innerText = this.ttlNum;
        }

    }


});


