/*新增进货申请视图*/

Ext.define('Seller.view.logistics.RefundAdddGrid', function () {

    return {
        extend: 'Ext.grid.Panel',
        xtype: 'refundAddGrid',
        store: 'RefundStore',
        title: '退货给供应商',
        width: '100%',
        columns: [
            {
                text: '删除',
                dataIndex: 'id',
                align: 'center',
                width: 70,
                sortable: false,
                menuDisabled : true,
                renderer: function () {
                    return '<a href="#" style="text-decoration: none;color: #007fdb;">删除</a>';
                },
                listeners: {
                    'click': function (grid, rowIndex, colIndex) {
                        // 获取数据
                        var data = grid.store.data.items[colIndex].data;
                        var id = data.id;
                        Ext.Msg.confirm('提示', '您确认需要删除当前记录吗?', function (btn) {
                            if (btn == 'yes') {
                                //var rec = grid.getStore().getAt(rowIndex);
                                PurchaseDetailDao.delete(id, function (success) {
                                    if (success) {
                                        grid.getStore().remove(grid.store.getById(id));
                                        Ext.Msg.alert('提示', '删除成功.');
                                    }
                                    else {
                                        Ext.Msg.alert('提示', '删除失败.');
                                    }
                                });
                            }

                        });
                        // Ext.getCmp('purchaseListView').loadData();
                    }
                }
            },

            {text: '商品名称', flex: 2,minWidth:200, sortable: false,menuDisabled : true, dataIndex: 'name', editor: 'textfield', align: 'left'},
            {text: '条码', flex:1, minWidth: 130, sortable: false,menuDisabled : true, dataIndex: 'barCode', editor: 'textfield', align: 'center'},
            {text: '分类', flex:1, minWidth: 120, sortable: false,menuDisabled : true, dataIndex: 'typeName', editor: 'textfield', align: 'left'},
            {text: '库存', flex:1,minWidth: 100, sortable: false,menuDisabled : true, dataIndex: 'stock', editor: 'textfield', align: 'right'},

            {
                text: '退货量',
                flex:1,minWidth: 100,
                sortable: false,menuDisabled : true,
                xtype: 'templatecolumn',
                dataIndex: 'refundNum',
                tpl: '<input id="{id}_refundNum" type="number" value="1" style="width: 60px;height: 27px;"/>',
                align: 'center'
            },
            {
                text: '退货价',
                flex:1,minWidth: 100,
                sortable: false,menuDisabled : true,
                xtype: 'templatecolumn',
                dataIndex: 'refundPrice',
                tpl: '<input id="{id}_costPrice" type="number" value={refundPrice} style="width: 60px;height: 27px;" />',
                align: 'center'
            },
            {
                text: '供货商',
                flex:2,minWidth: 150,
                sortable: false,menuDisabled : true,
                dataIndex: 'supplierName',
                xtype: 'templatecolumn',
                align: 'center',
                tpl: '<select  id="{id}_supplierName" style="width: 200px; height: 27px;">' + '</select>',
                align: 'center'
            },
        ]
    };
});


var myAddRefundSupplier = Ext.create('Ext.data.Store', {
    fields: ['id', 'name']

});

Ext.define('Seller.view.logistics.RefundAddView', {
    extend: 'Ext.container.Container',
    xtype: 'refundAddView',
    id: 'refundAddView',
    //title: '退货给供应商',
    width: '100%',
    supplierList: myAddRefundSupplier,
    layout: {
        type: 'vbox',
        align: 'stretch',
    },

    items: [
        {
            xtype: 'panel',
            height: 60,
            margin: '0 0 15 0',
            width: '100%',
            layout: 'hbox',
            baseCls: 'titleBar',
            items: [{
                xtype: 'fieldset',
                width: '100%',
                height: '100%',
                margin: 2,
                layout: 'hbox',
                padding: '10 5 10 5',
                style: {
                    backgroundColor: '#ccc',
                    borderRadius: '3px'
                },
                // layout:'hbox',
                cls: 'headerBar',

                items: [
                    {
                        xtype: 'textfield',
                        id: 'barCodeRefundAdd',
                        margin: 2,
                        emptyText: '请输入条码',
                        height: '90%',
                        labelStyle: 'margin-top:6px;',
                        enableKeyEvents: true,
                        listeners: {
                            keyup: function (field, e, eopts) {
                                if (event && event.keyCode == 13) {
                                    var btn = Ext.getCmp('btnSearchRefundAdd');
                                    btn.fireEvent('click', btn, e, eopts);
                                }
                            }
                        }
                    },
                    {xtype: 'button', text: '查询', id: 'btnSearchRefundAdd', scale: 'medium', width: 90, margin: '2 2 2 10',},
                    {
                        xtype: 'button',
                        text: '新建退货单',
                        id: 'btnAddRefund',
                        scale: 'medium',
                        width: 100,
                        margin: '2 2 2 5',
                    },
                    {xtype: 'button', text: '提交', id: 'btnSubmitRefundAdd', scale: 'medium', width: 90, margin: '2 2 2 5',},
                ]
            }]
        },
        {
            xtype: 'refundAddGrid',
            id: 'refundAddlist',
            cls:'refundAddGridTable',
            // height:600,
            flex: 1,
            style: {
                backgroundColor: '#ccc',
                borderRadius: '3px',
            },
        }],

    loadData: function () {

        var me = this;
        myAddRefundSupplier.removeAll();
        SupplierDao.loadAllData(function (success, items) {
            if (success && items) {
                var len = items.length;
                if (len > 0) {
                    for (var n = 0; n < len; n++) {
                        myAddRefundSupplier.add({id: items[n].id, name: items[n].name});
                    }
                    me.setSupplierData(myAddRefundSupplier);
                }
            }
        });

        loadSearchRefundList();
    },

    getSupplierData: function () {
        return this.supplierList;
    },
    setSupplierData: function (list) {
        this.supplierList = list;
    },

});



