/**
 * Created by lf on 2017/7/27.
 */

Ext.define('Seller.view.print.PrinterListGrid', function() {

    return {
        extend: 'Ext.grid.Panel',
        xtype: 'printerListGrid',
        store:'PrinterStore',
        title: '打印机信息列表',
        width:740,
        columns: [
            {
                menuDisabled: true,
                sortable: false,menuDisabled : true,
                align:'center',
                xtype: 'actioncolumn',
                text:'打印',
                width: 70,
                items: [{
                    icon   : 'shared/icons/fam/Print.ico',
                    tooltip: '打印任务',
                    handler: function(grid, rowIndex, colIndex) {
                        var rec = grid.getStore().getAt(rowIndex);
                        Ext.create('Ext.window.Window', {
                            id:'printTaskWin',
                            title: '打印任务',//'打印任务: ' + rec.get('ktPrintName'),
                            //height: 520,
                            width: 700,
                            modal:true,
                            items: {  // Let's put an empty grid in just to illustrate fit layout
                                xtype: 'printTaskListView',
                                id:'printTaskListView',
                            }
                        }).show();

                        Ext.getCmp('printTaskListView').loadData(rec.get('id'));
                    }
                }]
            },
            {
                menuDisabled: true,
                sortable: false,menuDisabled : true,
                align:'center',
                xtype: 'actioncolumn',
                text:'修改',
                width: 70,
                items: [{
                    icon   : 'shared/icons/fam/cog.gif',
                    tooltip: '修改',
                    handler: function(grid, rowIndex, colIndex) {
                        var rec = grid.getStore().getAt(rowIndex);
                        Ext.create('Ext.window.Window', {
                            id:'printerWin',
                            title: '修改打印机信息',
                            //height: 520,
                            width: 600,
                            modal:true,
                            items: {  // Let's put an empty grid in just to illustrate fit layout
                                xtype: 'printerAddView',
                                id:'editPrinterAddView',
                            }
                        }).show();

                        Ext.getCmp('editPrinterAddView').loadData(rec.get('id'));
                    }
                }]
            },
            {
                hidden: true,
                menuDisabled: true,
                sortable: false,menuDisabled : true,
                xtype: 'actioncolumn',
                width: 70,
                text:'删除',
                items: [{
                    icon   : 'shared/icons/fam/delete.gif',
                    tooltip: '删除',
                    handler: function(grid, rowIndex, colIndex) {
                        Ext.Msg.confirm('提示','您确认需要删除当前记录吗?',function(btn)
                        {
                            if(btn=='yes')
                            {
                                var rec = grid.getStore().getAt(rowIndex);
                                PrinterDao.delete(rec.get('id'),function(success)
                                {
                                    if(success)
                                    {
                                        grid.getStore().removeAt(rowIndex);
                                        Ext.Msg.alert('提示','删除成功.');
                                    }
                                    else
                                    {
                                        Ext.Msg.alert('提示','删除失败.');
                                    }
                                });
                            }

                        });

                    }
                }]
            },
            { text: '打印机名称', flex:1, sortable: false,menuDisabled : true, dataIndex: 'ktPrintName', editor: 'textfield' },
            { text: '模式', width: 100,  sortable: false,menuDisabled : true,  dataIndex: 'mode', editor: 'textfield' },
            { text: '接口', width: 160,  sortable: false,menuDisabled : true,  dataIndex: 'interface', editor: 'textfield' },
            { text: '状态', width: 100,  sortable: false,menuDisabled : true,  dataIndex: 'status', editor: 'textfield' },
            { text: '已打单', width: 100,  sortable: false,menuDisabled : true,  dataIndex: 'printedCount', editor: 'textfield' },
            { text: '未打单', width: 100,  sortable: false,menuDisabled : true,  dataIndex: 'notYetPrintedCount', editor: 'textfield' },
            { text: '阻塞单', width: 100,  sortable: false,menuDisabled : true,  dataIndex: 'blockPrintCount', editor: 'textfield' }
        ],

        listeners: {
            afterrender: function( thisArg, eOpts )
            {
                //console.log(eOpts)
            },

            itemdblclick: function( thisArg, record, item, index, e, eOpts )
            {
                //console.log(record)
                //console.log(item)
                //console.log(e)
                //console.log(index)
                //console.log(eOpts)

                var id = record.data.id;
                Ext.create('Ext.window.Window', {
                    id:'printTaskWin',
                    title: '打印任务',//'打印任务: ' + record.data.ktPrintName,
                    //height: 520,
                    width: 700,
                    modal:true,
                    items: {  // Let's put an empty grid in just to illustrate fit layout
                        xtype: 'printTaskListView',
                        id:'printTaskListView',
                    }
                }).show();

                Ext.getCmp('printTaskListView').loadData(id);
            }

        }
    };
});

Ext.define('Seller.view.print.KitchenPrintView', {
    extend: 'Ext.container.Container',
    xtype: 'kitchenPrintView',
    id: 'kitchenPrintView',
    width:'100%',
    //unitPageInfo:new pageInfo(1,25),
    pageSize:20, //每页多少记录
    pageIndex:1, //当前页码
    ttlNum:0,    //总数量
    layout: {
        type: 'vbox',
        align: 'stretch',
    },

    items: [
        {
           xtype: 'panel',
            height:60,
            margin:'0 0 15 0',
            layout:'hbox',
            baseCls:'titleBar',
            items:[ {
                xtype: 'fieldset',
                width:'100%',
                padding:'10 5 10 5',
                style:{
                    backgroundColor:'#ccc',
                    borderRadius:'3px'
                },
                height: '100%',
                margin: 2,
                layout:'hbox',
                items: [
                    { xtype: 'textfield', id :'printerName', fieldLabel: '打印机名称',margin:2,emptyText:'输入打印机名称',labelStyle:'font-size:16px;margin-top:5px;',height:'100%'},
                    { xtype:'button',text:'查询',id:'btnSearch',scale:'medium',margin:2},
                    { xtype:'button',text:'新增',id:'btnAdd',scale:'medium',margin:2},
                    //{ xtype:'button',text:'一键重打',id:'btnReprint',width:80,height:25,margin:2, tooltip: '重打所有打印机最近的阻塞单据'},
                ]
            }]
        },
        {
            xtype: 'printerListGrid',
            id:'printerlist',
            height:600,
            style:{
                backgroundColor:'#ccc',
                borderRadius:'3px'
            },
        }
    ],

    loadData : function() {
        //alert('KitchenPrintView')
        var supplierName=Ext.getCmp('printerName').getValue();
        loadPrinterList(supplierName);
    },
})