/**
 * Created by lf on 2017/8/1.
 */

//Ext.define('Seller.view.print.PrinterModel', {
//    extend: 'Ext.app.ViewModel',
//
//    alias: 'viewmodel.printerModel',
//
//    data: {
//
//    }
//});

Ext.define('Seller.view.print.PrinterAddView', {
    extend: 'Ext.container.Container',
    xtype: 'printerAddView',
    id: 'printerAddView',
    width: 1000,
    mode: 1,

    layout: {
        type: 'vbox',
        columns: 2,
    },
    items: [
        {
            xtype:'panel',
            layout: {
                type: 'table',
                columns: 2,
                tdAttrs: { style: 'padding: 2px; vertical-align: top;'}
            },
            items:
                [
                    { xtype: 'textfield', id:'name', fieldLabel: '名称',margin:2,emptyText:'请输入厨打机名称'},
                    { xtype: 'printerInterfaceComboBox', id: 'printerInterfaceComboBox', margin: 2, hidden: true},
                    { xtype: 'textfield', id:'ktPrintIp', fieldLabel: '网口打印机IP', margin:2, emptyText:'请输入打印机IP'},

                    { xtype: 'button', text: '高级>>', margin: 2, id: 'advToggle', baseCls:'', style: { color: 'white', backgroundColor: 'gray' }},
                    { xtype: 'panel'},

                    { xtype: 'printerModeComboBox', id: 'printerModeComboBox', adv: true, margin: 2, },
                    { xtype: 'printQuantityComboBox', id: 'printQuantityComboBox', adv: true, margin: 2, },
                    { xtype: 'paperWidthComboBox', id: 'paperWidthComboBox', adv: true, margin: 2, },
                    { xtype: 'textfield', id:'customWidth', fieldLabel: '自定纸宽', margin:2,emptyText:'', hidden: true},

                    { xtype: 'rowledgeComboBox', id: 'rowledgeComboBox', margin: 2, hidden: true},

                    //{ xtype: 'spacer' },
                    { xtype: 'panel'},

                    { xtype: 'panel', height: 10 },
                    { xtype: 'panel'},

                    { xtype: 'printerModelComboBox', id: 'printerModelComboBox', adv: true, margin: 2, },
                    { xtype: 'beepEnableComboBox', id: 'beepEnableComboBox', adv: true, margin: 2, },

                    { xtype: 'textfield', id:'port', fieldLabel: '打印机端口', adv: true, margin:2, emptyText:'请输入端口，如9100'},
                    { xtype: 'textfield', id:'roll', fieldLabel: '走纸', adv: true, margin:2, emptyText:'请输入走纸距离(mm)'},
                    { xtype: 'checkboxfield', id:'autoCut', fieldLabel: '自动切纸', margin:2, hidden:true},

                    { xtype: 'textfield', id:'printerId', fieldLabel: 'ID', margin:2, hidden:true}
                ]
        },
        {
            xtype:'panel',
            width:600,
            items:[
                { xtype:'button',text:'保存',id:'btnSave',  width:60,height:25,margin:10},
                { xtype:'button',text:'取消',id:'btnCancel', width:60,height:25,margin:10},
                { xtype:'button',text:'删除',id:'btnDelete', width:60,height:25,margin: '10, 10, 10, 350', tooltip: '删除此打印机'},
            ]
        }
    ],

    listeners: {
        added: function( thisArg, container, pos, eOpts )
        {
        },
        afterrender: function( thisArg, eOpts )
        {
            var advToggle = Ext.ComponentQuery.query('#advToggle')[0];
            //advToggle[0].setHandler(this.setMode, this);  // ok
            advToggle.on('click', this.setMode, this);

            this.setMode();
            //advToggle[0].fireEvent('click', null);

            Ext.getCmp('port').setValue(9100);
            Ext.getCmp('roll').setValue(10);
        }

    },

    loadData:function(id)
    {
        PrinterDao.getById(id, function (success, item) {
            if (success && item) {
                Ext.getCmp('name').setValue(item.ktPrintName);
                Ext.getCmp('printerInterfaceComboBox').setValue(item.interface);
                Ext.getCmp('ktPrintIp').setValue(item.ktPrintIp);
                Ext.getCmp('printerModeComboBox').setValue(item.mode);
                Ext.getCmp('printQuantityComboBox').setValue(item.printQuantity);
                Ext.getCmp('paperWidthComboBox').setValue(item.paperWidth);
                Ext.getCmp('customWidth').setValue(item.customWidth);
                Ext.getCmp('rowledgeComboBox').setValue(item.rowledge);
                Ext.getCmp('printerModelComboBox').setValue(item.model);
                Ext.getCmp('beepEnableComboBox').setValue(item.beepEnable == true);
                Ext.getCmp('port').setValue(item.port);
                Ext.getCmp('roll').setValue(item.roll);
                Ext.getCmp('autoCut').setValue(item.autoCut == true);
                Ext.getCmp('printerId').setValue(item.id);
            }
        });
    },

    setMode: function(mode)
    {
        if(this.mode == 0)
        {
            var advs = Ext.ComponentQuery.query('[adv]');
            for(var i = 0; i < advs.length; i++)
            {
                advs[i].show();
            }

            this.mode = 1;
        }
        else if(this.mode == 1)
        {
            var advs = Ext.ComponentQuery.query('[adv]');
            for(var i = 0; i < advs.length; i++)
            {
                advs[i].hide();
            }

            this.mode = 0;
        }

    }
})