var AssembleRuleDao = {


    /**
     * 查询
     * @param {Object} callBack(success,res|err)
     */
    loadAssembleRuleByPageTotal: function (searchkey, callBack) {

        var sql = "SELECT count(id) as ttlNum FROM assembleRule WHERE 1=1 and sellerId=? ";
        var keyArr = [];
        keyArr.push(loginInfo.storeId);
        if (!Ext.isEmpty(searchkey)) {
            sql = sql + " AND (aBarcode LIKE ? ESCAPE '^' OR aCommodityName LIKE ?  ESCAPE '^' )";
            keyArr.push('%' + replaceSQLiteCharacters(searchkey) + '%');
            keyArr.push('%' + replaceSQLiteCharacters(searchkey) + '%');
        }

        getBySql(sql, keyArr, callBack);
    },

    /**
     * 查询
     * @param {Object} callBack(success,res|err)
     */
    loadAssembleRuleByPage: function (searchkey, limitCount, pageIndex, callBack) {

        var sql = "SELECT * FROM assembleRule WHERE 1=1 and sellerId=?  ";
        var keyArr = [];
        keyArr.push(loginInfo.storeId);
        if (!Ext.isEmpty(searchkey)) {
            sql = sql + " AND (aBarcode LIKE ? ESCAPE '^' OR aCommodityName LIKE ? ESCAPE '^')";
            keyArr.push('%' + replaceSQLiteCharacters(searchkey) + '%');
            keyArr.push('%' + replaceSQLiteCharacters(searchkey) + '%');
        }

        sql = sql + " Order by ifnull(createTime,lastUpdateTime) desc limit " + limitCount + " offset (" + pageIndex + "-1)*" + limitCount;

        loadBySqlParam(sql, keyArr, callBack);
    },

    //获取商品库存
    getCommodityAssembleStock: function (assembleRuleId, callBack) {
        var sql = " SELECT A.id,A.bCommodityId CommodityId,A.bCommodityName CommodityName, A.bCommodityNum num,ifnull(B.stock,0) stock,'B' flag " +
            " FROM assembleRule A JOIN commodityinfo B ON A.bCommodityId=B.Id AND A.sellerId=B.sellerId WHERE ifnull(B.status,'')<>'9' AND ifnull(A.bCommodityId,'')<>'' AND A.id=? AND A.sellerId=? " +
            " UNION " +
            " SELECT A.id,A.cCommodityId CommodityId,A.cCommodityName CommodityName, A.cCommodityNum num,ifnull(B.stock,0) stock,'C' flag " +
            " FROM assembleRule A JOIN commodityinfo B ON A.bCommodityId=B.Id AND A.sellerId=B.sellerId WHERE ifnull(B.status,'')<>'9' AND ifnull(A.cCommodityId,'')<>'' AND A.id=? AND A.sellerId=? " +
            " UNION " +
            " SELECT A.id,A.dCommodityId CommodityId,A.dCommodityName CommodityName, A.dCommodityNum num,ifnull(B.stock,0) stock,'D' flag " +
            " FROM assembleRule A JOIN commodityinfo B ON A.bCommodityId=B.Id AND A.sellerId=B.sellerId WHERE ifnull(B.status,'')<>'9' AND ifnull(A.dCommodityId,'')<>'' AND A.id=? AND A.sellerId=? ";

        var keyArr = [];
        keyArr.push(assembleRuleId);
        keyArr.push(loginInfo.storeId);
        keyArr.push(assembleRuleId);
        keyArr.push(loginInfo.storeId);
        keyArr.push(assembleRuleId);
        keyArr.push(loginInfo.storeId);

        loadBySqlParam(sql, keyArr, callBack);
    },

    /**
     *增加
     */
    add: function (sqlData, callBack) {
        insert("assembleRule", sqlData, callBack);
    },

    /**
     *删除
     */
    delete: function (id, callBack) {
        del("assembleRule", id, callBack);
    },

    /**
     * 更新
     * @param {Object} callback(success,err)
     */
    update: function (sqlData, id, callback) {
        update('assembleRule', sqlData, id, callback)
    },

    /**
     * 查询数据
     * @param {Object} callback(success,err)
     */
    getById: function (id, callback) {
        var sql = "SELECT * FROM assembleRule where id=? and sellerId=?  ";
        getBySql(sql, [id, loginInfo.storeId], callback);
    },
}
