var ConponConfigDao = {
    /**
     * 查询
     * @param {Object} callBack(success,res|err)
     */
    loadConponConfigTypeInfo: function (name, callBack) {
        var sql = "SELECT * from commodityType where 1=1 ";
        var keyArr = [];
        if (!Ext.isEmpty(name)) {
            sql = sql + " and  name like ?  ESCAPE '^' ";
            keyArr.push('%' + replaceSQLiteCharacters(name) + '%');
        }
        sql = sql + 'Order by sequence';

        loadBySqlParam(sql, keyArr, callBack);
    },

    /**
     *增加
     */
    add: function (sqlData, callBack) {
        insert("couponConfig", sqlData, callBack);
    },
    /**
     *删除类型
     */
    delete: function (id, callBack) {
        del("couponConfig", id, callBack);
    },

    /**
     * 更新类型
     * @param {Object} callback(success,err)
     */
    update: function (sqlData, id, callback) {
        update('couponConfig', sqlData, id, callback)
    },

    /**
     * 根据id查询
     * @param id
     * @param callBack
     */
    getById: function (id, callBack) {
        var sql = "select * from couponConfig where id=? ";
        getBySql(sql, [id], callBack);
    },
    /**
     * 根据name查询
     * @param id
     * @param callBack
     */
    landCoupAndNameByPage: function (name, limitCount, pageIndex, callBack) {
        var sql = "select c.id,c.couponName,c.couponWeek,c.couponStartDate,c.couponEndDate,c.couponStartTime,c.couponEndTime,c.couponCycle," +
            " c.status,c.commodityTypeId," +
            " c.couponRange " +
            //"case c.couponRange  when '0' then  '微信点餐' when '1' then '收银台' when '2' then '点菜宝' when '1,2' then '收银台,点菜宝' when '0,1' then '微信点餐,收银台' when '1,0' then '收银台,微信点餐' when '0,2' then '微信点餐,点菜宝' when '2,0' then '点菜宝,微信点餐' when '0,1,2' then '微信点餐,收银台,点菜宝' when '1,2,0'  then '收银台,点菜宝,微信点餐' else '' end as couponRange"+
            " from couponConfig c where 1=1 ";
        var keyArr = [];
        if (!Ext.isEmpty(name)) {
            sql = sql + " and  c.couponName like ? ESCAPE '^'  ";
            keyArr.push('%' + replaceSQLiteCharacters(name) + '%');
        }
        sql = sql + " and c.sellerId=? and ifnull(c.status,'0')<>'9'  "
        keyArr.push(loginInfo.storeId);
        sql = sql + " order by c.id desc limit " + limitCount + " offset (" + pageIndex + "-1)*" + limitCount;
        loadBySqlParam(sql, keyArr, callBack);
    },

    /**
     * 总数
     * @param {Object} callBack(success,res|err)
     */
    landConponAndNameByPageTotal: function (name, callBack) {
        var sql = "SELECT count(c.id) as ttlNum from couponConfig c  where 1=1  ";
        var keyArr = [];
        if (!Ext.isEmpty(name)) {
            sql = sql + " and  c.couponName like ? ESCAPE '^'  ";
            keyArr.push('%' + replaceSQLiteCharacters(name) + '%');
        }
        sql = sql + " and c.sellerId=? and ifnull(c.status,'0')<>'9' "
        keyArr.push(loginInfo.storeId);
        getBySql(sql, keyArr, callBack);
    },

    /*检查重复满多少金额*/
    checkCouponDuplicate: function (costMoney, id, callBack) {
        var sql = "SELECT count(c.id) as ttlNum from couponConfig c where 1=1  ";
        var keyArr = [];
        if (!Ext.isEmpty(costMoney)) {
            sql = sql + ' and c.costMoney= ?  '
            keyArr.push(costMoney);
        }
        if (!Ext.isEmpty(id)) {
            sql = sql + ' and c.id<> ?  '
            keyArr.push(id);
        }
        sql = sql + " and c.sellerId=? and ifnull(c.status,'0')<>'9' "
        keyArr.push(loginInfo.storeId);

        getBySql(sql, keyArr, callBack);
    },


};
