var DiscountManageDao=
    {
        /**
         * 查询所有数据
         * @param {Object} callBack(success,res|err)
         */
        loadAllData : function(callBack) {
            //console.log(keyword);
            var sql = "SELECT * FROM discount WHERE sellerId=? and ifnull(status,'0')<>'9' order by sequence is null,sequence asc";
            loadBySqlParam(sql,[loginInfo.storeId], callBack);
        },


        /**
         * 查询
         * @param {Object} callBack(success,res|err)
         */
        loadSearchDiscount: function(unit, callBack) {

            var keyArr=[];
            var sql = "SELECT * FROM discount WHERE 1=1 and ifnull(status,'0')<>'9' and  sellerId=? ";
            keyArr.push(loginInfo.storeId);
            if(!Ext.isEmpty(unit))
            {
                sql=sql+" and remark Like ? ESCAPE '^'  ";
                keyArr.push("%"+replaceSQLiteCharacters(unit)+"%");
            }

            loadBySqlParam(sql,keyArr, callBack);
        },

        /**
         * 查询数据
         * @param {Object} callback(success,err)
         */
        getById : function(id, callback) {
            var sql = "SELECT * FROM discount where id=? and sellerId=? and ifnull(status,'0')<>'9' ";
            getBySql(sql,[id,loginInfo.storeId],callback);
        },

        /**
         * 更新数据
         * @param {Object} callback(success,err)
         */
        updateDiscountById : function(sqlData,id, callback) {
            update('discount',sqlData,id,callback)
        },

        /**
         *增加折扣
         * @param {Object} callback(success,err)
         */
        addDiscount : function(sqlData, callBack) {
            insert("discount", sqlData, callBack);
            // console.log(sqlData);
        },
        /**
         *删除数据
         */
        delete : function(id, callBack) {
            del("discount", id, callBack);
        },

        /*检查重复的打折*/
        checkDicountDuplicate: function (discountAmt, id, callBack) {
            var sql = "SELECT * from discount c where 1=1 and c.[discount]=? and c.sellerId=? and ifnull(c.status,'0')<>'9' ";
            var keyArr = [];

            keyArr.push(discountAmt);
            keyArr.push(loginInfo.storeId);
            if (!Ext.isEmpty(id)) {
                sql = sql + ' and c.id<> ?  '
                keyArr.push(id);
            }
            // console.log(sql,keyArr);
            getBySql(sql, keyArr, callBack);
        },

        /*检查重复的排序编号*/
        checkSequenceDuplicate: function(sequenceAmt,id,callBack){
            var sql = "SELECT * from discount c where 1=1 and c.[sequence]=? and c.sellerId=? and ifnull(c.status,'0')<>'9' ";
            var keyArr = [];
            keyArr.push(sequenceAmt);
            keyArr.push(loginInfo.storeId);
            if (!Ext.isEmpty(id)) {
                sql = sql + ' and c.id<> ?  '
                keyArr.push(id);
            }
            getBySql(sql, keyArr, callBack);
        },

        /*获取sequence的最大值+1*/
        GetDiscountMaxSeq : function(callBack) {
            var sql = "SELECT MAX(A.sequence)+1 as sequence FROM discount A  where A.sellerId=?  and  A.sequence is not null and  A.sequence is not '' and ifnull(A.status,'0')<>'9' ";
            getBySql(sql, [loginInfo.storeId], callBack);
        },
    }
