
var LossDetailDao={

    /**
     * 根据时间范围名称查询数据
     * @param {Object} callBack(success,res|err)
     */
    loadSearchInfoByTime : function(starTime,endTime,limitCount,pageIndex, callBack) {
        // var starTime = Ext.Date.format(new Date(starTime),'Y-m-d');
        // var endTime = Ext.Date.format(new Date(endTime),'Y-m-d');
        // console.log(starTime,endTime);
        // console.log(Ext.Date.format(dt, 'Y-m-d'));
        var keyArr=[];
        var sql = "SELECT * FROM lossInfo where 1= 1 ";
        if(starTime){
            sql=sql+'and date(lossDate) >= ? ';
            keyArr.push(starTime);
        };
        if(endTime){
            sql=sql+'and date(lossDate) <= ? ';
            keyArr.push(endTime);
        };
        sql=sql+' and sellerId=? ';
        keyArr.push(loginInfo.storeId);
        sql +=  " ORDER BY lossDate DESC limit "+limitCount+" offset ("+pageIndex+"-1)*"+limitCount;
        loadBySqlParam(sql,keyArr, callBack);
    },


    //获取查询到的总行数
    loadStockLossCountByPageTotal:function (keyArr,callBack) {
        var sql = "SELECT commodityName FROM lossDetail where 1= 1 ";
        var arr=[];
        if(keyArr[0]){
            sql += ' and losscause = '+"\""+keyArr[0]+"\"";
        }
        if(keyArr[1]){
            sql += " and commodityName LIKE ? ESCAPE '^' ";
            arr.push("%"+replaceSQLiteCharacters(keyArr[1])+"%");
        }
        if(keyArr[2]){
            sql += ' and date(createTime) >='+"\""+keyArr[2]+"\"";
        }
        if(keyArr[3]){
            sql += ' and date(createTime) <= '+"\""+keyArr[3]+"\"";
        }
        sql=sql+" and sellerId='"+loginInfo.storeId+"' ";
        if(!keyArr[1]){//没有给出商品名称时可能商品不止一样，需要分组
            sql += ' Group By commodityName ';
        }
        sql = "SELECT count(commodityName) as ttlNum FROM "+ "("+sql+") myTable";
        //console.log(sql);
        getBySql(sql,arr,callBack);
    },

    loadStockLossCountByPage:function (keyArr,limitCount,pageIndex,callBack) {
        var sql = "SELECT commodityName as name,round(sum(lossNum),2) as lossNum,round(sum(commodityNum),2) as num,round(commodityPrice,2) as price FROM lossDetail where 1= 1 ";
        var arr=[];
        if(keyArr[0]){
            sql += ' and losscause = '+"\""+keyArr[0]+"\"";
        }
        // if(keyArr[1]){
        //     sql += ' and commodityName LIKE '+"\"%"+keyArr[1]+"%\"";
        // }
        if(keyArr[1]){
            sql += " and commodityName LIKE ? ESCAPE '^' ";
            arr.push("%"+replaceSQLiteCharacters(keyArr[1])+"%");
        }
        if(keyArr[2]){
            sql += ' and date(createTime) >='+"\""+keyArr[2]+"\"";

        }
        if(keyArr[3]){
            sql += ' and date(createTime) <= '+"\""+keyArr[3]+"\"";
        }
        sql=sql+" and sellerId='"+loginInfo.storeId+"' ";


        if(!keyArr[1]){
            sql += ' Group By commodityName ';
        }
        sql += " ORDER BY createTime DESC limit "+limitCount+" offset ("+pageIndex+"-1)*"+limitCount;
        //console.log(sql);
        loadBySqlParam(sql,arr, callBack);
    },


    //获取查询到的总行数
    loadStockLossByPageTotal:function (starTime,endTime,callBack) {
        var keyArr=[];
        var sql = "SELECT count(id) as ttlNum FROM lossInfo where 1= 1 ";
        if(starTime){
            sql=sql+'and date(lossDate) >= ? ';
            keyArr.push(starTime);
        };
        if(endTime){
            sql=sql+'and date(lossDate) <= ? ';
            keyArr.push(endTime);
        };
        sql=sql+' and sellerId=? ';
        keyArr.push(loginInfo.storeId);
        // console.log(sql,keyArr);
        // sql +=  " ORDER BY lossDate DESC limit "+limitCount+" offset ("+pageIndex+"-1)*"+limitCount;
        getBySql(sql,keyArr, callBack);
    },

    loadAllData:function (callBack) {
        var sql = "SELECT * FROM lossInfo ORDER BY createTime DESC ";
        loadBySql(sql,callBack);
    },

    getInfoById:function (id,callBack) {
        var  sql = "SELECT * FROM lossDetail where lossId = '"+id+'\'';
        // console.log(sql);
        loadBySql(sql, callBack);
    },

    loadCountData:function (callBack) {
        var  sql = "SELECT commodityId,commodityName as name,sum(lossNum) as lossNum,sum(commodityNum) as num,sum(commodityPrice)as price FROM lossDetail group By commodityId ";
        loadBySql(sql, callBack);
    },



    /**
     *增加
     */
    add : function(sqlData, callBack) {
        insert("lossDetail", sqlData, callBack);
    },

    /**
     *删除
     */
    delete : function(id, callBack) {
        del("lossDetail", id, callBack);
    },

    /**
     * 更新
     * @param {Object} callback(success,err)
     */
    update : function(sqlData,id, callback) {
        update('lossDetail',sqlData,id,callback)
    },

}
