var SPTypeDao = {

    /**
     * 查询
     * @param {Object} callBack(success,res|err)
     */
    loadSearchSPTypeInfo: function (typeName, callBack) {
        var sql = "SELECT * from servicePlaceType where sellerId = ? and ifnull(status,'0')<>'9' ";
        var keyArr = [loginInfo.storeId];
        if (!Ext.isEmpty(typeName)) {
            sql = sql + " and  typeName like ? ESCAPE '^' ";
            keyArr.push('%' + replaceSQLiteCharacters(typeName) + '%');
        }
        sql = sql + 'Order by sequence';

        loadBySqlParam(sql, keyArr, callBack);
    },

    /**
     *增加会员
     */
    add: function (sqlData, callBack) {
        insert("servicePlaceType", sqlData, callBack);
    },

    /**
     *删除会员
     */
    delete: function (id, callBack) {
        del("servicePlaceType", id, callBack);
    },

    /**
     * 根据id查询数据
     * @param {Object} callback(success,err)
     */
    getSPTypeById: function (id, callback) {
        var sql = "SELECT * FROM servicePlaceType where id= ? and sellerId = ? and ifnull(status,'0')<>'9'  ";
        getBySql(sql, [id,loginInfo.storeId], callback);
    },

    /**
     * 更新桌位区域数据
     * @param {Object} callback(success,err)
     */
    updateById: function (sqlData, id, callback) {
        update('servicePlaceType', sqlData, id, callback)
    },


    /**
     * 分页查询
     * @param {Object} callback(success,res|err)
     */
    loadSPTypeByPage: function (typeName, limitCount, pageIndex, callback) {

        var sql = "SELECT * from servicePlaceType where sellerId = ? and ifnull(status,'0')<>'9' ";
        var keyArr = [loginInfo.storeId];
        if (!Ext.isEmpty(typeName)) {
            sql = sql + " and  typeName like ? ESCAPE '^' ";
            keyArr.push('%' + replaceSQLiteCharacters(typeName) + '%');
        }
        sql = sql + " Order by sequence limit ? offset ? ";
        keyArr.push(limitCount);
        keyArr.push( (pageIndex-1)*limitCount );
        loadBySqlParam(sql, keyArr, callback);
    },

    /**
     * 分页查询
     * @param {Object} callback(success,res|err)
     */
    loadSPTypeByPageTotal: function (typeName, callback) {

        var sql = "SELECT count(id) as ttlNum from servicePlaceType where sellerId = ? and ifnull(status,'0')<>'9'  ";
        var keyArr = [loginInfo.storeId];
        // if (typeName) {
        //     sql = sql + ' and  typeName like ?  ';
        //     keyArr.push('%' + typeName + '%');
        // }
        if (!Ext.isEmpty(typeName)) {
            sql = sql + " and  typeName like ? ESCAPE '^' ";
            keyArr.push('%' + replaceSQLiteCharacters(typeName) + '%');
        }
        getBySql(sql, keyArr, callback);
    },

    /**
     * 分页查询
     * @param {Object} callback(success,res|err)
     */
    checkDuplicateName: function (typeName,id, callback) {

        var sql = "SELECT * from servicePlaceType where sellerId = ? and ifnull(status,'0')<>'9'  ";
        var keyArr = [loginInfo.storeId];
        if (!Ext.isEmpty(typeName)) {
            sql = sql + ' and  typeName = ?  ';
            keyArr.push(typeName);
        }
        if(!Ext.isEmpty(id))
        {
            sql = sql + ' and  id<>?  ';
            keyArr.push(id);
        }
        console.log(sql)
        loadBySqlParam(sql, keyArr, callback);
    },


};
