var SellerRemarkDao = {

    /**
     *增加口味
     */
    addRemark: function (sqlData, callBack) {
        insert("sellerRemark", sqlData, callBack);
    },


    /**
     * 查询口味总数
     * @param name,callBack(success,res|err)
     */
    loadkouWeiByPageTotal: function (remark, callback) {

        var sql = "SELECT count(id) as ttlNum FROM sellerRemark where 1 = 1 and sellerId=? and ifnull(status,'0')<>'9' ";
        var keyArr = [];
        keyArr.push(loginInfo.storeId);
        if (!Ext.isEmpty(remark)) {
            sql += " and remark like ?  ESCAPE '^'  ";
            keyArr.push('%' + replaceSQLiteCharacters(remark) + '%');
        }
        getBySql(sql, keyArr, callback);

    },

    loadkouWeiByPage: function (remark, limitCount, pageIndex, callback) {

        var sql = "SELECT * FROM sellerRemark where 1 = 1 and sellerId=? and ifnull(status,'0')<>'9' ";
        var keyArr = [];
        keyArr.push(loginInfo.storeId);
        if (!Ext.isEmpty(remark)) {
            sql += " and remark like ? ESCAPE '^'  ";
            keyArr.push('%' + replaceSQLiteCharacters(remark) + '%');
        }
        sql += "order by createTime desc limit " + limitCount + " offset (" + pageIndex + "-1)*" + limitCount;

        loadBySqlParam(sql, keyArr, callback);
    },

    /**
     * 查询所有口味
     * @param callBack(success,res|err)
     */
    loadAllData: function (callBack) {
        var sql = "SELECT * FROM sellerRemark where sellerId=? and ifnull(status,'0')<>'9'";
        loadBySqlParam(sql, [loginInfo.storeId], callBack);
    },

    /**
     * 根据id查询口味
     * @param {Object} callBack(success,res|err)
     */
    getById: function (id, callBack) {
        var sql = "SELECT * FROM sellerRemark where id =? and sellerId=? and ifnull(status,'0')<>'9' ";
        getBySql(sql, [id, loginInfo.storeId], callBack);
    },

    /**
     * 根据id更新口味
     * @param {Object} callBack(success,res|err)
     */
    updateById: function (sqldata, id, callBack) {
        update('sellerRemark', sqldata, id, callBack);
    },


    /**
     * 检查单位名称是否存在
     * @param {Object} callBack(success,res|err)
     */
    checkRemarkExist: function (remark, id, callBack) {

        var keyArr = [];
        var sql = "SELECT count(id) as ttlNum FROM sellerRemark WHERE 1=1 and sellerId=? and ifnull(status,'0')<>'9' ";
        keyArr.push(loginInfo.storeId);

        if (!Ext.isEmpty(id)) {
            sql = sql + ' and id<>? ';
            keyArr.push(id);
        }

        if (!Ext.isEmpty(remark)) {
            sql = sql + ' and remark = ? ';
            keyArr.push(remark);
        }
        // console.log(keyArr);
        // console.log(sql);
        loadBySqlParam(sql, keyArr, callBack);
    },


    delete: function (id, callBack) {
        del('sellerRemark', id, callBack)
    },

    getSellListKouwei: function (arrayKey, callBack) {
        var keyArr = [];
        var sql = "SELECT A.sellNum,B.deviceId,A.remarkids,date(B.sellTime) sellTime  " +
            " FROM  selldetail A JOIN sellinfo B ON A.sellId=B.id AND A.sellerId=B.sellerId " +
            " WHERE  ifnull(B.isDelete,'0')<>'1' AND  ifnull(B.status,'0')='1' AND ifnull(A.remarkIds,'')<>'' AND B.sellerId=? ";

        keyArr.push(loginInfo.storeId);

        if (!Ext.isEmpty(arrayKey[0])) {
            sql = sql + ' and B.deviceId = ? ';
            keyArr.push(arrayKey[0]);
        }
        if (!Ext.isEmpty(arrayKey[1])) {
            sql = sql + ' and date(B.sellTime)>= ? ';
            keyArr.push(arrayKey[1]);
        }
        if (!Ext.isEmpty(arrayKey[2])) {
            sql = sql + ' and date(B.sellTime) <= ? ';
            keyArr.push(arrayKey[2]);
        }
        // console.log(arrayKey);
        // console.log(sql);
        loadBySqlParam(sql, keyArr, callBack);
    },

    //口味统计
    loadKouweiDataByPage: function (items, pageSize, pageIndex, callBack) {
        var sql = "select id,remark,deviceId, Round(SUM(ttlNum),2) ttlNum, round(SUM(ttlAmount),2) ttlAmount from ( ";

        var paramArray = [];
        var nNum = 1;
        Ext.Array.forEach(items, function (item) {
            if (!Ext.isEmpty(item)) {
                // console.log(item,item.remarkIds);
                var remarkIds = item.remarkIds.split(',');
                if (!Ext.isEmpty(remarkIds)) {
                    Ext.Array.forEach(remarkIds, function (remarkId) {
                        if (!Ext.isEmpty(remarkId)) {
                            if (nNum == 1) {
                                sql = sql + Ext.String.format(" SELECT id,remark,'{0}' deviceId,{2} ttlNum,{2}*ifnull(price,0) ttlAmount FROM sellerremark WHERE  ifnull(status,'')<>'9' AND ifnull(isDelete,'')<>'1' and id='{1}' ", item.deviceId, remarkId, item.sellNum);
                            }
                            else {
                                sql = sql + Ext.String.format(" UNION ALL SELECT id,remark,'{0}' deviceId,{2} ttlNum,{2}*ifnull(price,0) ttlAmount FROM sellerremark WHERE  ifnull(status,'')<>'9' AND ifnull(isDelete,'')<>'1' and id='{1}' ", item.deviceId, remarkId, item.sellNum);
                            }
                        }
                        nNum = nNum + 1;
                    });
                }
                nNum = nNum + 1;
            }
        });

        sql = sql + " ) K ";
        sql = sql + " GROUP BY id,remark,deviceId ";
        sql = sql + " Order by deviceId,remark  limit " + pageSize + " offset (" + pageIndex + "-1)*" + pageSize;

        loadBySqlParam(sql, paramArray, callBack);
        //console.log(sql);
    },

    //口味统计
    loadKouweiDataByTotal: function (items, callBack) {

        var sql = " SELECT COUNT(*) as ttlNum FROM (";
        var sql = sql + "select id,remark,deviceId, Round(SUM(ttlNum),2) ttlNum, round(SUM(ttlAmount),2) ttlAmount from ( ";
        var paramArray = [];
        var nNum = 1;
        Ext.Array.forEach(items, function (item) {
            if (!Ext.isEmpty(item)) {
                var remarkIds = item.remarkIds.split(',');
                if (!Ext.isEmpty(remarkIds)) {
                    Ext.Array.forEach(remarkIds, function (remarkId) {
                        if (!Ext.isEmpty(remarkId)) {
                            if (nNum == 1) {
                                sql = sql + Ext.String.format(" SELECT id,remark,'{0}' deviceId,{2} ttlNum,{2}*ifnull(price,0) ttlAmount FROM sellerremark WHERE  ifnull(status,'')<>'9' AND ifnull(isDelete,'')<>'1' and id='{1}' ", item.deviceId, remarkId, item.sellNum);
                            }
                            else {
                                sql = sql + Ext.String.format(" UNION ALL SELECT id,remark,'{0}' deviceId,{2} ttlNum,{2}*ifnull(price,0) ttlAmount FROM sellerremark WHERE  ifnull(status,'')<>'9' AND ifnull(isDelete,'')<>'1' and id='{1}' ", item.deviceId, remarkId, item.sellNum);
                            }
                        }
                        nNum = nNum + 1;
                    });
                }
                nNum = nNum + 1;
            }
        });

        sql = sql + " ) K ";
        sql = sql + " GROUP BY id,remark,deviceId ";
        sql = sql + " ) M ";

        getBySql(sql, paramArray, callBack);
        //console.log(sql);
    },

    getSellListByRemarkId: function (remarkId,startDate,endDate, callBack) {
        var sql = "SELECT B.ID,date(B.sellTime) sellTime ,B.deviceId,A.commodityName, A.sellNum,A.sellNum*(SELECT price FROM sellerremark WHERE ID='" + remarkId + "') ttlAmount " +
            " FROM  selldetail A JOIN sellinfo B ON A.sellId=B.id AND A.sellerId=B.sellerId " +
            " WHERE ifnull(A.isDelete,'0')<>'1' AND  B.sellerId=? AND ifnull(B.status,'0')='1' AND ifnull(A.remarkIds,'')<>'' AND A.remarkIds||',' LIKE '%"+ remarkId +",%'  ";

        var keyArr = [];
        keyArr.push(loginInfo.storeId);
        if(!Ext.isEmpty(startDate)){
            sql = sql + ' and date(B.sellTime)>= ? ';
            //keyArr.push(startDate);
            keyArr.push(Ext.Date.format(new Date(startDate), 'Y-m-d'));
        }
        if(!Ext.isEmpty(endDate)){
            sql = sql + ' and date(B.sellTime)<= ? ';
            //keyArr.push(endDate);
            keyArr.push(Ext.Date.format(new Date(endDate), 'Y-m-d'));
        }

        sql=sql+" order by B.deviceId,B.sellTime "
        //console.log(sql,keyArr);
        loadBySqlParam(sql, keyArr, callBack);
    }
}
