Ext.define('Seller.controller.ShouKuanController', {
	extend : 'Ext.app.Controller',
	// requires : ['Ext.util.Geolocation', 'Ext.dataview.List'],
	config : {
		// refs : {},
		control : {
            'ebutton[id=coupon-cancel-btn]': { // 扫描优惠卷取消
                tap: function () {
                    Ext.getCmp('couponView').destroy();
                }
            },
            'ebutton[id=coupon-use-btn]': { // 扫描优惠卷使用
                tap: function () {
                    couponUseFunc()
                }
            },
            'ebutton[id=shoukuan-view-close]': { // 收款返回
                tap: function () {
                    skButtonClick(1);
                }
            },
            'ebutton[id=pay-customer-btn]': { // 会员
                tap: function () {
                    skButtonClick(3);
                }
            },
            'ebutton[id=pay-discount-btn]': {
                tap: function () {
                    showShouKuanDiscountPanel()
                }
            },
            'ebutton[id=pay-eraseZero-btn]': { // 抹零
                tap: function () {
                    eraseZero()
                }
            },
            'ebutton[id=pay-delete-btn]': { // 删除
                tap: function () {
                    inputKeyValueDel()
                }
            },
            'ebutton[id=pay-reset-btn]': { // 清空
                tap: function () {
                    inputKeyValueClear()
                }
            },
            'ebutton[id=skSubmitButton]': { // 收款确定
                tap: function () {
                    var shoukuanView = Ext.getCmp('shoukuan_view');
                    if (!shoukuanView.payType || shoukuanView.payType == '' || shoukuanView.comboPayList.length < 1 || shoukuanView.comboPayList.indexOf('') != -1) {
                        showAlert('提示', '请选择支付方式！');
                        return;
                    }else if (parseFloat($('#singlePayAmount').html()) < 0 || parseFloat($('#groupAmount').html()) < 0) {
                        showAlert('提示', '收款金额不能为负！');
                        return;
                    }
                    new Promise(function(resolve, reject) {
                		if(shoukuanView.payType == '11' || (shoukuanView.comboPayList && shoukuanView.comboPayList.indexOf('11')>-1)) {
                			checkPermissions(PERMISSIONS.SELLFREE, true, "对不起, 您没有免单权限!")
                			.then(function() {resolve(true);})
                			.catch(function() {reject()});
                		} else resolve(true);
                	}).then(function() {
                		//Ext.getCmp('shoukuan_view').selectPayType(obj, payType);
                        var mealNo = Ext.getDom("sy-shopSign").value;
                        var mode = Ext.getCmp('shouyinMainView').shouhanMode;
                        if (mode == '0' && sySetting.mode == SYS_TYPE.FD && (mealSetting.isUse == 'true' || mealSetting.isUse == true)) {
                            if (!mealNo || mealNo <= 0 || mealNo.length != 4 || !isInteger(mealNo)) {
                                showAlert('提示', '取餐器牌号输入有误,请输入正确的牌号(0001~9999)！');
                                return
                            }
                            SellDao.isSameSellInfoMealNo(mealNo, function(success, total) {
                                if (success && total > 0) {
                                    showAlert('提示', '正在排队的牌号已存在相同牌号!');
                                    return;
                                }
                                shoukuanViewPayOff();
                            })
                        } else {
                            shoukuanViewPayOff();
                        }
                		// shoukuanViewPayOff();
                	})
                	.catch(function() {});
                    //skSubmitButton
                    //shoukuanViewPayOff()
                }
            },
            'checkboxfield[id=sk-isCustomerPrint]': {
                check: function (filed, e, eOpts) {
                    preventEventBubble(e);
                    payViewCheckBoxCheckFunc(filed, e, eOpts)
                },
                uncheck: function (filed, e, eOpts) {
                    preventEventBubble(e);
                    payViewCheckBoxUncheckFunc(filed, e, eOpts)
                },
            },
            'checkboxfield[id=sk-isPrivatePrint]': {
                check: function (filed, e, eOpts) {
                    preventEventBubble(e);
                    payViewCheckBoxCheckFunc(filed, e, eOpts)
                },
                uncheck: function (filed, e, eOpts) {
                    preventEventBubble(e);
                    payViewCheckBoxUncheckFunc(filed, e, eOpts)
                },
            },
            'checkboxfield[id=sk-kitchen-print]': {
                check: function (filed, e, eOpts) {
                    preventEventBubble(e);
                    payViewCheckBoxCheckFunc(filed, e, eOpts)
                },
                uncheck: function (filed, e, eOpts) {
                    preventEventBubble(e);
                    payViewCheckBoxUncheckFunc(filed, e, eOpts)
                },
            },
            'checkboxfield[id=sk-label-print]': {
                check: function (filed, e, eOpts) {
                    preventEventBubble(e);
                    payViewCheckBoxCheckFunc(filed, e, eOpts)
                },
                uncheck: function (filed, e, eOpts) {
                    preventEventBubble(e);
                    payViewCheckBoxUncheckFunc(filed, e, eOpts)
                },
            },
            'checkboxfield[id=sk-isTablePrint]': {
                check: function (filed, e, eOpts) {
                    preventEventBubble(e);
                    payViewCheckBoxCheckFunc(filed, e, eOpts)
                },
                uncheck: function (filed, e, eOpts) {
                    preventEventBubble(e);
                    payViewCheckBoxUncheckFunc(filed, e, eOpts)
                },
            },
            'checkboxfield[id=sk-isCustomerPrint2]': {
                check: function (filed, e, eOpts) {
                    SettingDao.updateSetting({
                        isShouyinCustomerPrint: 'true'
                    }, setting.id, function (success, msg) {
                        if (success) {
                            setting.isShouyinCustomerPrint = 'true';
                        }
                    });
                },
                uncheck: function (filed, e, eOpts) {
                    SettingDao.updateSetting({
                        isShouyinCustomerPrint: 'false'
                    }, setting.id, function (success, msg) {
                        if (success) {
                            setting.isShouyinCustomerPrint = 'false';
                        }
                    });
                }
            },
            'checkboxfield[id=sk-isPrivatePrint2]': {
                check: function (filed, e, eOpts) {
                    SettingDao.updateSetting({
                        isShouyinPrivatePrint: 'true'
                    }, setting.id, function (success, msg) {
                        if (success) {
                            setting.isShouyinPrivatePrint = 'true';
                        }
                    });
                },
                uncheck: function (filed, e, eOpts) {
                    SettingDao.updateSetting({
                        isShouyinPrivatePrint: 'false'
                    }, setting.id, function (success, msg) {
                        if (success) {
                            setting.isShouyinPrivatePrint = 'false';
                        }
                    });
                }
            },
            'checkboxfield[id=sk-isTablePrint2]': {
                check: function (filed, e, eOpts) {
                    SettingDao.updateSetting({
                        isShouyinTablePrint: 'true'
                    }, setting.id, function (success, msg) {
                        if (success) {
                            setting.isShouyinTablePrint = 'true';
                        }
                    });
                },
                uncheck: function (filed, e, eOpts) {
                    SettingDao.updateSetting({
                        isShouyinTablePrint: 'false'
                    }, setting.id, function (success, msg) {
                        if (success) {
                            setting.isShouyinTablePrint = 'false';
                        }
                    });
                }
            },
            'checkboxfield[id=sk-kitchen-print2]': {
                check: function (filed, e, eOpts) {
                    SettingDao.updateSetting({
                        isShouyinKitchenPrint: 'true'
                    }, setting.id, function (success, msg) {
                        if (success) {
                            setting.isShouyinKitchenPrint = 'true';
                        }
                    });
                },
                uncheck: function (filed, e, eOpts) {
                    SettingDao.updateSetting({
                        isShouyinKitchenPrint: 'false'
                    }, setting.id, function (success, msg) {
                        if (success) {
                            setting.isShouyinKitchenPrint = 'false';
                        }
                    });
                }
            },
            'checkboxfield[id=sk-label-print2]': {
                check: function (filed, e, eOpts) {
                    SettingDao.updateSetting({
                        isShouyinLabelPrint: 'true'
                    }, setting.id, function (success, msg) {
                        if (success) {
                            setting.isShouyinLabelPrint = 'true';
                        }
                    });
                },
                uncheck: function (filed, e, eOpts) {
                    SettingDao.updateSetting({
                        isShouyinLabelPrint: 'false'
                    }, setting.id, function (success, msg) {
                        if (success) {
                            setting.isShouyinLabelPrint = 'false';
                        }
                    });
                }
            },
            'ebutton[id=erase-view-close]': { // 抹零返回
                tap: function () {
                    if (Ext.getCmp('erase-main-view')) Ext.getCmp('erase-main-view').destroy();
                }
            },
            'ebutton[id=erase-confirm-btn]': { // 抹零确定
                tap: function () {
                    eraseConfirmFunc()
                }
            },
            'ebutton[id=custom-pay-type-confirm-btn]': {
                tap: function () {
                    if (Ext.getCmp('self-payType-view'))
                        Ext.getCmp('self-payType-view').destroy();
                }
            },
            'radiofield[id=onesPlace-radixPoint-chk]' : {
                check : function () {
                }
            },
            'radiofield[id=radixPoint-chk]' : {
                check : function () {
                }
            },
            'radiofield[id=IDDefineEraseAmountSel]' : {
                check : function (filed, e, eOpts) {
                    preventEventBubble(e);
                    Ext.getCmp('IDDefineEraseAmount').setHidden(false);
                    Ext.getCmp('erase-confirm-btn').hide();
                    /*Ext.getCmp('erase-main-view').setHeight(250);*/
                    // Ext.getCmp('erase-main-view').translate(-145, 0, 'fadeIn');
                    var marginLeft =  ($(window).width() - 590) /2;
                    $('#erase-main-view').animate({
                        left:marginLeft,
                        width:590,
                        height:258
                    },300)
                },
                uncheck : function (filed, e, eOpts) {
                    preventEventBubble(e);
                    Ext.getCmp('IDDefineEraseAmount').setHidden(true);
                    Ext.getCmp('erase-confirm-btn').show();
                    // Ext.getCmp('erase-main-view').setWidth(300);
                    // Ext.getCmp('erase-main-view').setHeight(300);
                    // Ext.getCmp('erase-main-view').translate(0, 0, 'fadeIn');
                    var marginLeft =  ($(window).width() - 300) /2;
                    $('#erase-main-view').animate({
                        left :marginLeft,
                        width: 300,
                        height: 300
                    },300)
                }
            },
            'dataview[id=shoukuan-discount-list]' :{
                itemtap: function(list, index, target, record, e, eOpts) {
                    preventEventBubble(e);
                    var isSupportPwd = record.get('isSupportPwd');
                    var discount=record.get("discount");
                    new Promise(function(resolve, reject) {
                        checkPermissions(PERMISSIONS.SELLDISCOUNT, true) // 折扣12
                        .then(function() {resolve()})
                        .catch(function() {reject()});
                    }).then(function() {
                        if (isSupportPwd == "1") {
                            showInputPwdView(record.get('password'), function() {
                                Ext.getCmp('shoukuan_view').updateShouKuanDiscount(discount);
                            });
                        } else {
                            Ext.getCmp('shoukuan_view').updateShouKuanDiscount(discount);
                        }
                    })
                    .catch(function() {});
                }
            }
        }
	}
});
function couponUseFunc() {
    nativePostRequest('/barcodesyndeal/consumeCoupon?time=' + new Date().getTime(), {
        randomNum : barCode
    }, function(result) {
        if (result.state) {
            Ext.getCmp('couponView').destroy();
            showAlert('提示', '优惠券使用成功!');
        } else {
            showAlert("优惠券使用出错", result.msg ? result.msg : '优惠券使用出错!');
        }
    }, function(msg) {
        showAlert("优惠券使用出错", msg ? msg : '优惠券使用出错，请检查网络状态！');
    });
}

function payViewCheckBoxCheckFunc(filed, e, eOpts) {
    var updateSettingData = {};
    if(filed.id == 'sk-isCustomerPrint') updateSettingData.isShouyinCustomerPrint = 'true';
    else if(filed.id == 'sk-isPrivatePrint') updateSettingData.isShouyinPrivatePrint = 'true';
    else if(filed.id == 'sk-isTablePrint') updateSettingData.isShouyinTablePrint = 'true';
    else if(filed.id == 'sk-kitchen-print') updateSettingData.isShouyinKitchenPrint = 'true';
    else if(filed.id == 'sk-label-print') updateSettingData.isShouyinLabelPrint = 'true';
    else return;
    SettingDao.updateSetting(updateSettingData, setting.id, function(success, msg) {
        if (success) {
            for(var key in updateSettingData) {
                if(updateSettingData.hasOwnProperty(key))
                    setting[key] = 'true';
            }
            //setting.isShouyinCustomerPrint = 'true';
        }
    });
}

function payViewCheckBoxUncheckFunc(filed, e, eOpts) {
    var updateSettingData = {};
    if(filed.id == 'sk-isCustomerPrint') updateSettingData.isShouyinCustomerPrint = 'false';
    else if(filed.id == 'sk-isPrivatePrint') updateSettingData.isShouyinPrivatePrint = 'false';
    else if(filed.id == 'sk-isTablePrint') updateSettingData.isShouyinTablePrint = 'false';
    else if(filed.id == 'sk-kitchen-print') updateSettingData.isShouyinKitchenPrint = 'false';
    else if(filed.id == 'sk-label-print') updateSettingData.isShouyinLabelPrint = 'false';
    else return;
    SettingDao.updateSetting(updateSettingData, setting.id, function(success, msg) {
        if (success) {
            for(var key in updateSettingData) {
                if(updateSettingData.hasOwnProperty(key))
                    setting[key] = 'false';
            }
        }
    });
}

function eraseConfirmFunc() {
    var eraseZeroForm = Ext.getCmp("eraseZeroForm");
    var formValues = eraseZeroForm.getValues();
    var type = formValues.type;
    var shoukuanView = Ext.getCmp('shoukuan_view');
    //取回四舍五入前sellAmount
    if(!isValidDigital(shoukuanView.roundAmount)) shoukuanView.roundAmount = 0;
    shoukuanView.sellAmount = shoukuanView.sellAmount - parseFloat(shoukuanView.roundAmount); //Ext.getCmp('shouyinMainView').sellAmount;
    shoukuanView.roundAmount = 0;  // 重设四舍五入值为0， 后面再计算四舍五入的值
    var afterSellAmount = 0;
    if (type == 1) {
        afterSellAmount = parseInt(shoukuanView.sellAmount);
    } else if (type == 2) {
        var eraseValue = formValues.inputEraseValue;
        //console.log(eraseValue);
        if (!eraseValue) {
            showAlert('提示', '请输入抹零金额!');
            return;
        } else if (!eraseZeroMaxAmount || eraseZeroMaxAmount <= 0) {
            showAlert('提示', '暂不支持自定义抹零!');
            return;
        } else if (eraseValue > eraseZeroMaxAmount) {
            showAlert('提示', '抹零金额超过上限!');
            return;
        } else if (eraseValue > shoukuanView.sellAmount) {
            showAlert('提示', '抹零金额超过支付金额!');
            return;
        }
        afterSellAmount = parseFloat(shoukuanView.sellAmount) - eraseValue;
    } else {
        var beforeEraseAmount = shoukuanView.sellAmount - (parseInt(shoukuanView.sellAmount / 10) * 10);
        if (cashierPermissions && cashierPermissions.indexOf('8') != -1) {// 有自定义抹零
            if (beforeEraseAmount > eraseZeroMaxAmount) {
                showAlert('提示', '抹零金额超过上限!');
                return;
            }
        }
        afterSellAmount = parseFloat(parseInt(shoukuanView.sellAmount / 10) + "0");
    }
    eraseZeroOperate(afterSellAmount);
}
function eraseZeroOperate(afterSellAmount) {
    var shoukuanView = Ext.getCmp('shoukuan_view');
    /* 使用现在的金额减去处理后的金额等于需要抹零的金额 */
    shoukuanView.eraseZeroAmount = (parseFloat(shoukuanView.sellAmount) - afterSellAmount - parseFloat(shoukuanView.roundAmount)).toFixed(2);
    //shoukuanView.eraseZeroAmount = (parseFloat(Ext.getCmp('shouyinMainView').sellAmount) - afterSellAmount).toFixed(2);
    shoukuanView.sellAmount = parseFloat(afterSellAmount).toFixed(2);
    //计算抹零后四舍五入金额
    var sellAmountRound = roundByUnit(shoukuanView.sellAmount, roundSetting.unit);
    if(parseFloat(shoukuanView.sellAmount) > parseFloat(sellAmountRound)){
        shoukuanView.roundAmount = '-' + roundByUnit((shoukuanView.sellAmount - sellAmountRound),'2');
    }else {
        shoukuanView.roundAmount =roundByUnit((sellAmountRound - shoukuanView.sellAmount),'2');
    }
    shoukuanView.sellAmount=sellAmountRound;// 恢复实收总额
    if(monitors == 2){
        sendMsg2SetTotalAmount(parseFloat(sellAmountRound).toFixed(2));// 刷新副屏总额
    }
    if (shoukuanView.sellId) {
        console.log('操作单据:订单号为' + shoukuanView.sellId + '订单抹零' + shoukuanView.eraseZeroAmount + '，实收金额变为' + sellAmountRound + '--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
    } else {
        console.log('操作单据:当前订单抹零' + shoukuanView.eraseZeroAmount + '，实收金额变为' + sellAmountRound + '--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
    }
    Ext.getDom("molingAmount").innerHTML = shoukuanView.eraseZeroAmount;
    Ext.getDom('roundAmount').innerHTML = shoukuanView.roundAmount;
    changeAmount(0, shoukuanView.sellAmount);
    if (Ext.getCmp('erase-main-view')) {
        Ext.getCmp('erase-main-view').destroy();
    }
    showEraseBtnStatusByEraseAmount(shoukuanView.eraseZeroAmount);
}

function showEraseBtnStatusByEraseAmount(eraseZeroAmount) {
    if(!Ext.getCmp('pay-eraseZero-btn')) return;
    if (parseFloat(eraseZeroAmount) != 0)
        Ext.getCmp('pay-eraseZero-btn').addCls('sk-benefit-btn-active');
    else
        Ext.getCmp('pay-eraseZero-btn').removeCls('sk-benefit-btn-active');
}

function showDiscountBtnStatusByDiscount(discount) {
    if (!Ext.getCmp('pay-discount-btn')) return;
    if (parseFloat(discount) != 100)
        Ext.getCmp('pay-discount-btn').addCls('sk-benefit-btn-active');
    else
        Ext.getCmp('pay-discount-btn').removeCls('sk-benefit-btn-active');
}
// 快键按键的选中*
function DiscountBtnSelect(discount){
    if (!Ext.getCmp('shoukuan-discount-list')) return;
    var shouKuanDiscountBtn=$('#shoukuan-discount-list .discountBtn');
    var shouKuanDiscountList=Ext.getCmp('shoukuan-discount-list').getStore();
    for (var i = 0; i < shouKuanDiscountList.getCount(); i++) {
        var discountRecord = shouKuanDiscountList.getAt(i);
        var getDiscount = parseFloat(discountRecord.get('discount')).toFixed(2);
        discount = parseFloat(discount).toFixed(2);
        if (getDiscount == discount) {
            shouKuanDiscountBtn.eq(i).addClass('sk-benefit-btn-active');
        } else {
            shouKuanDiscountBtn.eq(i).removeClass('sk-benefit-btn-active')
        }
    }
}

function showLockPayTypeAndAmountByLock() {
    var me = Ext.getCmp('shoukuan_view');
    var lockPayType = me.lockPayType;
    if (lockPayType) {
        $('#'+getIdbyPayType(lockPayType)).addClass('payLock');
    }
    if (lockPayType && getPayTypebyLabel('1') == lockPayType) {
        $('#singlePayAmount').addClass('sk-text-lock');
    } else {
        $('#singlePayAmount').removeClass('sk-text-lock');
    }
    if (lockPayType && getPayTypebyLabel('2') == lockPayType) {
        $('#groupAmount').addClass('sk-text-lock');
    } else {
        $('#groupAmount').removeClass('sk-text-lock');
    }
}