Ext.define("Seller.controller.shouyin.SelectPlaceController", {
	extend : "Ext.app.Controller",
	
	config : {
		refs : {
			"selectPlaceView" : "container[id=select-place-view]",
			"selectPlaceCancelBtn" : "button[id=select-place-cancel]",
			"selectPlaceSuspendBtn" : "button[id=select-place-suspend]",
			"selectPlaceConfirmBtn" : "button[id=select-place-confirm]",
			"selectPlaceNotShow" : "button[id=select-place-view-notshow]",
			/*数据类*/
			"selectPlaceId" : "hiddenfield[id=select-place-id]",
			"selectPlaceRemarkId" : "hiddenfield[id=select-place-remarkIds]",
			"selectPlaceShopSign1" : "textfield[id=select-place-shopSign1]",
			"selectPlaceRemark" : "textfield[id=select-place-remark]",
			"selectPlaceTeaPrice" : "textfield[id=select-place-teaprice]",
			"selectPlacePersonNum" : "textfield[id=select-place-personNum]",
			"selectPlaceName" : "textfield[id=select-place-name]",
            "selectWaiterName" : "selectfield[id=select-waiter-name]",
			
			/* 打印类 */
			"selectPlaceCustomerPrint" : "checkboxfield[id=select-place-customer-print]",
			"selectPlaceStubPrint" : "checkboxfield[id=select-place-stub-print]",
			"selectPlaceKitchenPrint" : "checkboxfield[id=select-place-kitchen-print]",
			"selectPlaceLabelPrint" : "checkboxfield[id=select-place-label-print]",
			"selectPlaceTablePrint" : "checkboxfield[id=select-place-table-print]",
			
			"selectPlaceCPMask" : "button[id=select-place-cp-mask]",
			"selectPlaceSPMask" : "button[id=select-place-sp-mask]",
			"selectPlaceKPMask" : "button[id=select-place-kp-mask]",
			"selectPlaceLPMask" : "button[id=select-place-lp-mask]",
			"selectPlaceTPMask" : "button[id=select-place-tp-mask]",
			
			"selectPlaceIsReShow" : "checkboxfield[id=is-reshow-putup-view]"
		},
		control : {
			"selectPlaceCancelBtn" : {
				tap : function(currView, e, eOpts) {
					this.destroySelectPlaceView.apply(this, arguments);
				}
			},
			"selectPlaceSuspendBtn" : {
				tap : function(currView, e, eOpts) {
					this.suspendSelectPlaceView.apply(this, arguments);
				}
			},
			"selectPlaceConfirmBtn" : {
				tap : function(currView, e, eOpts) {
					this.confirmSelectPlaceView.apply(this, arguments);
				}
			},
			"selectPlaceRemark" : {
				focus : function(field, e, eOpts) {
					this.remarkSelectPlaceView.apply(this, arguments);
				}
			},
			"selectPlaceTeaPrice" : {
				focus : function(field, e, eOpts) {
					this.teaPriceSelectPlaceView.apply(this, arguments);
                    hideSystemKeyboard();
				},
				keyup : function(field, e, eOpts) {
					if(field) {
						// 更新数字键盘的值
						if(Ext.getCmp("input-customer-num-identity"))
							Ext.getCmp("input-customer-num-identity").setValue(field.getValue());
					}
				},
                clearicontap : function(currView, input, e, eOpts) {
                    preventEventBubble(e);
                    ViewNumberKeyboard.resetInputValue();
                }
			},
			"selectPlacePersonNum" : {
				focus : function(field, e, eOpts) {
					this.personNumSelectPlaceView.apply(this, arguments);
                    hideSystemKeyboard();
				},
				keyup : function(field, e, eOpts) {
					if(field) {
						// 更新数字键盘的值
						if(Ext.getCmp("input-customer-num-identity"))
							Ext.getCmp("input-customer-num-identity").setValue(field.getValue());
					}
				},
                clearicontap : function(currView, input, e, eOpts) {
                    preventEventBubble(e);
                    ViewNumberKeyboard.resetInputValue();
                }
			},
			"selectPlaceCustomerPrint" : {check:function(field, e, eOpts) {this.printCheckSelectPlaceView.apply(this,arguments);},uncheck:function (field, e, eOpts) {this.printUnCheckSelectPlaceView.apply(this,arguments);}},
			"selectPlaceStubPrint" : {check:function(field, e, eOpts) {this.printCheckSelectPlaceView.apply(this,arguments);},uncheck:function (field, e, eOpts) {this.printUnCheckSelectPlaceView.apply(this,arguments);}},
			"selectPlaceKitchenPrint" : {check:function(field, e, eOpts) {this.printCheckSelectPlaceView.apply(this,arguments);},uncheck:function (field, e, eOpts) {this.printUnCheckSelectPlaceView.apply(this,arguments);}},
			"selectPlaceLabelPrint" : {check:function(field, e, eOpts) {this.printCheckSelectPlaceView.apply(this,arguments);},uncheck:function (field, e, eOpts) {this.printUnCheckSelectPlaceView.apply(this,arguments);}},
			"selectPlaceTablePrint" : {check:function(field, e, eOpts) {this.printCheckSelectPlaceView.apply(this,arguments);},uncheck:function (field, e, eOpts) {this.printUnCheckSelectPlaceView.apply(this,arguments);}},
			"selectPlaceCPMask" : { tap:function(currView, e, eOpts) {this.printMaskSelectPlaceView.apply(this,arguments);} },
			"selectPlaceSPMask" : { tap:function(currView, e, eOpts) {this.printMaskSelectPlaceView.apply(this,arguments);} },
			"selectPlaceKPMask" : { tap:function(currView, e, eOpts) {this.printMaskSelectPlaceView.apply(this,arguments);} },
			"selectPlaceLPMask" : { tap:function(currView, e, eOpts) {this.printMaskSelectPlaceView.apply(this,arguments);} },
			"selectPlaceTPMask" : { tap:function(currView, e, eOpts) {this.printMaskSelectPlaceView.apply(this,arguments);} },
			"selectPlaceNotShow" : {tap : function(currView, e, eOpts) {this.notShowSelectPlaceView.apply(this,arguments);}}
		},
	},
	init : function() {
		var me = this;
		me.selectPlaceView = me.getSelectPlaceView();
	},
	destroySelectPlaceView : function(currView, e, eOpts) {
		/*if(Ext.getCmp("select-place-view")) {
			Ext.getCmp("select-place-view").destroy();
		}*/
		var me = this;
		me.selectPlaceView = me.getSelectPlaceView();
		if(me.selectPlaceView) me.selectPlaceView.hide();
		// if(me.selectPlaceView) me.selectPlaceView.destroy();
	},
	getSelectPlaceViewData : function() {
		var me = this;
		var placeViewData = {};
		placeViewData.shopSign = "";
		if(me.getSelectPlaceShopSign1()) placeViewData.shopSign = me.getSelectPlaceShopSign1().getValue();
		if(me.getSelectPlaceId()) placeViewData.placeId = me.getSelectPlaceId().getValue();
		if(me.getSelectPlaceName()) placeViewData.placeName = me.getSelectPlaceName().getValue();
		if(me.getSelectPlacePersonNum()) placeViewData.personNum = me.getSelectPlacePersonNum().getValue();
		if(me.getSelectPlaceTeaPrice()) placeViewData.teaPrice = me.getSelectPlaceTeaPrice().getValue();
		if(me.getSelectPlaceRemark()) placeViewData.remark = me.getSelectPlaceRemark().getValue();
		if(me.getSelectPlaceRemarkId()) placeViewData.remarkIds = me.getSelectPlaceRemarkId().getValue();
		if(me.getSelectWaiterName()) {
			placeViewData.saleId = me.getSelectWaiterName().getValue();
			try {
                for (var si = 0, slen = saleEmloyees.length; si < slen; si++) {
					if(saleEmloyees[si].id == placeViewData.saleId) {
						placeViewData.saleWorkId = saleEmloyees[si].workId;
                        placeViewData.saleName = saleEmloyees[si].workName;
					}
                }
            } catch(err) {}
        }
		
		return placeViewData;
	},
	/* 挂起 */
	suspendSelectPlaceView: function(currView, e, eOpts) {
		preventEventBubble(e);
		var me = this;
		me.selectPlaceView = me.getSelectPlaceView();
		if(me.selectPlaceView) {
			var placeViewData = me.getSelectPlaceViewData();
			new Promise(function(resolve, reject){
				SellDao.getSellInfoForOrderByPlaceId(placeViewData.placeId, function(success, result){
					if(success && result){
						resolve(result);
					}else{
						reject();
					}
				});
			}).
			then(function(result){
					if(result && result.total > 0){
						showAlert('提示', '已下单订单不能再做挂单操作！');
					}else{
						submitPutup.call(placeViewData, "-1");
					}
				}).
			catch(function(err){
					console.log('销售订单查询失败', err);
				});
		}
	},
	/* 确认下单 */
	confirmSelectPlaceView : function(currView, e, eOpts) {
		preventEventBubble(e);
		var me = this;
		me.selectPlaceView = me.getSelectPlaceView();
		if(me.selectPlaceView) {
			var placeViewData = me.getSelectPlaceViewData();
			placeViewData.isViewData = true;//下单框传过去的数据
			var personNum = placeViewData.personNum;
			if (!checkValidCondition(personNum.trim(), ConditionValue.NOTEMPTY | ConditionValue.NOTZERO | ConditionValue.CKINTEGER, '请输入正确的人数!')) {
				return;
			}
			submitPutup.call(placeViewData, "0");
		}
	},
	/* 口味操作 */
	remarkSelectPlaceView : function() {
		var me = this;
		/*if(Ext.getCmp('select-place-view'))
			Ext.getCmp('select-place-view').toAllRemarkView();*/
		me.selectPlaceView = me.getSelectPlaceView();
		if(me.selectPlaceView)
			me.selectPlaceView.toAllRemarkView();
	},
	/* 茶位操作 */
	teaPriceSelectPlaceView : function(field, e, eOpts) {
		var me = this;
		me.selectPlaceView = me.getSelectPlaceView();
		var selectPlaceCtxt = me.selectPlaceView;
		if(selectPlaceCtxt) {
			selectPlaceCtxt.currField = field;
			selectPlaceCtxt.firstFocus = true;
		}
		ViewNumberKeyboard("select-place-teaprice", ["select-place-teaprice","select-place-personNum"], "select-place-view");
	},
	/* 人数操作 */
	personNumSelectPlaceView : function(field, e, eOpts) {
		var me = this;
		me.selectPlaceView = me.getSelectPlaceView();
		var selectPlaceCtxt = me.selectPlaceView;
		if(selectPlaceCtxt) {
			selectPlaceCtxt.currField = field;
			selectPlaceCtxt.firstFocus = true;
		}
		ViewNumberKeyboard("select-place-personNum", ["select-place-teaprice","select-place-personNum"], "select-place-view");
	},
	/* 打印遮罩层点击 */
	printMaskSelectPlaceView : function(currView, e, eOpts) {
		preventEventBubble(e);
		if(!currView) return;
		var me = this;
		var viewId = currView.id;
		var printCmp = null;
		if(viewId === "select-place-cp-mask") {
			printCmp = me.getSelectPlaceCustomerPrint();
		} else if(viewId === "select-place-sp-mask") {
			printCmp = me.getSelectPlaceStubPrint();
		} else if(viewId === "select-place-kp-mask") {
			printCmp = me.getSelectPlaceKitchenPrint();
		} else if(viewId === "select-place-lp-mask") {
			printCmp = me.getSelectPlaceLabelPrint();
		} else if(viewId === "select-place-tp-mask") {
			printCmp = me.getSelectPlaceTablePrint();
		}

		printCmp ? (printCmp.isChecked() ? printCmp.uncheck() : printCmp.check()) : null;
	},
	/* 打印选中操作 */
	printCheckSelectPlaceView : function(field, e, eOpts) {
		preventEventBubble(e);
		var me = this;
		if(!field) return;
		var fieldId = field.id;
		var updateData = {};
        var printName;

		if(fieldId === "select-place-customer-print") {updateData.isOrderCustomerPrint = 'true';printName = '客户单';}
		else if(fieldId === "select-place-stub-print") {updateData.isOrderPrivatePrint = 'true';printName = '存根单';}
		else if(fieldId === "select-place-kitchen-print") {updateData.isOrderKitchenPrint = 'true';printName = '厨房';}
		else if(fieldId === "select-place-label-print") {updateData.isOrderLabelPrint = 'true';printName = '标签';}
		else if(fieldId === "select-place-table-print") {updateData.isOrderTablePrint = 'true';printName = '台单';}
		else {return;}
		
		me.updatePrintData(updateData);
        addOptPrintSetting({
            printType: '下单',
            printName: printName,
            printValue: '是',
            status: '修改'
        });
	},
	/* 打印不选中操作 */
	printUnCheckSelectPlaceView : function(field, e, eOpts) {
		preventEventBubble(e);
		var me = this;
		if(!field) return;
		var fieldId = field.id;
		var updateData = {};
        var printName;
		if(fieldId === "select-place-customer-print") {updateData.isOrderCustomerPrint = 'false';printName = '客户单';}
		else if(fieldId === "select-place-stub-print") {updateData.isOrderPrivatePrint = 'false';printName = '存根单';}
		else if(fieldId === "select-place-kitchen-print") {updateData.isOrderKitchenPrint = 'false';printName = '厨房';}
		else if(fieldId === "select-place-label-print") {updateData.isOrderLabelPrint = 'false';printName = '标签';}
		else if(fieldId === "select-place-table-print") {updateData.isOrderTablePrint = 'false';printName = '台单';}
		else {return;}
		
		me.updatePrintData(updateData);
        addOptPrintSetting({
            printType: '下单',
            printName: printName,
            printValue: '否',
            status: '修改'
        });
	},
	updatePrintData : function(updateData) {
		SettingDao.updateSetting(updateData, setting.id, function (success, msg) {
            if (success) {
            	for(var key in updateData) {
            		if(updateData.hasOwnProperty(key)) {
            			setting[key] = updateData[key];
            		}
            	}
            }
        });
	},
	notShowSelectPlaceView : function(currView, e, eOpts) {
		preventEventBubble(e);
		var me = this;
		//var cbCmp = Ext.getCmp("is-reshow-putup-view");
		var cbCmp = me.getSelectPlaceIsReShow();
		var viewData = cbCmp && cbCmp.getData();
		if(viewData && viewData.id);
		else viewData = {id : createUUIDForId()};
		var isChecked = false;
		if(cbCmp) {
			isChecked = cbCmp.isChecked();
		}
		var paramsData = {
				id : viewData.id,
				sellerId : seller.id,
				paramType : "SYS",
				paramName : "directOrder",
				paramValue : isChecked ? "false" : "true",
				syned : "0",
			};
		SettingDao.saveSysParams(paramsData, function(success) {
			if(success) {
				cbCmp && cbCmp.setData(viewData);
				isChecked ? cbCmp.uncheck() : cbCmp.check();
				if(sysParams) {
					sysParams.replace(getMapKeyBySeperator([paramsData.paramType,paramsData.paramName]), paramsData);
				}
			} else {
				showAlert("提示", "修改失败!");
			}
		});
	}
});