Ext.define('Seller.view.commodity.CommodityTypeSub', {
	extend: 'Seller.view.commodity.CommodityType',
	alias: 'widget.commoditytypesub',
	constructor: function() {
		this.callParent(arguments);
	},
	initialize: function(panel, eOpts) {},
	/* 增加商品分类设置数据 */
	setAddData: function() {
		this.optCommTypeViewType = this.ADDTYPEVIEW;
		ComTypeAddClass.call(this);
		this.initViewContent();
	},
	/* 修改商品分类设置数据 */
	setEditData: function() {
		this.optCommTypeViewType = this.EDITTYPEVIEW;
		ComTypeEditClass.call(this);
		this.initViewContent();
	},
	setData: function(viewType) {
		this.optCommTypeViewType = viewType;
		if (this.optCommTypeViewType === this.ADDTYPEVIEW) {
			ComTypeAddClass.call(this);
		} else {
			ComTypeEditClass.call(this);
		}
		this.initViewContent();
	},
})
/**
 * 增加商品分类
 */
function ComTypeAddClass() {
	this.initViewContent = function() {
		Ext.getCmp('commodity-type-toolbar').setTitle('添加商品分类');
		CommodityDao.getMaxSequence(function(success, res) {
			if (success) {
				var commodityTypeForm = Ext.getCmp('commodityTypeForm');
				commodityTypeForm.getFields("sequence").setValue(res ? parseInt(res) + 1 : 0);
			}
		});
		setTimeout(function() {
			Ext.getCmp('commodityType-view-delete').setHidden(true);
		}, 100);
	},
	this.getKtPrinterJson = function() {
		return {};
	},
	this.checkPermission = function() {
		return new Promise(function(resolve, reject) {
			checkPermissions("16", true)
			.then(function() {resolve();})
			.catch(function() {reject();});
		});
	},
	this.dealKtPrinter = function(optionsArray, optionSelected, optionSel) {
		Ext.getCmp('cdTypePrintSelField').setValue(optionsArray[0].value);
		if (!Ext.getCmp('type-ktcb-field').isChecked())
			Ext.getCmp('type-ktcb-field').check();
	},
	this.saveViewData = function(viewDatas) {
		var me = this;
		viewDatas.isDelete = '0';
		viewDatas.syned = '0';
		viewDatas.status = '1';
		viewDatas.lastUpdateTime = new Date().format('yyyy-MM-dd hh:mm:ss');
		// 检测是否同名
		CommodityDao.checkCommodityTypeName(viewDatas.name, function(success, datas) {
			if (success && datas) {
				if (datas.length && datas.length > 0) {
					if (datas[0].isDelete != '1') {
						showAlert('提示', '该分类名称已经存在！');
						return;
					}
					viewDatas.isDelete = null;
					viewDatas.id = datas[0].id;
					CommodityDao.updateCommodityType(viewDatas, datas[0].id, function(success) {
						if (success) {
							me.afterViewData(viewDatas);
							showAlert('提示', '保存成功！');
						} else {
							showAlert('提示', '保存出错！');
						}
					});
					return;
				}
			}
			viewDatas.id = createSysId();
			CommodityDao.addCommodityType(viewDatas, function(success) {
				if (success) {
					me.afterViewData(viewDatas);
					showAlert('提示', '保存成功！');
				} else {
					showAlert('提示', '保存出错！');
				}
			});
		});
	},
	this.afterViewData = function(viewDatas) {
		this.afterViewDataParent(viewDatas);
	}
}

/**
 * 修改商品分类
 */
function ComTypeEditClass() {
	this.initViewContent = function() {
		Ext.getCmp('commodity-type-toolbar').setTitle(Application.Ftype == Application.SLAVE ? "查看商品分类" : '修改商品分类');
		setTimeout(function() {
			Ext.getCmp('commodityType-view-delete').setHidden(Application.Ftype == Application.SLAVE ? true : false);
		}, 0);
	},
	this.checkPermission = function() {
		/**
		 * 1. 手动打开钱箱
		 * 2. 退货
		 * 3. 反结账
		 * 4. 打折
		 * 5. 删除
		 * 6. 撤销订单
		 * 7. 修改
		 * 8. 自定义抹零
		 */
		return new Promise(function(resolve, reject) {
			checkPermissions("7", true)
			.then(function() {resolve();})
			.catch(function() {reject();});
		});
	},
	this.setCommodityTypeDefaultValue = function(record) {
		if (!record.get('isTypeDiscount')) {
			record.set('isTypeDiscount', record.get('isDiscount') == '1' ? true : false);
		}
		if (!record.get('isTypeInventory')) {
			record.set('isTypeInventory', record.get('isInventory') == '1' ? true : false);
		}
	},
	this.setRecord = function(record) {
		if (!record) return;
		var copyRecord = record.copy(record.get('id'));
		this.record = record;
		var commodityTypeForm = Ext.getCmp('commodityTypeForm');
		this.setCommodityTypeDefaultValue(copyRecord);
		commodityTypeForm.setRecord(copyRecord);
		this.loadData();
	},
	this.getKtPrinterJson = function() {
		var me = this;
		var ktPrintJson = me.record.get("kitchenPrintJson"); // 已经具有的设置
		if (ktPrintJson) ktPrintJson = Ext.JSON.decode(ktPrintJson);
		else ktPrintJson = {};

		return ktPrintJson;
	},
	this.saveViewData = function(viewDatas) {
		var me = this;
		var commodityTypeId = Ext.getCmp('commodityType-view').record.get('id');
		viewDatas.id = commodityTypeId;
		viewDatas.lastUpdateTime = createDateStr();
		// 检测是否同名
		CommodityDao.isSameCommodityTypeName(commodityTypeId, viewDatas.name, function(success, total) {
			if (success && total > 0) {
				showAlert('提示', '已经存在相同的商品类型!');
				return;
			}
			CommodityDao.updateCommodityType(viewDatas, Ext.getCmp('commodityType-view').record.get('id'), function(success) {
				if (success) {
					showAlert("提示", "保存成功!");
					Ext.getCmp('commodityType-view').record.set('isDiscount', viewDatas.isDiscount);
					me.afterViewData(viewDatas);
					//Ext.getCmp('editCommodityTypeView').hide();
				} else {
					showAlert('提示', '保存出错！');
				}
			});
		});
	},
	this.afterViewData = function(viewDatas) {
		this.afterViewDataParent(viewDatas);
	},
	this.dealKtPrinter = function(optionsArray, optionSelected, optionSel) {
		if (optionSelected) {
			Ext.getCmp('cdTypePrintSelField').setValue(optionsArray[optionSel].value);
			if (!Ext.getCmp('type-ktcb-field').isChecked())
				Ext.getCmp('type-ktcb-field').check();
		}
	},
	this.deleteCommodityType = function() {
		var me = this;
		checkPermissions("5", true).then(function() {
			var record = Ext.getCmp('commodityType-view').record;
			showConfirm('提示', '是否确定删除该商品分类', function(btnId) {
				if (btnId == 'yes') {
					var typeId = record.get('id');
					CommodityDao.getComInfoNotDelTotalCountByTypeId(typeId, function(success, count) {
						if (success && count > 0) {
							showAlert('提示', '该商品分类下面还有商品!');
							return;
						}
						CommodityDao.updateCommodityType({
							syned: '0',
							isDelete: '1',
							status: '9',
							lastUpdateTime: createDateStr()
						}, Ext.getCmp('commodityType-view').record.get('id'), function(success) {
							if (success) {
								Ext.getCmp('select-commodity-view').deleteCommodityType(Ext.getCmp('commodityType-view').record);
								me.afterViewData({
									id: record.get('id'),
									status: '9'
								});
							} else {
								showAlert('提示', '删除出错！');
							}
						});
					});
				}
			});
		}).catch (function() {});
	}
}