/**
 *@收银台首页
 *@Author: lijy
 *@Date: 2015-03-01
 */
Ext.define('Seller.view.place.EditPlaceSub', {
	extend : 'Seller.view.place.Place',
	alias : 'widget.editplacesub',
	initialize : function(panel, eOpts) {
		Ext.getCmp('place-toolbar').setTitle(Application.Ftype==Application.SLAVE?"查看桌子":'修改桌子');
		setTimeout(function() {
			Ext.getCmp('place-view-delete').setHidden(Application.Ftype==Application.SLAVE?true:false);
		}, 100);
	},
	checkPermission : function() {
		/**
		 * 1. 手动打开钱箱
		 * 2. 退货
		 * 3. 反结账
		 * 4. 打折
		 * 5. 删除
		 * 6. 撤销订单
		 * 7. 修改
		 * 8. 自定义抹零
		 */
		return new Promise(function(resolve, reject) {
			checkPermissions("7", true).then(function() {resolve();})
			.catch(function(){reject();});
		})
		/*if (!checkPermissions("7", true)) {
			return false;
		}
		return true;*/
	},
	setRecord : function(record) {
		if(!record) return;
		var placeForm = Ext.getCmp('placeForm');
		if (placeForm) {
			placeForm.setRecord(record);
		}
		this.typeId = record.get("typeId");
		this.record = record;
	},
	saveViewData : function(viewData) {
		var me = this;
		viewData.id = Ext.getCmp('place-view').record.get('id');
		viewData.lastUpdateTime=new Date().format('yyyy-MM-dd hh:mm:ss');
		viewData.isDelete = '0';
		viewData.syned = '0';
		ServicePlaceDao.isSamePlaceName(viewData.typeId, viewData.id, viewData.placeName, function(success, total) {
			if(success && total > 0) {
				showAlert('提示', samePlaceNameHintTxt);
				return;
			}
			ServicePlaceDao.updatePlace(viewData, viewData.id, function(success) {
				if (success) {
					me.afterViewData(viewData);
				} else {
					showAlert('提示', '保存出错！');
				}
			});
		});
	},
	afterViewData : function(viewData) {
		this.callParent(arguments);
	},
	deletePlace : function() {
		var me = this;
		checkPermissions("5", true).then(function() {
			showConfirm('提示', '是否确定删除该餐桌?', function(btnId) {
				if(btnId == 'yes') {
					var id = Ext.getCmp('place-view').record.get('id');
					var placeForm = Ext.getCmp('placeForm');
					var status = Ext.getCmp('place-view').record.get('status');
					if(status && status !== '0') {
						if(status == '3') {
							showAlert('提示', '当前餐桌是留位状态');
						} else {
							showAlert('提示', '当前餐桌还在使用中...');
						}
						return;
					}
					var tmpRecord = Ext.getCmp('place-view').record;
					ServicePlaceDao.updatePlace({
						syned : '0',
	                    status : '9',
						isDelete : '1',
						lastUpdateTime:createDateStr()
					}, id, function(success) {
						if (success) {
							if (Ext.getCmp('putup-view')) {
								Ext.getCmp('putup-view').deletePlace(Ext.getCmp('place-view').record);
							} else {
								Ext.getCmp('placeView-view').deletePlace(Ext.getCmp('place-view').record);
							}
							me.afterViewData({id : id, typeId : tmpRecord.get('typeId'), operateType:'delete'});
						} else {
							showAlert('提示', '删除出错！');
						}
					});
				}
			});
		}).catch(function() {});
		/*if (!checkPermissions("5", true)) {
			return;
		}
		showConfirm('提示', '是否确定删除该餐桌?', function(btnId) {
			if(btnId == 'yes') {
				var id = Ext.getCmp('place-view').record.get('id');
				var placeForm = Ext.getCmp('placeForm');
				var status = Ext.getCmp('place-view').record.get('status');
				if(status && status !== '0') {
					if(status == '3') {
						showAlert('提示', '当前餐桌是留位状态');
					} else {
						showAlert('提示', '当前餐桌还在使用中...');
					}
					return;
				}
				var tmpRecord = Ext.getCmp('place-view').record;
				ServicePlaceDao.updatePlace({
					syned : '0',
                    status : '9',
					isDelete : '1',
					lastUpdateTime:createDateStr()
				}, id, function(success) {
					if (success) {
						if (Ext.getCmp('putup-view')) {
							Ext.getCmp('putup-view').deletePlace(Ext.getCmp('place-view').record);
						} else {
							Ext.getCmp('placeView-view').deletePlace(Ext.getCmp('place-view').record);
						}
						me.afterViewData({id : id, typeId : tmpRecord.get('typeId'), operateType:'delete'});
					} else {
						showAlert('提示', '删除出错！');
					}
				});
			}
		});*/
	}
});
