Ext.define('Seller.view.place.EditPlaceTypeSub', {
	extend : 'Seller.view.place.PlaceType',
	alias : 'widget.editplacetypesub',
	autoDestroy:true,
	initialize : function(panel, eOpts) {
		Ext.getCmp('placetype-toolbar').setTitle(Application.Ftype==Application.SLAVE?"查看桌号区域":'修改桌号区域');
	},
	setRecord : function(record) {
        if(!record) return;
		var placeTypeForm = Ext.getCmp('placeTypeForm');
		var teaUnitPrice = parseDigitalDecimal(record.get('teaUnitPrice'));// 茶位费
		record.set('teaUnitPrice', teaUnitPrice);
		if(placeTypeForm) placeTypeForm.setRecord(record);
		this.record = record;
	},
	/* 修改权限 */
	checkModifyPermission : function() {
		/**
		 * 1. 手动打开钱箱
		 * 2. 退货
		 * 3. 反结账
		 * 4. 打折
		 * 5. 删除
		 * 6. 撤销订单
		 * 7. 修改
		 * 8. 自定义抹零
		 */
		return new Promise(function(resolve, reject) {
			checkPermissions("7", true)
			.then(function() {resolve();})
			.catch(function() {reject();});
		});
		/*if (!checkPermissions("7", true)) {
			return false;
		}
		return true;*/
	},
	checkPermission : function(viewData) {
		var me = this;
		return new Promise(function(resolve, reject) {
			if(!me.record) resolve(true);
			if(me.record.get('teaUnitPrice') != viewData.teaUnitPrice) {
				checkPermissions(PERMISSIONS.TEAPRICEMODIFY, true, "对不起,您没有权限修改茶位费!")
				.then(function() {resolve(true);})
				.catch(function() {reject()});
			} else resolve(true);
		});
		/*if(!this.record) return;
		if(this.record.get('teaUnitPrice') != viewData.teaUnitPrice
				&& !checkPermissions(PERMISSIONS.TEAPRICEMODIFY, true, "对不起,您没有权限修改茶位费!")) return false;
		return true;*/
	},
	saveViewData : function(viewData) {
		var me = this;
		var typeId = Ext.getCmp('placeType-view').record.get('id');
		viewData.id = Ext.getCmp('placeType-view').record.get('id');
		viewData.isDelete = '0';
		viewData.syned = '0';
		viewData.lastUpdateTime=new Date().format('yyyy-MM-dd hh:mm:ss');
		ServicePlaceDao.isSamePlaceTypeName(typeId, viewData.typeName, function(success, total) {
			if(success && total > 0) {
				showAlert('提示', samePlaceTypeNameHintTxt);
				return;
			}
			ServicePlaceDao.updatePlaceType(viewData, typeId, function(success) {
				if (success) {
					showAlert('提示','保存成功');
					// 桌台类型修改, 只有在新增桌台的时候syned='0'
					ServicePlaceDao.submitPlaceTypeToServer(viewData, function(success, message) {
						if(success) {
						} else {
							//showAlert('提示', message?message:'修改失败');
						}
					});
					var pPlaceView = Ext.getCmp('placeView-view');
					ServicePlaceDao.loadServicePlaceType(function(success, res) {
						if(success)
							pPlaceView.loadServicePlaceType(res);
					});
					me.afterViewData(viewData);
				} else {
					showAlert('提示','保存出错！');
				}
			});
		});
	},
	afterViewData : function(viewData) {
		this.callParent(arguments);
	}
});
