Ext.define('Seller.view.place.Place', {
	//extend : 'Ext.Container',
	extend : 'Seller.view.Base.Base',
	alias : 'widget.place',
	parentContainer : null,
	fromContainer : null,
	parentId : null,
	typeId : null,
	optPlaceViewType: null,
	ADDVIEW: 'ADDVIEW',
	EDITVIEW:　'EDITVIEW',
	config : {
		id : 'place-view',
		cls: 'place-view',
		centered : true,
		height : '100%',
		width : '100%',
		listeners : {
			painted : function(element, eOpts) {
				var isMaster = isConfigMaster();
				if(isMaster) return;
				var placeViewCmp = Ext.getCmp("place-view");
				var placeNameCmp = placeViewCmp.down("textfield[id=id-place-name]");
				if(placeNameCmp) placeNameCmp.setDisabled(true);
				var placeNumCmp = placeViewCmp.down("textfield[id=id-person-num]");
				if(placeNumCmp) placeNumCmp.setDisabled(true);
				var placeSequenceCmp = placeViewCmp.down("textfield[id=id-place-sequence]");
				if(placeSequenceCmp) placeSequenceCmp.setDisabled(true);
				var placeStatusCmp = placeViewCmp.down("selectfield[id=id-place-status]");
				if(placeStatusCmp) placeStatusCmp.setDisabled(true);
				var placeRemarkCmp = placeViewCmp.down("textareafield[id=id-place-remark]");
				if(placeRemarkCmp) placeRemarkCmp.setDisabled(true);
				var placeSaveCmp = placeViewCmp.down("button[id=id-place-save]");
				if(placeSaveCmp) placeSaveCmp.setHidden(true);
				var placeViewDeleteCmp = placeViewCmp.down("button[id=place-view-delete]");
				if(placeViewDeleteCmp) placeViewDeleteCmp.setHidden(true);
			}
		},
		items : [{
			xtype : 'formpanel',
			id : 'placeForm',
			scrollable : false,
			height : '100%',
			items : [{
				xtype : 'fieldset',
				title : '',
				instructions : '',
				margin : 1,
				defaults : {
                    disabled: Application.Ftype == Application.SLAVE ? true : false,
                    disabledCls : 'disableFontCls',
					labelWidth : 130
				},
				items : [{
					xtype : 'textfield',
					name : 'placeName',
					id : 'id-place-name',
					placeHolder : '请输入桌子名称',
					label : '桌子名称',
					required : true
				}, {
					xtype : 'numberfield',
					name : 'personNum',
					id : 'id-person-num',
					placeHolder : '请输入人数',
					value : 2,
					label : '人数',
					required : true
				}, {
					xtype : 'textfield',
					name : 'sequence',
					id : 'id-place-sequence',
					placeHolder : '请输入排序号',
					value : 0,
					label : '排序号',
					listeners : {
                        keyup : function (field, event, eOpts) {
                            checkNumberForm(field, event, eOpts, 'Integer')
                        }
					}
					//required : true
				},{
					xtype : 'selectfield',
					name : 'status',
					id : 'id-place-status',
					label : '状态',
					disabled: true,
					options : [{
						text : '空闲',
						value : '0'
					}, {
						text : '使用中',
						value : '1'
					}]
				}, {
					xtype : 'textareafield',
					name : 'remark',
					id : 'id-place-remark',
					placeHolder : '请输入备注',
					value : 0,
					label : '备注'
				}, {
					xtype: 'panel',
					id: 'new-place-tips',
					height:  40,
					html: '<div style="line-height:40px;padding-left: 10px;color:red;">提示：新增桌子请前往系统设置->打印设置->厨房打印机处设置打印</div>'
				}]
			}]
		}, {
			xtype : 'toolbar',
			title : '添加桌子',
			docked : 'top',
			id : 'place-toolbar',
			items : [{
				xtype : 'button',
				//cls : 'close-button',
				cls : 'close-button-complete',
				width : 80,
				iconCls : 'close-icon',
				icon : 'resources/icon/public/back.png',
				text : '返回',
				id : 'add-place-close',
				handler : function() {
					var parentContainer = Ext.getCmp('place-view').parentContainer;
					parentContainer.hide();
					// parentContainer.destroy();
				}
			}, {
				xtype : 'spacer'
			}, {
				xtype : 'button',
				text : '保存',
				id : 'id-place-save',
				hidden : Application.Ftype==Application.SLAVE?true:false,
				handler : function() {
					Ext.getCmp('place-view').dealPlace();
				}
			}, {
				xtype : 'button',
				id : 'place-view-delete',
				text : '删除',
				hidden : Application.Ftype==Application.SLAVE?true:false,
				handler : function() {
					Ext.getCmp('place-view').deletePlace();
				}
			}]
		}]
	},
	initialize : function(panel, eOpts) {
	},
	setParentContainer : function(parentContainer) {
		this.parentContainer = parentContainer;
	},
	setFromContainer : function(fromContainer) {
		this.fromContainer = fromContainer;
	},
	checkPermission : function() {return new Promise(function(resolve, reject) {resolve();});/*return true;*/},
	checkCondition : function(viewData) {
        viewData.placeName = viewData.placeName.trim();
		if (!viewData.placeName) {
			showAlert('提示', '请输入桌子名称！');
			return false;
		}
		if (!viewData.personNum) {
			showAlert('提示', '请输入人数！');
			return false;
		} else {
			if (viewData.personNum < 0) {
                showAlert('提示', '人数不能小于0！');
                return false;
            } else if(!isInteger(viewData.personNum)) {
                showAlert('提示', '人数应为正整数!');
                return false;
            } else if ((viewData.personNum + '').length > 4) {
                showAlert('提示', '人数整数位最大只支持 4 位！');
                return false;
			}
		}



		if(!this.checkSequenceCondition(viewData)) return false;
		/*if (!viewData.sequence && viewData.sequence != 0) {
			showAlert('提示', '请输入排序号！');
			return false;
		} else if(!isInteger(viewData.sequence)){
			showAlert('提示', '请输入排序号(只支持正整数)!');
			return false;
		}*/
		return true;
	},
	getViewDatas : function() {
		var placeForm = Ext.getCmp('placeForm');
		var dataValues = placeForm.getValues();
		dataValues.typeId = Ext.getCmp('place-view').typeId;
		dataValues.sellerId = seller.id;
		var placeViewCmp = Ext.getCmp('place-view');
		if(placeViewCmp && placeViewCmp.typeId) {
			dataValues.typeId = placeViewCmp.typeId;
		}
		//保存内存文件
		dataValues.syned = "0";
		
		return dataValues;
	},
	dealPlace : function() {
		var me = this;
		me.checkPermission().then(function() {
			var viewData = me.getViewDatas();
			if(!me.checkCondition(viewData)) return;
			
			me.saveViewData && me.saveViewData(viewData);
		}).catch(function() {});
		/*if(!me.checkPermission()) return;
		var viewData = me.getViewDatas();
		if(!me.checkCondition(viewData)) return;
		
		me.saveViewData && me.saveViewData(viewData);*/
	},
	deletePlace : function() {
		
	},
	afterViewDataParent : function(viewData) {
		var me = this;
		var parentContainer = me.parentContainer;
		var fromContainer= me.fromContainer;
		parentContainer.hide();
		// parentContainer.destroy();
		if (viewData.operateType == 'delete') {
            showAlert('提示', '删除成功！');
		} else {
			showAlert('提示', '保存成功！');
        }
		fromContainer.clearplace();
		sendPlace(viewData.id);
		if(fromContainer){
			fromContainer.selectEditPlaceType(viewData.typeId);
		}
		//ServicePlaceDao.submitPlaceToServer(viewData);
		ServicePlaceDao.submitPlaceById(viewData.id);		
	}
});
