Ext.define('Seller.view.place.PlaceSub', {
	extend: 'Seller.view.place.Place',
	alias: 'widget.placesub',
	initialize: function(panel, eOpts) {},
	/* 增加餐桌设置数据 */
	setAddData: function() {
		this.optPlaceViewType = this.ADDVIEW;
		PlaceAddClass.call(this);
		this.initViewContent();
	},
	/* 修改餐桌设置数据 */
	setEditData: function() {
		this.optPlaceViewType = this.EDITVIEW;
		PlaceEditClass.call(this);
		this.initViewContent();
	},
	setData: function(viewType) {
		this.optPlaceViewType = viewType;
		if (this.optPlaceViewType === this.ADDVIEW) {
			PlaceAddClass.call(this);
		} else {
			PlaceEditClass.call(this);
		}
		this.initViewContent();
	},
})
/**
 * 增加餐桌类
 */
function PlaceAddClass() {
	this.initViewContent = function(panel, eOpts) {
		if (Ext.getCmp('place-toolbar'))
			Ext.getCmp('place-toolbar').setTitle('添加桌子');
		if (Ext.getCmp('place-view-delete'))
			Ext.getCmp('place-view-delete').setHidden(true);
	},
	this.checkPermission = function() {
		return new Promise(function(resolve, reject) {
			checkPermissions("16", true).then(function() {
				resolve();
			}).catch (function() {
				reject();
			});
		})
	},
	this.saveViewData = function(viewData) {
		var me = this;
		viewData.id = createSysId();
		viewData.lastUpdateTime = createDateStr();
		viewData.isDelete = '0';
		viewData.syned = "0";
		viewData.status = "0";
		viewData.createId = shouYinEmployee.workId;
		viewData.createTime = createDateStr();
		viewData.lastUpdateId = shouYinEmployee.workId;
		ServicePlaceDao.checkPlaceAndType(viewData.typeId, viewData.placeName, function(success, datas) {
			if (success && datas) {
				if (datas.length && datas.length > 0) {
					showAlert('提示', '当前区域此桌子名称已存在!');
					return;
				}
			}
			ServicePlaceDao.addPlace(viewData, function(success) {
				if (success) {
					me.afterViewData(viewData);
				} else {
					showAlert('提示', '保存出错！');
				}
			});
		});
	},
	this.afterViewData = function(viewData) {
		this.afterViewDataParent(viewData);
	}
}

/**
 * 修改餐桌类
 */
function PlaceEditClass() {
	this.initViewContent = function(panel, eOpts) {
		Ext.getCmp('place-toolbar').setTitle(Application.Ftype == Application.SLAVE ? "查看桌子" : '修改桌子');
		setTimeout(function() {
			Ext.getCmp('place-view-delete').setHidden(Application.Ftype == Application.SLAVE ? true : false);
		}, 100);
	},
	this.checkPermission = function() {
		return new Promise(function(resolve, reject) {
			checkPermissions("7", true).then(function() {
				resolve();
			}).catch (function() {
				reject();
			});
		})
	},
	this.setRecord = function(record) {
		if (!record) return;
		var placeForm = Ext.getCmp('placeForm');
		if (placeForm) {
			placeForm.setRecord(record);
		}
		this.typeId = record.get("typeId");
		this.record = record;
	},
	this.saveViewData = function(viewData) {
		var me = this;
		viewData.id = Ext.getCmp('place-view').record.get('id');
		viewData.lastUpdateTime = new Date().format('yyyy-MM-dd hh:mm:ss');
		viewData.isDelete = '0';
		viewData.syned = '0';
		ServicePlaceDao.isSamePlaceName(viewData.typeId, viewData.id, viewData.placeName, function(success, total) {
			if (success && total > 0) {
				showAlert('提示', samePlaceNameHintTxt);
				return;
			}
			ServicePlaceDao.updatePlace(viewData, viewData.id, function(success) {
				if (success) {
					me.afterViewData(viewData);
				} else {
					showAlert('提示', '保存出错！');
				}
			});
		});
	},
	this.afterViewData = function(viewData) {
		this.afterViewDataParent(viewData);
	},
	this.deletePlace = function() {
		var me = this;
		checkPermissions("5", true).then(function() {
			showConfirm('提示', '是否确定删除该餐桌?', function(btnId) {
				if (btnId == 'yes') {
					var id = Ext.getCmp('place-view').record.get('id');
					var placeForm = Ext.getCmp('placeForm');
					var status = Ext.getCmp('place-view').record.get('status');
					if (status && status !== '0') {
						if (status == '3') {
							showAlert('提示', '当前餐桌是留位状态');
						} else {
							showAlert('提示', '当前餐桌还在使用中...');
						}
						return;
					}
					var tmpRecord = Ext.getCmp('place-view').record;
					ServicePlaceDao.updatePlace({
						syned: '0',
						status: '9',
						isDelete: '1',
						lastUpdateTime: createDateStr()
					}, id, function(success) {
						if (success) {
							if (Ext.getCmp('putup-view')) {
								Ext.getCmp('putup-view').deletePlace(Ext.getCmp('place-view').record);
							} else {
								Ext.getCmp('placeView-view').deletePlace(Ext.getCmp('place-view').record);
							}
							me.afterViewData({
								id: id,
								typeId: tmpRecord.get('typeId'),
								operateType: 'delete'
							});
						} else {
							showAlert('提示', '删除出错！');
						}
					});
				}
			});
		}).catch (function() {});
	}
}