Ext.define('Seller.view.place.PlaceTypeSub', {
	extend: 'Seller.view.place.PlaceType',
	alias: 'widget.placetypesub',
	initialize: function(panel, eOpts) {},
	/* 增加餐桌分类设置数据 */
	setAddData: function() {
		this.optPlaceTypeView = this.ADDTYPEVIEW;
		PlaceTypeAddClass.call(this);
		this.initViewContent();
	},
	/* 修改餐桌分类设置数据 */
	setEditData: function() {
		this.optPlaceTypeView = this.EDITTYPEVIEW;
		PlaceTypeEditClass.call(this);
		this.initViewContent();
	},
	setData: function(viewType) {
		this.optPlaceTypeView = viewType;
		if (this.optPlaceTypeView === this.ADDTYPEVIEW) {
			PlaceTypeAddClass.call(this);
		} else {
			PlaceTypeEditClass.call(this);
		}
		this.initViewContent();
	},
})
/**
 * 增加餐桌分类
 */
function PlaceTypeAddClass() {
	this.initViewContent = function(panel, eOpts) {
		Ext.getCmp('placetype-toolbar').setTitle('添加桌号区域');
		ServicePlaceDao.getMaxSequence(function(success, res) {
			if (success) {
				var placeTypeForm = Ext.getCmp('placeTypeForm');
				placeTypeForm.getFields("sequence").setValue(parseInt(res) ? parseInt(res) + 1 : 0);
			}
		});
	},
	/* 修改权限 */
	this.checkModifyPermission = function() {
		return new Promise(function(resolve, reject) {
			checkPermissions("16", true).then(function() {
					resolve();
				}).catch (function() {
				reject();
			});
		});
	},
	this.saveViewData = function(viewData) {
		var me = this;
		ServicePlaceDao.getServicePlaceTypeByName(viewData.typeName, function(success, items) {
			if (success && items.length > 0) {
				showAlert('提示', '桌台类型已存在');
				return;
			} else {
				viewData.sellerId = seller.id;
				viewData.id = createSysId();
				viewData.syned = "0";
				var parent = Ext.getCmp(Ext.getCmp('placeType-view').parentId);
				viewData.lastUpdateTime = createDateStr();
				viewData.isDelete = '0';
				viewData.syned = "0";
				viewData.status = "1";
				viewData.createId = shouYinEmployee.workId;
				viewData.createTime = createDateStr();
				viewData.lastUpdateId = shouYinEmployee.workId;
				ServicePlaceDao.addPlaceType(viewData, function(success) {
					if (success) {
						me.afterViewData(viewData);
					} else {
						showAlert('提示', '保存出错！');
					}
				});
			}
		});
	},
	this.afterViewData = function(viewData) {
		this.afterViewDataParent(viewData);
	}
}
/**
 * 修改餐桌分类
 */
function PlaceTypeEditClass() {
	this.initViewContent = function(panel, eOpts) {
		Ext.getCmp('placetype-toolbar').setTitle(Application.Ftype == Application.SLAVE ? "查看桌号区域" : '修改桌号区域');
	},
	this.setRecord = function(record) {
		if (!record) return;
		var placeTypeForm = Ext.getCmp('placeTypeForm');
		var teaUnitPrice = parseDigitalDecimal(record.get('teaUnitPrice')); // 茶位费
		record.set('teaUnitPrice', teaUnitPrice);
		if (placeTypeForm) placeTypeForm.setRecord(record);
		this.record = record;
	},
	/* 修改权限 */
	this.checkModifyPermission = function() {
		return new Promise(function(resolve, reject) {
			checkPermissions("7", true)
			.then(function() {resolve();})
			.catch(function() {reject();});
		});
	},
	this.checkPermission = function(viewData) {
		var me = this;
		return new Promise(function(resolve, reject) {
			if(!me.record) resolve(true);
			if(me.record.get('teaUnitPrice') != viewData.teaUnitPrice) {
				checkPermissions(PERMISSIONS.TEAPRICEMODIFY, true, "对不起,您没有权限修改茶位费!")
				.then(function() {resolve(true);})
				.catch(function() {reject()});
			} else resolve(true);
		});
	},
	this.saveViewData = function(viewData) {
		var me = this;
		var typeId = Ext.getCmp('placeType-view').record.get('id');
		viewData.id = Ext.getCmp('placeType-view').record.get('id');
		viewData.isDelete = '0';
		viewData.syned = '0';
		viewData.lastUpdateTime = new Date().format('yyyy-MM-dd hh:mm:ss');
		ServicePlaceDao.isSamePlaceTypeName(typeId, viewData.typeName, function(success, total) {
			if (success && total > 0) {
				showAlert('提示', samePlaceTypeNameHintTxt);
				return;
			}
			ServicePlaceDao.updatePlaceType(viewData, typeId, function(success) {
				if (success) {
					showAlert('提示', '保存成功');
					// 桌台类型修改, 只有在新增桌台的时候syned='0'
					ServicePlaceDao.submitPlaceTypeToServer(viewData, function(success, message) {
						if (success) {} else {
							//showAlert('提示', message?message:'修改失败');
						}
					});
					var pPlaceView = Ext.getCmp('placeView-view');
					ServicePlaceDao.loadServicePlaceType(function(success, res) {
						if (success)
							pPlaceView.loadServicePlaceType(res);
					});
					me.afterViewData(viewData);
				} else {
					showAlert('提示', '保存出错！');
				}
			});
		});
	},
	this.afterViewData = function(viewData) {
		this.afterViewDataParent(viewData);
	}
}