/**
 *@Author: Xiongzp
 *@Date: 2018/9/10
 */
Ext.define('Seller.view.place.SelectMergePlaceView', {
    extend : 'Ext.Container',
    alias : 'widget.selectmergeplaceview',
    autoDestroy : true,
    currPlaceTypeId : null,
    //分页工具
    placeTypePage : new $.PageUtil({
        limitCount : 8
    }),
    placeViewPage : new $.PageUtil({
        limitCount : 15
    }),
    config : {
        layout : 'vbox',
        centered : true,
        height : '100%',
        cls : 'select-place-opt-view',
        id : 'selectMergePlaceView-view',
        items : [{
            xtype : 'toolbar',
            title : '并台',
            docked : 'top',
            items : [{
                xtype : 'button',
                cls : 'close-button-complete',
                width : 80,
                iconCls : 'close-icon',
                icon : 'resources/icon/public/back.png',
                text : '返回',
                id : 'select-mergeplace-view-close',
                handler : function() {
                    Ext.getCmp('selectMergePlaceView').hide();
                    Ext.getCmp('selectMergePlaceView-list-panel').parent.show();
                    Ext.getCmp('selectMergePlaceSellDetail-panel').hide();
                    Ext.getCmp('mergePlacePreviousBtn').hide();
                    Ext.getCmp('mergePlaceCompleteBtn').hide();
                    Ext.getCmp('mergePlaceBtn').show();
                }
            }, {
                xtype : 'spacer'
            }, {
                xtype : 'ebutton',
                id : 'mergePlacePreviousBtn',
                width: 100,
                style: 'font-size:16px;',
                text : '上一步',
                hidden: true,
                handler : function() {
                    timeoutDisable('mergePlacePreviousBtn');
                    var placeView = Ext.getCmp('selectMergePlaceView-view');
                    placeView.showViewListAndBtn();
                }
            },{
                xtype : 'ebutton',
                id : 'mergePlaceBtn',
                width: 100,
                style: 'font-size:16px;',
                text : '选择台位',
                handler : function() {
                    timeoutDisable('mergePlaceBtn');
                    var me = Ext.getCmp('selectMergePlaceView-view');
                    var mergePlaceList  = Ext.getCmp('selectMergePlaceView-list');
                    if(mergePlaceList.getSelection().length > 0){
                        var record = mergePlaceList.getSelection()[0];
                        var placeId = record.get('id');
                        getAllPinPlace(placeId, function(success, pinSellInfos){
                            if(success && pinSellInfos.length > 1){
                                var selectPinPlaceView = Ext.getCmp('selectPinPlaceView');
                                if(!selectPinPlaceView) {
                                    selectPinPlaceView = Ext.Viewport.add({
                                        xtype : 'panel',
                                        modal : true,
                                        centered : true,
                                        hideOrMaskTap : false,
                                        id : 'selectPinPlaceView',
                                        width : 300,
                                        height : 400,
                                        items : [{
                                            xtype: 'toolbar',
                                            title: '请选择并台位',
                                            height: 50,
                                            docked: 'top',
                                            items: [{
                                                xtype: 'button',
                                                cls: 'close-button',
                                                handler: function () {
                                                    if (Ext.getCmp('selectPinPlaceView'))
                                                        Ext.getCmp('selectPinPlaceView').destroy();
                                                }
                                            }, {
                                                xtype: 'spacer'
                                            }, {
                                                xtype: 'button',
                                                cls: 'sy-tm-button',
                                                text: '确认',
                                                hidden: true,
                                                handler: function () {
                                                }
                                            }]
                                        }, {
                                            xtype : 'list',
                                            id : 'select-pin-place-list',
                                            //height : 224,
                                            height : 350,
                                            margin : '0 0 0 0',
                                            store : Ext.create("Ext.data.Store", {
                                                id:'select-pin-place-store',
                                                fields : ['id', 'placeName', 'oldPlaceId', 'status'],
                                                data : []
                                            }),
                                            selectedCls : 'checkedbg',
                                            itemTpl : new Ext.XTemplate('<div class="sy-commodity-list" style="width:300px !important;border-bottom:1px solid #ccc;"><div class="name jz-center" style="width:100%!important;">{placeName}</div></div>'),
                                            isAfterrendered : false, //添加一个变量，用于检测afterrender是否已经发生
                                            listeners : {
                                                itemtap : function(list, index, target, record, e, eOpts) {
                                                    preventEventBubble(e);
                                                    if (record) {
                                                        if(me.selectCurrentPlace.placeName == record.get('placeName')){
                                                            showAlert("提示", "不能选择相同的拼桌台位！");
                                                            return;
                                                        }
                                                        if(record.get('status') == '-1'){
                                                            showAlert("提示", "不能选择挂单的台位并台！");
                                                            return;
                                                        }
                                                        SellDao.getCurrSellInfoByPlacePinId(record.get("id"), function(success, sellInfo) {
                                                            if (success && sellInfo) {
                                                                me.getCurrSellInfoByPlacePinId(sellInfo.placeId).
                                                                then(function(sellInfo){
                                                                    me.selectTargetPlaceSellInfo = sellInfo;
                                                                    me.selectTargetPlaceName = sellInfo.placeName;
                                                                    var sellId = sellInfo.id;
                                                                    me.selectTargetPlace = {
                                                                        placeName: sellInfo.placeName,
                                                                        sellId: sellId
                                                                    };
                                                                    return me.getSellDetailBySellId(sellId);
                                                                }).
                                                                then(function(sellDetail){
                                                                    //保存并过滤删除的销售信息
                                                                    me.selectTargetPlaceSellDetail = me.getSellDetailAfterFilter(sellDetail);
                                                                    me.hideViewListAndBtn();
                                                                    me.loadMergePlaceDetail();
                                                                    me.loadMergePlaceSellAmount();
                                                                }).
                                                                catch(function(err){});
                                                            } else {
                                                                showAlert("提示", "该餐桌没人用餐,可以清台!");
                                                            }
                                                        });
                                                    }
                                                    Ext.getCmp('selectPinPlaceView').destroy();
                                                },
                                                itemtouchmove : function(list, index, target, record, e, eOpts) {
                                                },
                                                itemdoubletap : function(list, index, target, record, e, eOpts) {

                                                }
                                            }
                                        }]
                                    });
                                }
                                showBy(selectPinPlaceView,Ext.getCmp('selectMergePlaceView-view'),100);
                                var selectPinPlaceStore = Ext.getStore('select-pin-place-store');
                                for(var pi=0,pilen=pinSellInfos.length;pi<pilen;pi++) {
                                    selectPinPlaceStore.add({
                                        id: pinSellInfos[pi].placeId,
                                        placeName: pinSellInfos[pi].placeName,
                                        oldPlaceId: record.get('id'),
                                        status: pinSellInfos[pi].status
                                    });
                                }
                            }else if(pinSellInfos && pinSellInfos.length > 0){
                                if(pinSellInfos[0].status == '-1'){
                                    showAlert("提示", "当前选中餐桌为挂单状态，请下单后再进行并台！");
                                    return;
                                }
                                me.getCurrSellInfoByPlacePinId(pinSellInfos[0].placeId).
                                then(function(sellInfo){
                                    me.selectTargetPlaceSellInfo = sellInfo;
                                    me.selectTargetPlaceName = sellInfo.placeName;
                                    var sellId = sellInfo.id;
                                    me.selectTargetPlace = {
                                        placeName: sellInfo.placeName,
                                        sellId: sellId
                                    };
                                    return me.getSellDetailBySellId(sellId);
                                }).
                                then(function(sellDetail){
                                    me.hideViewListAndBtn();
                                    me.selectTargetPlaceSellDetail = me.getSellDetailAfterFilter(sellDetail);
                                    me.loadMergePlaceDetail();
                                    me.loadMergePlaceSellAmount();
                                }).
                                catch(function(err){});
                            }else if(pinSellInfos && pinSellInfos.length == 0){
                                showAlert("提示", "该餐桌没人用餐,请先清台!");
                            }
                        });
                    }else{
                        $(".place-selected").removeClass('place-selected');
                        showAlert('提示', '请先选择台位！');
                    }
                }
            }, {
                xtype : 'ebutton',
                id : 'mergePlaceCompleteBtn',
                width: 100,
                style: 'font-size:16px;',
                text : '确定',
                hidden: true,
                handler : function() {
                    timeoutDisable('mergePlaceCompleteBtn');
                    var mergePlaceView = Ext.getCmp('selectMergePlaceView-view');

                    //当前台位信息
                    var selectCurrentPlaceSellInfo = mergePlaceView.selectCurrentPlaceSellInfo;
                    var currentMergePlaceDatas = [];
                    //目标台位信息
                    var selectTargetPlaceSellInfo = mergePlaceView.selectTargetPlaceSellInfo;
                    var targetMergePlaceDatas = mergePlaceView.selectCurrentPlaceSellDetail;

                    var targetSellDetails = createSellDetailsByData(targetMergePlaceDatas, selectTargetPlaceSellInfo);
                    var currentSellDetails = createSellDetailsByData(currentMergePlaceDatas, selectCurrentPlaceSellInfo);
                    var targetPlaceSellId = selectTargetPlaceSellInfo.id;
                    var currentPlaceSellId = selectCurrentPlaceSellInfo.id;

                    //合并目标台位增加的销售详情
                    var targetSellDetail = mergePlaceView.concatSellDetail(targetSellDetails, currentSellDetails, currentPlaceSellId, targetPlaceSellId);
                    //合并当前台位销售详情
                    var currentSellDetail = mergePlaceView.concatSellDetail(currentSellDetails, targetSellDetails, targetPlaceSellId, currentPlaceSellId);

                    //更新目标台位销售信息sellinfo
                    var targetDetailAry = mergePlaceView.selectTargetPlaceSellDetail.concat(targetSellDetails);
                    mergePlaceView.updateSellInfo(targetDetailAry, selectTargetPlaceSellInfo, selectCurrentPlaceSellInfo);

                    showLoading("正在处理，请稍后...");
                    mergePlaceView.addSellDetailByData(targetSellDetail, selectTargetPlaceSellInfo.id).
                    then(function(){
                        return mergePlaceView.addSellDetailByData(currentSellDetail, selectCurrentPlaceSellInfo.id);
                    }).
                    then(function(){
                        //更新销售信息表
                        return mergePlaceView.updateSellInfoByData(selectTargetPlaceSellInfo, selectTargetPlaceSellInfo.id);
                    }).
                    then(function(){
                        //更新销售信息表
                        return mergePlaceView.updateSellInfoByData(selectCurrentPlaceSellInfo, selectCurrentPlaceSellInfo.id);
                    }).
                    then(function(){
                        //撤销当前订单
                        mergePlaceView.mergePlaceSellInfoCancel(selectCurrentPlaceSellInfo, function(){});

                        mergePlaceView.showViewListAndBtn();
                        Ext.getCmp('selectMergePlaceView').hide();
                        refreshPlace();
                        closeLoading();
                    }).
                    catch(function(err){
                        console.log('mergePlace error：', err.message);
                        mergePlaceView.showViewListAndBtn();
                        Ext.getCmp('selectMergePlaceView').hide();
                        closeLoading();
                    });
                }
            }]
        }, {
            xtype : 'container',
            layout : 'hbox',
            flex : 1,
            items : [{
                flex : 1,
                layout : 'vbox',
                id : 'selectMergePlaceView-list-panel',
                items : [{
                    xtype : 'container',
                    id : 'selectMergePlaceTypeView-list-panel',
                    layout : 'hbox',
                    height : 55,
                    items : [{
                        xtype : 'container',
                        layout : 'vbox',
                        items : [{
                            cls:'order-margin',
                            html : '<div class="white-button fy-button jz-center" onclick="Ext.getCmp(\'selectMergePlaceView-view\').downPlaceType()"><img src="resources/icon/public/left-black.png"></div>'
                        }]
                    }, //Ext.create('Ext.DataView', {
                    {
                        xtype : "dataview",
                        id : 'selectMergePlaceTypeView-list',
                        cls : 'placetype-dataview',
                        scrollable : false,
                        flex : 1,
                        store : Ext.create('Ext.data.Store', {
                            id : 'selectmergeplacetypeview-store',
                            model : 'Seller.model.ServicePlaceType',
                            data : []
                        }),
                        itemTpl : ['<tpl if="id == 0"><div  class="commodityType"><div class="white-button placetype-button jz-center"><img src="resources/icon/public/tianjia.png" /></div></div><tpl else><div  class="commodityType"><div class="white-button placetype-button jz-center" id="select-placetype-button-{id}"  onclick="Ext.getCmp(\'selectMergePlaceView-view\').serviceChangePlaceTypeClick(this,\'{id}\',\'{typeName}\')">{typeName}</div></div></tpl>'].join('')
                    //}), {
                    }, {
                        xtype : 'container',
                        layout : 'vbox',
                        items : [{
                            cls:'order-margin',
                            html : '<div class="white-button fy-button jz-center" onclick="Ext.getCmp(\'selectMergePlaceView-view\').upPlaceType()"><img src="resources/icon/public/right-black.png"></div>'
                        }]
                    }]
                }, //Ext.create('Ext.DataView', {
                {
                    xtype : "container",
                    id : 'selectMergePlaceView-list',
                    flex : 1,
                    store : Ext.create('Ext.data.Store', {
                        id : 'selectmergeplaceview-store',
                        fields : ['id', 'placeName', 'sequence', 'remark', 'typeId', 'typeName', 'personNum', 'sellerId', 'parentSellerId', 'status', 'syned', 'isDelete', 'sellAmount', 'sellTime', 'sellAmountText', 'isPinPlace', 'sellTimeTxt', 'placePersonNum','teaPrice'],
                        data : []
                    }),
                    emptyText : '<div class="jz-center" style="font-size: 24px;margin-top: 50px;">无可选餐桌(￣▽￣)／</div>',
                    listeners : {
                        itemtap : function(list, index, target, record, e, eOpts) {
                            preventEventBubble(e);
                        },
                        itemtouchend : function(view, index, target, record, e, eOpts) {
                            if(record){
                                setTimeout(function() {
                                    $(".place-selected").removeClass('place-selected');
                                    $("#mergeplaceview" + record.get("id")).addClass("place-selected");
                                }, 50);
                            }
                        }
                    },
                    selectedCls : 'place-selected',
                    itemTpl : ['<tpl if="id == 0"><div class="place-dataview"><div class="addimg jz-center"><img src="resources/icon/public/add.png"/></div></div><tpl else> <div class="place-dataview"><div style="background: rgba(117,117,117,0.8);" class="cent place-status{status}" id="mergeplaceview{id}"><div style="width:100%;height:55px;" class="jz-center"><p style="word-break:break-word;">{placeName}</p><tpl if="isPinPlace==\'1\'"><div class="commoditynamepin"></div><tpl else><div class="commodityname{status}"></div></tpl></div><span id="mergeplaceSpan{id}" class="">人数:{placePersonNum}</span><span class="">{sellAmountText}</span><span>{sellTimeTxt}</span></div></tpl>'].join('')
                //}), {
                }, {
                    xtype : 'container',
                    layout : 'hbox',
                    hidden : false,
                    id : 'placeview-bar',
                    defaults : {
                        height : 40
                    },
                    items : [{
                        xtype : 'container',
                        layout : 'hbox',
                        width : 200,
                        margin:10,
                        defaults : {
                            width : 80,
                            xtype:'button'
                        },
                        items : []
                    }, {
                        xtype : 'spacer'
                    }, {
                        xtype : "container",
                        margin : '0 0 0 30',
                        html : '<div style="width:60px;height:30px;border-radius:10px;" class="white-button jz-center" onclick="Ext.getCmp(\'selectMergePlaceView-view\').downChangePlaceView()"><img src="resources/icon/public/left-black.png"></div>'
                    }, {
                        margin : '0 30',
                        xtype : 'container',
                        id : 'mergeplaceview-total-label',
                        html : '1/1'
                    }, {
                        xtype : "container",
                        margin : '0 30 0 0',
                        html : '<div style="width:60px;height:30px;border-radius:10px;" class="white-button jz-center" onclick="Ext.getCmp(\'selectMergePlaceView-view\').upChangePlaceView()"><img src="resources/icon/public/right-black.png"></div>'
                    }]
                }]
            }]
        },{
            xtype: 'container',
            id: 'selectMergePlaceSellDetail-panel',
            layout: 'hbox',
            hidden: true,
            flex: 1,
            style: 'padding: 0 10px;',
            items: [{
                xtype: 'container',
                flex: 1,
                id: 'selectCurrentMergePlace-panel',
                layout: {
                    type: 'vbox',
                    align: 'center'
                },
                items: [
                    {
                        xtype : 'container',
                        style: 'width:75%;height:40px;line-height:40px',
                        html: '<div class="selectMergePlace-title"><span>当前台位：</span><span id="selectCurrentMergePlace-title"></span></div>'
                    },
                    {
                        xtype: 'container',
                        height: 36,
                        style: 'width:75%;border: 1px solid rgba(0,0,0,0.1);border-bottom: none;',
                        html : '<div class="sy-putupQurey-header" style="width:100%;" ><div class="name">品名</div><div class="num" style="width:25%;">&nbsp;&nbsp;&nbsp;&nbsp;数量</div><div class="price">价格&nbsp;&nbsp;</div><div class="sellAmount">小计</div></div>'
                    },
                    //Ext.create('Ext.DataView', {
                    {
                        xtype : "container",
                        id: 'selectCurrentMergePlace-list',
                        flex: 1,
                        style: 'width:75%;border: 1px dashed rgba(0,0,0,0.1);background-color: rgba(220,220,220,0.2);',
                        scrollable: {
                            direction: 'vertical',
                            directionLock: true
                        },
                        store: Ext.create('Ext.data.Store', {
                            id: 'selectCurrentMergePlace-store',
                            model: 'Seller.model.SelectMergePlace',
                            data: []
                        }),
                        selectedCls : 'mergeplace-list-select',
                        itemCls: 'mergeplace-list-item',
                        itemTpl: new Ext.XTemplate('<div class="sy-commodity-list" style="min-height: 42px;width:100% !important;font-size:16px !important;"><div class="name jz-center sp-left">{commodityName}</div><div class="num jz-center">{sellNum}</div><div class="price jz-center">{sellPrice}</div><div class="sellAmount jz-center">{sellAmount}</div></div>')
                    //}),{
                    },{
                        xtype : 'container',
                        height : 34,
                        cls : 'sp-list-juci',
                        style : 'width:75%;border:none;'
                    }, {
                        xtype: 'container',
                        height: 30,
                        width: '75%',
                        //hidden: true,
                        style: 'text-align:right;line-height:30px;',
                        html: '<div><span>整单折扣&nbsp;&nbsp;</span><span id="current-mergeplace-discount">100%</span></div>'
                    },{
                        xtype: 'container',
                        height: 40,
                        width: '75%',
                        style: 'text-align:right;line-height:40px;margin-bottom:20px;font-size:20px;',
                        html: '<div><span>总金额&nbsp;&nbsp;</span><span><i style="font-style: normal;">￥</i><span id="current-mergeplace-sellAmount">0.00</span></span></div>'
                    }
                ]
            },{
                    xtype: 'container',
                    flex: 1,
                    id: 'selectTargetMergePlace-panel',
                    layout: {
                        type: 'vbox',
                        align: 'center'
                    },
                    items: [
                        {
                            xtype : 'container',
                            style: 'width:75%;height:40px;line-height:40px',
                            html: '<div class="selectMergePlace-title"><span>并入台位：</span><span id="selectTargetMergePlace-title"></span></div>'
                        },
                        {
                            xtype: 'container',
                            height: 36,
                            style: 'width:75%;border: 1px solid rgba(0,0,0,0.1);border-bottom: none;',
                            html : '<div class="sy-putupQurey-header" style="width:100%;" ><div class="name">品名</div><div class="num" style="width:25%;">&nbsp;&nbsp;&nbsp;&nbsp;数量</div><div class="price">价格&nbsp;&nbsp;</div><div class="sellAmount">小计</div></div>'
                        },
                        //Ext.create('Ext.DataView', {
                        {
                            xtype : "container",
                            id: 'selectTargetMergePlace-list',
                            flex: 1,
                            style: 'width:75%;border: 1px dashed rgba(0,0,0,0.1);background-color: rgba(220,220,220,0.2);',
                            scrollable: {
                                direction: 'vertical',
                                directionLock: true
                            },
                            store: Ext.create('Ext.data.Store', {
                                id: 'selectTargetMergePlace-store',
                                model: 'Seller.model.SelectMergePlace',
                                data: []
                            }),
                            selectedCls : 'mergeplace-list-select',
                            itemCls: 'mergeplace-list-item',
                            itemTpl: new Ext.XTemplate('<div class="sy-commodity-list" style="min-height: 42px;width:100% !important;font-size:16px !important;"><div class="name jz-center sp-left">{commodityName}</div><div class="num jz-center">{sellNum}</div><div class="price jz-center">{sellPrice}</div><div class="sellAmount jz-center">{sellAmount}</div></div>')
                        //}),{
                        },{
                            xtype : 'container',
                            height : 34,
                            cls : 'sp-list-juci',
                            style : 'width:75%;border:none;'
                        },{
                            xtype: 'container',
                            height: 30,
                            width: '75%',
                            //hidden: true,
                            style: 'text-align:right;line-height:30px;',
                            html: '<div><span>整单折扣&nbsp;&nbsp;</span><span id="target-mergeplace-discount">100%</span></div>'
                        },{
                            xtype: 'container',
                            height: 40,
                            width: '80%',
                            style: 'text-align:right;line-height:40px;margin-bottom:20px;font-size:20px;',
                            html:  '<div><span>总金额&nbsp;&nbsp;</span><span><i style="font-style: normal;">￥</i><span id="target-mergeplace-sellAmount">0.00</span></span></div>'
                        }
                    ]
                }
            ]
        }]
    },
    initialize : function(panel, eOpts) {

    },
    printOrderDetail: function(sellInfo, sellDetail, callback){
        PrintDao.printOrderInfoDetail(sellInfo, sellDetail, function (message) {
            if (message){
                callback && callback();
            }
        });
    },
    mergePlaceSellInfoCancel: function(sellInfo, callback){
        var sellAmount = sellInfo.sellAmount + nvlValue(sellInfo.teaAmount, 0);
        var totalAmount = sellInfo.totalAmount + nvlValue(sellInfo.teaAmount, 0);
        sellInfo.sellAmount = sellAmount;
        sellInfo.totalAmount = totalAmount;
        var sellId = sellInfo.id;
        SellDao.updateSellInfo({
            sellAmount : sellInfo.sellAmount,
            totalAmount : sellInfo.totalAmount,
            status : '3',
            endTime : new Date().format("yyyy-MM-dd hh:mm:ss"),
            syned : '0'
        }, sellId, function(success, res, resultData) {
            if (success) {
                SellDao.submitById(sellId, function(success) {
                });
                dealPlaceBySellId(sellId);
                callback && callback();
            } else {
                showAlert('提示', "撤销失败！");
            }
        });
    },
    concatSellDetail: function(addData, delData, cId, tId){//添加商品和删除商品信息
        var concatSellDetail = [];
        if(!addData || !delData){
            return concatSellDetail;
        }
        //组合销售详情表信息，sellDetail
        var _delData = JSON.parse(JSON.stringify(delData));
        var _addData = JSON.parse(JSON.stringify(addData));
        //添加销售详情，移出移入字段，mergeFromSellId 和 mergeToSellId
        for(var k = 0,leng = _addData.length; k < leng; k++){
            _addData[k].mergeFromSellId = cId;
            _addData[k].type = '1';
            _addData[k].hasKitchenPrinted = '1';
            _addData[k].hasTablePrinted = '1';
            _addData[k].hasLabelPrinted = '1';
        }
        for(var i = 0, len = _delData.length; i < len; i++){
            var sellNum = parseFloat(_delData[i].sellNum);
            var totalAmount = parseFloat(_delData[i].totalAmount);
            var sellAmount = parseFloat(_delData[i].sellAmount);
            var gainAmount = parseFloat(_delData[i].gainAmount);
            var costAmount = parseFloat(_delData[i].costAmount);
            var remarkAmount = parseFloat(_delData[i].remarkAmount);
            _delData[i].sellNum = !isNaN(sellNum) ? (-sellNum).toFixed(2) : 0;
            _delData[i].totalAmount = !isNaN(totalAmount) ? parseFloat(-totalAmount).toFixed(2) : 0;
            _delData[i].sellAmount = !isNaN(sellAmount) ? parseFloat(-sellAmount).toFixed(2) : 0;
            _delData[i].gainAmount = !isNaN(gainAmount) ? parseFloat(-gainAmount).toFixed(2) : 0;
            _delData[i].costAmount = !isNaN(costAmount) ? parseFloat(-costAmount).toFixed(2) : null;
            _delData[i].remarkAmount = !isNaN(remarkAmount) ? parseFloat(-remarkAmount).toFixed(2) : 0;
            _delData[i].isDelete = '1';
            _delData[i].id = createSellId(new Date(), "SD");//id不能重复
            _delData[i].mergeToSellId = cId;
            _delData[i].sellId = tId;
            _delData[i].hasKitchenPrinted = '1';
            _delData[i].hasTablePrinted = '1';
            _delData[i].hasLabelPrinted = '1';
        }
        concatSellDetail = _addData.concat(_delData);
        return concatSellDetail;
    },
    updateSellInfo: function(detailDatas, sellInfo, currentSellInfo){
        var data = {
            commodityNum: 0,
            totalAmount: 0,
            sellAmount: 0,
            roundAmount: 0,
            discountAmount:0,
            notDiscountAmount: 0,
            alreadyDiscountAmount: 0
        };
        //计算移菜后改变总金额，销售总价 * 整单折扣
        var discount = !isNaN(parseFloat(sellInfo.discount)) ? parseFloat(sellInfo.discount) : 100;
        //重新计算不可打折金额
        if(detailDatas){
            var sumPrice = 0;
            var commodityNum = 0;
            var notDiscountAmount = 0;
            for(var si = 0, len = detailDatas.length; si < len; si++){
                var sellAmount = parseFloat(detailDatas[si].sellAmount);
                var num = parseFloat(detailDatas[si].sellNum);
                sumPrice += sellAmount;
                commodityNum += num;
                notDiscountAmount += parseFloat(getNotDiscountAmount(detailDatas[si]));
            }
            data.notDiscountAmount = notDiscountAmount.toFixed(2);
            data.commodityNum = commodityNum.toFixed(2);
            data.totalAmount = sumPrice.toFixed(2);
            data.discountAmount = (sumPrice - notDiscountAmount).toFixed(2);//可打折金额
            //可打折金额 * 折扣 + 不可打折金额 = 销售金额
            data.sellAmount= ((((sumPrice - notDiscountAmount) * discount)/100) + notDiscountAmount).toFixed(2);
            data.alreadyDiscountAmount = ((((sumPrice - notDiscountAmount) * (100 - discount))/100)).toFixed(2);
            data.roundAmount = (roundByUnit(data.sellAmount, roundSetting.unit) - data.sellAmount).toFixed(2);

            for(var key in data){
                if(data.hasOwnProperty(key)){
                    sellInfo[key] = parseFloat(data[key]);
                }
            }

            sellInfo.syned = '0';
            sellInfo.personNum = parseFloat(sellInfo.personNum) + parseFloat(currentSellInfo.personNum);
            sellInfo.teaAmount = parseFloat(sellInfo.personNum * sellInfo.teaPrice).toFixed(2);
        }
    },
    hideViewListAndBtn: function(){
        Ext.getCmp('selectMergePlaceView-list-panel').parent.hide();
        Ext.getCmp('selectMergePlaceSellDetail-panel').show();
        Ext.getCmp('mergePlacePreviousBtn').show();
        Ext.getCmp('mergePlaceCompleteBtn').show();
        Ext.getCmp('mergePlaceBtn').hide();
    },
    showViewListAndBtn: function(){
        Ext.getCmp('selectMergePlaceView-list-panel').parent.show();
        Ext.getCmp('selectMergePlaceSellDetail-panel').hide();
        Ext.getCmp('mergePlacePreviousBtn').hide();
        Ext.getCmp('mergePlaceCompleteBtn').hide();
        Ext.getCmp('mergePlaceBtn').show();
    },
    addSellDetailByData: function(detail, id){
        //添加销售详情
        return new Promise(function(resolve, reject){
            SellDao.addSellDetails(detail, id, function(success, msg){
                if(success){
                    addComboMealsSelldetail(detail, function(success1) {
                        if (success1) { }
                        resolve();
                    });
                }
            });
        });
    },
    updateSellInfoByData: function(sellInfo, id){
        //更新销售信息
        return new Promise(function(resolve, reject){
            SellDao.updateSellInfo(sellInfo, id, function(success, msg){
                if(success){
                    resolve();
                }
            });
        });
    },
    getCurrSellInfoByPlacePinId: function(id){
        return new Promise(function(resolve, reject){
            SellDao.getCurrSellInfoByPlacePinId(id, function(success, sellInfo){
                if(success && sellInfo){
                    resolve(sellInfo);
                }
            });
        })
    },
    getSellDetailBySellId: function(id){
        return new Promise(function(resolve, reject){
            SellDao.loadSellDetail(id, function(success, sellDetail){
                if(success && sellDetail){
                    resolve(sellDetail);
                }
            });
        });
    },
    loadMergePlaceSellAmount: function(){
        var me = this;
        $('#current-mergeplace-sellAmount').text(roundByUnit(me.selectCurrentPlaceSellInfo.sellAmount, roundSetting.unit));
        $('#target-mergeplace-sellAmount').text(roundByUnit(me.selectTargetPlaceSellInfo.sellAmount, roundSetting.unit));
        $('#target-mergeplace-discount').text(parseFloat(me.selectTargetPlaceSellInfo.discount).toFixed(2) + '%');
        $('#current-mergeplace-discount').text(parseFloat(me.selectCurrentPlaceSellInfo.discount).toFixed(2) + '%');
    },
    getSellDetailAfterFilter: function(detail){
        if(!isArray(detail)){
            return;
        }
        var _detail = JSON.parse(JSON.stringify(detail));
        var deleteDetail = [];
        var normalDetail = [];
        //将删除的和正常的商品分开
        for(var j = 0, length = _detail.length; j < length; j++){
            if(_detail[j].isDelete == '1'){
                deleteDetail.push(_detail[j])
            }else{
                normalDetail.push(_detail[j])
            }
        }
        //没有删除的记录，直接返回
        if(deleteDetail.length == 0){
            return detail;
        }
        for(var k = 0, len = deleteDetail.length; k < len; k++){
            var delCommodityId = deleteDetail[k].commodityId;
            var delSellPrice  = deleteDetail[k].sellPrice;
            var delSellNum = parseFloat(deleteDetail[k].sellNum);
            for(var i = 0, size = normalDetail.length; i < size; i++){
                var norCommodityId = normalDetail[i].commodityId;
                var norSellPrice  = normalDetail[i].sellPrice;
                var norSellNum = parseFloat(normalDetail[i].sellNum);
                if((delCommodityId == norCommodityId) && (delSellPrice == norSellPrice)){
                    if(delSellNum < 0 && norSellNum > 0){
                        //删除的数量小于零才相加
                        normalDetail[i].sellNum = norSellNum + delSellNum;
                        delSellNum = norSellNum + delSellNum;

                        var sellPrice = normalDetail[i].sellPrice;
                        var commodityPrice = normalDetail[i].commodityPrice
                        var remarkPrice = normalDetail[i].remarkPrice ? normalDetail[i].remarkPrice : 0;
                        var costPrice = normalDetail[i].costPrice ? normalDetail[i].costPrice : 0;
                        normalDetail[i].sellAmount = parseFloat((sellPrice * normalDetail[i].sellNum)).toFixed(2);
                        normalDetail[i].totalAmount= parseFloat((remarkPrice + commodityPrice + costPrice) * normalDetail[i].sellNum).toFixed(2);
                        normalDetail[i].remarkAmount = parseFloat(remarkPrice * normalDetail[i].sellNum).toFixed(2);
                        normalDetail[i].gainAmount = parseFloat(normalDetail[i].sellAmount).toFixed(2);
                        normalDetail[i].costAmount = parseFloat(costPrice * normalDetail[i].sellNum).toFixed(2);
                        normalDetail[i].sellNum = parseFloat(normalDetail[i].sellNum).toFixed(2);
                    }
                }
            }
        }
        //再过滤掉数量为零的记录
        var resultDetail = [];
        for(var si = 0, long = normalDetail.length; si < long; si++){
            if(parseFloat(normalDetail[si].sellNum) > 0){
                resultDetail.push(normalDetail[si]);
            }
        }
        return resultDetail;
    },
    loadMergePlaceDetail: function(){
        var me = this;

        $('#selectCurrentMergePlace-title').text(me.selectCurrentPlace.placeName);
        $('#selectTargetMergePlace-title').text(me.selectTargetPlace.placeName);

        var selectCurrentMergePlaceStore = Ext.getCmp('selectCurrentMergePlace-list').getStore();
        var selectTargetMergePlaceStore = Ext.getCmp('selectTargetMergePlace-list').getStore();

        selectCurrentMergePlaceStore && selectCurrentMergePlaceStore.removeAll();
        selectTargetMergePlaceStore && selectTargetMergePlaceStore.removeAll();

        me.addMergePlaceStore(selectTargetMergePlaceStore, me.selectTargetPlaceSellDetail);
        me.addMergePlaceStore(selectCurrentMergePlaceStore, me.selectCurrentPlaceSellDetail);
    },
    addMergePlaceStore: function(store,sellDetail){
        if(!store || !sellDetail){
            return;
        }
        if(sellDetail.length > 0){
            for(var i = 0, len = sellDetail.length; i < len; i++){
                var _sellDetail = sellDetail[i];
                _sellDetail.sellAmount = parseFloat(_sellDetail.sellAmount).toFixed(2);
                _sellDetail.sellPrice = parseFloat(_sellDetail.sellPrice).toFixed(2);
                store.add(_sellDetail);
            }
        }
    },
    resetData : function() {
        var store = Ext.getStore('selectmergeplacetypeview-store');
        store.removeAll();
        this.clearplace();
    },
    loadData : function(placeId, sellInfo) {
        var me = Ext.getCmp('selectMergePlaceView-view');
        //拼桌或拼桌后的placeId多了'-'，需要做处理
        if(placeId.lastIndexOf('-') != -1){
            me.placeId = placeId.substring(0, placeId.lastIndexOf('-'));
        }else{
            me.placeId = placeId;
        }

        me.selectCurrentPlaceSellInfo = sellInfo;
        me.selectCurrentPlace = {
            placeName: sellInfo.placeName,
            sellId: sellInfo.id,
            sellAmount: sellInfo.sellAmount
        };
        this.clearPlaceType();
        this.getServicePlaceTypeTotalCount(me.placeId).
        then(function(result){
            var placetypeIds = [];
            for(var i = 0, len = result.length; i < len; i++){
                placetypeIds.push(result[i].typeId);
            }
            me.placetypeIds = placetypeIds;
            me.placeTypePage.countPage(placetypeIds.length);
            me.placeTypePage.reset();
            ServicePlaceDao.loadSelectPlaceTypePageById(placetypeIds, me.placeTypePage.getLimitCount(), 0, function(success, res){
                if(success && res){
                    me.loadServicePlaceType(res);
                }
            });
        }).
        catch(function(error){
            console.log('移菜分类查询出错', error);
        });
        //移菜分类优化
        ServicePlaceDao.getServicePlaceTypeTotalCountForOrder(me.placeId, function(success, result){
            if(success && result){
                var placetypeIds = [];
                for(var i = 0, len = result.length; i < len; i++){
                    placetypeIds.push(result[i].typeId);
                }
                me.placetypeIds = placetypeIds;
                me.placeTypePage.countPage(placetypeIds.length);
                me.placeTypePage.reset();
                ServicePlaceDao.loadSelectPlaceTypePageById(placetypeIds, me.placeTypePage.getLimitCount(), 0, function(success, res){
                    if(success && res){
                        me.loadServicePlaceType(res);
                    }
                });
            }
        });
        //保存选中餐桌销售详情
        this.getSellDetailBySellId(sellInfo.id).
        then(function(sellDetail){
            //保存并过滤删除的记录
            me.selectCurrentPlaceSellDetail = me.getSellDetailAfterFilter(sellDetail);
        }).
        catch(function(err){});
    },
    getServicePlaceTypeTotalCount: function(placeId){
        return new Promise(function(resolve, reject){
            ServicePlaceDao.getServicePlaceTypeTotalCountForOrder(placeId, function(success, result){
                if(success && result){
                    resolve(result);
                }else{
                    reject();
                }
            });
        });
    },
    loadServicePlaceType : function(datas) {
        var me = this;
        var store = Ext.getStore('selectmergeplacetypeview-store');
        var item;
        var first;
        store.removeAll();
        var firstId;
        for (var i = 0, len = datas.length; i < len; i++) {
            item = datas[i];
            store.add(item);
            if (i == 0) {
                currServicePlaceTypeId = item.id;
                firstId = item.id;
            }
        }
        if (firstId) {
            me.selectChangePlaceType(firstId);
            setTimeout(function() {
                $("#select-placetype-button-" + firstId).addClass('checkedbg');
            }, 100);
        }
    },
    /**
     * 清空
     */
    clearplace : function() {
        var store = Ext.getStore('selectmergeplaceview-store');
        store.removeAll();
    },
    refreshData : function(typeId) {
        var me = this;
        me.resetData();
        me.loadData();
    },
    /**
     * 加载商品
     * @param {Object} datas
     * @param {Object} typeId
     */
    loadplace : function(datas, typeId) {
        var me = this;
        me.clearplace();
        var store = Ext.getStore('selectmergeplaceview-store');
        var placeData;
        placeData = datas;
        store.add(placeData);
        for(var j=0,len=placeData.length;j<len;j++) {
            placeData[j].placePersonNum = placeData[j].personNum;
            var placeRecord = store.findRecord('id', placeData[j].id);
            placeRecord.set('placePersonNum', placeData[j].personNum);
            if(placeData[j].status == '1') {
                me.loadSellInfo(placeRecord);
            }
        }
    },
    loadSellInfo: function(record){
        var placeId = record.get("id");
        // 查看是否存在拼桌并填写开台时间(最早开台的时间)
        SellDao.getCurrSellInfoByPlaceIdPin(placeId, function(success, places) {
            if(success && places && places.length > 0) {
                var plen = places.length;
                var sellTime = new Date().format('yyyy-MM-dd hh:mm:ss');
                var sellAmount = 0;
                var totalAmount = 0;
                var discount = 100;
                var costAmount = (totalAmount * discount / 100);
                var personNum = 0;
                var curShowPlace = {};
                var showFactAmount = 0;
                for(var pi=0;pi<plen;pi++) {
                    if(places[pi].sellTime && places[pi].sellTime < sellTime) {
                        sellTime = places[pi].sellTime;
                        curShowPlace = places[pi];
                    }
                    personNum += places[pi].personNum ? places[pi].personNum : 0;
                    var tmpDiscount = places[pi].discount ? places[pi].discount : 100;
                    var tmpTotalAmount = places[pi].totalAmount ? places[pi].totalAmount : 0;
                    showFactAmount += parseFloat(tmpTotalAmount * (tmpDiscount/100));
                }
                sellAmount = curShowPlace.sellAmount ? curShowPlace.sellAmount : 0;
                totalAmount = curShowPlace.totalAmount ? curShowPlace.totalAmount : 0;
                discount = curShowPlace.discount ? curShowPlace.discount : 100;
                costAmount = (totalAmount * discount / 100);
                //personNum = curShowPlace.personNum;
                record.set('sellAmount', sellAmount);
                //record.set('sellAmountText', '消费:' + parseFloat(costAmount).toFixed(2));
                record.set('sellAmountText', '消费:' + parseFloat(showFactAmount).toFixed(2));
                //record.set('personNum', personNum);
                record.set('placePersonNum', personNum);
                record.set('sellTime', sellTime);

                if(!sellTime || sellTime.length < 16) return;
                /*var placeSellTime = sellTime.substring(11, 16);
                var placeDate = new Date(sellTime);
                var curSysDate = new Date();
                var placeSellTimeTxt = placeSellTime + '';
                var pvExeTime = loadPlaceViewExeTime(placeDate, curSysDate);
                placeSellTimeTxt += pvExeTime;
                if(sellTime)
                    record.set('sellTimeTxt', placeSellTimeTxt);
                else
                    record.set("sellTimeTxt", '');*/
            } else {
                //待清台label显示
                record.set('sellTimeTxt', '(待清台)');
            }
        });
        SellDao.getCurrSellInfoByPlaceIdPin(placeId, function(success, pinSellInfos) {
            var isPinPlace = false;
            if(success && pinSellInfos && pinSellInfos.length > 1) {
                isPinPlace = true;
            }
            record.set('isPinPlace', isPinPlace);
        });
    },
    deletePlace : function(record) {
        var store = Ext.getStore('selectmergeplaceview-store');
        store.remove(record);
    },
    deletePlaceType : function(record) {
        var store = Ext.getStore('selectmergeplacetypeview-store');
        store.remove(record);
    },
    upPlaceType : function() {
        var me = this;
        Ext.getCmp('selectMergePlaceView-view').clearPlaceType();
        me.placeTypePage.up();
        ServicePlaceDao.loadSelectPlaceTypePageById(me.placetypeIds, me.placeTypePage.getLimitCount(), me.placeTypePage.getOffset(), function(success, res){
            if(success && res){
                me.loadServicePlaceType(res);
            }
        });
    },
    downPlaceType : function() {
        var me = this;
        Ext.getCmp('selectMergePlaceView-view').clearPlaceType();
        me.placeTypePage.down();
        ServicePlaceDao.loadSelectPlaceTypePageById(me.placetypeIds, me.placeTypePage.getLimitCount(), me.placeTypePage.getOffset(), function(success, res){
            if(success && res){
                me.loadServicePlaceType(res);
            }
        });
    },
    getPlaceTypeTotalPage : function(callBack) {
        var me = this;
        ServicePlaceDao.getPlaceTypeTotalCount(function(success, totalCount) {
            if (success) {
                me.placeTypePage.countPage(totalCount);
                if (callBack) {
                    callBack(true);
                }
            } else {
                if (callBack) {
                    callBack(false);
                }
            }
        });
    },
    clearPlaceType : function() {
        var store = Ext.getStore('selectmergeplaceview-store');
        store.removeAll();
        this.clearplace();
    },

    /**
     * 点击分类
     */
    serviceChangePlaceTypeClick : function(element, id, name) {
        var me = Ext.getCmp('selectMergePlaceView-view');
        if (!name) {
            return;
        }
        Ext.query(".placetype-button", Ext.getDom('selectMergePlaceView-view')).forEach(function(element, index, array) {
            Ext.get(element).removeCls('checkedbg');
        });
        Ext.get(element).addCls('checkedbg');
        me.selectChangePlaceType(id);
    },
    selectChangePlaceType : function(id) {
        var me = Ext.getCmp('selectMergePlaceView-view');
        var currPlaceId = me.placeId;
        me.clearplace();
        me.currPlaceTypeId = id;
        me.placeViewPage.setCurrPage(1);
        me.getChangePlaceViewTotalPageByTypeId(id, function(success) {
            if (success) {
                ServicePlaceDao.loadSelectPlacePageByTypeIdForOrder(id, currPlaceId, me.placeViewPage.getLimitCount(), me.placeViewPage.getOffset(), function(success, res) {
                    if (success && res) {
                        Ext.getCmp('selectMergePlaceView-view').loadplace(res, id);
                    }
                });
            }
        });
    },
    getChangePlaceViewTotalPageByTypeId : function(currPlaceTypeId, callBack) {
        var me = Ext.getCmp('selectMergePlaceView-view');
        var currPlaceId = me.placeId;
        ServicePlaceDao.getSelectPlaceTotalCountByTypeIdForOrder(currPlaceTypeId, currPlaceId, function(success, totalCount) {
            if (success) {
                me.placeViewPage.countPage(totalCount);
                Ext.getCmp('mergeplaceview-total-label').setHtml(me.placeViewPage.getCurrPage() + "/" + me.placeViewPage.getTotalPage());
                if (callBack) {
                    callBack(true);
                }
            } else {
                if (callBack) {
                    callBack(false);
                }
            }
        });
    },
    /**
     * 向上滚动
     */
    upChangePlaceView : function() {
        var me = this;
        var currPlaceId = me.placeId;
        if (!me.currPlaceTypeId) {
            showAlert("提示", "请先增加分类！");
            return;
        }
        //me.placeViewPage.up();
        upThingPage(me.placeViewPage, function(startPage, endPage) {
            Ext.getCmp('selectMergePlaceView-view').clearplace();
            ServicePlaceDao.loadSelectPlacePageByTypeIdForOrder(me.currPlaceTypeId, currPlaceId, me.placeViewPage.getLimitCount(), me.placeViewPage.getOffset(), function(success, res) {
                if (success) {
                    me.loadplace(res, me.currPlaceTypeId);
                }
            });
            Ext.getCmp('mergeplaceview-total-label').setHtml(me.placeViewPage.getCurrPage() + "/" + me.placeViewPage.getTotalPage());
        });
    },
    /**
     * 向下滚动
     */
    downChangePlaceView : function() {
        var me = this;
        var currPlaceId = me.placeId;
        if (!me.currPlaceTypeId) {
            showAlert("提示", "请先增加分类！");
            return;
        }
        //me.placeViewPage.down();
        downThingPage(me.placeViewPage, function(startPage, endPage) {
            me.clearplace();
            ServicePlaceDao.loadSelectPlacePageByTypeIdForOrder(me.currPlaceTypeId, currPlaceId, me.placeViewPage.page.limitCount, me.placeViewPage.getOffset(), function(success, res) {
                if (success) {
                    Ext.getCmp('selectMergePlaceView-view').loadplace(res, me.currPlaceTypeId);
                }
            });
            Ext.getCmp('mergeplaceview-total-label').setHtml(me.placeViewPage.getCurrPage() + "/" + me.placeViewPage.getTotalPage());
        });
    }
});
