/**
 *@Author: Xiongzp
 *@Date: 2018-07-12
 */
Ext.define('Seller.view.place.SelectRemovePlaceView', {
    extend : 'Ext.Container',
    alias : 'widget.selectremoveplaceview',
    autoDestroy : true,
    currPlaceTypeId : null,
    currentRemovePlaceDatas: [],
    targetRemovePlaceDatas: [],
    //分页工具
    placeTypePage : new $.PageUtil({
        limitCount : 8
    }),
    placeViewPage : new $.PageUtil({
        limitCount : 15
    }),
    config : {
        layout : 'vbox',
        centered : true,
        height : '100%',
        cls : 'select-place-opt-view',
        id : 'selectRemovePlaceView-view',
        items : [{
            xtype : 'toolbar',
            title : '移菜',
            docked : 'top',
            items : [{
                xtype : 'button',
                //cls : 'close-button',
                cls : 'close-button-complete',
                width : 80,
                iconCls : 'close-icon',
                icon : 'resources/icon/public/back.png',
                text : '返回',
                id : 'select-removeplace-view-close',
                handler : function() {
                    var sellInfo = Ext.getCmp('selectRemovePlaceView-view').selectCurrentPlaceSellInfo;
                    console.log('操作单据：餐桌' + sellInfo.placeName + '（订单号' + sellInfo.id + '）取消了移菜--' + new Date().format('yyyy-MM-dd hh:mm:ss'))
                    Ext.getCmp('selectRemovePlaceView').hide();
                    Ext.getCmp('selectRemovePlaceView-list-panel').parent.show();
                    Ext.getCmp('selectRemovePlaceSellDetail-panel').hide();
                    Ext.getCmp('removePlacePreviousBtn').hide();
                    Ext.getCmp('removePlaceCompleteBtn').hide();
                    Ext.getCmp('removePlaceBtn').show();
                    Ext.getCmp('selectRemovePlaceView-view').resetSelectPlaceViewData();
                }
            }, {
                xtype : 'spacer'
            }, {
                xtype : 'ebutton',
                id : 'removePlacePreviousBtn',
                width: 100,
                style: 'font-size:16px;',
                text : '上一步',
                hidden: true,
                handler : function() {
                    timeoutDisable('removePlacePreviousBtn');
                    var placeView = Ext.getCmp('selectRemovePlaceView-view');
                    console.log('操作单据：餐桌' + placeView.selectCurrentPlace.placeName + '取消了向餐桌' + placeView.selectTargetPlace.placeName + '的移菜--' + new Date().format('yyyy-MM-dd hh:mm:ss'))
                    placeView.showViewListAndBtn();
                    placeView.resetSelectPlaceViewData();
                }
            },{
                xtype : 'ebutton',
                id : 'removePlaceBtn',
                width: 100,
                style: 'font-size:16px;',
                text : '选择台位',
                handler : function() {
                    timeoutDisable('removePlaceBtn');
                    var me = Ext.getCmp('selectRemovePlaceView-view');
                    var removePlaceList  = Ext.getCmp('selectRemovePlaceView-list');
                    var removePlaceStore = removePlaceList.getStore();
                    if(removePlaceList.getSelection().length > 0){
                        var record = removePlaceList.getSelection()[0];
                        var placeId = record.get('id');
                        getAllPinPlace(placeId, function(success, pinSellInfos){
                            if(success && pinSellInfos.length > 1){
                                var selectPinPlaceView = Ext.getCmp('selectPinPlaceView');
                                if(!selectPinPlaceView) {
                                    selectPinPlaceView = Ext.Viewport.add({
                                        xtype : 'panel',
                                        modal : true,
                                        centered : true,
                                        hideOrMaskTap : false,
                                        id : 'selectPinPlaceView',
                                        width : 300,
                                        height : 400,
                                        items : [{
                                            xtype: 'toolbar',
                                            title: '请选择移菜台位',
                                            height: 50,
                                            docked: 'top',
                                            items: [{
                                                    xtype: 'button',
                                                    cls: 'close-button',
                                                    handler: function () {
                                                        if (Ext.getCmp('selectPinPlaceView'))
                                                            Ext.getCmp('selectPinPlaceView').destroy();
                                                    }
                                                }, {
                                                    xtype: 'spacer'
                                                }, {
                                                    xtype: 'button',
                                                    cls: 'sy-tm-button',
                                                    text: '确认',
                                                    hidden: true,
                                                    handler: function () {
                                                    }
                                                }]
                                        }, {
                                            xtype : 'list',
                                            id : 'select-pin-place-list',
                                            //height : 224,
                                            height : 350,
                                            margin : '0 0 0 0',
                                            store : Ext.create("Ext.data.Store", {
                                                id:'select-pin-place-store',
                                                fields : ['id', 'placeName', 'oldPlaceId', 'status'],
                                                data : []
                                            }),
                                            selectedCls : 'checkedbg',
                                            itemTpl : new Ext.XTemplate('<div class="sy-commodity-list" style="width:300px !important;border-bottom:1px solid #ccc;"><div class="name jz-center" style="width:100%!important;">{placeName}</div></div>'),
                                            isAfterrendered : false, //添加一个变量，用于检测afterrender是否已经发生
                                            listeners : {
                                                itemtap : function(list, index, target, record, e, eOpts) {
                                                    preventEventBubble(e);
                                                    if (record) {
                                                        if(me.selectCurrentPlace.placeName == record.get('placeName')){
                                                            showAlert("提示", "不能选择相同的拼桌台位！");
                                                            return;
                                                        }
                                                        if(record.get('status') == '-1'){
                                                            showAlert("提示", "不能选择挂单的台位移菜！");
                                                            return;
                                                        }
                                                        SellDao.getCurrSellInfoByPlacePinId(record.get("id"), function(success, sellInfo) {
                                                            if (success && sellInfo) {
                                                                me.getCurrSellInfoByPlacePinId(sellInfo.placeId).
                                                                    then(function(sellInfo){
                                                                        me.selectTargetPlaceSellInfo = sellInfo;
                                                                        me.selectTargetPlaceName = sellInfo.placeName;
                                                                        var sellId = sellInfo.id;
                                                                        me.selectTargetPlace = {
                                                                            placeName: sellInfo.placeName,
                                                                            sellId: sellId
                                                                        };
                                                                    console.log('操作单据：餐桌' + me.selectCurrentPlace.placeName + '选择向餐桌' + me.selectTargetPlace.placeName + '进行移菜--' + new Date().format('yyyy-MM-dd hh:mm:ss'))
                                                                        return me.getSellDetailBySellId(sellId);
                                                                    }).
                                                                    then(function(sellDetail){
                                                                        //保存并过滤删除的销售信息
                                                                        me.selectTargetPlaceSellDetail = me.getSellDetailAfterFilter(sellDetail);
                                                                        me.hideViewListAndBtn();
                                                                        me.loadRemovePlaceDetail();
                                                                        me.loadRemovePlaceSellAmount();
                                                                    }).
                                                                    catch(function(err){});
                                                            } else {
                                                                showAlert("提示", "该餐桌没人用餐,可以清台!");
                                                            }
                                                        });
                                                    }
                                                    Ext.getCmp('selectPinPlaceView').destroy();
                                                },
                                                itemtouchmove : function(list, index, target, record, e, eOpts) {
                                                },
                                                itemdoubletap : function(list, index, target, record, e, eOpts) {

                                                }
                                            }
                                        }]
                                    });
                                }
                                showBy(selectPinPlaceView,Ext.getCmp('selectRemovePlaceView-view'),100);
                                var selectPinPlaceStore = Ext.getStore('select-pin-place-store');
                                for(var pi=0,pilen=pinSellInfos.length;pi<pilen;pi++) {
                                    selectPinPlaceStore.add({
                                        id: pinSellInfos[pi].placeId,
                                        placeName: pinSellInfos[pi].placeName,
                                        oldPlaceId: record.get('id'),
                                        status: pinSellInfos[pi].status
                                    });
                                }
                            }else if(pinSellInfos && pinSellInfos.length > 0){
                                if(pinSellInfos[0].status == '-1'){
                                    showAlert("提示", "当前选中餐桌为挂单状态，请下单后再进行移菜！");
                                    return;
                                }
                                me.getCurrSellInfoByPlacePinId(pinSellInfos[0].placeId).
                                    then(function(sellInfo){
                                        me.selectTargetPlaceSellInfo = sellInfo;
                                        me.selectTargetPlaceName = sellInfo.placeName;
                                        var sellId = sellInfo.id;
                                        me.selectTargetPlace = {
                                            placeName: sellInfo.placeName,
                                            sellId: sellId
                                        };
                                    console.log('操作单据：餐桌' + me.selectCurrentPlace.placeName + '选择向餐桌' + me.selectTargetPlace.placeName + '进行移菜--' + new Date().format('yyyy-MM-dd hh:mm:ss'))
                                        return me.getSellDetailBySellId(sellId);
                                    }).
                                    then(function(sellDetail){
                                        me.hideViewListAndBtn();
                                        me.selectTargetPlaceSellDetail = me.getSellDetailAfterFilter(sellDetail);
                                        me.loadRemovePlaceDetail();
                                        me.loadRemovePlaceSellAmount();
                                    }).
                                    catch(function(err){});
                            }else if(pinSellInfos && pinSellInfos.length == 0){
                                showAlert("提示", "该餐桌没人用餐,请先清台!");
                            }
                        });
                    }else{
                        $(".place-selected").removeClass('place-selected');
                        showAlert('提示', '请先选择台位！');
                    }
                }
            }, {
                xtype : 'ebutton',
                id : 'removePlaceCompleteBtn',
                width: 100,
                style: 'font-size:16px;',
                text : '完成',
                hidden: true,
                handler : function() {
                    timeoutDisable('removePlaceCompleteBtn');
                    var removePlaceView = Ext.getCmp('selectRemovePlaceView-view');

                    var currentRemovePlaceList  = Ext.getCmp('selectCurrentRemovePlace-list');
                    var targetRemovePlaceList  = Ext.getCmp('selectTargetRemovePlace-list');
                    //当前台位信息
                    var selectCurrentPlaceSellInfo = removePlaceView.selectCurrentPlaceSellInfo;
                    var currentRemovePlaceDatas = removePlaceView.currentRemovePlaceDatas;
                    //目标台位信息
                    var selectTargetPlaceSellInfo = removePlaceView.selectTargetPlaceSellInfo;
                    var targetRemovePlaceDatas = removePlaceView.targetRemovePlaceDatas;

                    if(currentRemovePlaceDatas.length == 0 && targetRemovePlaceDatas.length == 0){
                        showAlert('提示','当前台位菜品未变动！');
                        return;
                    }
                    console.log('操作单据：餐桌' + selectCurrentPlaceSellInfo.placeName + '完成了对餐桌' + selectTargetPlaceSellInfo.placeName + '的移菜--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
                    var targetSellDetails = createSellDetailsByData(targetRemovePlaceDatas, selectTargetPlaceSellInfo);
                    var currentSellDetails = createSellDetailsByData(currentRemovePlaceDatas, selectCurrentPlaceSellInfo);
                    var targetPlaceSellId = selectTargetPlaceSellInfo.id;
                    var currentPlaceSellId = selectCurrentPlaceSellInfo.id;

                    //合并目标台位销售详情，删除和增加的
                    var targetSellDetail = removePlaceView.concatSellDetail(targetSellDetails, currentSellDetails, currentPlaceSellId, targetPlaceSellId);
                    //合并当前台位销售详情，删除和增加的
                    var currentSellDetail = removePlaceView.concatSellDetail(currentSellDetails, targetSellDetails, targetPlaceSellId, currentPlaceSellId);
                    showLoading("正在处理，请稍后...");
                    removePlaceView.addSellDetailByData(targetSellDetail, selectTargetPlaceSellInfo.id).
                        then(function(){
                            return removePlaceView.addSellDetailByData(currentSellDetail, selectCurrentPlaceSellInfo.id);
                        }).
                        then(function(){
                            //更新销售信息表
                             return removePlaceView.updateSellInfoByData(selectTargetPlaceSellInfo, selectTargetPlaceSellInfo.id);
                        }).
                        then(function(){
                            //更新销售信息表
                            return removePlaceView.updateSellInfoByData(selectCurrentPlaceSellInfo, selectCurrentPlaceSellInfo.id);
                        }).
                        then(function(){
                            //如果餐桌菜品移除完，撤销订单。
                            if(currentRemovePlaceList.getStore().getAllCount() <= 0){
                                var cancelSellInfo = selectCurrentPlaceSellInfo;
                            }else if(targetRemovePlaceList.getStore().getAllCount() <= 0){
                                var cancelSellInfo = selectTargetPlaceSellInfo;
                            }
                            if(cancelSellInfo){
                                removePlaceView.removePlaceSellInfoCancel(cancelSellInfo, function(){});
                            }

                            removePlaceView.showViewListAndBtn();
                            removePlaceView.resetSelectPlaceViewData();
                            Ext.getCmp('selectRemovePlaceView').hide();
                            refreshPlace();
                            closeLoading();
                        }).
                        catch(function(err){
                            console.log('removePlace error', err.message);
                            removePlaceView.showViewListAndBtn();
                            removePlaceView.resetSelectPlaceViewData();
                            Ext.getCmp('selectRemovePlaceView').hide();
                            closeLoading();
                        });
                }
            }]
        }, {
            xtype : 'container',
            layout : 'hbox',
            flex : 1,
            items : [{
                flex : 1,
                layout : 'vbox',
                id : 'selectRemovePlaceView-list-panel',
                items : [{
                    xtype : 'container',
                    id : 'selectRemovePlaceTypeView-list-panel',
                    layout : 'hbox',
                    height : 55,
                    items : [{
                        xtype : 'container',
                        layout : 'vbox',
                        items : [{
                            cls:'order-margin',
                            html : '<div class="white-button fy-button jz-center" onclick="Ext.getCmp(\'selectRemovePlaceView-view\').downPlaceType()"><img src="resources/icon/public/left-black.png"></div>'
                        }]
                    }, Ext.create('Ext.DataView', {
                        id : 'selectRemovePlaceTypeView-list',
                        cls : 'placetype-dataview',
                        scrollable : false,
                        flex : 1,
                        store : Ext.create('Ext.data.Store', {
                            id : 'selectremoveplacetypeview-store',
                            model : 'Seller.model.ServicePlaceType',
                            data : []
                        }),
                        itemTpl : ['<tpl if="id == 0"><div  class="commodityType"><div class="white-button placetype-button jz-center"><img src="resources/icon/public/tianjia.png" /></div></div><tpl else><div  class="commodityType"><div class="white-button placetype-button jz-center" id="select-placetype-button-{id}"  onclick="Ext.getCmp(\'selectRemovePlaceView-view\').serviceChangePlaceTypeClick(this,\'{id}\',\'{typeName}\')">{typeName}</div></div></tpl>'].join('')
                    }), {
                        xtype : 'container',
                        layout : 'vbox',
                        items : [{
                            cls:'order-margin',
                            html : '<div class="white-button fy-button jz-center" onclick="Ext.getCmp(\'selectRemovePlaceView-view\').upPlaceType()"><img src="resources/icon/public/right-black.png"></div>'
                        }]
                    }]
                }, Ext.create('Ext.DataView', {
                    id : 'selectRemovePlaceView-list',
                    flex : 1,
                    store : Ext.create('Ext.data.Store', {
                        id : 'selectremoveplaceview-store',
                        fields : ['id', 'placeName', 'sequence', 'remark', 'typeId', 'typeName', 'personNum', 'sellerId', 'parentSellerId', 'status', 'syned', 'isDelete', 'sellAmount', 'sellTime', 'sellAmountText', 'isPinPlace', 'sellTimeTxt', 'placePersonNum','teaPrice'],
                        data : []
                    }),
                    emptyText : '<div class="jz-center" style="font-size: 24px;margin-top: 50px;">无可选餐桌(￣▽￣)／</div>',
                    listeners : {
                        itemtap : function(list, index, target, record, e, eOpts) {
                            preventEventBubble(e);
                        },
                        itemtouchend : function(view, index, target, record, e, eOpts) {
                            if(record){
                                setTimeout(function() {
                                    $(".place-selected").removeClass('place-selected');
                                    $("#removeplaceview" + record.get("id")).addClass("place-selected");
                                }, 50);
                            }
                        }
                    },
                    selectedCls : 'place-selected',
                    itemTpl : ['<tpl if="id == 0"><div class="place-dataview"><div class="addimg jz-center"><img src="resources/icon/public/add.png"/></div></div><tpl else> <div class="place-dataview"><div style="background: rgba(117,117,117,0.8);" class="cent place-status{status}" id="removeplaceview{id}"><div style="width:100%;height:52%;font-size:24px;" class="jz-center"><p style="word-break:break-word;">{placeName}</p><tpl if="isPinPlace==\'1\'"><div class="commoditynamepin"></div><tpl else><div class="commodityname{status}"></div></tpl></div><span id="removeplaceSpan{id}" class="">人数:{placePersonNum}</span><span class="">{sellAmountText}</span><span>{sellTimeTxt}</span></div></tpl>'].join('')
                }), {
                    xtype : 'container',
                    layout : 'hbox',
                    hidden : false,
                    id : 'placeview-bar',
                    defaults : {
                        height : 40
                    },
                    items : [{
                        xtype : 'container',
                        layout : 'hbox',
                        width : 200,
                        margin:10,
                        defaults : {
                            width : 80,
                            xtype:'button'
                        },
                        items : []
                    }, {
                        xtype : 'spacer'
                    }, {
                        xtype : "container",
                        margin : '0 0 0 30',
                        html : '<div style="width:60px;height:30px;border-radius:10px;" class="white-button jz-center" onclick="Ext.getCmp(\'selectRemovePlaceView-view\').downChangePlaceView()"><img src="resources/icon/public/left-black.png"></div>'
                    }, {
                        margin : '0 30',
                        xtype : 'container',
                        id : 'removeplaceview-total-label',
                        html : '1/1'
                    }, {
                        xtype : "container",
                        margin : '0 30 0 0',
                        html : '<div style="width:60px;height:30px;border-radius:10px;" class="white-button jz-center" onclick="Ext.getCmp(\'selectRemovePlaceView-view\').upChangePlaceView()"><img src="resources/icon/public/right-black.png"></div>'
                    }]
                }]
            }]
        },{
            xtype: 'panel',
            id: 'selectRemovePlaceSellDetail-panel',
            layout: 'hbox',
            hidden: true,
            flex: 1,
            style: 'padding: 0 10px;',
            items: [
                {
                    xtype: 'panel',
                    flex: 1,
                    id: 'selectCurrentRemovePlace-panel',
                    layout: {
                        type: 'vbox',
                        align: 'center'
                    },
                    items: [
                        {
                            xtype : 'container',
                            style: 'width:80%;height:40px;line-height:40px',
                            html: '<div class="selectRemovePlace-title"><span>当前台位：</span><span id="selectCurrentRemovePlace-title"></span></div>'
                        },
                        {
                            xtype: 'container',
                            height: 36,
                            style: 'width:80%;border: 1px solid rgba(0,0,0,0.1);border-bottom: none;',
                            html : '<div class="sy-putupQurey-header" style="width:100%;" ><div class="name">品名</div><div class="num" style="width:25%;">&nbsp;&nbsp;&nbsp;&nbsp;数量</div><div class="price">价格&nbsp;&nbsp;</div><div class="sellAmount">小计</div></div>'
                        },
                         Ext.create('Ext.DataView', {
                             id: 'selectCurrentRemovePlace-list',
                             flex: 1,
                             style: 'width:80%;border: 1px dashed rgba(0,0,0,0.1);background-color: rgba(220,220,220,0.2);',
                             scrollable: {
                                 direction: 'vertical',
                                 directionLock: true
                             },
                             store: Ext.create('Ext.data.Store', {
                                 id: 'selectCurrentRemovePlace-store',
                                 model: 'Seller.model.SelectRemovePlace',
                                 data: []
                             }),
                             selectedCls : 'removeplace-list-select',
                             itemCls: 'removeplace-list-item',
                             itemTpl: new Ext.XTemplate('<div class="sy-commodity-list" style="min-height: 42px;width:100% !important;font-size:16px !important;"><div class="name jz-center sp-left">{commodityName}</div><div class="num jz-center">{sellNum}</div><div class="price jz-center">{sellPrice}</div><div class="sellAmount jz-center">{sellAmount}</div></div>')
                         }),{
                            xtype : 'container',
                            height : 34,
                            cls : 'sp-list-juci',
                            style : 'width:80%;border:none;'
                        },{
                            xtype: 'container',
                            height: 30,
                            width: '80%',
                            style: 'text-align:right;line-height:30px;',
                            html: '<div><span>整单折扣&nbsp;&nbsp;</span><span id="current-removeplace-discount">100%</span></div>'
                        },{
                            xtype: 'container',
                            height: 40,
                            width: '80%',
                            style: 'text-align:right;line-height:40px;margin-bottom:20px;font-size:20px;',
                            html: '<div><span>总金额&nbsp;&nbsp;</span><span><i style="font-style: normal;">￥</i><span id="current-removeplace-sellAmount">0.00</span></span></div>'
                        }
                    ]
                },{
                    xtype: 'container',
                    width: 90,
                    layout: 'vbox',
                    items:[
                        {
                            xtype: 'container',
                            height: 75
                        },
                        {
                            xtype: 'container',
                            layout: {
                                type: 'vbox'
                            },
                            flex: 1,
                            width: 90,
                            items: [
                                {
                                    xtype: 'container',
                                    height: 30
                                },
                                {
                                    xtype: 'ebutton',
                                    text : '>>',
                                    width: 80,
                                    height: 40,
                                    style: 'border-radius:18px;color:rgba(153,153,153,0.6);background: #e8e8e8;font-size:22px;border:none;-webkit-box-shadow: 1px 1px 5px #ccc inset, -1px -1px 5px #ccc inset',
                                    id: 'removeAllToTargetBtn',
                                    handler: function(){
                                        var selectRemovePlaceView = Ext.getCmp('selectRemovePlaceView-view');
                                        var currentRemovePlaceList  = Ext.getCmp('selectCurrentRemovePlace-list');
                                        var targetRemovePlaceList  = Ext.getCmp('selectTargetRemovePlace-list');
                                        var currentRemovePlaceStore = currentRemovePlaceList.getStore();
                                        var targetRemovePlaceStore = targetRemovePlaceList.getStore();
                                        var currentPlaceSellInfo = selectRemovePlaceView.selectCurrentPlaceSellInfo;
                                        var targetPlaceSellInfo = selectRemovePlaceView.selectTargetPlaceSellInfo;

                                        var targetSellDetail = selectRemovePlaceView.selectTargetPlaceSellDetail;
                                        var currentSellDetail = selectRemovePlaceView.selectCurrentPlaceSellDetail;

                                        if(!currentRemovePlaceStore || (currentRemovePlaceStore.getAllCount() == 0) || !targetRemovePlaceStore){
                                            return;
                                        }

                                        //先清空store所有数据，再全部添加进目标store
                                        currentRemovePlaceStore.removeAll();
                                        targetRemovePlaceStore.removeAll();
                                        selectRemovePlaceView.addRemovePlaceStore(targetRemovePlaceStore, targetSellDetail);
                                        selectRemovePlaceView.addRemovePlaceStore(targetRemovePlaceStore, currentSellDetail);

                                        //先清空数据数据，再添加
                                        var targetDatas = selectRemovePlaceView.targetRemovePlaceDatas;
                                        var currentDatas = selectRemovePlaceView.currentRemovePlaceDatas;
                                        targetDatas.length = 0;
                                        currentDatas.length= 0;
                                        for(var i = 0, len = currentSellDetail.length; i < len; i++){
                                            targetDatas.push(currentSellDetail[i]);
                                        }

                                        //更新移菜后sellInfo的信息
                                        selectRemovePlaceView.updateSellInfo(currentRemovePlaceList.getStore(), currentPlaceSellInfo);
                                        selectRemovePlaceView.updateSellInfo(targetRemovePlaceList.getStore(), targetPlaceSellInfo);
                                        console.log('操作单据：餐桌' + currentPlaceSellInfo.placeName + '(订单号' + currentPlaceSellInfo.id + ')的菜品全部移向了餐桌' + targetPlaceSellInfo.placeName + '(订单号' + targetPlaceSellInfo.id + ')--' + new Date().format('yyyy-MM-dd hh:mm:ss'))
                                        $('#current-removeplace-sellAmount').text(roundByUnit(currentPlaceSellInfo.sellAmount, roundSetting.unit));
                                        $('#target-removeplace-sellAmount').text(roundByUnit(targetPlaceSellInfo.sellAmount, roundSetting.unit));

                                        showAlert('提示', '当前台位菜品被移完，将会被清台！');

                                    }
                                },{
                                    xtype: 'container',
                                    height: 14
                                },
                                {
                                    xtype: 'ebutton',
                                    text: '>',
                                    width: 80,
                                    height: 40,
                                    style: 'border-radius:18px;color:rgba(153,153,153,0.6);background: #e8e8e8;font-size:22px;border:none;-webkit-box-shadow: 1px 1px 5px #ccc inset, -1px -1px 5px #ccc inset',
                                    id: 'removeToTargetBtn',
                                    handler: function(){
                                        var selectRemovePlaceView = Ext.getCmp('selectRemovePlaceView-view');
                                        var currentRemovePlaceList  = Ext.getCmp('selectCurrentRemovePlace-list');
                                        var targetRemovePlaceList  = Ext.getCmp('selectTargetRemovePlace-list');
                                        var currentRemovePlaceStore = currentRemovePlaceList.getStore();
                                        var targetRemovePlaceStore = targetRemovePlaceList.getStore();
                                        var currentPlaceSellInfo = selectRemovePlaceView.selectCurrentPlaceSellInfo;
                                        var targetPlaceSellInfo = selectRemovePlaceView.selectTargetPlaceSellInfo;

                                        if(currentRemovePlaceList.getSelection().length == 0){
                                            return;
                                        }
                                        var currentRemoveRecord = currentRemovePlaceList.getSelection()[0];
                                        currentRemovePlaceStore.remove(currentRemoveRecord);
                                        targetRemovePlaceStore.addData(currentRemoveRecord);

                                        //更新移菜后sellInfo的信息
                                        selectRemovePlaceView.updateSellInfo(currentRemovePlaceList.getStore(), currentPlaceSellInfo);
                                        selectRemovePlaceView.updateSellInfo(targetRemovePlaceList.getStore(), targetPlaceSellInfo);

                                        $('#current-removeplace-sellAmount').text(roundByUnit(currentPlaceSellInfo.sellAmount, roundSetting.unit));
                                        $('#target-removeplace-sellAmount').text(roundByUnit(targetPlaceSellInfo.sellAmount, roundSetting.unit));

                                        //移动的记录保存进数组
                                        var recordData = currentRemoveRecord.getData();
                                        var targetPlaceSellId = selectRemovePlaceView.selectTargetPlace.sellId;
                                        var targetDatas = selectRemovePlaceView.targetRemovePlaceDatas;
                                        var currentDatas = selectRemovePlaceView.currentRemovePlaceDatas;
                                        console.log('操作单据：餐桌' + currentPlaceSellInfo.placeName + '(订单号' + currentPlaceSellInfo.id + ')的菜品' + recordData.commodityName + '移向了餐桌' + targetPlaceSellInfo.placeName + '(订单号' + targetPlaceSellInfo.id + ')--' + new Date().format('yyyy-MM-dd hh:mm:ss'))
                                        if(targetPlaceSellId != recordData.sellId){
                                            //加入targetDatas数组
                                            if(targetDatas.length == 0){
                                                targetDatas.push(recordData);
                                            }else if(targetDatas.length >= 1){
                                                var isRepeat = false;
                                                //判断是否有重复记录
                                                for(var i = 0, len = targetDatas.length; i < len; i++){
                                                    var _record = targetDatas[i];
                                                    if(_record.id == recordData.id){
                                                        isRepeat = true;
                                                        break;
                                                    }
                                                }
                                                if(!isRepeat){
                                                    targetDatas.push(recordData);
                                                }
                                            }
                                        }else if(targetPlaceSellId == recordData.sellId){
                                            //从currentDatas删除数据
                                            var recordId = recordData.id;
                                            for(var k = 0, len = currentDatas.length; k < len; k++){
                                                if(recordId == currentDatas[k].id){
                                                    currentDatas.splice(k, 1);
                                                    break;
                                                }
                                            }
                                        }
                                        if(currentRemovePlaceList.getStore().getAllCount() <= 0){
                                            showAlert('提示', '当前台位菜品被移完，将会被清台！');
                                        }
                                    }
                                },
                                {
                                    xtype: 'spacer',
                                    flex: 1
                                },
                                {
                                    xtype: 'ebutton',
                                    text: '<',
                                    width: 80,
                                    height: 40,
                                    style: 'border-radius:18px;color:rgba(153,153,153,0.6);background: #e8e8e8;font-size:22px;border:none;-webkit-box-shadow: 1px 1px 5px #ccc inset, -1px -1px 5px #ccc inset',
                                    id: 'removeToCurrentBtn',
                                    handler: function(){
                                        var selectRemovePlaceView = Ext.getCmp('selectRemovePlaceView-view');
                                        var currentRemovePlaceList  = Ext.getCmp('selectCurrentRemovePlace-list');
                                        var targetRemovePlaceList  = Ext.getCmp('selectTargetRemovePlace-list');
                                        var currentRemovePlaceStore = currentRemovePlaceList.getStore();
                                        var targetRemovePlaceStore = targetRemovePlaceList.getStore();
                                        var currentPlaceSellInfo = selectRemovePlaceView.selectCurrentPlaceSellInfo;
                                        var targetPlaceSellInfo = selectRemovePlaceView.selectTargetPlaceSellInfo;

                                        if(targetRemovePlaceList.getSelection().length == 0){
                                            return;
                                        }
                                        var targetRemoveRecord = targetRemovePlaceList.getSelection()[0];
                                        targetRemovePlaceStore.remove(targetRemoveRecord);
                                        currentRemovePlaceStore.addData(targetRemoveRecord);

                                        //更新移菜后sellInfo的信息
                                        selectRemovePlaceView.updateSellInfo(currentRemovePlaceList.getStore(), currentPlaceSellInfo);
                                        selectRemovePlaceView.updateSellInfo(targetRemovePlaceList.getStore(), targetPlaceSellInfo);

                                        $('#current-removeplace-sellAmount').text(roundByUnit(currentPlaceSellInfo.sellAmount, roundSetting.unit));
                                        $('#target-removeplace-sellAmount').text(roundByUnit(targetPlaceSellInfo.sellAmount, roundSetting.unit));

                                        //移动的记录保存进数组
                                        var recordData = targetRemoveRecord.getData();
                                        var currentPlaceSellId = selectRemovePlaceView.selectCurrentPlace.sellId;
                                        var currentDatas = selectRemovePlaceView.currentRemovePlaceDatas;
                                        var targetDatas = selectRemovePlaceView.targetRemovePlaceDatas;
                                        console.log('操作单据：餐桌' + targetPlaceSellInfo.placeName + '(订单号' + targetPlaceSellInfo.id + ')的菜品' + recordData.commodityName + '移向了餐桌' + currentPlaceSellInfo.placeName + '(订单号' + currentPlaceSellInfo.id + ')--' + new Date().format('yyyy-MM-dd hh:mm:ss'))
                                        if(currentPlaceSellId != recordData.sellId){
                                            //加入currentDatas数组
                                            if(currentDatas.length == 0){
                                                currentDatas.push(recordData);
                                            }else if(currentDatas.length >= 1){
                                                var isRepeat = false;
                                                //判断是否有重复记录
                                                for(var i = 0, len = currentDatas.length; i < len; i++){
                                                    var _record = currentDatas[i];
                                                    if(_record.id == recordData.id){
                                                        isRepeat = true;
                                                        break;
                                                    }
                                                }
                                                if(!isRepeat){
                                                    currentDatas.push(recordData);
                                                }
                                            }
                                        }else if(currentPlaceSellId == recordData.sellId){
                                            //从targetDatas删除数据
                                            var recordId = recordData.id;
                                            for(var k = 0, len = targetDatas.length; k < len; k++){
                                                if(recordId == targetDatas[k].id){
                                                    targetDatas.splice(k, 1);
                                                    break;
                                                }
                                            }
                                        }
                                        if(targetRemovePlaceList.getStore().getAllCount() <= 0){
                                            showAlert('提示', '目标台位菜品被移完，将会被清台！');
                                        }
                                    }
                                },
                                {
                                    xtype: 'container',
                                    height: 14
                                },{
                                    xtype: 'ebutton',
                                    text: '<<',
                                    width: 80,
                                    height: 40,
                                    style: 'border-radius:18px;color:rgba(153,153,153,0.6);background: #e8e8e8;font-size:22px;border:none;-webkit-box-shadow: 1px 1px 5px #ccc inset, -1px -1px 5px #ccc inset',
                                    id: 'removeAllToCurrentBtn',
                                    handler: function(){
                                        var selectRemovePlaceView = Ext.getCmp('selectRemovePlaceView-view');
                                        var currentRemovePlaceList  = Ext.getCmp('selectCurrentRemovePlace-list');
                                        var targetRemovePlaceList  = Ext.getCmp('selectTargetRemovePlace-list');
                                        var currentRemovePlaceStore = currentRemovePlaceList.getStore();
                                        var targetRemovePlaceStore = targetRemovePlaceList.getStore();
                                        var currentPlaceSellInfo = selectRemovePlaceView.selectCurrentPlaceSellInfo;
                                        var targetPlaceSellInfo = selectRemovePlaceView.selectTargetPlaceSellInfo;

                                        var targetSellDetail = selectRemovePlaceView.selectTargetPlaceSellDetail;
                                        var currentSellDetail = selectRemovePlaceView.selectCurrentPlaceSellDetail;

                                        if(!targetRemovePlaceStore || (targetRemovePlaceStore.getAllCount() == 0) || !currentRemovePlaceStore){
                                            return;
                                        }

                                        //先清空store所有数据，再全部添加进目标store
                                        currentRemovePlaceStore.removeAll();
                                        targetRemovePlaceStore.removeAll();
                                        selectRemovePlaceView.addRemovePlaceStore(currentRemovePlaceStore, targetSellDetail);
                                        selectRemovePlaceView.addRemovePlaceStore(currentRemovePlaceStore, currentSellDetail);

                                        //先清空数据数据，再添加
                                        var targetDatas = selectRemovePlaceView.targetRemovePlaceDatas;
                                        var currentDatas = selectRemovePlaceView.currentRemovePlaceDatas;
                                        targetDatas.length = 0;
                                        currentDatas.length= 0;
                                        for(var i = 0, len = targetSellDetail.length; i < len; i++){
                                            currentDatas.push(targetSellDetail[i]);
                                        }
                                        //更新移菜后sellInfo的信息
                                        selectRemovePlaceView.updateSellInfo(currentRemovePlaceList.getStore(), currentPlaceSellInfo);
                                        selectRemovePlaceView.updateSellInfo(targetRemovePlaceList.getStore(), targetPlaceSellInfo);
                                        console.log('操作单据：餐桌' + targetPlaceSellInfo.placeName + '(订单号' + targetPlaceSellInfo.id + ')的菜品全部移向了餐桌' + currentPlaceSellInfo.placeName + '(订单号' + currentPlaceSellInfo.id + ')--' + new Date().format('yyyy-MM-dd hh:mm:ss'))

                                        $('#current-removeplace-sellAmount').text(roundByUnit(currentPlaceSellInfo.sellAmount, roundSetting.unit));
                                        $('#target-removeplace-sellAmount').text(roundByUnit(targetPlaceSellInfo.sellAmount, roundSetting.unit));

                                        showAlert('提示', '目标台位菜品被移完，将会被清台！');

                                    }
                                },
                                {
                                    xtype: 'container',
                                    height: 30
                                }
                            ]
                        },{
                            xtype: 'container',
                            height: 124
                        }
                    ]
                },{
                    xtype: 'panel',
                    flex: 1,
                    id: 'selectTargetRemovePlace-panel',
                    layout: {
                        type: 'vbox',
                        align: 'center'
                    },
                    items: [
                        {
                            xtype : 'container',
                            style: 'width:80%;height:40px;line-height:40px',
                            html: '<div class="selectRemovePlace-title"><span>目标台位：</span><span id="selectTargetRemovePlace-title"></span></div>'
                        },
                        {
                            xtype: 'container',
                            height: 36,
                            style: 'width:80%;border: 1px solid rgba(0,0,0,0.1);border-bottom: none;',
                            html : '<div class="sy-putupQurey-header" style="width:100%;" ><div class="name">品名</div><div class="num" style="width:25%;">&nbsp;&nbsp;&nbsp;&nbsp;数量</div><div class="price">价格&nbsp;&nbsp;</div><div class="sellAmount">小计</div></div>'
                        },
                        Ext.create('Ext.DataView', {
                            id: 'selectTargetRemovePlace-list',
                            flex: 1,
                            style: 'width:80%;border: 1px dashed rgba(0,0,0,0.1);background-color: rgba(220,220,220,0.2);',
                            scrollable: {
                                direction: 'vertical',
                                directionLock: true
                            },
                            store: Ext.create('Ext.data.Store', {
                                id: 'selectTargetRemovePlace-store',
                                model: 'Seller.model.SelectRemovePlace',
                                data: []
                            }),
                            selectedCls : 'removeplace-list-select',
                            itemCls: 'removeplace-list-item',
                            itemTpl: new Ext.XTemplate('<div class="sy-commodity-list" style="min-height: 42px;width:100% !important;font-size:16px !important;"><div class="name jz-center sp-left">{commodityName}</div><div class="num jz-center">{sellNum}</div><div class="price jz-center">{sellPrice}</div><div class="sellAmount jz-center">{sellAmount}</div></div>')
                        }),{
                            xtype : 'container',
                            height : 34,
                            cls : 'sp-list-juci',
                            style : 'width:80%;border:none;'
                        },{
                            xtype: 'container',
                            height: 30,
                            width: '80%',
                            style: 'text-align:right;line-height:30px;',
                            html: '<div><span>整单折扣&nbsp;&nbsp;</span><span id="target-removeplace-discount">100%</span></div>'
                        },{
                            xtype: 'container',
                            height: 40,
                            width: '80%',
                            style: 'text-align:right;line-height:40px;margin-bottom:20px;font-size:20px;',
                            html:  '<div><span>总金额&nbsp;&nbsp;</span><span><i style="font-style: normal;">￥</i><span id="target-removeplace-sellAmount">0.00</span></span></div>'
                        }
                    ]
                }
            ]
        }]
    },
    initialize : function(panel, eOpts) {

    },
    printOrderDetail: function(sellInfo, sellDetail, callback){
        PrintDao.printOrderInfoDetail(sellInfo, sellDetail, function (message) {
            if (message){
                callback && callback();
            }
        });
    },
    removePlaceSellInfoCancel: function(sellInfo, callback){
        var sellAmount = sellInfo.sellAmount + nvlValue(sellInfo.teaAmount, 0);
        var totalAmount = sellInfo.totalAmount + nvlValue(sellInfo.teaAmount, 0);
        sellInfo.sellAmount = sellAmount;
        sellInfo.totalAmount = totalAmount;
        var sellId = sellInfo.id;
        SellDao.updateSellInfo({
            sellAmount : sellInfo.sellAmount,
            totalAmount : sellInfo.totalAmount,
            status : '3',
            endTime : new Date().format("yyyy-MM-dd hh:mm:ss"),
            syned : '0'
        }, sellId, function(success, res, resultData) {
            if (success) {
                SellDao.submitById(sellId, function(success) {
                });
                dealPlaceBySellId(sellId);
                callback && callback();
            } else {
                showAlert('提示', "撤销失败！");
            }
        });
    },
    concatSellDetail: function(addData, delData, cId, tId){//添加商品和删除商品信息
        var concatSellDetail = [];
        if(!addData || !delData){
            return concatSellDetail;
        }
        //组合销售详情表信息，sellDetail
        var _delData = JSON.parse(JSON.stringify(delData));
        var _addData = JSON.parse(JSON.stringify(addData));
        //添加销售详情，移出移入字段，removeFromSellId 和 removeToSellId
        for(var k = 0,leng = _addData.length; k < leng; k++){
            _addData[k].removeFromSellId = cId;
            _addData[k].type = '1';
            _addData[k].hasKitchenPrinted = '1';
            _addData[k].hasTablePrinted = '1';
            _addData[k].hasLabelPrinted = '1';
        }
        for(var i = 0, len = _delData.length; i < len; i++){
            var sellNum = parseFloat(_delData[i].sellNum);
            var totalAmount = parseFloat(_delData[i].totalAmount);
            var sellAmount = parseFloat(_delData[i].sellAmount);
            var gainAmount = parseFloat(_delData[i].gainAmount);
            var costAmount = parseFloat(_delData[i].costAmount);
            var remarkAmount = parseFloat(_delData[i].remarkAmount);
            _delData[i].sellNum = !isNaN(sellNum) ? (-sellNum).toFixed(2) : 0;
            _delData[i].totalAmount = !isNaN(totalAmount) ? parseFloat(-totalAmount).toFixed(2) : 0;
            _delData[i].sellAmount = !isNaN(sellAmount) ? parseFloat(-sellAmount).toFixed(2) : 0;
            _delData[i].gainAmount = !isNaN(gainAmount) ? parseFloat(-gainAmount).toFixed(2) : 0;
            _delData[i].costAmount = !isNaN(costAmount) ? parseFloat(-costAmount).toFixed(2) : null;
            _delData[i].remarkAmount = !isNaN(remarkAmount) ? parseFloat(-remarkAmount).toFixed(2) : 0;
            _delData[i].isDelete = '1';
            _delData[i].id = createSellId(new Date(), "SD");//id不能重复
            _delData[i].removeToSellId = cId;
            _delData[i].sellId = tId;
            _delData[i].hasKitchenPrinted = '1';
            _delData[i].hasTablePrinted = '1';
            _delData[i].hasLabelPrinted = '1';
        }
        concatSellDetail = _addData.concat(_delData);
        return concatSellDetail;
    },
    updateSellInfo: function(store, sellInfo){
        var data = {
            commodityNum: 0,
            totalAmount: 0,
            sellAmount: 0,
            roundAmount: 0,
            discountAmount:0,
            notDiscountAmount: 0,
            alreadyDiscountAmount: 0
        };
        //计算移菜后改变总金额，销售总价 * 整单折扣
        var discount = parseFloat(sellInfo.discount);
        //重新计算不可打折金额
        var notDiscountAmount = calcNotDiscountAmountForStore(store);
        if(!store || isNaN(discount)){
            return;
        }
        if(store.getData){
            var storeDatas = store.getData();
            var sumPrice = 0;
            var commodityNum = 0;
            for(var si = 0, len = storeDatas.length; si < len; si++){
                var record = storeDatas.getAt(si);
                var sellAmount = parseFloat(record.get('sellAmount'));
                var num = parseFloat(record.get('sellNum'));
                sumPrice += sellAmount;
                commodityNum += num;
            }
            data.notDiscountAmount = notDiscountAmount;
            data.commodityNum = commodityNum.toFixed(2);
            data.totalAmount = sumPrice.toFixed(2);
            data.discountAmount = (sumPrice - notDiscountAmount).toFixed(2);//可打折金额
            //可打折金额 * 折扣 + 不可打折金额 = 销售金额
            data.sellAmount= ((((sumPrice - notDiscountAmount) * discount)/100) + notDiscountAmount).toFixed(2);
            data.alreadyDiscountAmount = ((((sumPrice - notDiscountAmount) * (100 - discount))/100)).toFixed(2);
            data.roundAmount = (roundByUnit(data.sellAmount, roundSetting.unit) - data.sellAmount).toFixed(2);

            for(var key in data){
                if(data.hasOwnProperty(key)){
                    sellInfo[key] = parseFloat(data[key]);
                }
            }

            sellInfo.syned = '0';
        }
    },
    hideViewListAndBtn: function(){
        Ext.getCmp('selectRemovePlaceView-list-panel').parent.hide();
        Ext.getCmp('selectRemovePlaceSellDetail-panel').show();
        Ext.getCmp('removePlacePreviousBtn').show();
        Ext.getCmp('removePlaceCompleteBtn').show();
        Ext.getCmp('removePlaceBtn').hide();
    },
    showViewListAndBtn: function(){
        Ext.getCmp('selectRemovePlaceView-list-panel').parent.show();
        Ext.getCmp('selectRemovePlaceSellDetail-panel').hide();
        Ext.getCmp('removePlacePreviousBtn').hide();
        Ext.getCmp('removePlaceCompleteBtn').hide();
        Ext.getCmp('removePlaceBtn').show();
    },
    resetSelectPlaceViewData: function(){
        this.currentRemovePlaceDatas=[];
        this.targetRemovePlaceDatas=[];
    },
    addSellDetailByData: function(detail, id){
        //添加销售详情
        return new Promise(function(resolve, reject){
            SellDao.addSellDetails(detail, id, function(success, msg){
                if(success){
                    addComboMealsSelldetail(detail, function(success1) {
                        if (success1) { }
                        resolve();
                    });
                }
            });
        });
    },
    updateSellInfoByData: function(sellInfo, id){
        //更新销售信息
        return new Promise(function(resolve, reject){
            SellDao.updateSellInfo(sellInfo, id, function(success, msg){
                if(success){
                    if (sellInfo && sellInfo.commodityNum > 0) {
                        console.log('上传订单' + id + '数据--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
                        SellDao.submitById(id);
                    }
                    resolve();
                }
            });
        });
    },
    getCurrSellInfoByPlacePinId: function(id){
        return new Promise(function(resolve, reject){
            SellDao.getCurrSellInfoByPlacePinId(id, function(success, sellInfo){
                if(success && sellInfo){
                   resolve(sellInfo);
                }
            });
        })
    },
    getSellDetailBySellId: function(id){
        return new Promise(function(resolve, reject){
            SellDao.loadSellDetail(id, function(success, sellDetail){
                if(success && sellDetail){
                    resolve(sellDetail);
                }
            });
        });
    },
    loadRemovePlaceSellAmount: function(){
        var me = this;
        $('#current-removeplace-sellAmount').text(roundByUnit(me.selectCurrentPlace.sellAmount, roundSetting.unit));
        $('#target-removeplace-sellAmount').text(roundByUnit(me.selectTargetPlaceSellInfo.sellAmount, roundSetting.unit));
        $('#current-removeplace-discount').text(parseFloat(me.selectCurrentPlaceSellInfo.discount).toFixed(2) + '%');
        $('#target-removeplace-discount').text(parseFloat(me.selectTargetPlaceSellInfo.discount).toFixed(2) + '%');
    },
    getSellDetailAfterFilter: function(detail){
        if(!isArray(detail)){
            return;
        }
        var _detail = JSON.parse(JSON.stringify(detail));
        var deleteDetail = [];
        var normalDetail = [];
        //将删除的和正常的商品分开
        for(var j = 0, length = _detail.length; j < length; j++){
            if(_detail[j].isDelete == '1'){
                deleteDetail.push(_detail[j])
            }else{
                normalDetail.push(_detail[j])
            }
        }
        //没有删除的记录，直接返回
        if(deleteDetail.length == 0){
            return detail;
        }
        for(var k = 0, len = deleteDetail.length; k < len; k++){
            var delCommodityId = deleteDetail[k].commodityId;
            var delSellPrice  = deleteDetail[k].sellPrice;
            var delSellNum = parseFloat(deleteDetail[k].sellNum);
            for(var i = 0, size = normalDetail.length; i < size; i++){
                var norCommodityId = normalDetail[i].commodityId;
                var norSellPrice  = normalDetail[i].sellPrice;
                var norSellNum = parseFloat(normalDetail[i].sellNum);
                if((delCommodityId == norCommodityId) && (delSellPrice == norSellPrice)){
                    if(delSellNum < 0 && norSellNum > 0){
                        //删除的数量小于零才相加
                        normalDetail[i].sellNum = norSellNum + delSellNum;
                        delSellNum = norSellNum + delSellNum;

                        var sellPrice = normalDetail[i].sellPrice;
                        var commodityPrice = normalDetail[i].commodityPrice
                        var remarkPrice = normalDetail[i].remarkPrice ? normalDetail[i].remarkPrice : 0;
                        var costPrice = normalDetail[i].costPrice ? normalDetail[i].costPrice : 0;
                        normalDetail[i].sellAmount = parseFloat((sellPrice * normalDetail[i].sellNum)).toFixed(2);
                        normalDetail[i].totalAmount= parseFloat((remarkPrice + commodityPrice + costPrice) * normalDetail[i].sellNum).toFixed(2);
                        normalDetail[i].remarkAmount = parseFloat(remarkPrice * normalDetail[i].sellNum).toFixed(2);
                        normalDetail[i].gainAmount = parseFloat(normalDetail[i].sellAmount).toFixed(2);
                        normalDetail[i].costAmount = parseFloat(costPrice * normalDetail[i].sellNum).toFixed(2);
                        normalDetail[i].sellNum = parseFloat(normalDetail[i].sellNum).toFixed(2);
                    }
                }
            }
        }
        //再过滤掉数量为零的记录
        var resultDetail = [];
        for(var si = 0, long = normalDetail.length; si < long; si++){
            if(parseFloat(normalDetail[si].sellNum) > 0){
                resultDetail.push(normalDetail[si]);
            }
        }
        return resultDetail;
    },
    loadRemovePlaceDetail: function(){
        var me = this;

        $('#selectCurrentRemovePlace-title').text(me.selectCurrentPlace.placeName);
        $('#selectTargetRemovePlace-title').text(me.selectTargetPlace.placeName);

        var selectTargetRemovePlaceStore = Ext.getCmp('selectTargetRemovePlace-list').getStore();
        var selectCurrentRemovePlaceStore = Ext.getCmp('selectCurrentRemovePlace-list').getStore();

        selectTargetRemovePlaceStore && selectTargetRemovePlaceStore.removeAll();
        selectCurrentRemovePlaceStore && selectCurrentRemovePlaceStore.removeAll();

        me.addRemovePlaceStore(selectTargetRemovePlaceStore, me.selectTargetPlaceSellDetail);
        me.addRemovePlaceStore(selectCurrentRemovePlaceStore, me.selectCurrentPlaceSellDetail);
    },
    addRemovePlaceStore: function(store,sellDetail){
        if(!store || !sellDetail){
            return;
        }
        if(sellDetail.length > 0){
            for(var i = 0, len = sellDetail.length; i < len; i++){
                var _sellDetail = sellDetail[i];
                _sellDetail.sellNum = parseDigitalDecimal(_sellDetail.sellNum);
                _sellDetail.sellAmount = parseFloat(_sellDetail.sellAmount).toFixed(2);
                _sellDetail.sellPrice = parseFloat(_sellDetail.sellPrice).toFixed(2);
                store.add(_sellDetail);
            }
        }
    },
    resetData : function() {
        var store = Ext.getStore('selectremoveplacetypeview-store');
        store.removeAll();
        this.clearplace();
    },
    loadData : function(placeId, sellInfo) {
        var me = Ext.getCmp('selectRemovePlaceView-view');
        //拼桌或拼桌后的placeId多了'-'，需要做处理
        if(placeId.lastIndexOf('-') != -1){
            me.placeId = placeId.substring(0, placeId.lastIndexOf('-'));
        }else{
            me.placeId = placeId;
        }

        me.selectCurrentPlaceSellInfo = sellInfo;
        me.selectCurrentPlace = {
            placeName: sellInfo.placeName,
            sellId: sellInfo.id,
            sellAmount: sellInfo.sellAmount
        };
        this.clearPlaceType();
        this.getServicePlaceTypeTotalCount(me.placeId).
            then(function(result){
                var placetypeIds = [];
                for(var i = 0, len = result.length; i < len; i++){
                    placetypeIds.push(result[i].typeId);
                }
                me.placetypeIds = placetypeIds;
                me.placeTypePage.countPage(placetypeIds.length);
                me.placeTypePage.reset();
                ServicePlaceDao.loadSelectPlaceTypePageById(placetypeIds, me.placeTypePage.getLimitCount(), 0, function(success, res){
                    if(success && res){
                        me.loadServicePlaceType(res);
                    }
                });
            }).
            catch(function(error){
                console.log('移菜分类查询出错', error);
            });
        //移菜分类优化
        ServicePlaceDao.getServicePlaceTypeTotalCountForOrder(me.placeId, function(success, result){
            if(success && result){
                var placetypeIds = [];
                for(var i = 0, len = result.length; i < len; i++){
                    placetypeIds.push(result[i].typeId);
                }
                me.placetypeIds = placetypeIds;
                me.placeTypePage.countPage(placetypeIds.length);
                me.placeTypePage.reset();
                ServicePlaceDao.loadSelectPlaceTypePageById(placetypeIds, me.placeTypePage.getLimitCount(), 0, function(success, res){
                    if(success && res){
                        me.loadServicePlaceType(res);
                    }
                });
            }
        });
        //保存选中餐桌销售详情
        this.getSellDetailBySellId(sellInfo.id).
            then(function(sellDetail){
                //保存并过滤删除的记录
                me.selectCurrentPlaceSellDetail = me.getSellDetailAfterFilter(sellDetail);
            }).
            catch(function(err){});
    },
    getServicePlaceTypeTotalCount: function(placeId){
        return new Promise(function(resolve, reject){
                ServicePlaceDao.getServicePlaceTypeTotalCountForOrder(placeId, function(success, result){
                    if(success && result){
                        resolve(result);
                    }else{
                        reject();
                    }
                });
        });
    },
    loadServicePlaceType : function(datas) {
        var me = this;
        var store = Ext.getStore('selectremoveplacetypeview-store');
        var item;
        var first;
        store.removeAll();
        var firstId;
        for (var i = 0, len = datas.length; i < len; i++) {
            item = datas[i];
            store.add(item);
            if (i == 0) {
                currServicePlaceTypeId = item.id;
                firstId = item.id;
            }
        }
        if (firstId) {
            me.selectChangePlaceType(firstId);
            setTimeout(function() {
                $("#select-placetype-button-" + firstId).addClass('checkedbg');
            }, 100);
        }
    },
    /**
     * 清空
     */
    clearplace : function() {
        var store = Ext.getStore('selectremoveplaceview-store');
        store.removeAll();
    },
    refreshData : function(typeId) {
        var me = this;
        me.resetData();
        me.loadData();
    },
    /**
     * 加载商品
     * @param {Object} datas
     * @param {Object} typeId
     */
    loadplace : function(datas, typeId) {
        var me = this;
        me.clearplace();
        var store = Ext.getStore('selectremoveplaceview-store');
        var placeData;
        placeData = datas;
        store.add(placeData);
        for(var j=0,len=placeData.length;j<len;j++) {
            placeData[j].placePersonNum = placeData[j].personNum;
            var placeRecord = store.findRecord('id', placeData[j].id);
            placeRecord.set('placePersonNum', placeData[j].personNum);
            if(placeData[j].status == '1') {
                me.loadSellInfo(placeRecord);
            }
        }
    },
    loadSellInfo: function(record){
        var placeId = record.get("id");
        // 查看是否存在拼桌并填写开台时间(最早开台的时间)
        SellDao.getCurrSellInfoByPlaceIdPin(placeId, function(success, places) {
            if(success && places && places.length > 0) {
                var plen = places.length;
                var sellTime = new Date().format('yyyy-MM-dd hh:mm:ss');
                var sellAmount = 0;
                var totalAmount = 0;
                var discount = 100;
                var costAmount = (totalAmount * discount / 100);
                var personNum = 0;
                var curShowPlace = {};
                var showFactAmount = 0;
                for(var pi=0;pi<plen;pi++) {
                    if(places[pi].sellTime && places[pi].sellTime < sellTime) {
                        sellTime = places[pi].sellTime;
                        curShowPlace = places[pi];
                    }
                    personNum += places[pi].personNum ? places[pi].personNum : 0;
                    var tmpDiscount = places[pi].discount ? places[pi].discount : 100;
                    var tmpTotalAmount = places[pi].totalAmount ? places[pi].totalAmount : 0;
                    showFactAmount += parseFloat(tmpTotalAmount * (tmpDiscount/100));
                }
                sellAmount = curShowPlace.sellAmount ? curShowPlace.sellAmount : 0;
                totalAmount = curShowPlace.totalAmount ? curShowPlace.totalAmount : 0;
                discount = curShowPlace.discount ? curShowPlace.discount : 100;
                costAmount = (totalAmount * discount / 100);
                //personNum = curShowPlace.personNum;
                record.set('sellAmount', sellAmount);
                //record.set('sellAmountText', '消费:' + parseFloat(costAmount).toFixed(2));
                record.set('sellAmountText', '消费:' + parseFloat(showFactAmount).toFixed(2));
                //record.set('personNum', personNum);
                record.set('placePersonNum', personNum);
                record.set('sellTime', sellTime);

                if(!sellTime || sellTime.length < 16) return;
                /*var placeSellTime = sellTime.substring(11, 16);
                var placeDate = new Date(sellTime);
                var curSysDate = new Date();
                var placeSellTimeTxt = placeSellTime + '';
                var pvExeTime = loadPlaceViewExeTime(placeDate, curSysDate);
                placeSellTimeTxt += pvExeTime;
                if(sellTime)
                    record.set('sellTimeTxt', placeSellTimeTxt);
                else
                    record.set("sellTimeTxt", '');*/
            } else {
                //待清台label显示
                record.set('sellTimeTxt', '(待清台)');
            }
        });
        SellDao.getCurrSellInfoByPlaceIdPin(placeId, function(success, pinSellInfos) {
            var isPinPlace = false;
            if(success && pinSellInfos && pinSellInfos.length > 1) {
                isPinPlace = true;
            }
            record.set('isPinPlace', isPinPlace);
        });
    },
    deletePlace : function(record) {
        var store = Ext.getStore('selectremoveplaceview-store');
        store.remove(record);
    },
    deletePlaceType : function(record) {
        var store = Ext.getStore('selectremoveplacetypeview-store');
        store.remove(record);
    },
    upPlaceType : function() {
        var me = this;
        Ext.getCmp('selectRemovePlaceView-view').clearPlaceType();
        me.placeTypePage.up();
        /*ServicePlaceDao.loadPlaceTypePage(me.placeTypePage.getLimitCount(), me.placeTypePage.getOffset(), function(success, res) {
            if (success) {
                me.loadServicePlaceType(res);
            }
        });*/
        ServicePlaceDao.loadSelectPlaceTypePageById(me.placetypeIds, me.placeTypePage.getLimitCount(), me.placeTypePage.getOffset(), function(success, res){
            if(success && res){
                me.loadServicePlaceType(res);
            }
        });
    },
    downPlaceType : function() {
        var me = this;
        Ext.getCmp('selectRemovePlaceView-view').clearPlaceType();
        me.placeTypePage.down();
        /*ServicePlaceDao.loadPlaceTypePage(me.placeTypePage.getLimitCount(), me.placeTypePage.getOffset(), function(success, res) {
            if (success) {
                me.loadServicePlaceType(res);
            }
        });*/
        ServicePlaceDao.loadSelectPlaceTypePageById(me.placetypeIds, me.placeTypePage.getLimitCount(), me.placeTypePage.getOffset(), function(success, res){
            if(success && res){
                me.loadServicePlaceType(res);
            }
        });
    },
    getPlaceTypeTotalPage : function(callBack) {
        var me = this;
        ServicePlaceDao.getPlaceTypeTotalCount(function(success, totalCount) {
            if (success) {
                me.placeTypePage.countPage(totalCount);
                if (callBack) {
                    callBack(true);
                }
            } else {
                if (callBack) {
                    callBack(false);
                }
            }
        });
    },
    clearPlaceType : function() {
        var store = Ext.getStore('selectremoveplaceview-store');
        store.removeAll();
        this.clearplace();
    },

    /**
     * 点击分类
     */
    serviceChangePlaceTypeClick : function(element, id, name) {
        var me = Ext.getCmp('selectRemovePlaceView-view');
        if (!name) {
            return;
        }
        Ext.query(".placetype-button", Ext.getDom('selectRemovePlaceView-view')).forEach(function(element, index, array) {
            Ext.get(element).removeCls('checkedbg');
        });
        Ext.get(element).addCls('checkedbg');
        me.selectChangePlaceType(id);
    },
    selectChangePlaceType : function(id) {
        var me = Ext.getCmp('selectRemovePlaceView-view');
        var currPlaceId = me.placeId;
        me.clearplace();
        me.currPlaceTypeId = id;
        me.placeViewPage.setCurrPage(1);
        me.getChangePlaceViewTotalPageByTypeId(id, function(success) {
            if (success) {
                ServicePlaceDao.loadSelectPlacePageByTypeIdForOrder(id, currPlaceId, me.placeViewPage.getLimitCount(), me.placeViewPage.getOffset(), function(success, res) {
                    if (success && res) {
                        Ext.getCmp('selectRemovePlaceView-view').loadplace(res, id);
                    }
                });
            }
        });
    },
    getChangePlaceViewTotalPageByTypeId : function(currPlaceTypeId, callBack) {
        var me = Ext.getCmp('selectRemovePlaceView-view');
        var currPlaceId = me.placeId;
        ServicePlaceDao.getSelectPlaceTotalCountByTypeIdForOrder(currPlaceTypeId, currPlaceId, function(success, totalCount) {
            if (success) {
                me.placeViewPage.countPage(totalCount);
                Ext.getCmp('removeplaceview-total-label').setHtml(me.placeViewPage.getCurrPage() + "/" + me.placeViewPage.getTotalPage());
                if (callBack) {
                    callBack(true);
                }
            } else {
                if (callBack) {
                    callBack(false);
                }
            }
        });
    },
    /**
     * 向上滚动
     */
    upChangePlaceView : function() {
        var me = this;
        var currPlaceId = me.placeId;
        if (!me.currPlaceTypeId) {
            showAlert("提示", "请先增加分类！");
            return;
        }
        //me.placeViewPage.up();
        upThingPage(me.placeViewPage, function(startPage, endPage) {
            Ext.getCmp('selectRemovePlaceView-view').clearplace();
            ServicePlaceDao.loadSelectPlacePageByTypeIdForOrder(me.currPlaceTypeId, currPlaceId, me.placeViewPage.getLimitCount(), me.placeViewPage.getOffset(), function(success, res) {
                if (success) {
                    me.loadplace(res, me.currPlaceTypeId);
                }
            });
            Ext.getCmp('removeplaceview-total-label').setHtml(me.placeViewPage.getCurrPage() + "/" + me.placeViewPage.getTotalPage());
        });
    },
    /**
     * 向下滚动
     */
    downChangePlaceView : function() {
        var me = this;
        var currPlaceId = me.placeId;
        if (!me.currPlaceTypeId) {
            showAlert("提示", "请先增加分类！");
            return;
        }
        //me.placeViewPage.down();
        downThingPage(me.placeViewPage, function(startPage, endPage) {
            me.clearplace();
            ServicePlaceDao.loadSelectPlacePageByTypeIdForOrder(me.currPlaceTypeId, currPlaceId, me.placeViewPage.page.limitCount, me.placeViewPage.getOffset(), function(success, res) {
                if (success) {
                    Ext.getCmp('selectRemovePlaceView-view').loadplace(res, me.currPlaceTypeId);
                }
            });
            Ext.getCmp('removeplaceview-total-label').setHtml(me.placeViewPage.getCurrPage() + "/" + me.placeViewPage.getTotalPage());
        });
    }
});
