Ext.define('Seller.model.PutupSellDetail', {
	extend : 'Ext.data.Model',
	config : {
		fields : ['id', 'sellNum', 'sellPrice', 'discount', 'commodityPrice', 'commodityId', 'commodityName', 'barCode', 'totalAmount', 'sellAmount', 'sellId', 'sellerId', 'remark', 'remarkIds', 'createTime', 'type', 'parentCommodityId', 'parentCommodityTypeId', 'parentSellerId', 'index', 'css', 'rowId']
	}
});
/**
 *@Project: 取单
 *@Author: lijy
 *@Date: 2015-03-01
 */
Ext.define('Seller.view.putup.PutupQueryAfter', {
	extend : 'Ext.Container',
	alias : 'widget.putupqueryafter',
	parentContainer : null,
	page : new $.PageUtil({
		limitCount : 20
	}),
	config : {
		id : 'putup-main-view',
		centered : true,
		width : '100%',
		height : '100%',
		scrollable : false,
		layout : 'vbox',
		items : [{
			xtype : 'toolbar',
			id : 'putup-main-toolbar',
			cls : 'solid-border-bottom',
			height : 50,
			items : [{
				xtype : 'button',
				//cls : 'close-button',
				cls : 'close-button-complete',
				width : 80,
				iconCls : 'close-icon',
				icon : 'resources/icon/public/back.png',
				text : '返回',
				id : 'putup-main-view-close',
				handler : function() {
					/*Ext.getCmp('putup-main-view').parentContainer.hide();*/
				}
			}],
			title : '取单'
		}, {
			xtype : 'container',
			cls : 'sy-bg',
			id : 'putup-left-panel',
			flex:1,
			layout : {
				type : 'hbox'
			},
			items : [{
				width : 300,
				margin : '0 20',
				layout : 'vbox',
				items : [{
					xtype : 'container',
					height : 26,
					width : 310,
					cls : 'sy-sy-img'
				}, {
					xtype : 'container',
					height : 36,
					cls : 'whitebg',
					html : '<div class="sy-putupQurey-header" ><div class="name">&nbsp;&nbsp;品名</div><div class="num">数量</div><div class="price">价格</div><div class="sellAmount">小计</div></div>'
				}, {
					xtype : 'list',
					id : 'putup-menuList',
					flex:1,
					margin : '0 0 0 0',
					store : Ext.create("Ext.data.Store", {
						model : "Seller.model.SellDetailPutup",
						data : []
					}),
					selectedCls : 'sell-select',
					itemTpl : new Ext.XTemplate('<div class="sy-commodity-list" style="width:300px !important;font-size:16px !important;"><div class="name jz-center sp-left">{commodityName}</div><div class="num jz-center" onclick="syCommodityClick(1,\'{commodityId}\')">{sellNum}</div><div class="price jz-center">{sellPrice}</div><div class="sellAmount jz-center">{sellAmount}</div><div class="type{type} delete{isDelete}"></div></div>'),
					listeners : {
						itemtap : function(list, index, target, record, e, eOpts) {

						},
						selectionchange : function(selectionModel, records) {
						}
					}
				}, {
					xtype : 'container',
					height : 34,
					cls : 'sp-list-juci',
					style : 'border:none'
				}, {
					xtype : 'container',
					layout : 'hbox',
					padding : '20 0 10 0',
					defaults : {
						labelWidth : 80,
						width : 90,
						height : 40
					},
					items : [{
						xtype : 'button',
						cls : 'red-button',
						iconMask : true,
						id :'putup-Receivables',
						text : '收款',
						handler : function() {
                            //refreshPutupReceivables();
						}
					}, {
						xtype : 'button',
						cls : 'orange-button',
						margin : '0 15',
						iconMask : true,
						id : 'putup-update',
						text : '修改',
						handler : function() {
                            // refreshPutupUpdate();
						}
					}, {
						xtype : 'button',
						cls : 'sy-tm-button',
						id : 'putup-revoke',
						iconMask : true,
						text : '撤销',
						handler : function() {
                            // refreshPutupRevoke();
						}
					}]
				}]
			}, {
				xtype : 'container',
				flex : 1,
				id : 'putup-right-panel',
				layout : 'vbox',
				items : [{
					xtype : 'container',
					layout : 'hbox',
					cls : 'solid-border-bottom-grey',
					defaults : {
						labelWidth : 120
					},
					items : [{
						xtype : 'spacer'
					}, {
						xtype : 'radiofield',
						name : 'status',
						value : '0',
						labelCls : 'white-color',
						label : '已下单' + (isConfigSlave() ? "(本机)" : ""),
						id : 'putupOrderStatus',
						labelAlign : 'right',
						//checked : true,
						/*listeners : {
							check : function(filed, e, eOpts) {
								// Ext.getCmp('putup-main-view').loadData();
							}
						}*/
					}, {
						xtype : 'radiofield',
						name : 'status',
						id : 'putupOrderNoneStatus',
						value : '-1',
						labelCls : 'white-color',
						labelAlign : 'right',
						label : '未下单' + (isConfigSlave() ? "(本机)" : ""),
						/*listeners : {
							check : function(filed, e, eOpts) {
								Ext.getCmp('putup-main-view').loadData();
							}
						}*/
					}, {
						xtype : 'spacer'
					}]
				}, //Ext.create('Ext.DataView', {
				{
					xtype : "dataview",
					id : 'putup-after-categoryList',
					flex:1,
					scrollable : false,
					store : Ext.create('Ext.data.Store', {
						model : 'Seller.model.SellInfo',
						data : []
					}),
					listeners : {
						itemtap : function(list, index, target, record, e, eOpts) {
							Ext.getCmp('putup-main-view').loadDetail(record);
							$(".sell-select").removeClass('sell-select');
							$("#sellinfoSpan" + record.get("id")).addClass("sell-select");
							if (record.get("placeName")) {
								Ext.getCmp('putup-main-toolbar').setTitle("取单(" + record.get("placeName") + ")");
							} else {
								Ext.getCmp('putup-main-toolbar').setTitle("取单");
							}
						},
						select2 : function(self, record, eOpts) {
							Ext.getCmp('putup-main-view').loadDetail(record);
							$(".sell-select").removeClass('sell-select');
							$("#sellinfoSpan" + record.get("id")).addClass("sell-select");
							if (record.get("placeName")) {
								Ext.getCmp('putup-main-toolbar').setTitle("取单(" + record.get("placeName") + ")");
							} else {
								Ext.getCmp('putup-main-toolbar').setTitle("取单");
							}
						}
					},
					//itemTpl : ['<div class="sell-dataview"><div class="cent" id="sellinfoSpan{id}"><span class="jz-center">桌号 : {placeName}</span><span class="jz-center">牌号 : {shopSign}</span><span class="jz-center">{sellTime}{sellTimeTxt}</span></div>'].join('')
					itemTpl : ['<div class="sell-dataview"><div class="cent" id="sellinfoSpan{id}"><span class="jz-center">桌号 : {placeName}</span><span class="jz-center">{sellTime}</span><span class="jz-center">{sellTimeTxt}</span></div>'].join('')
				//}), {
                }, {
					xtype : 'container',
					layout : 'hbox',
					margin : '0 0 0 0',
					cls : 'solid-border-bottom-grey',
					height : 40,
					items : [{
						xtype : 'container',
						flex : 5
					}, {
						xtype : 'button',
						icon : 'resources/icon/public/left.png',
						cls : 'sy-tm-button jz-center',
						id : 'fySPutupAfter',
						style : 'width:60px;height:30px;border-radius:12px;padding:0;',
                        /*handler : function () {
                            Ext.getCmp('putup-main-view').down();
                        }*/
					}, {
						xtype : 'spacer'
					}, {
						xtype : 'container',
						cls : 'jz-center',
						id : 'putup-sell-total-label',
						html : '1/1'
					}, {
						xtype : 'spacer'
					}, {
                        xtype : 'button',
                        icon : 'resources/icon/public/right.png',
                        cls : 'sy-tm-button jz-center',
                        id : 'fyXPutupAfter',
                        style : 'width:60px;height:30px;border-radius:12px;padding:0;',
                        /*handler : function () {
                            Ext.getCmp('putup-main-view').up();
                        }*/
					}, {
						xtype : 'spacer'
					}]
				}, {
					xtype : 'container',
					padding : 15,
					hidden : false,
					items : [{
						xtype : 'fieldset',
						layout : 'hbox',
						baseCls : 'bg-transparent',
						margin : '0 0 0 0',
						defaults : {
							labelWidth : 80,
							flex : 1,
							labelCls : 'bg-transparent white-color',
							inputCls : 'bg-transparent white-color'
						},
						items : [{
							xtype : 'numberfield',
							id : 'putup-main-commodityNum',
							label : '件数：',
							readOnly : true
						}, {
							xtype : 'numberfield',
							id : 'putup-main-sellAmount',
							label : '总额：',
							readOnly : true
						}, {
							xtype : 'numberfield',
							id : 'putup-main-discount',
							label : '整单折扣%：',
							labelWidth : 120,
							readOnly : true
						}]
					}, {
						xtype : 'fieldset',
						layout : 'hbox',
						baseCls : 'bg-transparent',
						padding : '5 0 0 0',
						defaults : {
							labelWidth : 80,
							flex : 1,
							labelCls : 'bg-transparent white-color',
							inputCls : 'bg-transparent white-color'
						},
						items : [{
							xtype : 'textfield',
							id : 'putup-main-remark',
							label : '备注：',
							readOnly : true
						}]
					}]
				}]
			}]
		}]
	},
	initialize : function(panel, eOpts) {
		var heght = document.body.clientHeight;
		setTimeout(function() {
			var putupOrderStatusCmp = Ext.getCmp('putupOrderStatus');
			if(putupOrderStatusCmp) {
				putupOrderStatusCmp.check();
				putupOrderStatusCmp.setLabel('已下单' + (isConfigSlave() ? "(本机)" : ""));
			}
			var putupOrderNoneStatusCmp = Ext.getCmp('putupOrderNoneStatus');
			if(putupOrderNoneStatusCmp) {
				putupOrderNoneStatusCmp.setLabel('未下单' + (isConfigSlave() ? "(本机)" : ""));
			}
		}, 200);
	},
	loadData : function() {
		var me = this;
		me.page = new $.PageUtil({
			limitCount : 20
		});
		me.page.setCurrPage(1);
		Ext.getCmp('putup-main-toolbar').setTitle("取单");
		var status = 0;
		if (!Ext.getCmp('putupOrderStatus').isChecked() && !Ext.getCmp('putupOrderNoneStatus').isChecked()) {
			Ext.getCmp('putupOrderStatus').check();
		} else {
			if (Ext.getCmp('putupOrderNoneStatus').isChecked()) {
				status = "-1";
			}
		}
		me.clearSellInfo();
		me.clearDetail();
		me.loadDataByPage();
		/*me.getTotalPage(function(success) {
			if (success) {
				SellDao.loadSellInfoPageByStatus(status, '0', me.page.getLimitCount(), me.page.getOffset(), function(success, res) {
					if (success && res) {
						Ext.getCmp('putup-main-view').loadSellInfo(res);
					}
				});
			}
		});*/
	},
	loadDataByPage : function() {
		var me = this;
		var status = me.getOrderStatus();
		me.getTotalPage(function(success, message) {
			if(success) {
				SellDao.loadSellInfoPageByStatus(null,null,status, '0', me.page.getLimitCount(), me.page.getOffset(), function(success, res) {
					if (success && res) {
						Ext.getCmp('putup-main-view').loadSellInfo(res);
					}
				});
			} else {
				showAlert("提示", message ? message : "查询失败!");
			}
		});
	},
	loadDataByDCB: function() {
		var me = this;
		me.setSelectStatus = false;
		if(Ext.getCmp('putup-after-categoryList').getSelection().length > 0) {
			me.selRecord = Ext.getCmp('putup-after-categoryList').getSelection()[0];
			if(me.selRecord) {
				me.setSelectStatus = true;
				SellDao.getSellInfoById(me.selRecord.get('id'), function(success, data) {
					me.loadData();
					if(success && data) {
						if(data.status != '0' && data.status != '-1') {
							findViewNames = {'SCF_SPECIAL' : 'show-cancel-view-btn'};
					    	findTheViewForLayer(Ext.Viewport, findViewNames, function(id, isPrefix, orginalId) {
					    		var tipView = null;
					    		if(isPrefix && Ext.getCmp(orginalId)) {
					    			tipView = Ext.getCmp(orginalId);
					    		} else tipView = Ext.getCmp(id);
					    		if(tipView) tipView.destroy();
					    		/*var cancelId = findConfirmViewId(tipView, 'cancel');
					    		if(Ext.getCmp(cancelId)) {
					    			var cmpHandler = Ext.getCmp(cancelId).getHandler();
					    			cmpHandler && cmpHandler();
					    		}*/
					    	});
					    	return;
						} else if(data.status === '1') { // 已经买单了，直接刷新页面
							return;
						}
					}
				});
			}
		} else { 
			me.loadData();
		}
	},
	loadDataDetailByDCB: function() {
		// 改变商品数据
		var me = this;
		me.loadDataByDCB();
	},
	clearSellInfo : function() {
		var categoryList = Ext.getCmp("putup-after-categoryList");
		var store = categoryList.getStore();
		store.removeAll();
		this.clearDetail();
	},
	loadSellInfo : function(res) {
		var categoryList = Ext.getCmp("putup-after-categoryList");
		var store = categoryList.getStore();
		var sellInfo = null;
		if (res.length > 0) {
			for (var i = 0, len = res.length; i < len; i++) {
				sellInfo = res[i];
				var placeDate = new Date(sellInfo.sellTime);
				sellInfo.sellTime = sellInfo.sellTime ? (sellInfo.sellTime.substring(11, 16)) : '';
				var curSysDate = new Date();
				var afterExeTime = loadPlaceViewExeTime(placeDate, curSysDate);
				sellInfo.sellTimeTxt = afterExeTime;
				var record = store.add(sellInfo);
			}
		}
		
		var me = this;
		if(me.setSelectStatus) { // 点菜宝刷新页面的之后再选中
			for(var pui=0,pulen=store.getAllCount();pui<pulen;pui++) {
				var tmpPutRecord = store.getAt(pui);
				if(tmpPutRecord.get('id') === me.selRecord.get('id')) {
					categoryList.select(tmpPutRecord, true);
					Ext.getCmp('putup-main-view').loadDetail(tmpPutRecord);
					$(".sell-select").removeClass('sell-select');
					$("#sellinfoSpan" + tmpPutRecord.get("id")).addClass("sell-select");
					if (tmpPutRecord.get("placeName")) {
						Ext.getCmp('putup-main-toolbar').setTitle("取单(" + tmpPutRecord.get("placeName") + ")");
					} else {
						Ext.getCmp('putup-main-toolbar').setTitle("取单");
					}
					break;
				}
			}
		}
	},
	clearDetail : function() {
		var menuList = Ext.getCmp("putup-menuList");
		var store = menuList.getStore();
		store.removeAll();
		Ext.getCmp('putup-main-commodityNum').setValue('');
		Ext.getCmp('putup-main-sellAmount').setValue('');
		Ext.getCmp('putup-main-discount').setValue('');
		//Ext.getCmp('putup-main-customerName').setValue('');
		//Ext.getCmp('putup-main-customerMobile').setValue('');
		Ext.getCmp('putup-main-remark').setValue('');
	},
	loadDetail : function(record) {
		var status = 0;
		if (!Ext.getCmp('putupOrderStatus').isChecked()) {
			status = "-1";
		}
		var id = record.get("id");
		var menuList = Ext.getCmp("putup-menuList");
		var store = menuList.getStore();
		store.removeAll();
		var sellDetail = null;
		var detailList = '';
		var cssClass = "putup-sell-detail";
		var createTime = "";
		
		Ext.getCmp('putup-main-commodityNum').setValue(parseFloat(record.get('commodityNum')?record.get('commodityNum'):0).toFixed(2));
		Ext.getCmp('putup-main-sellAmount').setValue(parseFloat(record.get('sellAmount')).toFixed(2));
		Ext.getCmp('putup-main-discount').setValue(parseFloat(record.get('discount')).toFixed(2));
		Ext.getCmp('putup-main-remark').setValue(record.get('remark'));
		SellDao.loadSellDetail(id, function(success, res) {
			if (!success) {
				return;
			}
			if (res.length > 0) {
				var tmpRecord;
				var totalNum = 0;
				var typeName;
				var rowId = 0;
				var tmpSellAmount = 0;
				var tmpRemark = "";
				for (var i = 0, len = res.length; i < len; i++) {
					sellDetail = res[i];
					typeName = getSellDetailType(sellDetail.type);
					sellDetail.remark = nvlValue(sellDetail.remark, "");
					tmpSellAmount += res[i].sellAmount;
					tmpRemark += sellDetail.remark;
					sellDetail.sellAmount = parseFloat(sellDetail.sellAmount).toFixed(2);
					sellDetail.sellPrice = parseFloat(sellDetail.sellPrice).toFixed(2);
					var records = store.add(sellDetail);
					totalNum += sellDetail.sellNum;
				}
			}
			Ext.getCmp('putup-main-commodityNum').setValue(parseFloat(totalNum?totalNum:0).toFixed(2));
			Ext.getCmp('putup-main-sellAmount').setValue(parseFloat(record.get('sellAmount')).toFixed(2));
			Ext.getCmp('putup-main-discount').setValue(parseFloat(record.get('discount')).toFixed(2));
			Ext.getCmp('putup-main-remark').setValue(record.get('remark'));
		});
	},
	addDetail : function(sellId, updateData) {
		var categoryList = Ext.getCmp("putup-after-categoryList");
		var store = categoryList.getStore();
		var record = store.findRecord("id", sellId);
		record.set('commodityNum', updateData.commodityNum);
		record.set('sellAmount', updateData.sellAmount);
		record.set('totalAmount', updateData.sellAmount);
		this.clearDetail();
		this.loadDetail(record);
	},
	setParentContainer : function(parentContainer) {
		this.parentContainer = parentContainer;
	},
	up : function() {
		this.pagePutupAfter(upThingPage);
	},
	down : function() {
		this.pagePutupAfter(downThingPage);
	},
	pagePutupAfter : function(pageExecutor) {
		var me = this;
		var status = 0;
		if (!Ext.getCmp('putupOrderStatus').isChecked()) {
			status = "-1";
		}
		pageExecutor(me.page, function(startPage, endPage) {
			Ext.getCmp('putup-main-view').clearSellInfo();
			SellDao.loadSellInfoPageByStatus(null,null,status, '0', me.page.getLimitCount(), me.page.getOffset(), function(success, res) {
				if (success) {
					Ext.getCmp('putup-main-view').loadSellInfo(res);
				} else showAlert("提示", res ? res : "查询失败!");
			});
			Ext.getCmp('putup-sell-total-label').setHtml(me.page.getCurrPage() + "/" + me.page.getTotalPage());
		});
	},
	getOrderStatus : function() {
		var status = 0;
		if (!Ext.getCmp('putupOrderStatus').isChecked()) {
			status = "-1";
		}
		return status;
	},
	getTotalPage : function(callBack) {
		callBack = callBack || emFunc;
		var me = this;
		var status = me.getOrderStatus();
		SellDao.getSellTotalCountByStatus(null,null,status, '0', function(success, totalCount) {
			if (success) {
				me.page.countPage(totalCount);
				if(me.page.getCurrPage() > me.page.getTotalPage()) me.page.setCurrPage(me.page.getTotalPage());
				Ext.getCmp('putup-sell-total-label').setHtml(me.page.getCurrPage() + "/" + me.page.getTotalPage());
				if (callBack) {
					callBack(true);
				}
			} else {
				if (callBack) {
					callBack(false, totalCount);
				}
			}
		});
	},
	refreshChgData : function(operatorData) {
		var me = this;
		me.loadDataByDCB();
	}
});

/**
 * 刷新取单页面
 * @returns
 */
function refreshPutup() {
	if (Ext.getCmp('putupqueryafterview') && !Ext.getCmp('putupqueryafterview').getHidden() && Ext.getCmp('putup-main-view')) {
		Ext.getCmp('putup-main-view').loadDataByDCB();
	}
}

function refreshPutupDetail() {
	if (!Ext.getCmp('putupqueryafterview').getHidden() && Ext.getCmp('putup-main-view')) {
		Ext.getCmp('putup-main-view').loadDataDetailByDCB();
	}
}
//撤销
function refreshPutupRevoke() {
    var categoryList = Ext.getCmp("putup-after-categoryList");
    var store = categoryList.getStore();
    if (categoryList.getSelection().length < 1) {
        return;
    }
    var record = categoryList.getSelection()[0];
    checkSellInfoStatus(record.get('id'), function (success, status) {
        if (success && (status == '0' || status == '-1')) {
            var message = '您确定要撤销该下单记录吗?';
            new Promise(function(resolve, reject) {
            	if (record.get("status") != -1) {
            		checkPermissions("6", true).then(function() {
            			resolve();
            		}).catch(function() {reject();});
                } else {
                	resolve(true);
                    message = '您确定要撤销该挂单记录吗?';
                }
            }).then(function() {
            	showConfirm('提示', message, function(buttonId) {
                    if (buttonId == "yes") {
                        if(categoryList.getSelection().length <= 0) {
                            showAlert('提示', '未选中任何单据!');
                            return;
                        }
                        record = categoryList.getSelection()[0];
                        var sellId = record.get('id');
                        var status = record.get('status');
                        var placeId=record.get('placeId');
						console.log('操作单据：餐桌' + record.get('placeName') + '撤销订单号为' + record.get('id') + '的订单记录--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
                        if (status == "-1") {
                            commonSellInfoResumeCancel(record.getData(), function() {
                                var tmpSelRecord = categoryList.getSelection();
                                store.remove(tmpSelRecord);
                                Ext.getCmp('putup-main-view').clearDetail();
                                if (store.getAllCount() > 0) {
                                    categoryList.select(store.getAt(0));
                                } else {
                                    Ext.getCmp('putup-main-toolbar').setTitle('取单');
                                }
                                setTimeout(pushUpdateSellInfo(sellId), 100);
                                Ext.getCmp('putup-main-view').loadDataByPage();
                            });
                            return;
                        }
                        var sellAmount = nvlValue(record.get('sellAmount'),0)+nvlValue(record.get('teaAmount'), 0);
                        var totalAmount = nvlValue(record.get('totalAmount'), 0) + nvlValue(record.get('teaAmount'), 0);
                        var sellInfoData = record.getData();
                        sellInfoData.sellAmount = sellAmount;
                        sellInfoData.totalAmount = totalAmount;
                        commonSellInfoCancel(sellInfoData, function() {
                            store.remove(categoryList.getSelection());
                            Ext.getCmp('putup-main-view').clearDetail();
                            if (store.getAllCount() > 0) {
                                categoryList.select(store.getAt(0));
                            } else {
                                Ext.getCmp('putup-main-toolbar').setTitle('取单');
                            }
                            Ext.getCmp('putup-main-view').loadDataByPage();
                            pushMasterSocket({viewIds:"shouyinMainView",methods:["clearShouyinCart"],operatorData:{sellId:sellId,placeId:placeId}}, null, M_EVENT_TYPE.REFRESHVIEW);
                        });
                    }
                });
            }).catch(function() {});
            /*if (record.get("status") != -1) {
                if (!checkPermissions("6", true)) {
                    return;
                }
            } else {
                message = '您确定要撤销该挂单记录吗?';
            }
            showConfirm('提示', message, function(buttonId) {
                if (buttonId == "yes") {
                    if(categoryList.getSelection().length <= 0) {
                        showAlert('提示', '未选中任何单据!');
                        return;
                    }
                    record = categoryList.getSelection()[0];
                    var sellId = record.get('id');
                    var status = record.get('status');
                    var placeId=record.get('placeId');
                    if (status == "-1") {
                        commonSellInfoResumeCancel(record.getData(), function() {
                            var tmpSelRecord = categoryList.getSelection();
                            store.remove(tmpSelRecord);
                            Ext.getCmp('putup-main-view').clearDetail();
                            if (store.getAllCount() > 0) {
                                categoryList.select(store.getAt(0));
                            } else {
                                Ext.getCmp('putup-main-toolbar').setTitle('取单');
                            }
                            setTimeout(pushUpdateSellInfo(sellId), 100);
                            Ext.getCmp('putup-main-view').loadDataByPage();
                        });
                        return;
                        SellDao.loadSellDetail(sellId, function(success, details) {
                            SellDao.deleteSellInfoById(sellId, function(success) {
                                if (success) {
                                    if(details && details.length > 0)
                                        restoreSoldoutNumBySellDetail(details, updateCommoditySoldout2Store);
                                    store.remove(categoryList.getSelection());
                                    dealPlace('3', placeId);
                                    Ext.getCmp('putup-main-view').clearDetail();
                                    if (store.getAllCount() > 0) {
                                        categoryList.select(store.getAt(0));
                                    } else {
                                        Ext.getCmp('putup-main-toolbar').setTitle('取单');
                                    }
                                    setTimeout(pushUpdateSellInfo(sellId), 100);
                                }else{
                                    showAlert('提示', "撤销失败！");
                                }
                            });
                        });

                        return;
                    }
                    var sellAmount = nvlValue(record.get('sellAmount'),0)+nvlValue(record.get('teaAmount'), 0);
                    var totalAmount = nvlValue(record.get('totalAmount'), 0) + nvlValue(record.get('teaAmount'), 0);
                    var sellInfoData = record.getData();
                    sellInfoData.sellAmount = sellAmount;
                    sellInfoData.totalAmount = totalAmount;
                    commonSellInfoCancel(sellInfoData, function() {
                        store.remove(categoryList.getSelection());
                        Ext.getCmp('putup-main-view').clearDetail();
                        if (store.getAllCount() > 0) {
                            categoryList.select(store.getAt(0));
                        } else {
                            Ext.getCmp('putup-main-toolbar').setTitle('取单');
                        }
                        Ext.getCmp('putup-main-view').loadDataByPage();
                    });
                    return;
                    SellDao.updateSellInfo({
                        sellAmount : sellAmount,
                        totalAmount : totalAmount,
                        status : '3',
                        endTime : new Date().format("yyyy-MM-dd hh:mm:ss"),
                        syned : '0'
                    }, sellId, function(success, res, resultData) {
                        if (success) {
                            //SellDao.submitById(sellId, function(success) {});
                            restoreSoldoutNumBySellId(sellId, updateCommoditySoldout2Store);
                            store.remove(categoryList.getSelection());
                            dealPlaceBySellId(sellId);
                            Ext.getCmp('putup-main-view').clearDetail();
                            if (store.getAllCount() > 0) {
                                categoryList.select(store.getAt(0));
                            } else {
                                Ext.getCmp('putup-main-toolbar').setTitle('取单');
                            }
                            //setTimeout(pushUpdateSellInfo(sellId), 100);
                            //PrintDao.printOrderById(sellId);
                            PrintDao.printCancelLogic(sellId);
                        } else {
                            showAlert('提示', "撤销失败！");
                        }
                    });
                }
            });*/
		}
        else if (!success) {
            showAlert('提示', '获取订单状态失败！');
            return;
        } else if (status == '1') {
            Ext.getCmp('putup-main-view').loadData();
            showAlert('提示', '该订单已收款！');
            // showToast('该订单已完成！');
            return;
        } else if (status == '3') {
            Ext.getCmp('putup-main-view').loadData();
            // showAlert('提示', '该订单已撤销！');
			showToast('该订单已被撤销，不再进行撤销！');
            return;
        }
    });
}
/**
 * 修改
 */
function refreshPutupUpdate() {
    var categoryList = Ext.getCmp("putup-after-categoryList");
    var store = categoryList.getStore();
    if (categoryList.getSelection().length > 0) {
        var record = categoryList.getSelection()[0];
        //console.log(record.get('sellAmount'));
		checkSellInfoStatus(record.get('id'), function (success, status) {
            if (success && (status == '0' || status == '-1')){
                SellDao.getSellInfoById(record.get('id'), function(success, sellInfo) {
                    if (success && sellInfo) {
                        if (sellInfo.status == "1") {
                            showAlert('提示', '该单据已经买单,不能修改!');
                            Ext.getCmp('putup-main-view').loadData();
                            return;
                        } else if (sellInfo.status == '3') {
                            showAlert('提示', '该单据已经撤销,不能修改!');
                            Ext.getCmp('putup-main-view').loadData();
                            return;
						}
						console.log('操作单据：餐桌' + sellInfo.placeName + '取出订单号为' + sellInfo.id + '的订单进行修改--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
                        showCustomerDisplay(0x32, parseFloat(record.get('sellAmount')).toFixed(2));
                        Ext.getCmp('putup-main-view').parentContainer.hide();
                        Ext.getCmp('shouyinMainView').loadDataBySellIdPage(record.getData());
                    } else {
                        showAlert('提示', '该单据不存在!');
                        return;
                    }
                });
			}
        });
    }
}
/**
 * 收款
 */
function refreshPutupReceivables() {
	var categoryList = Ext.getCmp("putup-after-categoryList");
	var store = categoryList.getStore();
	if (categoryList.getSelection().length < 1) {
		return;
	}
	var record = categoryList.getSelection()[0];
	console.log('操作单据：餐桌' + record.get('placeName') + '取出订单号为' + record.get('id') + '的订单准备进行收款--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
    checkSellInfoStatus(record.get('id'), function (success, status) {
		if (success && (status == '0' || status == '-1')) {
            Ext.getCmp('putup-main-view').parentContainer.hide();
            var shoukuanView = Ext.getCmp('shoukuan_view');
            if (!shoukuanView) {
            	shoukuanView =Ext.Viewport.add(Ext.create('Seller.view.shoukuan.ShouKuan'));
            }
            shoukuanView.setSellId(record.get('id'));
            shoukuanView.setNotDiscountAmount(calcNotDiscountAmountForPutup());
            var teaAmount = record.get('teaAmount');
            if (teaAmount) {
                teaAmount = parseFloat(teaAmount);
            } else {
                teaAmount = 0;
            }
            Ext.getCmp('shouyinMainView').loadDataBySellId(record.getData(), null, function() {
                var customerId = record.get('customerId');
                if (customerId) {
                    nativePostRequest(webHostDownInterface + '/loaddata/getSellerCustomerInfo?time=' + new Date().getTime(), {
                        sellerCustomerId : customerId
                    }, function(result) {
                        if (result.success && result.customer) {
                            shoukuanView.setSelectCustomer(result.customer);
                        }
                        var customerInfo = result.customer ? result.customer : null;
                        var totalAmount = parseFloat(record.get('totalAmount'));
                        var discount = record.get('discount') ? record.get('discount') : 100;
                        var sellAmount = parseFloat(totalAmount * (discount ? parseFloat(discount) : 100)/100).toFixed(2);
                        showCustomerDisplay(0x32, sellAmount);
                        var shoukuanData = {
                            totalAmount : parseFloat(record.get("totalAmount")).toFixed(2),
                            sellAmount : sellAmount,
                            discount : parseFloat(record.get('discount')).toFixed(2),
                            teaAmount : teaAmount,
                            selectCustomerInfo : customerInfo,
                            costAmount : Ext.getCmp("shouyinMainView").costAmount
                        };
						if(parseFloat(shoukuanData.totalAmount) < 0){
							shoukuanData.totalAmount = 0;
							shoukuanData.sellAmount = 0;
						}
                        shoukuanView.loadData(shoukuanData, function (success, isPrePayDef) {
                        	if (success) {
                                showBy(shoukuanView, Ext.getCmp('shouyinMainView'),10);
                                if (isPrePayDef) {
                                    selectType(Ext.get('sk-paytype-prepayAmount'), '2');
                                }
                            }
                        });
                    }, function(msg) {
                        showAlert('提示', msg ? msg : '加载会员信息出错!');
                        var shoukuanData = {
                            totalAmount : parseFloat(record.get('totalAmount')).toFixed(2),
                            sellAmount : parseFloat(record.get('sellAmount')).toFixed(2),
                            discount : parseFloat(record.get('discount')).toFixed(2),
                            teaAmount : teaAmount,
                            selectCustomerInfo : null,
                            costAmount : Ext.getCmp("shouyinMainView").costAmount
                        };
                        shoukuanView.loadData(shoukuanData, function (success, isPrePayDef) {
                            if (success) {
                                showBy(shoukuanView, Ext.getCmp('shouyinMainView'),10);
                                if (isPrePayDef) {
                                    selectType(Ext.get('sk-paytype-prepayAmount'), '2');
                                }
                            }
                        });
                    });
                } else {
                    var shoukuanData = {
                        totalAmount : parseFloat(record.get('totalAmount')).toFixed(2),
                        sellAmount : parseFloat(record.get('sellAmount')).toFixed(2),
                        discount : parseFloat(record.get('discount')).toFixed(2),
                        teaAmount : teaAmount,
                        selectCustomerInfo : null,
                        costAmount : Ext.getCmp("shouyinMainView").costAmount
                    };
					if(parseFloat(shoukuanData.totalAmount) < 0){
						shoukuanData.totalAmount = 0;
						shoukuanData.sellAmount = 0;
					}
                    shoukuanView.loadData(shoukuanData, function (success, isPrePayDef) {
                        if (success) {
                            showBy(shoukuanView, Ext.getCmp('shouyinMainView'),10);
                            if (isPrePayDef) {
                                selectType(Ext.get('sk-paytype-prepayAmount'), '2');
                            }
                        }
                    });
                }
            });
		}
		else if (!success) {
            showAlert('提示', '获取订单状态失败!');
            return;
        } else if (status == '1') {
            Ext.getCmp('putup-main-view').loadData();
            // showAlert('提示', '该订单已完成！');
			showToast('该订单已完成收款，不再进行收款!');
            return;
        } else if (status == '3') {
            Ext.getCmp('putup-main-view').loadData();
            showAlert('提示', '该订单已被撤销!');
            return;
        }
    });
}

function checkSellInfoStatus(id, callback) {
	SellDao.getSellInfoById(id, function (success, info) {
		if (info && info.status != null) {
			return callback && callback(success, info.status)
		} else return callback && callback(false, null);
    })
}