/**
 * Created by cjc on 17/4/6.
 */
Ext.define('Seller.view.takeout.meituanMain.Order', {
    extend : 'Ext.data.Model',
    config : {
        fields : ['id', 'orderId', 'orderIdView', 'sellerId', 'caution', 'cTime', 'daySeq', 'deliveryTime', 'hasInvoiced',
                  'invoiceTitle', 'isPre', 'isFavorites', 'isPoiFirstOrder', 'isThirdShipping',
                  'logisticsCode', 'logisticsCompletedTime', 'logisticsConfirmTime', 'logisticsDispathcerTime',
                  'shipperPhone', 'logisticsFetchTime', 'logisticsId', 'logisticsName', 'logisticsSendTime',
                  'logisticsStatus', 'originalPrice', 'payType', 'poiAddress', 'poiName', 'poiPhone', 'recipientAddress',
                  'recipientName', 'recipientPhone', 'shippingFee', 'status', 'total', 'orderCompletedTime', 'orderConfirmTime',
                  'orderCancelTime', 'cancelReasonCode', 'cancelReason', 'dinnersNumber', 'notifyType',
                  'refundReason', 'fooShareFeeChargeByPoi', 'onlinePayment', 'wmPoiReceiveCent', 'isPush', 'waimainSource', 'courierName', 'courierPhone','showStatus', 'orderClerkId','orderClerkName']
    }
});

Ext.define('Seller.view.takeout.meituanMain.OrderDetail', {
	extend : 'Ext.data.Model',
	config : {
		fields : ['id', 'orderId', 'commodityId', 'boxNum', 'boxPrice', 'foodName', 'price', 'skuId', 'quantity', 
		          'unit', 'waimaiSource', 'sellAmount']
	}
});

/**
 * generator enum object
 * @param enumObject
 * @param values
 * @param keys
 * @returns
 */
function generatorEnum(enumObject, values, keys) {
	if(!enumObject) return;
	if(!values) return;
	if(!keys) return;
	if(values.length != keys.length) return;
	for(var vali=0,vallen=values.length;vali<vallen;vali++) {
		if(keys.length > vali) {
			Object.defineProperty(enumObject, keys[vali], {
				value : values[vali],
				configurable : false,
				writable : false
			})
		}
	}
}

var meituanOrderEnum = {};
generatorEnum(meituanOrderEnum, [1, 2, 3, 4, 5, 6],
		["WAIT_ORDER", "WAIT_SEND", "WAIT_PAYOFF", "CANCEL_ORDER", "ORDER_WHOLE", "CANCEL_CONFIRM"]);

var meituanPageLimitCount = 5;
Ext.define('Seller.view.takeout.meituanMain', {
    extend : 'Ext.Container',
    requires : ['Seller.view.takeout.meituanMain.Order', 'Seller.view.takeout.meituanMain.OrderDetail'],
    alias : ['widget.meituanMain'],
    categoryPage : new $.PageUtil({
        limitCount : meituanPageLimitCount
    }),
    config : {
        id : 'take-out-meituan-main',
        centered : true,
        width : '100%',
        height : '100%',
        layout : 'hbox',
        items : [{
            xtype : 'toolbar',
            docked : 'top',
            title : '美团外卖',
            style : 'border-bottom:1px solid #fff;',
            items : [{
                xtype : 'button',
                //cls : 'close-button',
                cls : 'close-button-complete',
                width : 80,
                iconCls : 'close-icon',
                icon : 'resources/icon/public/back.png',
                text : '返回',
                id : 'meituan-main-close',
                handler : function() {
                    var mainContainer = Ext.getCmp('take-out-meituan-main');
                    var parentContainer = mainContainer.getParent();
                    //if(parentContainer) parentContainer.destroy();
                    if(parentContainer) parentContainer.hide();
                }
            }]
        }, {
            xtype : 'container',
            flex : 1,
            cls : 'sy-bg',
            layout : 'hbox',
            items : [{
                xtype : 'container',
                layout : 'vbox',
                flex : 1.5,
                items : [{
                    xtype : 'container',
                    width : '100%',
                    height : '100%',
                    layout : 'vbox',
                    items : [{
                        xtype : 'container',
                        margin : "3",
                        layout : 'hbox',
                        baseCls : 'bg-transparent',
                        height: 44,
                        defaults : {
                            labelWidth : '68%',
                            labelAlign : 'right',
                            style : 'line-height: 32px;',
                            cls : 'margin:0 5px;',
                            inputCls : 'input-radio-width',
                            labelCls : 'white-color text-center',
                            flex : 1,
                            listeners : {
                                check : function(radioView, e, eOpts) {
                                	preventEventBubble(e);
                                	Ext.getCmp('take-out-meituan-main').changeMtOrderCheck(radioView, e, eOpts);
                                }
                            }
                        },
                        items : [{
                            xtype : 'radiofield',
                            checked : true,
                            value : '0',
                            id : 'meituan-order-receive',
                            label : '待接单',
                            name : 'name-mt-order-recv'
                        }, {
                            xtype : 'radiofield',
                            checked : false,
                            id : 'meituan-order-send',
                            label : '待配送',
                            name : 'name-mt-order-send',
                            value : '1'
                        }, {
                            xtype : 'radiofield',
                            checked : false,
                            id : 'meituan-order-payoff',
                            label : '待收银',
                            name : 'name-mt-order-payoff',
                            value : '2'
                        }]
                    }, {
                        xtype : 'fieldset',
                        layout : 'hbox',
                        baseCls : 'bg-transparent',
                        height: 44,
                        cls : 'jz-center',
                        defaults : {
                            //labelWidth : 80,
                            //labelAlign : 'right',
                            //style : 'line-height : 32px;',
                            //labelCls : 'white-color',
                            //cls : 'color:white;',
                            labelWidth : '68%',
                            labelAlign : 'right',
                            style : 'line-height: 32px;',
                            cls : 'margin:0 5px;',
                            inputCls : 'input-radio-width',
                            labelCls : 'white-color text-center',
                            flex : 1,
                            listeners : {
                                check : function(radioView, e, eOpts) {
                                	preventEventBubble(e);
                                	Ext.getCmp('take-out-meituan-main').changeMtOrderCheck(radioView, e, eOpts);
                                }
                            }
                        },
                        items : [{
                            xtype : 'radiofield',
                            checked : false,
                            value : '4',
                            id : 'meituan-order-wait-cancel',
                            name : 'name-mt-order-wait-cancel',
                            label : '取消待处理'
                        }, {
                            xtype : 'radiofield',
                            checked : false,
                            value : '3',
                            id : 'meituan-order-cancel',
                            name : 'name-mt-order-cancel',
                            label : '已取消/作废'
                        }, {
                            xtype : 'radiofield',
                            checked : false,
                            value : '5',
                            id : 'meituan-order-all',
                            name : 'name-mt-order-all',
                            label : '全部'
                        }]
                    }, {
                        id : 'meituan-category-list',
                        xtype : 'list',
                        margin : '6 15',
                        width : '90%',
                        //height : '80%',
                        height : '75%',
                        cls : 'tm-bg',
                        baseCls : 'bg-transparent',
                        store : Ext.create('Ext.data.Store', {
                            //data : []
                        	//fields : ['id', 'recipientName', 'recipientPhone', 'cTime', 'recipientAddress'],
                        	model : 'Seller.view.takeout.meituanMain.Order',
                            id : 'meituan-category-store',
                            autoLoad : false
                        }),
                        mode : 'MULTI', //'SINGLE',
                        selectedCls : 'checkedbg2',
                        itemCls : 'box-center',
                        //itemTpl : new Ext.XTemplate('<div style="border-bottom:1px solid #fff;height:74px;padding:12px 15px;"><div style="height:22px;line-height:22px;height:90px;" class="text-overflow"><span>{recipientName}</span><span>({recipientPhone})</span></div><div style="height:22px;line-height:22px;" class="text-overflow"><span>{cTime}</span><span>{recipientAddress}</span></div></div>'),
                        //itemTpl : new Ext.XTemplate('<div id="takeout-mt-order-{orderId}" class="takeout-mt-order-cls" <tpl if="courierName">style="border-bottom:1px solid #fff;height:120px;padding:3px 15px;width:100%;"<tpl else>style="border-bottom:1px solid #fff;height:120px;padding:15px 15px;width:100%;"</tpl>><tpl if="status==\'1\'||status==\'2\'||status==\'3\'"><div class="status1"></div><tpl elseif="status==\'4\'"><div class="status4"></div><tpl elseif="status==\'6\'"><div class="status6"></div><tpl elseif="status==\'8\'"><div class="status8"></div><tpl elseif="status==\'9\'"><div class="status9"></div></tpl><div style="height:22px;line-height:22px;" class="text-overflow"><span>{recipientName}</span><span>({recipientPhone})</span></div><div style="height:22px;line-height:22px;" class="text-overflow"><span>{cTime}</span></div><tpl if="courierName"><div style="height:22px;line-height:22px;width:100%;">送货员:{courierName}</div></tpl><div style="height:22px;line-height:22px;width:90%;">{recipientAddress}</div></div>'),
                        //<tpl if="status==\'1\'||status==\'2\'||status==\'3\'"><div class="status1"></div><tpl elseif="status==\'4\'"><div class="status4"></div><tpl elseif="status==\'6\'"><div class="status6"></div><tpl elseif="status==\'8\'"><div class="status8"></div><tpl elseif="status==\'9\'"><div class="status9"></div></tpl>
                        //itemTpl : new Ext.XTemplate('<div id="takeout-mt-order-{orderId}" class="takeout-mt-order-cls" style="border-bottom:1px solid #fff;height:120px;"><tpl if="status==\'1\'||status==\'2\'||status==\'3\'"><div class="status1"></div><tpl elseif="status==\'4\'"><div class="status4"></div><tpl elseif="status==\'6\'"><div class="status6"></div><tpl elseif="status==\'8\'"><div class="status8"></div><tpl elseif="status==\'9\'"><div class="status9"></div></tpl><div <tpl if="courierName">style="height:100%;padding:3px 15px;width:100%;"<tpl else>style="height:100%;padding:15px 15px;width:100%;"</tpl>><div style="height:22px;line-height:22px;" class="text-overflow"><span>{recipientName}</span><span>({recipientPhone})</span><tpl if="payType==\'2\'"><span style="color:red;margin-left:10px;">已支付</span></tpl><tpl if="logisticsCode!=\'0000\'"><span style="color:red;margin-left:10px;"><tpl if="logisticsStatus==\'0\'">配送单发往配送<tpl elseif="logisticsStatus==\'10\'">配送单已确认<tpl elseif="logisticsStatus==\'20\'">骑手已取餐<tpl elseif="logisticsStatus==\'100\'">配送单已取消<tpl else></tpl></span></tpl></div><div style="height:22px;line-height:22px;" class="text-overflow"><span>{cTime}</span></div><tpl if="courierName"><div style="height:22px;line-height:22px;width:100%;">送货员:{courierName}</div></tpl><div style="height:22px;line-height:22px;width:100%;">{recipientAddress}</div></tpl></div>'),
                        itemTpl : new Ext.XTemplate('<div id="takeout-mt-order-{orderId}" class="takeout-mt-order-cls" style="border-bottom:1px solid #fff;height:120px;"><tpl if="status==\'1\'||status==\'2\'||status==\'3\'"><div class="status1"></div><tpl elseif="status==\'4\'"><div class="status4"></div><tpl elseif="status==\'6\'"><div class="status6"></div><tpl elseif="status==\'8\'"><div class="status8"></div><tpl elseif="status==\'9\'"><tpl if="showStatus==\'1\'"><div class="showStatus1"></div><tpl elseif="showStatus==\'2\'"><div class="showStatus2"></div><tpl else><div class="status9"></div></tpl></tpl><div <tpl if="courierName">style="height:100%;padding:3px 15px;width:100%;"<tpl else>style="height:100%;padding:15px 15px;width:100%;"</tpl>><div style="height:22px;line-height:22px;" class="text-overflow"><span>{recipientName}</span><span>({recipientPhone})</span><tpl if="payType==\'2\'"><span style="color:red;margin-left:10px;">已支付</span></tpl><tpl if="logisticsCode!=\'0000\'"><span style="color:red;margin-left:10px;"><tpl if="logisticsStatus==\'0\'">配送单发往配送<tpl elseif="logisticsStatus==\'10\'">配送单已确认<tpl elseif="logisticsStatus==\'20\'">骑手已取餐<tpl elseif="logisticsStatus==\'100\'">配送单已取消<tpl else></tpl></span></tpl></div><div style="height:22px;line-height:22px;" class="text-overflow"><span>{cTime}</span><span style="margin-left:5px;">美团订单号:{orderId}</span></div><tpl if="courierName"><div style="height:22px;line-height:22px;width:100%;">送货员:{courierName}</div></tpl><div style="height:22px;line-height:22px;width:100%;">{recipientAddress}</div></div></div>'),
                        emptyText : '没有找到数据',
                        listeners : {
                            itemtap : function(listView, index, target, record, e, eOpts) {
                            	preventEventBubble(e);
                            },
                            select : function(listView, record, eOpts) {
                            	Ext.getCmp('take-out-meituan-main').loadDetailData(record);
                                Ext.getCmp('take-out-meituan-main').showMtOrderFloatBtn(listView, record);
                            },
                            deselect : function(listView, record, supressed, eOpts) {
                            	Ext.getCmp('take-out-meituan-main').loadDetailData(record);
                                Ext.getCmp('take-out-meituan-main').showMtOrderFloatBtn(listView, record);
                            }
                        }
                    }, {
                        xtype : 'container',
                        height : 35,
                        //width : 145,
                        hidden : true,
                        id : 'mtOrderDetailBtn',
                        margin : '0 15 0 0',
                        modal : false,
                        hideOnMaskTap : true,
                        width : '90%',
                        top : 45,
                        layout : 'vbox',
                        items : [{
                            xtype: 'container',
                            height: 35,
                            defaults: {
                                xtype: 'button',
                            },
                            layout: 'hbox',
                            items: [{
                                xtype : 'spacer'
                            }, {
                                width: 70,
                                text: '不接',
                                id : 'id-mt-order-left-btn',
                                cls: 'red-button',
                                //cls : 'sy-tm-button',
                                margin : '0 5 0 0',
                                handler: function () {
                                    var btnText = this.getText();
                                    if(btnText == '不接') {
                                    	//if(!checkPermissions(PERMISSIONS.MTORDERREJECT, true)) return;
                                    	checkPermissions(PERMISSIONS.MTORDERREJECT, true)
                                    	.then(function() {Ext.getCmp('take-out-meituan-main').cancelOrderView();})
                                    	.catch(function() {});
                                    } else if(btnText == '作废') {
                                    	//if(!checkPermissions(PERMISSIONS.MTORDERCANCELDISPATCH, true)) return;
                                    	checkPermissions(PERMISSIONS.MTORDERCANCELDISPATCH, true)
                                    	.then(function() {Ext.getCmp('take-out-meituan-main').cancelDeliverView();})
                                        .catch(function() {});
                                    } else if(btnText == '取消') {
                                        Ext.getCmp('take-out-meituan-main').cancelDeliverView();
                                    }
                                }
                            }, {
                                width: 70,
                                text: '接单',
                                cls: 'red-button',
                                //cls : 'sy-tm-button',
                                id : 'id-mt-order-right-btn',
                                handler: function () {
                                    var btnText = this.getText();
                                    if(btnText == '接单') {
                                    	//if(!checkPermissions(PERMISSIONS.MTORDERRESOLVE, true)) return;
                                    	checkPermissions(PERMISSIONS.MTORDERRESOLVE, true)
                                    	.then(function() {
                                    		Ext.getCmp('take-out-meituan-main').getSelectionItems(function (orderIds, orderDatas, isSelfDeliver) {
                                                if (!orderIds || orderIds.length <= 0) return;
                                                if(isSelfDeliver)
                                                	Ext.getCmp('take-out-meituan-main').resolveOrderView(orderIds, orderDatas, isSelfDeliver);
                                			    else
                                			    	Ext.getCmp('take-out-meituan-main').resolveOrderViewForMt(orderIds, orderDatas, isSelfDeliver);
                                            });
                                    	}).catch(function() {});
                                    } else if(btnText == '配送') {
                                    	//if(!checkPermissions(PERMISSIONS.MTORDERDISPATCH, true)) return;
                                    	checkPermissions(PERMISSIONS.MTORDERDISPATCH, true)
                                    	.then(function() {
                                            Ext.getCmp('take-out-meituan-main').getSelectionItemForDeliver(function(deliverDatas) {
                                                if(!deliverDatas || deliverDatas.length <= 0) return;
                                                Ext.getCmp('take-out-meituan-main').resolveDeliverView(deliverDatas);
                                            });
                                        })
                                    	.catch(function() {});
                                    } else if(btnText == '结算') {
                                    	//if(!checkPermissions(PERMISSIONS.MTORDERPAYOFF, true)) return;
                                    	checkPermissions(PERMISSIONS.MTORDERPAYOFF, true)
                                    	.then(function() {
                                            Ext.getCmp('take-out-meituan-main').getSelectionItemForPayOff(function(payOffData) {
                                                if(!payOffData) return;
                                                Ext.getCmp('take-out-meituan-main').resolvePayOffView(payOffData);
                                            });
                                        })
                                    	.catch(function() {});
                                    } else if(btnText == '确认') {
                                        Ext.getCmp('take-out-meituan-main').getSelectionItemForCancelConfirm(function(cancelConfirmData) {
                                            if(!cancelConfirmData) return;
                                            Ext.getCmp('take-out-meituan-main').resolveCancelConfirmView(cancelConfirmData);
                                        });
                                    }
                                }
                            }]
                        }]
                    }, {
                        xtype : 'container',
                        layout : 'hbox',
                        width : '100%',
                        padding : '5 30 5 20',
                        height : 40,
                        items : [{
                        	xtype : 'container',
                        	layout : 'hbox',
                        	flex : 1.8,
                        	id : 'id-mt-wait-order',
                        	margin : '0 5 0 0',
                        	items : [{
                        		xtype : 'button',
                        		cls : 'sy-tm-button',
                        		//width : 78,
                        		flex : 1,
                        		margin : '0 5 0 0',
                        		text : '不接',
                        		handler : function(currView, e, eOpts) {
                        			/*Ext.getCmp('take-out-meituan-main').getSelectionItems(function(tOrderIds, cancelTypes) {
                        				Ext.getCmp('take-out-meituan-main').getCancelTypes(function(orderIds, mtOrderIds) {
                        					MTOrderDao.cancelMtOrders(orderIds, function(success) {
                            					console.warn(arguments);
                            				});
                        					MTOrderDao.cancelMtOrdersMTP(mtOrderIds, function(success) {
                            					console.warn(arguments);
                            				});
                        				});
                        			});*/
                        			preventEventBubble(e);
                                    checkPermissions(PERMISSIONS.MTORDERREJECT, true)
                                    .then(function() {
                                        Ext.getCmp('take-out-meituan-main').getSelectionItemsForCancel(function(cancelSelected) {
                                            if(cancelSelected && cancelSelected.length > 0)
                                                Ext.getCmp('take-out-meituan-main').cancelOrderViews();
                                        });
                                    });
                        		}
                        	}, {
                        		xtype : 'button',
                        		cls : 'sy-tm-button',
                        		//width : 78,
                        		flex : 1,
                        		text : '接单',
                        		handler : function(currView, e, eOpts) {
                                    preventEventBubble(e);
                                    checkPermissions(PERMISSIONS.MTORDERRESOLVE, true)
                                    .then(function() {
                                        Ext.getCmp('take-out-meituan-main').getSelectionItems(function(orderIds, orderDatas, isSelfDeliver) {
                                            if(!orderIds || orderIds.length <= 0) return;
                                            if(isSelfDeliver)
                                                Ext.getCmp('take-out-meituan-main').resolveOrderView(orderIds, orderDatas, isSelfDeliver);
                                            else
                                                Ext.getCmp('take-out-meituan-main').resolveOrderViewForMt(orderIds, orderDatas, isSelfDeliver);
                                        });
                                    });
                                }
                        	}]
                        }, {
                        	xtype : 'container',
                        	layout : 'hbox',
                        	flex : 1.8,
                        	id : 'id-mt-wait-send',
                        	hidden : true,
                        	margin : '0 5 0 0',
                        	items : [{
                        		xtype : 'button',
                        		cls : 'sy-tm-button',
                        		//width : 78,
                        		flex : 1,
                        		margin : '0 5 0 0',
                        		//text : '取消',
                        		text : '作废',
                        		handler : function(currView, e, eOpts) {
                                    preventEventBubble(e);
                                    checkPermissions(PERMISSIONS.MTORDERCANCELDISPATCH, true)
                                    .then(function() {
                                        Ext.getCmp('take-out-meituan-main').getSelectionItemsForCancel(function (cancelSelected) {
                                            if (cancelSelected && cancelSelected.length > 0)
                                                Ext.getCmp('take-out-meituan-main').cancelDeliverViews();
                                        });
                                    });
                                }
                        	}, {
                        		xtype : 'button',
                        		cls : 'sy-tm-button',
                        		//width : 78,
                        		flex : 1,
                        		text : '配送',
                        		handler : function(currView, e, eOpts) {
                                    preventEventBubble(e);
                                    checkPermissions(PERMISSIONS.MTORDERDISPATCH, true)
                                    .then(function() {
                                        Ext.getCmp('take-out-meituan-main').getSelectionItemForDeliver(function (deliverDatas) {
                                            if (!deliverDatas || deliverDatas.length <= 0) return;
                                            Ext.getCmp('take-out-meituan-main').resolveDeliverView(deliverDatas);
                                        });
                                    });
                                }
                        	}]
                        }, {
                        	xtype : 'container',
                        	layout : 'hbox',
                        	flex : 1.8,
                        	id : 'id-mt-wait-payoff',
                        	hidden : true,
                        	margin : '0 5 0 0',
                        	items : [{
                        		xtype : 'button',
                        		cls : 'sy-tm-button',
                        		//width : 78,
                        		flex : 1,
                        		margin : '0 5 0 0',
                        		//text : '取消',
                        		text : '作废',
                        		handler : function(currView, e, eOpts) {
                                    preventEventBubble(e);
                                    checkPermissions(PERMISSIONS.MTORDERCANCELPAYOFF, true)
                                    .then(function() {
                                        Ext.getCmp('take-out-meituan-main').getSelectionItemsForCancel(function (cancelSelected) {
                                            if (cancelSelected && cancelSelected.length > 0)
                                                Ext.getCmp('take-out-meituan-main').cancelDeliverViews();
                                        });
                                    });
                                }
                        	}, {
                        		xtype : 'button',
                        		cls : 'sy-tm-button',
                        		//width : 78,
                        		flex : 1,
                        		text : '结算',
                        		handler : function(currView, e, eOpts) {
                                    preventEventBubble(e);
                                    /*Ext.getCmp('take-out-meituan-main').getSelectionItems(function(orderIds) {
                                        if(!orderIds || orderIds.length <= 0) return;
                                        Ext.getCmp('take-out-meituan-main').resolvePayOffView(orderIds);
                                    });*/
                                    checkPermissions(PERMISSIONS.MTORDERPAYOFF, true)
                                    .then(function() {
                                        Ext.getCmp('take-out-meituan-main').getSelectionItemForPayOff(function (payOffData) {
                                            if (!payOffData) return;
                                            Ext.getCmp('take-out-meituan-main').resolvePayOffView(payOffData);
                                        });
                                    });
                                }
                        	}]
                        }, {
                            xtype : 'container',
                            layout : 'hbox',
                            flex : 1,
                            id : 'id-mt-wait-cancel-confirm',
                            hidden : true,
                            margin : '0 5 0 0',
                            items : [{
                                xtype : 'button',
                                cls : 'sy-tm-button',
                                flex : 1,
                                margin : '0 5 0 0',
                                //text : '取消',
                                text : '作废',
                                hidden : true,
                                handler : function() {
                                }
                            }, {
                                xtype : 'button',
                                cls : 'sy-tm-button',
                                flex : 1,
                                text : '批量处理',
                                handler : function(currView, e, eOpts) {
                                    preventEventBubble(e);
                                    Ext.getCmp('take-out-meituan-main').getSelectionItemsForCancelConfirms(function(cancelConfirmDatas) {
                                        if(!cancelConfirmDatas || cancelConfirmDatas.length <= 0) return;
                                        Ext.getCmp('take-out-meituan-main').resolveCancelConfirmViews(cancelConfirmDatas);
                                    });
                                    /*Ext.getCmp('take-out-meituan-main').getSelectionItems(function(payOffData) {
                                        if(!payOffData) return;
                                        Ext.getCmp('take-out-meituan-main').resolvePayOffView(payOffData);
                                    });*/
                                }
                            }]
                        }, {
                            xtype : 'button',
                            cls : 'sy-tm-button',
                            text : '上一页',
                            handler : function(currView, e, eOpts) {
                                preventEventBubble(e);
                                var meituanMainView = Ext.getCmp('take-out-meituan-main');
                                meituanMainView.prevPage();
                            }
                        }, {
                            xtype : 'container',
                            flex : 1,
                            cls : 'jz-center',
                            id : 'mt-category-page-label',
                            html : '1/1'
                        }, {
                            xtype : 'button',
                            cls : 'sy-tm-button',
                            text : '下一页',
                            handler : function(currView, e, eOpts) {
                                preventEventBubble(e);
                                var meituanMainView = Ext.getCmp('take-out-meituan-main');
                                meituanMainView.nextPage();
                            }
                        }]
                    }]
                }]
            }, {
                xtype : 'container',
                layout : 'vbox',
                flex : 2.5,
                items : [{
                    xtype : 'container',
                    //width : '100%',
                    //height : '100%',
                    flex : 3.5,
                    items : [{
                        xtype : 'container',
                        width : '100%',
                        height : 44,
                        cls : 'jz-center',
                        style : 'line-height:44px;border-bottom:1px solid #fff;',
                        html : '<div><span style="width:30%;display:inline-block;" class="jz-center">商品名称</span><span style="width:10%;display:inline-block;" class="jz-center">数量</span><span style="width:20%;display:inline-block;" class="jz-center">价格</span><span style="width:40%;display:inline-block;" class="jz-center">小计</span></div>'
                    }, {
                        id : 'meituan-detail-list',
                        xtype : 'list',
                        width : '100%',
                        height : '90%',
                        baseCls : 'bg-transparent',
                        selectedCls : 'checkedbg2',
                        itemCls : 'jz-center',
                        store : Ext.create('Ext.data.Store', {
                        	model : 'Seller.view.takeout.meituanMain.OrderDetail',
                            id : 'meituan-detail-store',
                            //fields : ['id', 'name', 'num', 'price', 'sellAmount'],
                            autoLoad : false
                        }),
                        //itemTpl : new Ext.XTemplate('<div><span style="width:30%;display:inline-block;text-align:center;">{name}</span><span style="width:10%;display:inline-block;text-align:center;">{num}</span><span style="width:20%;display:inline-block;text-align:center;">{price}</span><span style="width:40%;display:inline-block;text-align:center;">{sellAmount}</span></div>'),
                        itemTpl : new Ext.XTemplate('<div><span style="width:30%;display:inline-block;text-align:center;" class="jz-center">{foodName}<tpl if="skuId">({skuId})</tpl></span><span style="width:10%;display:inline-block;text-align:center;" class="jz-center">{quantity}</span><span style="width:20%;display:inline-block;text-align:center;" class="jz-center">{price}</span><span style="width:40%;display:inline-block;text-align:center;" class="jz-center">{sellAmount}</span></div>'),
                        emptyText : '没有相应数据'
                    }]
                },  {
                	xtype : 'container',
                	flex : 1,
                	layout : 'vbox',
                	style : 'border-top:1px solid #fff;',
                	items : [{
                		xtype : 'container',
                		layout: 'hbox',
                		defaults : {
                			xtype : 'textfield',
                			readOnly : true,
                			labelWidth : 90,
                            flex : 1,
                			labelCls : 'white-color',
                			inputCls : 'bg-transparent white-color'
                		},
                		items : [{
                			id : 'id-mt-order-sellAmount',
                			label : '总额:'
                		}, {
                			id : 'id-mt-order-number',
                			label : '件数:'
                		}, {
                		    id : 'id-mt-order-fee',
                            label : '配送费:'
                        }]
                	}, {
                        xtype : 'container',
                        layout : 'hbox',
                        defaults : {
                            xtype : 'textfield',
                            readOnly : true,
                            labelWidth : 105,
                            flex : 1,
                            labelCls : 'white-color',
                            inputCls : 'bg-transparent white-color'
                        },
                        items : [{
                            id : 'id-mt-order-courier-name',
                            label : '送货员名称:'
                        }, {
                            id : 'id-mt-order-courier-phone',
                            //flex : 2,
                            label : '送货员电话:'
                        }, {
                            id : 'id-mt-order-box-amount',
                            label: '餐盒费:',
                            hidden : false,
                        }]
                    }, {
                		xtype : 'container',
                		layout : 'hbox',
                		defaults : {
                			xtype : 'textfield',
                			readOnly : true,
                			labelWidth : 90,
                            flex : 1,
                			labelCls : 'white-color',
                			inputCls : 'bg-transparent white-color'
                		},
                		items : [{
                			id : 'id-mt-order-bill-name',
                			label : '发票:'
                		}, {
                			id : 'id-mt-order-comment',
                			label : '备注:',
                            flex : 2
                		}, {
                		    id : 'id-mt-order-empty-1',
                            hidden : true,
                            label : ''
                        }]
                	}, {
                		xtype : 'container',
                		layout : 'hbox',
                		flex : 1,
                        hidden : true,
                		items : [{
                			xtype : 'container',
                			width : '100%',
                			html : '<p>----</p>'
                		}]
                	}]
                }]
            }]
        }]
    },
    initialize : function() {
    },
    getRadioItems : function() {
        return [{
            radioName : "meituan-order-receive",
            loadDataType : meituanOrderEnum.WAIT_ORDER
        }, {
            radioName : "meituan-order-send",
            loadDataType : meituanOrderEnum.WAIT_SEND
        }, {
            radioName : "meituan-order-payoff",
            loadDataType : meituanOrderEnum.WAIT_PAYOFF
        }, {
            radioName : "meituan-order-cancel",
            loadDataType : meituanOrderEnum.CANCEL_ORDER
        }, {
            radioName : "meituan-order-all",
            loadDataType : meituanOrderEnum.ORDER_WHOLE
        }, {
            radioName : 'meituan-order-wait-cancel',
            loadDataType : meituanOrderEnum.CANCEL_CONFIRM
        }];
    },
    getSelectedRadio : function() {
        var radioItems = this.getRadioItems();
        var rdlen = radioItems.length;
        for(var rdi=0;rdi<rdlen;rdi++) {
            if(Ext.getCmp(radioItems[rdi].radioName).getChecked())
                return radioItems[rdi].radioName;
        }
    },
    changeMtOrderCheck : function(radioView, e, eOpts) {
    	var curRadioId = radioView.getId();
        var radioIds = ["meituan-order-receive", "meituan-order-send", "meituan-order-payoff",
            "meituan-order-cancel", "meituan-order-all", "meituan-order-wait-cancel"];
        for(var ri=0,rlen=radioIds.length;ri<rlen;ri++) {
            if(radioIds[ri] != curRadioId) {
                Ext.getCmp(radioIds[ri]).uncheck();
            }
        }
        var me = Ext.getCmp('take-out-meituan-main');
        if(curRadioId == 'meituan-order-receive') {
        	Ext.getCmp('id-mt-wait-order').setHidden(false);
        	Ext.getCmp('id-mt-wait-send').setHidden(true);
        	Ext.getCmp('id-mt-wait-payoff').setHidden(true);
            Ext.getCmp('id-mt-wait-cancel-confirm').setHidden(true);
        	me.loadData(meituanOrderEnum.WAIT_ORDER);
            Ext.getCmp('meituan-category-list').setMode('MULTI');
        } else if(curRadioId == 'meituan-order-send') {
        	Ext.getCmp('id-mt-wait-order').setHidden(true);
        	Ext.getCmp('id-mt-wait-send').setHidden(false);
        	Ext.getCmp('id-mt-wait-payoff').setHidden(true);
            Ext.getCmp('id-mt-wait-cancel-confirm').setHidden(true);
        	me.loadData(meituanOrderEnum.WAIT_SEND);
            Ext.getCmp('meituan-category-list').setMode('MULTI');
        } else if(curRadioId == 'meituan-order-payoff') {
        	Ext.getCmp('id-mt-wait-order').setHidden(true);
        	Ext.getCmp('id-mt-wait-send').setHidden(true);
        	Ext.getCmp('id-mt-wait-payoff').setHidden(false);
            Ext.getCmp('id-mt-wait-cancel-confirm').setHidden(true);
        	me.loadData(meituanOrderEnum.WAIT_PAYOFF);
            Ext.getCmp('meituan-category-list').setMode('MULTI');
        } else if(curRadioId == 'meituan-order-cancel') {
        	Ext.getCmp('id-mt-wait-order').setHidden(true);
        	Ext.getCmp('id-mt-wait-send').setHidden(true);
        	Ext.getCmp('id-mt-wait-payoff').setHidden(true);
            Ext.getCmp('id-mt-wait-cancel-confirm').setHidden(true);
        	me.loadData(meituanOrderEnum.CANCEL_ORDER);
            Ext.getCmp('meituan-category-list').setMode('SINGLE');
        } else if(curRadioId == 'meituan-order-all') {
        	Ext.getCmp('id-mt-wait-order').setHidden(true);
        	Ext.getCmp('id-mt-wait-send').setHidden(true);
        	Ext.getCmp('id-mt-wait-payoff').setHidden(true);
            Ext.getCmp('id-mt-wait-cancel-confirm').setHidden(true);
        	me.loadData(meituanOrderEnum.ORDER_WHOLE);
            Ext.getCmp('meituan-category-list').setMode('SINGLE');
        } else if(curRadioId == 'meituan-order-wait-cancel') {
            Ext.getCmp('id-mt-wait-order').setHidden(true);
            Ext.getCmp('id-mt-wait-send').setHidden(true);
            Ext.getCmp('id-mt-wait-payoff').setHidden(true);
            Ext.getCmp('id-mt-wait-cancel-confirm').setHidden(false);
            me.loadData(meituanOrderEnum.CANCEL_CONFIRM);
            Ext.getCmp('meituan-category-list').setMode('MULTI');
        }
        Ext.getCmp('mtOrderDetailBtn').hide();
    },
    showMtOrderFloatBtn : function(listView, record) {
        var me = this;
        var selectedItems = listView.getSelection();
        if(selectedItems.length > 1 || selectedItems.length <= 0) {
            Ext.getCmp('mtOrderDetailBtn').hide();
            return;
        }
        var selectedRecord = selectedItems[0];
        var listViewStore = listView.getStore();
        var index = listViewStore.indexOf(selectedRecord);
        if(index == -1) return;

        var topOffset = 130;
        var itemOffset = $('#takeout-mt-order-' + selectedRecord.get('orderId'))[0].offsetHeight * index;
        var status = selectedRecord.get('status');
        //console.log(status);
        Ext.getCmp('mtOrderDetailBtn').hide();
        if(status) {
            if(status == '1' || status=='2'|| status=='3') { //用户提交订单或商家已收到
                Ext.getCmp('mtOrderDetailBtn').show();
                Ext.getCmp('id-mt-order-left-btn').setText('不接');
                Ext.getCmp('id-mt-order-left-btn').setHidden(false);
                Ext.getCmp('id-mt-order-right-btn').setText('接单');
            } else if(status == '4') { // 确认
                Ext.getCmp('mtOrderDetailBtn').show();
                if(selectedRecord.get('logisticsCode') == '0000') {
                    Ext.getCmp('id-mt-order-left-btn').setText('作废');
                    Ext.getCmp('id-mt-order-left-btn').setHidden(false);
                    Ext.getCmp('id-mt-order-right-btn').setText('配送');
                } else {
                    Ext.getCmp('id-mt-order-left-btn').setText('取消');
                    Ext.getCmp('id-mt-order-left-btn').setHidden(false);
                }
            } else if(status == '6') { // 已配送
                Ext.getCmp('mtOrderDetailBtn').show();
                Ext.getCmp('id-mt-order-left-btn').setText('作废'); // 退款
                Ext.getCmp('id-mt-order-left-btn').setHidden(false);
                Ext.getCmp('id-mt-order-right-btn').setText('结算');
            } else if(status == '8') { // 已完成
                //Ext.getCmp('mtOrderDetailBtn').show();
                //Ext.getCmp('id-mt-order-left-btn').setText('不接');
                //Ext.getCmp('id-mt-order-right-btn').setText('接单');
            } else if(status == '9') {
                if(me.getSelectedRadio() == 'meituan-order-wait-cancel') {
                    Ext.getCmp('mtOrderDetailBtn').show();
                    Ext.getCmp('id-mt-order-left-btn').setHidden(true);
                    Ext.getCmp('id-mt-order-right-btn').setText('确认');
                }
            }
            Ext.getCmp('mtOrderDetailBtn').setTop(topOffset + itemOffset);
            //Ext.getCmp('mtOrderDetailBtn').setLeft(320);
        }
    },
    getSelectionItemForDeliver : function(callback) {
        var mtCategoryCmp = Ext.getCmp('meituan-category-list');
        var selectedItems = mtCategoryCmp.getSelection();
        var selectedLen = selectedItems.length;
        var deliverSelected = [];
        for(var si=0;si<selectedLen;si++) {
            var record = selectedItems[si];
            if(record) {
                if(record.get('logisticsCode') != '0000') {
                    showAlert('提示', '美团专送的单不需要配送!');
                    callback && callback([]);
                    return;
                }
                deliverSelected.push({
                    'logisticsCode' : record.get('logisticsCode'),
                    'orderId': record.get('orderId'),
                    'courierName' : record.get('courierName'),
                    'courierPhone' : record.get('courierPhone'),
                    'payType' : record.get('payType')
                });
            }
        }
        callback && callback(deliverSelected);
    },
    getSelectionItemForCancel : function(callback) {
        var mtCategoryCmp = Ext.getCmp('meituan-category-list');
        var selectedItems = mtCategoryCmp.getSelection();
        var selectedLen = selectedItems.length;
        if(selectedLen <= 0) return;
        var record = selectedItems[0];
        var cancelSelected = {
            'orderId' : record.get('orderId'),
            'cancelReason' : record.get('cancelReason'),
            'cancelReasonCode' : record.get('cancelReasonCode'),
            'logisticsCode' : record.get('logisticsCode'),
            'logisticsStatus' : record.get('logisticsStatus')
        };
        callback && callback(cancelSelected);
        return;
        var deliverSelected = [];
        for(var si=0;si<selectedLen;si++) {
            var record = selectedItems[si];
            if(record) {
                deliverSelected.push({
                    'logisticsCode' : record.get('logisticsCode'),
                    'orderId': record.get('orderId'),
                    'courierName' : record.get('courierName'),
                    'courierPhone' : record.get('courierPhone')
                });
            }
        }
        callback && callback(deliverSelected);
    },
    getSelectionItemsForCancel : function(callback) {
        var mtCategoryCmp = Ext.getCmp('meituan-category-list');
        var selectedItems = mtCategoryCmp.getSelection();
        var selectedLen = selectedItems.length;
        if(selectedLen <= 0) return;
        var cancelSelected = [];
        for(var si=0;si<selectedLen;si++) {
            var record = selectedItems[si];
            if(record) {
                cancelSelected.push({
                    'orderId' : record.get('orderId'),
                    'cancelReason' : record.get('cancelReason'),
                    'cancelReasonCode' : record.get('cancelReasonCode'),
                    'logisticsCode' : record.get('logisticsCode'),
                    'logisticsStatus' : record.get('logisticsStatus')
                });
            }
        }

        callback && callback(cancelSelected);
    },
    getSelectionItemForPayOff : function(callback) {
        var mtCategoryCmp = Ext.getCmp('meituan-category-list');
        var selectedItems = mtCategoryCmp.getSelection();
        var selectedLen = selectedItems.length;
        if(selectedLen <= 0) return;
        var payOffSelected = {};
        payOffSelected.orderIds = [];
        payOffSelected.total = 0;
        var courierName = null;
        var courierPhone = null;
        for(var si=0;si<selectedLen;si++) {
            var record = selectedItems[si];
            if(record) {
                payOffSelected.orderIds.push(record.get('orderId'));
                payOffSelected.courierName = record.get('courierName');
                payOffSelected.courierPhone = record.get('courierPhone');
                var tmpTotal = record.get('total');
                payOffSelected.total += (tmpTotal ? tmpTotal : 0);
                if(!courierName) courierName = payOffSelected.courierName;
                else if(courierName != payOffSelected.courierName) {
                    showAlert('提示', '批量结算时不能选择不同的送货员!');
                    callback && callback(null);
                    return;
                }
                if(!courierPhone) courierPhone = payOffSelected.courierPhone;
            }
        }
        callback && callback(payOffSelected);
    },
    getSelectionItemForCancelConfirm : function(callback) {
        var mtCategoryCmp = Ext.getCmp('meituan-category-list');
        var selectedItems = mtCategoryCmp.getSelection();
        var selectedLen = selectedItems.length;
        if(selectedLen <= 0) return;
        var record = selectedItems[0];
        var cancelConfirm = {};
        if(record) {
            cancelConfirm.isReadCancel = record.get('isReadCancel');
            cancelConfirm.orderId = record.get('orderId');
        }
        callback && callback(cancelConfirm);
    },
    getSelectionItemsForCancelConfirms : function(callback) {
        var mtCategoryCmp = Ext.getCmp('meituan-category-list');
        var selectedItems = mtCategoryCmp.getSelection();
        var selectedLen = selectedItems.length;
        if(selectedLen <= 0) return;
        var cancelConfirm = [];
        for(var si=0;si<selectedLen;si++) {
            var record = selectedItems[si];
            cancelConfirm.push({
                isReadCancel : record.get('isReadCancel'),
                orderId : record.get('orderId')
            });
        }
        callback && callback(cancelConfirm);
    },
    getSelectionItems : function(callback) {
    	var mtCategoryCmp = Ext.getCmp('meituan-category-list');
		var selectedItems = mtCategoryCmp.getSelection();
		var selectedLen = selectedItems.length;
		var orderIds = [];
		var cancelTypes = [];
		var selLogisticsCode = null;
		var isSelfDeliver = true;
		for(var si=0;si<selectedLen;si++) {
			var record = selectedItems[si];
			if(record) {
				if(selLogisticsCode && selLogisticsCode != record.get('logisticsCode')) {
					showAlert('提示', '不能同时选择不同配送方式的单!');
                    callback && callback([]);
                    return;
				}
				selLogisticsCode = record.get('logisticsCode');
				if(selLogisticsCode != '0000') isSelfDeliver = false; 
				orderIds.push(record.get('orderId'));
				cancelTypes.push({
					'logisticsCode' : record.get('logisticsCode'),
					'orderId': record.get('orderId'),
                    'courierName' : record.get('courierName'),
                    'courierPhone' : record.get('courierPhone')
				});
			}
		}
		callback && callback(orderIds, cancelTypes, isSelfDeliver);
    },
    getCancelTypes : function(cancelTypes, callback) {
    	var ctlen = cancelTypes.length;
		var tmpOrderIds = [];
		var tmpMtOrderIds = [];
		for(var cti=0;cti<ctlen;cti++) {
			var logCode = cancelTypes[cti].logisticsCode;
			if(logCode == '0000') {
				tmpOrderIds.push(cancelTypes[cti]['orderId']);
			} else if(logCode == '1001' || logCode == '1002' || 
					logCode == '1003' || logCode == '1004') {
				tmpMtOrderIds.push(cancelTypes[cti]['orderId']);
			}
		}
		
		callback && callback(tmpOrderIds, tmpMtOrderIds);
    },
    getCancelReasonForRejectOrder : function() {
    	// 不接单的原因
    	return [{reasonName:"商家超时接单",code:2001}, 
	    		{reasonName :"非顾客原因修改订单",code:2002}, 
	    		{reasonName : "非顾客原因取消订单",code:2003}, 
	    		{reasonName : "配送延迟",code:2004}, 
	    		{reasonName : "售后投诉", code:2005}, 
	    		{reasonName : "用户要求取消", code:2006} , 
	    		{reasonName:"其他", code:2007}];
    },
    getCancelReasonFromCode : function(code) {
        if(code == 2001) {
            return '商家超时接单';
        } else if(code == 2002) {
            return '非顾客原因修改订单';
        } else if(code == 2003) {
            return '非顾客原因取消订单';
        } else if(code == 2004) {
            return '配送延迟';
        } else if(code == 2005) {
            return '售后投诉';
        } else if(code == 2006) {
            return '用户要求取消';
        } else if(code == 2007) {
            return '其他';
        }
    },
    getCancelReasonForCancel : function() {
    	// 配送取消或结算取消
    	return [{reasonName: "用户取消",code:1103},
    	        {reasonName: "系统取消, 超时未确认", code:1001},
    	        {reasonName: "客服取消, 重复订单", code:1203},
    	        {reasonName: "其他原因", code:1301}];
    },
    getCancelReasonForDeliverCode : function(code) {
        if(code == 1103) {
            return '用户取消';
        } else if(code == 1001) {
            return '系统取消, 超时未确认';
        } else if(code == 1203) {
            return '客服取消, 重复订单';
        } else if(code == 1301) {
            return '其他原因';
        } else return '';
    },
    generatorCancelReasonLabelHtml : function(reasonName, dealCode, onClickCallback) {
        onClickCallback = onClickCallback ? onClickCallback : 'cancelOrderReasonFromLabel';
    	//return {html:'<p style="border-bottom:1px solid #ddd;" onclick="Ext.getCmp(\'take-out-meituan-main\').cancelOrderReasonFromLabel(' + dealCode + ')">' + reasonName + '</p>'};
    	return {html:'<p style="border-bottom:1px solid #ddd;" onclick="Ext.getCmp(\'take-out-meituan-main\').' + onClickCallback + '(' + dealCode + ')">' + reasonName + '</p>'};
    },
    genCancelReasonDeliverLabelHtml : function(reasonName, dealCode, onClickCallback) {
        onClickCallback = onClickCallback ? onClickCallback : 'cancelDeliverReasonFromLabel';
        //return {html:'<p style="border-bottom:1px solid #ddd;" onclick="Ext.getCmp(\'take-out-meituan-main\').cancelDeliverReasonFromLabel(' + dealCode + ')">' + reasonName + '</p>'};
        return {html:'<p style="border-bottom:1px solid #ddd;" onclick="Ext.getCmp(\'take-out-meituan-main\').' + onClickCallback + '(' + dealCode + ')">' + reasonName + '</p>'};
    },
    cancelOrderView : function(type) {
    	var me = this;
    	var cancelOrderView = null;
    	var tmpCancelReasonList = [];
    	var tmpCancelReasonListHtml = [];
    	type = type?type:1;
    	if(type == 1) {
    		tmpCancelReasonList = me.getCancelReasonForRejectOrder();
    	} else if(type == 2) { // 配送取消
    		tmpCancelReasonList = me.getCancelReasonForCancel();
    	}
    	for(var ti=0,tlen=tmpCancelReasonList.length;ti<tlen;ti++) {
    	    if(type == 2) {
                tmpCancelReasonListHtml.push(me.genCancelReasonDeliverLabelHtml(tmpCancelReasonList[ti].reasonName,
                    tmpCancelReasonList[ti].code));
            } else
                tmpCancelReasonListHtml.push(me.generatorCancelReasonLabelHtml(tmpCancelReasonList[ti].reasonName,
                        tmpCancelReasonList[ti].code));
    	}
    	var viewId = 'sel-order-cancel-reason';
        if(type == 2)
            viewId = 'sel-deliver-cancel-reason';
    	if(Ext.getCmp(viewId)) {
    		cancelOrderView = Ext.getCmp(viewId);
    	} else {
	    	cancelOrderView = Ext.Viewport.add({
	    		xtype : 'panel',
	    		centered : true,
	    		modal : true,
	    		hideOnTapMask : false,
	    		width : 300,
	    		height : 400,
	    		id : viewId,
	    		items : [{
	    			xtype : 'toolbar',
	    			docked : 'top',
	    			title : '请选择取消理由',
	    			items : [{
	    				xtype : 'button',
	    				cls : 'close-button',
	    				handler : function() {
	    					if(Ext.getCmp(viewId))
	    						Ext.getCmp(viewId).destroy();
	    				}
	    			}]
	    		}, {
	    			xtype : 'container',
	    			width : '90%',
	    			height : '100%',
	    			margin : '0 0 0 5%',
	    			cls : 'jz-center',
	    			defaults : {
	    				xtype : 'label',
	    				cls : 'jz-center',
	    				height : 45,
	    				width : '90%',
	    				margin : '0 0 0 5%',
	    				handler : function() {
	    					if(Ext.getCmp(viewId))
	    						Ext.getCmp(viewId).destroy();
	    				}
	    			},
	    			items : tmpCancelReasonListHtml
	    		}]
	    	});
    	}
    	cancelOrderView.show();
    },
    cancelOrderViews : function(type) {
        // 批量取消接单
        var me = this;
        var cancelDeliverViews = null;
        var tmpCancelReasonList = [];
        var tmpCancelReasonListHtml = [];
        type = type ? type:1;
        if(type == 1) {
            tmpCancelReasonList = me.getCancelReasonForRejectOrder();
        } else if(type == 2) { // 配送取消
            tmpCancelReasonList = me.getCancelReasonForCancel();
        }
        for(var ti=0,tlen=tmpCancelReasonList.length;ti<tlen;ti++) {
            if(type == 2) {
                tmpCancelReasonListHtml.push(me.genCancelReasonDeliverLabelHtml(tmpCancelReasonList[ti].reasonName,
                    tmpCancelReasonList[ti].code, 'cancelDeliverReasonFromLabels'));
            } else {
                tmpCancelReasonListHtml.push(me.generatorCancelReasonLabelHtml(tmpCancelReasonList[ti].reasonName,
                    tmpCancelReasonList[ti].code, 'cancelOrderReasonFromLabels'));
            }
        }
        var viewId = 'sel-order-cancel-reason';
        if(type == 2) viewId = 'sel-deliver-cancel-reason';
        if(Ext.getCmp(viewId)) {
            cancelDeliverViews = Ext.getCmp(viewId);
        } else {
            cancelDeliverViews = Ext.Viewport.add({
                xtype : 'panel',
                centered : true,
                modal : true,
                hideOnTapMask : false,
                width : 300,
                height : 400,
                id : viewId,
                items : [{
                    xtype : 'toolbar',
                    docked : 'top',
                    title : '请选择取消理由',
                    items : [{
                        xtype : 'button',
                        cls : 'close-button',
                        handler : function() {
                            if(Ext.getCmp(viewId))
                                Ext.getCmp(viewId).destroy();
                        }
                    }]
                }, {
                    xtype : 'container',
                    width : '90%',
                    height : '100%',
                    margin : '0 0 0 5%',
                    cls : 'jz-center',
                    defaults : {
                        xtype : 'label',
                        cls : 'jz-center',
                        height : 45,
                        width : '90%',
                        margin : '0 0 0 5%',
                        handler : function() {
                            if(Ext.getCmp(viewId))
                                Ext.getCmp(viewId).destroy();
                        }
                    },
                    items : tmpCancelReasonListHtml
                }]
            });
        }
        cancelDeliverViews.show();
    },
    cancelDeliverViews : function(type) {
        // 批量取消接单
        this.cancelOrderViews(2);
    },
    cancelOrderReasonFromLabels : function(reasonCode) {
        var me = this;
        var reasonTxt = this.getCancelReasonFromCode(reasonCode);
        this.getSelectionItemsForCancel(function(cancelSelectedDatas) {
            MTOrderDao.cancelMtOrders(cancelSelectedDatas, {
                reason : reasonTxt,
                reasonCode : reasonCode
            }, function(success, msg) {
                if(!success) {
                    showAlert('提示', msg ? msg : '部分处理不成功');
                }
                getMtOrderCount();
                me.loadDataFromRadio();
                refreshMtOrderForSocket();
            });
        });

        if(Ext.getCmp('sel-order-cancel-reason'))
            Ext.getCmp('sel-order-cancel-reason').destroy();
    },
    cancelDeliverReasonFromLabels : function(reasonCode) {
        var me = this;
        var reasonTxt = this.getCancelReasonForDeliverCode(reasonCode);
        this.getSelectionItemsForCancel(function(cancelSelectedDatas) {
            MTOrderDao.cancelMtOrders(cancelSelectedDatas, {
                reason : reasonTxt,
                reasonCode : reasonCode
            }, function(success, msg) {
                if(!success) {
                    showAlert('提示', msg ? msg : '部分处理不成功');
                }
                var clen = cancelSelectedDatas.length;
                var cancelOrderIds = [];
                for(var ci=0;ci<clen;ci++) {
                    cancelOrderIds.push(cancelSelectedDatas[ci].orderId);
                }
                PrintDao.printMtOrdersLogic(12, cancelOrderIds);
                me.loadDataFromRadio();
                refreshMtOrderForSocket();
            });
        });

        if(Ext.getCmp('sel-deliver-cancel-reason'))
            Ext.getCmp('sel-deliver-cancel-reason').destroy();
    },
    cancelOrderReasonFromLabel : function(reasonCode) {
        var me = this;
        var reasonTxt = this.getCancelReasonFromCode(reasonCode);
        this.getSelectionItemForCancel(function(cancelSelectedData) {
            MTOrderDao.cancelMtOrder(cancelSelectedData.orderId, {
                reason : reasonTxt,
                reasonCode : reasonCode
            }, function(success, msg) {
                if(!success) {
                    showAlert('提示', msg ? msg : '取消不成功!');
                }
                getMtOrderCount();
                me.loadDataFromRadio();
                refreshMtOrderForSocket();
            });
        });

        if(Ext.getCmp('sel-order-cancel-reason'))
			Ext.getCmp('sel-order-cancel-reason').destroy();
    },
    cancelDeliverReasonFromLabel : function(reasonCode) {
        var me = this;
        var reasonTxt = this.getCancelReasonForDeliverCode(reasonCode);
        this.getSelectionItemForCancel(function(cancelSelectedData) {
            MTOrderDao.cancelMtOrder(cancelSelectedData.orderId, {
                reason : reasonTxt,
                reasonCode : reasonCode
            }, function(success, msg) {
                if(!success) {
                    showAlert('提示', msg ? msg : '取消不成功!');
                    return;
                }
                PrintDao.printMtOrdersLogic(12, [cancelSelectedData.orderId]);
                me.loadDataFromRadio();
                refreshMtOrderForSocket();
            });
        });

        if(Ext.getCmp('sel-deliver-cancel-reason'))
            Ext.getCmp('sel-deliver-cancel-reason').destroy();
    },
    //resolveOrderView : function(orderIds, fn, logisticsCode) {
    resolveOrderViewForMt : function(orderIds, orderDatas, isSelfDeliver) {
    	var me = this;
    	var resolveOrderViewMt = Ext.Viewport.add({
            xtype : 'panel',
            centered : true,
            hideOnTapMask : false,
            modal : true,
            width : 380,
            height : 200,
            id : 'id-resolve-mt-order-view-mt',
            items : [{
                xtype : 'toolbar',
                docked : 'top',
                title : '接单',
                items : [{
                    xtype : 'button',
                    cls : 'close-button',
                    handler : function() {
                        if(Ext.getCmp('id-resolve-mt-order-view-mt'))
                            Ext.getCmp('id-resolve-mt-order-view-mt').destroy();
                    }
                }, {
                    xtype : 'spacer'
                }, {
                    xtype : 'button',
                    cls : 'sy-tm-button',
                    text : '确认',
                    handler : function() {
                    	showLoading("正在确认订单中, 请稍侯...");
                        MTOrderDao.confirmMtOrdersForMT(orderIds, {courierName:"",courierPhone:""}, function(success, msg) {
                            console.warn(arguments);
                            closeLoading();
                            if(!success) {
                            	showAlert('提示', msg ? msg : '操作失败, 订单已被取消!');
                            }
                            getMtOrderCount();
                            PrintDao.printMtOrdersLogic(1, orderIds);
                            //me.loadData(meituanOrderEnum.WAIT_ORDER);
                            me.loadDataFromRadio();
                            refreshMtOrderForSocket();
                            if(success) { // 生成销售单(非自配送的接单之后都生成销售单)
                            	me.takeoutSellInfoBefore(orderIds);
                            }
                        });
                        var isMtOrderCustomerPrint = Ext.getCmp('mt-order-customer-print').getChecked();
                        var isMtOrderPrivatePrint = Ext.getCmp('mt-order-private-print').getChecked();
                        var isMtOrderKitchenPrint = Ext.getCmp('mt-order-kitchen-print').getChecked();
                        var isMtOrderLabelPrint = Ext.getCmp('mt-order-label-print').getChecked();
                        if(setting && setting.id) {
                            SettingDao.updateSetting({
                                isMtOrderCustomerPrint : isMtOrderCustomerPrint?'1':'0',
                                isMtOrderPrivatePrint : isMtOrderPrivatePrint?'1':'0',
                                isMtOrderKitchenPrint : isMtOrderKitchenPrint?'1':'0',
                                isMtOrderLabelPrint : isMtOrderLabelPrint?'1':'0'
                            }, setting.id, function(success) {
                                if(setting) {
                                    setting.isMtOrderCustomerPrint = isMtOrderCustomerPrint?'1':'0';
                                    setting.isMtOrderPrivatePrint = isMtOrderPrivatePrint?'1':'0';
                                    setting.isMtOrderKitchenPrint = isMtOrderKitchenPrint?'1':'0';
                                    setting.isMtOrderLabelPrint = isMtOrderLabelPrint?'1':'0';
                                }
                            });
                        } else {
                            SettingDao.getSetting(function(success, settingd) {
                                SettingDao.updateSetting({
                                    isMtOrderCustomerPrint : isMtOrderCustomerPrint?'1':'0',
                                    isMtOrderPrivatePrint : isMtOrderPrivatePrint?'1':'0',
                                    isMtOrderKitchenPrint : isMtOrderKitchenPrint?'1':'0',
                                    isMtOrderLabelPrint : isMtOrderLabelPrint?'1':'0'
                                }, settingd.id, function(success) {
                                    if(setting) {
                                        setting.isMtOrderCustomerPrint = isMtOrderCustomerPrint?'1':'0';
                                        setting.isMtOrderPrivatePrint = isMtOrderPrivatePrint?'1':'0';
                                        setting.isMtOrderKitchenPrint = isMtOrderKitchenPrint?'1':'0';
                                        setting.isMtOrderLabelPrint = isMtOrderLabelPrint?'1':'0';
                                    }
                                });
                            });
                        }
                        if(Ext.getCmp('id-resolve-mt-order-view-mt'))
                            Ext.getCmp('id-resolve-mt-order-view-mt').destroy();
                    }
                }]
            }, {
                xtype: 'container',
                width: '100%',
                height: '100%',
                items: [{
                    xtype: 'fieldset',
                    margin: '0 0 0 0',
                    items: [{
                        xtype: 'container',
                        layout: 'hbox',
                        defaults: {
                            xtype: 'checkboxfield',
                            checked: true,
                            labelAlign: 'right',
                            labelWidth: 130,
                            listeners: {
                                check: function () {
                                }
                            }
                        },
                        items: [{
                            label: '客户单打印',
                            id : 'mt-order-customer-print'
                        }, {                           
                        	label : '存根单打印',
                            id : 'mt-order-private-print'
                        }]
                    }, {
                        xtype: 'container',
                        layout: 'hbox',
                        defaults: {
                            xtype: 'checkboxfield',
                            checked: false,
                            labelAlign: 'right',
                            labelWidth: 130
                        },
                        items: [{
                            label: '厨房打印',
                            checked : true,
                            id : 'mt-order-kitchen-print'
                        }, {
                            label: '标签打印',
                            id : 'mt-order-label-print'
                        }]
                    }]
                }]
            }]
        });
        resolveOrderViewMt.show();

        SettingDao.getSetting(function(success, settingd) {
            if(success && settingd) {
                isMtOrderCustomerPrint = settingd.isMtOrderCustomerPrint ? (settingd.isMtOrderCustomerPrint=='1'?true:false) : true;
                isMtOrderPrivatePrint = settingd.isMtOrderPrivatePrint ? (settingd.isMtOrderPrivatePrint=='1'?true:false) : true;
                isMtOrderKitchenPrint = settingd.isMtOrderKitchenPrint ? (settingd.isMtOrderKitchenPrint=='1'?true:false) : true;
                isMtOrderLabelPrint = settingd.isMtOrderLabelPrint ? (settingd.isMtOrderLabelPrint=='1'?true:false) : true;
                Ext.getCmp('mt-order-customer-print').setChecked(isMtOrderCustomerPrint);
                Ext.getCmp('mt-order-private-print').setChecked(isMtOrderPrivatePrint);
                Ext.getCmp('mt-order-kitchen-print').setChecked(isMtOrderKitchenPrint);
                Ext.getCmp('mt-order-label-print').setChecked(isMtOrderLabelPrint);
                if(setting) {
                    setting.isMtOrderCustomerPrint = isMtOrderCustomerPrint;
                    setting.isMtOrderPrivatePrint = isMtOrderPrivatePrint;
                    setting.isMtOrderKitchenPrint = isMtOrderKitchenPrint;
                    setting.isMtOrderLabelPrint = isMtOrderLabelPrint;
                }
            }
        });
    	return;  // 旧版本
        showConfirm('提示', '您确认接单吗?', function(btnId) {
        	if(btnId == 'yes') {
        		MTOrderDao.confirmMtOrdersForMT(orderIds, {courierName:"",courierPhone:""}, function(success, msg) {
                    console.warn(arguments);
                    if(!success) {
                    	showAlert('提示', msg ? msg : '操作失败, 订单已被取消!');
                    }
                    getMtOrderCount();
                    PrintDao.printMtOrdersLogic(1, orderIds);
                    //me.loadData(meituanOrderEnum.WAIT_ORDER);
                    me.loadDataFromRadio();
                    refreshMtOrderForSocket();
                    if(success) { // 生成销售单(非自配送的接单之后都生成销售单)
                    	me.takeoutSellInfoBefore(orderIds);
                    }
                });
        	}
        });
    },
    resolveOrderView : function(orderIds, orderDatas, isSelfDeliver) {
        var me = this;
        /*var message = '您确认接单吗?';
        if(logisticsCode == '1001' || logisticsCode == '1002'
            || logisticsCode == '1003' || logisticsCode == '1004') {
            message = '您确认接单(美团自配送)吗?'
        }*/
        var resolveOrderView = Ext.Viewport.add({
            xtype : 'panel',
            centered : true,
            hideOnTapMask : false,
            modal : true,
            width : 380,
            height : 260,
            id : 'id-resolve-mt-order-view',
            items : [{
                xtype : 'toolbar',
                docked : 'top',
                title : '接单',
                items : [{
                    xtype : 'button',
                    cls : 'close-button',
                    handler : function() {
                        if(Ext.getCmp('id-resolve-mt-order-view'))
                            Ext.getCmp('id-resolve-mt-order-view').destroy();
                    }
                }, {
                    xtype : 'spacer'
                }, {
                    xtype : 'button',
                    cls : 'sy-tm-button',
                    text : '确认',
                    handler : function() {
                        var nameInfo = Ext.getCmp('id-resolve-mt-order-name').getValue();
                        var phoneInfo = Ext.getCmp('id-resolve-mt-order-phone').getValue();
                        if(!nameInfo) {
                            showAlert('提示', '请输入送货员名称!');
                            return;
                        }
                        if(!phoneInfo) {
                            showAlert('提示', '请输入送货员电话!');
                            return;
                        } else if(!isMobile(phoneInfo)) {
                        	showAlert('提示', '请输入正确的送货员电话!');
                        	return;
                        }
                        var resolveOrderIds = [];
                        showLoading("正在确认订单中, 请稍侯...");
                        MTOrderDao.confirmMtOrders(orderIds, {courierName:nameInfo,courierPhone:phoneInfo}, function(success, msg, resolveIds) {
                            console.warn(arguments);
                            closeLoading();
                            if(!success) { // 所有单都操作失败
                            	showAlert('提示', msg ? msg : '操作失败, 订单已被取消!');
                            	return;
                            }
                            getMtOrderCount();
                            if(resolveIds.length != orderIds.length) { // 部分成功
                            	showAlert('提示', msg ? msg : "操作失败");
                            	PrintDao.printMtOrdersLogic(1, resolveIds);
                            } else
                            	PrintDao.printMtOrdersLogic(1, orderIds);
                            //me.loadData(meituanOrderEnum.WAIT_ORDER);
                            me.loadDataFromRadio();
                            refreshMtOrderForSocket();
                            //if(success) {
                            //    me.loadData(meituanOrderEnum.WAIT_ORDER);
                            //} else {
                            //	showAlert('提示', msg ? msg : '操作失败,订单已被取消!');
                            //}
                        });
                        var isMtOrderCustomerPrint = Ext.getCmp('mt-order-customer-print').getChecked();
                        var isMtOrderPrivatePrint = Ext.getCmp('mt-order-private-print').getChecked();
                        var isMtOrderKitchenPrint = Ext.getCmp('mt-order-kitchen-print').getChecked();
                        var isMtOrderLabelPrint = Ext.getCmp('mt-order-label-print').getChecked();
                        if(setting && setting.id) {
                            SettingDao.updateSetting({
                                isMtOrderCustomerPrint : isMtOrderCustomerPrint?'1':'0',
                                isMtOrderPrivatePrint : isMtOrderPrivatePrint?'1':'0',
                                isMtOrderKitchenPrint : isMtOrderKitchenPrint?'1':'0',
                                isMtOrderLabelPrint : isMtOrderLabelPrint?'1':'0'
                            }, setting.id, function(success) {
                                if(setting) {
                                    setting.isMtOrderCustomerPrint = isMtOrderCustomerPrint?'1':'0';
                                    setting.isMtOrderPrivatePrint = isMtOrderPrivatePrint?'1':'0';
                                    setting.isMtOrderKitchenPrint = isMtOrderKitchenPrint?'1':'0';
                                    setting.isMtOrderLabelPrint = isMtOrderLabelPrint?'1':'0';
                                }
                            });
                        } else {
                            SettingDao.getSetting(function(success, settingd) {
                                SettingDao.updateSetting({
                                    isMtOrderCustomerPrint : isMtOrderCustomerPrint?'1':'0',
                                    isMtOrderPrivatePrint : isMtOrderPrivatePrint?'1':'0',
                                    isMtOrderKitchenPrint : isMtOrderKitchenPrint?'1':'0',
                                    isMtOrderLabelPrint : isMtOrderLabelPrint?'1':'0'
                                }, settingd.id, function(success) {
                                    if(setting) {
                                        setting.isMtOrderCustomerPrint = isMtOrderCustomerPrint?'1':'0';
                                        setting.isMtOrderPrivatePrint = isMtOrderPrivatePrint?'1':'0';
                                        setting.isMtOrderKitchenPrint = isMtOrderKitchenPrint?'1':'0';
                                        setting.isMtOrderLabelPrint = isMtOrderLabelPrint?'1':'0';
                                    }
                                });
                            });
                        }
                        if(Ext.getCmp('id-resolve-mt-order-view'))
                            Ext.getCmp('id-resolve-mt-order-view').destroy();
                    }
                }]
            }, {
                xtype: 'container',
                width: '100%',
                height: '100%',
                items: [{
                    xtype: 'fieldset',
                    margin: '0 0 0 0',
                    items: [{
                        xtype: 'textfield',
                        labelWidth: 120,
                        label: '送货员姓名',
                        hidden: false,
                        id: 'id-resolve-mt-order-name',
                        name: 'field-resolve-mt-order-name',
                        clearIcon : false,
                        placeHolder: '请输入送货员姓名',
                        listeners : {
                            focus : function(curView, e, eOpts) {
                            	preventEventBubble(e);
                                Ext.getCmp('id-resolve-mt-order-name').blur();
                                var mtOrderCourierListView = Ext.Viewport.add({
                                    xtype : 'panel',
                                    centered : true,
                                    modal : true,
                                    hideOnTapMask : false,
                                    width : 300,
                                    height : 300,
                                    id : 'id-resolve-mt-order-courier-list-view',
                                    items : [{
                                        xtype : 'toolbar',
                                        docked : 'top',
                                        title : '请选择送货员',
                                        items : [{
                                            xtype : 'button',
                                            cls : 'close-button',
                                            handler : function() {
                                                if(Ext.getCmp('id-resolve-mt-order-courier-list-view'))
                                                    Ext.getCmp('id-resolve-mt-order-courier-list-view').destroy();
                                            }
                                        }, {
                                            xtype : 'spacer'
                                        }, {
                                            xtype : 'button',
                                            cls : 'sy-tm-button',
                                            text : '确认',
                                            hidden : true,
                                            handler : function() {
                                                if(Ext.getCmp('id-resolve-mt-order-courier-list-view'))
                                                    Ext.getCmp('id-resolve-mt-order-courier-list-view').destroy();
                                            }
                                        }]
                                    }, {
                                        xtype : 'list',
                                        id : 'id-resolve-mt-order-courier-list',
                                        width : '100%',
                                        height : '100%',
                                        itemCls : 'jz-center solid-border-bottom',
                                        store : Ext.create('Ext.data.Store', {
                                            model : 'Seller.model.Option',
                                            data : [],
                                            id : 'id-resolve-mt-order-courier-store'
                                        }),
                                        listeners : {
                                            itemtap : function(listView, index, target, record, e, eOpts) {
                                            	preventEventBubble(e);
                                                if(Ext.getCmp('id-resolve-mt-order-name'))
                                                    Ext.getCmp('id-resolve-mt-order-name').setValue(record.get('text'));
                                                if(Ext.getCmp('id-resolve-mt-order-phone'))
                                                    Ext.getCmp('id-resolve-mt-order-phone').setValue(record.get('value'));
                                                if(Ext.getCmp('id-resolve-mt-order-courier-list-view'))
                                                    Ext.getCmp('id-resolve-mt-order-courier-list-view').destroy();
                                            }
                                        }
                                    }]
                                });
                                mtOrderCourierListView.show();
                                var courierListView = Ext.getCmp('id-resolve-mt-order-courier-list');
                                var courierStore = courierListView.getStore();
                                //加载送货员
                                SellerEmployeeDao.loadSellerEmployee('3', function(success, res) {
                                    if (!success) {
                                        return;
                                    }
                                    if (res.length > 0) {
                                        var data = [{
                                            text : '',
                                            value : ''
                                        }];
                                        for (var i = 0, len = res.length; i < len; i++) {
                                            data[i + 1] = {};
                                            data[i + 1].text = res[i].workName;
                                            data[i + 1].value = res[i].mobile ? res[i].mobile : '';
                                            courierStore.add(data[i+1]);
                                        }
                                    }
                                });
                            }
                        }
                    }, {
                        xtype: 'textfield',
                        labelWidth: 120,
                        label: '送货号电话',
                        hidden: false,
                        name: 'field-resolve-mt-order-phone',
                        id: 'id-resolve-mt-order-phone',
                        placeHolder: '请输入送货员电话'
                    }, {
                        xtype: 'textfield',
                        labelWidth: 120,
                        label: '送货员',
                        hidden: true,
                        id: 'id-resolve-mt-order-name-mt',
                        name: 'field-resolve-mt-order-name-mt',
                        placeHolder: '由美团骑手接单并配送',
                        readOnly: true,
                    }, {
                        xtype: 'panel',
                        height: 40,
                        id: 'meituan-hide-print',
                        hidden: true,
                        html: '<div style="color:red;line-height: 40px;text-align: center;">(需要修改打印配置，请到系统设置->打印设置中修改)</div>'
                    }, {
                        xtype: 'panel',
                        layout: 'vbox',
                        id: 'meituan-show-print',
                        hidden: false,
                        items: [{
                            xtype: 'panel',
                            layout: 'hbox',
                            defaults: {
                                xtype: 'checkboxfield',
                                checked: true,
                                labelAlign: 'right',
                                labelWidth: 130,
                                listeners: {
                                    check: function(curView, e, eOpts) {
                                        preventEventBubble(e);
                                    }
                                }
                            },
                            items: [{
                                label: '客户单打印',
                                id: 'mt-order-customer-print'
                            }, {
                                label: '存根单打印',
                                id: 'mt-order-private-print'
                            }, {
                                xtype: 'button',
                                style: 'background:transparent;border:none;',
                                width: 190,
                                height: 40,
                                left: 0,
                                top: 1,
                                listeners: {
                                    tap: function(ele, e, eOpts) {
                                        preventEventBubble(e);
                                        var isprintCmp = Ext.getCmp('mt-order-customer-print');
                                        isprintCmp.getChecked() ? isprintCmp.uncheck() : isprintCmp.check();
                                        addOptPrintSetting({
                                            printType: '美团订单',
                                            printName: '客户单',
                                            printValue: isprintCmp.getChecked() ? '是' : '否',
                                            status: '修改'
                                        });
                                    }
                                }
                            }, {
                                xtype: 'button',
                                style: 'background:transparent;border:none;',
                                width: 190,
                                height: 40,
                                left: 190,
                                top: 1,
                                listeners: {
                                    tap: function(ele, e, eOpts) {
                                        preventEventBubble(e);
                                        var isprintCmp = Ext.getCmp('mt-order-private-print');
                                        isprintCmp.getChecked() ? isprintCmp.uncheck() : isprintCmp.check();
                                        addOptPrintSetting({
                                            printType: '美团订单',
                                            printName: '存根单',
                                            printValue: isprintCmp.getChecked() ? '是' : '否',
                                            status: '修改'
                                        });
                                    }
                                }
                            }]
                        }, {
                            xtype: 'container',
                            layout: 'hbox',
                            defaults: {
                                xtype: 'checkboxfield',
                                checked: false,
                                labelAlign: 'right',
                                labelWidth: 130
                            },
                            items: [{
                                label: '厨房打印',
                                checked: true,
                                id: 'mt-order-kitchen-print'
                            }, {
                                label: '标签打印',
                                id: 'mt-order-label-print'
                            }, {
                                xtype: 'button',
                                style: 'background:transparent;border:none;',
                                width: 190,
                                height: 40,
                                left: 0,
                                top: 1,
                                listeners: {
                                    tap: function(ele, e, eOpts) {
                                        preventEventBubble(e);
                                        var isprintCmp = Ext.getCmp('mt-order-kitchen-print');
                                        isprintCmp.getChecked() ? isprintCmp.uncheck() : isprintCmp.check();
                                        addOptPrintSetting({
                                            printType: '美团订单',
                                            printName: '厨房',
                                            printValue: isprintCmp.getChecked() ? '是' : '否',
                                            status: '修改'
                                        });
                                    }
                                }
                            }, {
                                xtype: 'button',
                                style: 'background:transparent;border:none;',
                                width: 190,
                                height: 40,
                                left: 190,
                                top: 1,
                                listeners: {
                                    tap: function(ele, e, eOpts) {
                                        preventEventBubble(e);
                                        var isprintCmp = Ext.getCmp('mt-order-label-print');
                                        isprintCmp.getChecked() ? isprintCmp.uncheck() : isprintCmp.check();
                                        addOptPrintSetting({
                                            printType: '美团订单',
                                            printName: '标签',
                                            printValue: isprintCmp.getChecked() ? '是' : '否',
                                            status: '修改'
                                        });
                                    }
                                }
                            }]
                        }]
                    }]
                }]
            }]
        });
        resolveOrderView.show();

        SettingDao.getSetting(function(success, settingd) {
            if(success && settingd) {
                isMtOrderCustomerPrint = settingd.isMtOrderCustomerPrint ? (settingd.isMtOrderCustomerPrint=='1'?true:false) : true;
                isMtOrderPrivatePrint = settingd.isMtOrderPrivatePrint ? (settingd.isMtOrderPrivatePrint=='1'?true:false) : true;
                isMtOrderKitchenPrint = settingd.isMtOrderKitchenPrint ? (settingd.isMtOrderKitchenPrint=='1'?true:false) : true;
                isMtOrderLabelPrint = settingd.isMtOrderLabelPrint ? (settingd.isMtOrderLabelPrint=='1'?true:false) : true;
                Ext.getCmp('mt-order-customer-print').setChecked(isMtOrderCustomerPrint);
                Ext.getCmp('mt-order-private-print').setChecked(isMtOrderPrivatePrint);
                Ext.getCmp('mt-order-kitchen-print').setChecked(isMtOrderKitchenPrint);
                Ext.getCmp('mt-order-label-print').setChecked(isMtOrderLabelPrint);
                if(setting) {
                    setting.isMtOrderCustomerPrint = isMtOrderCustomerPrint;
                    setting.isMtOrderPrivatePrint = isMtOrderPrivatePrint;
                    setting.isMtOrderKitchenPrint = isMtOrderKitchenPrint;
                    setting.isMtOrderLabelPrint = isMtOrderLabelPrint;
                }
            }
        });
        // 是否显示打印设置
        if (!(showPtSetting.isMtOrderPrintShow == 'false' || showPtSetting.isMtOrderPrintShow == false)) {
            Ext.getCmp('id-resolve-mt-order-view').setHeight(230)
            Ext.getCmp('meituan-show-print').setHidden(false);
            Ext.getCmp('meituan-hide-print').setHidden(true);
        } else {
            Ext.getCmp('id-resolve-mt-order-view').setHeight(180)
            Ext.getCmp('meituan-show-print').setHidden(true);
            Ext.getCmp('meituan-hide-print').setHidden(false);
        }
    },
    // 配送视图
    resolveDeliverView : function(deliverDatas, fn) {
        var me = this;
        var message = "您确认配送吗?";
        var deliverSelf = [];
        var deliverMt = [];
        for(var di=0,dlen=deliverDatas.length;di<dlen;di++) {
            if(deliverDatas[di].logisticsCode == '0000')
                deliverSelf.push(deliverDatas[di]);
            else
                deliverMt.push(deliverDatas[di]);
        }
        showConfirm('确认配送', '确认配送吗?', function(btnId) {
            if(btnId == 'yes') {
            	showLoading("正在处理配送, 请稍侯...");
                if(deliverSelf && deliverSelf.length > 0) {
                    MTOrderDao.deliverMtOrders(deliverSelf, function(success, msg) {
                        console.warn(arguments);
                        closeLoading();
                        if(!success) {
                        	showAlert('提示', msg ? msg : '配送操作失败!');
                        } //else if(success) {
                        else {
                            //me.loadData(meituanOrderEnum.WAIT_SEND);
                        	me.loadDataFromRadio();
                            refreshMtOrderForSocket();
                        }
                    });
                } else if(deliverMt && deliverMt.length > 0) {
                    MTOrderDao.dispatchMtOrdersMTP(deliverMt, function(success) {
                        console.warn(arguments);
                        closeLoading();
                        if(!success) {
                        	showAlert('提示', msg ? msg : "配送操作失败!");
                        } else {
                        //if(success) {
                            //me.loadData(meituanOrderEnum.WAIT_SEND);
                        	me.loadDataFromRadio();
                            refreshMtOrderForSocket();
                        }
                    });
                }
                /*MTOrderDao.deliverMtOrders(deliverDatas, function(success) {
                    console.warn(arguments);
                    if(success) {
                        me.loadData(meituanOrderEnum.WAIT_SEND);
                    }
                });*/
            }
        });
        return;
    	var viewId = 'id-resolve-mt-order-view';
    	var showCmpList = ['id-resolve-mt-order-name', 'id-resolve-mt-order-phone'];
    	var hideCmpList = ['id-resolve-mt-order-name-mt'];
    	/*if(logisticsCode == '1001' || logisticsCode=='1002'
    		|| logisticsCode=='1003' || logisticsCode=='1004') {
    		viewId = 'id-resolve-mt-order-view-mt';
    		var cmpList = hideCmpList;
    		hideCmpList = showCmpList;
    		showCmpList = cmpList;
    	}*/
    	var resolveOrderView = Ext.Viewport.add({
    		xtype : 'panel',
    		centered : true,
    		hideOnTapMask : false,
    		modal : true,
    		width : 380,
    		height : 180,
    		id : viewId,
    		items : [{
    			xtype : 'toolbar',
    			docked : 'top',
    			title : '确认配送',
    			items : [{
    				xtype : 'button',
    				cls : 'close-button',
    				handler : function() {
    					if(Ext.getCmp(viewId))
    						Ext.getCmp(viewId).destroy();
    				}
    			}, {xtype: 'spacer'}, {
    				xtype : 'button',
    				cls : 'sy-tm-button',
    				text : '确认',
    				handler : function() {
    					var nameInfo = Ext.getCmp('id-resolve-mt-order-name').getValue();
    					var phoneInfo = Ext.getCmp('id-resolve-mt-order-phone').getValue();
    					//MTOrderDao.deliverMtOrders(deliverDatas, {courierName:nameInfo,courierPhone:phoneInfo}, function(success) {
    					MTOrderDao.deliverMtOrders(deliverDatas, function(success) {
        					console.warn(arguments);
                            if(success) {
                                //me.loadData(meituanOrderEnum.WAIT_SEND);
                                PrintDao.printMtOrdersLogic(2, orderIds);
                                me.loadDataFromRadio();
                            }
        				});
						if(Ext.getCmp(viewId))
    						Ext.getCmp(viewId).destroy();
    				}
    			}]
    		}, {
    			xtype : 'container',
    			width : '100%',
    			height : '100%',
    			items : [{
    				xtype : 'fieldset',
    				margin : '0 0 0 0',
    				items : [{
    					xtype : 'textfield',
    					labelWidth : 120,
    					label : '送货员姓名',
                        hidden : true,
    					id : 'id-resolve-mt-order-name',
    					name : 'field-resolve-mt-order-name',
    					placeHolder : '请输入送货员姓名'
    				}, {
    					xtype : 'textfield',
    					labelWidth : 120,
    					label : '送货号电话',
                        hidden : true,
    					name : 'field-resolve-mt-order-phone',
    					id : 'id-resolve-mt-order-phone',
    					placeHolder : '请输入送货员电话'
    				}, {
    					xtype : 'textfield',
    					labelWidth : 120,
    					label : '送货员',
    					hidden : true,
    					id : 'id-resolve-mt-order-name-mt',
    					name : 'field-resolve-mt-order-name-mt',
    					placeHolder : '由美团骑手接单并配送',
    					readOnly : true,
    				}, {
    					xtype : 'container',
    					layout : 'hbox',
                        hidden : false,
    					defaults : {
    						xtype : 'checkboxfield',
    						checked : true,
    						labelAlign : 'right',
    						labelWidth : 130,
    						listeners : {
    							check : function() {
    								
    							}
    						}
    					},
    					items : [{
    						label : '客户单打印',
    						id : 'mt-order-print-customer'
    					}, {
    						label : '存根单打印',
        					id : 'mt-order-print-inner'
    					}]
    				}, {
    					xtype : 'container',
    					layout : 'hbox',
                        hidden : false,
    					defaults : {
    						xtype : 'checkboxfield',
    						checked : false,
    						labelAlign : 'right',
    						labelWidth : 130
    					},
    					items : [{
    						label : '厨房打印',
    						id : 'mt-order-print-kitchen'
    					}, {
    						label : '标签打印',
    						id : 'mt-order-print-label',
    					}]
    				}, {
    					xtype : 'container',
    					layout : 'hbox',
    					margin : '8 0 0 0',
    					hidden : true,
    					items : [{
    						xtype : 'spacer'
    					}, {
    						xtype : 'button',
    						width : 120,
    						height : 36,
    						cls : 'sy-tm-button',
    						text : '下单',
    						handler : function() {
    							
    						}
    					}, {
    						xtype : 'spacer'
    					}]
    				}]
    			}]
    		}]
    	});
    	resolveOrderView.show();
    	//for(var hi=0,hlen=hideCmpList.length;hi<hlen;hi++)
    	//	Ext.getCmp(hideCmpList[hi]).setHidden(true);
    	//for(var si=0,slen=showCmpList.length;si<slen;si++)
    	//	Ext.getCmp(showCmpList[si]).setHidden(false);
    },
    cancelDeliverView : function() {
        this.cancelOrderView(2);
    },
    resolvePayOffView : function(payOffData, fn, logisticsCode) {
        var me = this;
        /*showConfirm('确认完成', '您确认此单已完成吗?', function(btnId) {
            if(btnId == 'yes') {
                MTOrderDao.deliveredMtOrders(orderIds, function(success) {
                    console.warn(arguments);
                    if(success) {
                        me.loadData(meituanOrderEnum.WAIT_PAYOFF);
                        me.takeoutSellInfoBefore(orderIds);
                    }
                });
            }
        });*/
        var viewId = 'id-resolve-payoff-mt-order-view';
        var resolvePayOffView = Ext.Viewport.add({
            xtype : 'panel',
            centered : true,
            hideOnTapMask : false,
            modal : true,
            width : 380,
            height : 180,
            id : viewId,
            items : [{
                xtype : 'toolbar',
                docked : 'top',
                title : '确认结算',
                items : [{
                    xtype : 'button',
                    cls : 'close-button',
                    handler : function() {
                        if(Ext.getCmp(viewId))
                            Ext.getCmp(viewId).destroy();
                    }
                }, {xtype: 'spacer'}, {
                    xtype : 'button',
                    cls : 'sy-tm-button',
                    text : '确认',
                    handler : function() {
                        var nameInfo = Ext.getCmp('id-resolve-mt-order-name').getValue();
                        var phoneInfo = Ext.getCmp('id-resolve-mt-order-phone').getValue();
                        showLoading("正在结算, 请稍后...");
                        MTOrderDao.deliveredMtOrders(payOffData.orderIds, function(success, msg, resolveIds) {
                            console.warn(arguments);
                            closeLoading();
                            if(!success) {
                            	showAlert('提示', msg ? msg : '结算操作失败!');
                            } else {
                            //if(success) {
                                //me.loadData(meituanOrderEnum.WAIT_PAYOFF);
                                //PrintDao.printMtOrdersLogic(3, payOffData.orderIds);
                                me.loadDataFromRadio();
                                if(resolveIds.length != payOffData.orderIds.length) { // 部分订单失败
                                	showAlert('提示', '结算操作失败!');
                                	me.takeoutSellInfoBefore(resolveIds);
                                } else 
                                	me.takeoutSellInfoBefore(payOffData.orderIds);
                                refreshMtOrderForSocket();
                            }
                        });
                        if(Ext.getCmp(viewId))
                            Ext.getCmp(viewId).destroy();
                    }
                }]
            }, {
                xtype : 'container',
                width : '100%',
                height : '100%',
                items : [{
                    xtype : 'fieldset',
                    margin : '0 0 0 0',
                    items : [{
                        xtype : 'textfield',
                        labelWidth : 120,
                        label : '送货员姓名',
                        hidden : true,
                        id : 'id-resolve-mt-order-name',
                        name : 'field-resolve-mt-order-name',
                        placeHolder : '请输入送货员姓名'
                    }, {
                        xtype : 'textfield',
                        labelWidth : 120,
                        label : '送货号电话',
                        hidden : true,
                        name : 'field-resolve-mt-order-phone',
                        id : 'id-resolve-mt-order-phone',
                        placeHolder : '请输入送货员电话'
                    }, {
                        xtype : 'textfield',
                        labelWidth : 120,
                        label : '送货员',
                        hidden : true,
                        id : 'id-resolve-mt-order-name-mt',
                        name : 'field-resolve-mt-order-name-mt',
                        placeHolder : '由美团骑手接单并配送',
                        readOnly : true,
                    }, {
                        xtype : 'textfield',
                        labelWidth : 120,
                        label : '总额',
                        hidden : false,
                        id : 'id-resolve-mt-order-name-total',
                        name : 'field-resolve-mt-order-name-total',
                        placeHolder : '',
                        readOnly : true
                    }, {
                        xtype : 'container',
                        layout : 'hbox',
                        hidden : false,
                        defaults : {
                            xtype : 'checkboxfield',
                            checked : false,
                            labelAlign : 'right',
                            labelWidth : 130,
                            listeners : {
                                check : function() {

                                }
                            }
                        },
                        items : [{
                            label : '客户单打印',
                            hidden : true
                        }, {
                            label : '存根单打印',
                            id : 'mt-pf-order-private-print',
                            checked : true
                        }, {
                            xtype : 'button',
                            style : 'background:transparent;border:none;',
                            width : 190,
                            height : 40,
                            left : 0,
                            top : 1,
                            listeners : {
                                tap : function (ele, e, eOpts) {
                                	preventEventBubble(e);
                                    var isprintCmp = Ext.getCmp('mt-pf-order-private-print');
                                    var checked = isprintCmp.getChecked();
                                    checked ? isprintCmp.uncheck() : isprintCmp.check();
                                    var updateSettingData = {};
                                    updateSettingData.isMtShouyinPrivatePrint = !checked;
                                    SettingDao.updateSetting(updateSettingData, setting.id, function(success, msg) {
                                        if (success) {
                                            for(var key in updateSettingData) {
                                                if(updateSettingData.hasOwnProperty(key))
                                                    setting[key] = !checked;
                                            }
                                        }
                                    });
                                }
                            }
                        }]
                    }, {
                        xtype : 'container',
                        layout : 'hbox',
                        hidden : true,
                        defaults : {
                            xtype : 'checkboxfield',
                            checked : false,
                            labelAlign : 'right',
                            labelWidth : 130
                        },
                        items : [{
                            label : '厨房打印'
                        }, {
                            label : '标签打印'
                        }]
                    }, {
                        xtype : 'container',
                        layout : 'hbox',
                        margin : '8 0 0 0',
                        hidden : true,
                        items : [{
                            xtype : 'spacer'
                        }, {
                            xtype : 'button',
                            width : 120,
                            height : 36,
                            cls : 'sy-tm-button',
                            text : '下单',
                            handler : function() {

                            }
                        }, {
                            xtype : 'spacer'
                        }]
                    }]
                }]
            }]
        });
        showBy(resolvePayOffView,Ext.getCmp('take-out-meituan-main').getParent());
        if(Ext.getCmp("mt-pf-order-private-print"))
        	Ext.getCmp("mt-pf-order-private-print").setChecked(setting.isMtShouyinPrivatePrint ? true : false);
        if(Ext.getCmp('id-resolve-mt-order-name-total'))
            Ext.getCmp('id-resolve-mt-order-name-total').setValue(parseFloat(payOffData.total).toFixed(2));
    },
    resolveCancelConfirmView : function(cancelConfirmData, fn) {
        var me = this;
        showConfirm('提示', '确认已读吗?', function(btnId) {
            if(btnId == 'yes') {
            	MTOrderDao.updateOrder({isReadCancel : '1'}, cancelConfirmData.orderId, function(success) {});
                setTimeout(function() {
                    me.loadDataFromRadio();
                    refreshMtOrderForSocket();
                }, 1000);
            }
        });
        return;
        var viewId = 'id-resolve-mt-order-cancel-view';
        var resolveCancelConfirmView = Ext.Viewport.add({
            xtype : 'panel',
            centered : true,
            hideOnTapMask : false,
            modal : true,
            width : 380,
            height : 200,
            id : viewId,
            items : [{
                xtype : 'toolbar',
                docked : 'top',
                title : '取消确认',
                items : [{
                    xtype : 'button',
                    cls : 'close-button',
                    handler : function() {
                        if(Ext.getCmp(viewId))
                            Ext.getCmp(viewId).destroy();
                    }
                }, {
                    xtype : 'spacer'
                }, {
                    xtype : 'button',
                    cls : 'sy-tm-button',
                    text : '确认',
                    handler : function() {
                        MTOrderDao.updateOrder({isReadCancel : '1'}, cancelConfirmData.orderId, function(success) {});
                        setTimeout(function() {
                            me.loadDataFromRadio();
                            refreshMtOrderForSocket();
                        }, 1000);
                        if(Ext.getCmp(viewId))
                            Ext.getCmp(viewId).destroy();
                    }
                }]
            }, {
                xtype: 'container',
                width: '100%',
                height: '100%',
                items: [{
                    xtype: 'fieldset',
                    margin: '0 0 0 0',
                    items: [{
                        xtype: 'container',
                        layout: 'hbox',
                        defaults: {
                            xtype: 'checkboxfield',
                            checked: false,
                            labelAlign: 'right',
                            labelWidth: 130,
                            listeners: {
                                check: function () {

                                }
                            }
                        },
                        items: [{
                            label: '客户单打印'
                        }, {
                        	label : '存根单打印'
                        }]
                    }, {
                        xtype: 'container',
                        layout: 'hbox',
                        defaults: {
                            xtype: 'checkboxfield',
                            checked: false,
                            labelAlign: 'right',
                            labelWidth: 130
                        },
                        items: [{
                            label: '厨房打印'
                        }, {
                            label: '标签打印'
                        }]
                    }]
                }]
            }]
        });
        resolveCancelConfirmView.show();
    },
    resolveCancelConfirmViews : function(cancelConfirmDatas, fn) {
        // 批量取消确认
        if(!cancelConfirmDatas || cancelConfirmDatas.length <= 0) return;
        var me = this;
        var olen = cancelConfirmDatas.length;
        showConfirm('提示', '确认已读吗?', function(btnId) {
            if(btnId == 'yes') {
		        for(var oi=0;oi<olen;oi++) {
		            MTOrderDao.updateOrderStatus({isReadCancel:'1'}, cancelConfirmDatas[oi].orderId, function(success) {});
		        }
		        setTimeout(function() {
		            me.loadDataFromRadio();
		            refreshMtOrderForSocket();
		        }, 1000);
            }
        });
        return;
        var viewId = 'id-resolve-mt-order-cancel-view';
        var resolveCancelConfirmView = Ext.Viewport.add({
            xtype : 'panel',
            centered : true,
            hideOnTapMask : false,
            modal : true,
            width : 380,
            height : 200,
            id : viewId,
            items : [{
                xtype : 'toolbar',
                docked : 'top',
                title : '取消确认',
                items : [{
                    xtype : 'button',
                    cls : 'close-button',
                    handler : function() {
                        if(Ext.getCmp(viewId))
                            Ext.getCmp(viewId).destroy();
                    }
                }, {
                    xtype : 'spacer'
                }, {
                    xtype : 'button',
                    cls : 'sy-tm-button',
                    text : '确认',
                    handler : function() {
                        for(var oi=0;oi<olen;oi++) {
                            MTOrderDao.updateOrderStatus({isReadCancel:'1'}, cancelConfirmDatas[oi].orderId, function(success) {});
                        }
                        setTimeout(function() {
                            me.loadDataFromRadio();
                            refreshMtOrderForSocket();
                        }, 1000);
                        if(Ext.getCmp(viewId))
                            Ext.getCmp(viewId).destroy();
                    }
                }]
            }, {
                xtype: 'container',
                width: '100%',
                height: '100%',
                items: [{
                    xtype: 'fieldset',
                    margin: '0 0 0 0',
                    items: [{
                        xtype: 'container',
                        layout: 'hbox',
                        defaults: {
                            xtype: 'checkboxfield',
                            checked: false,
                            labelAlign: 'right',
                            labelWidth: 130,
                            listeners: {
                                check: function () {

                                }
                            }
                        },
                        items: [{
                            label: '客户单打印'
                        }, {                
                            label: '存根单打印'
                        }]
                    }, {
                        xtype: 'container',
                        layout: 'hbox',
                        defaults: {
                            xtype: 'checkboxfield',
                            checked: false,
                            labelAlign: 'right',
                            labelWidth: 130
                        },
                        items: [{
                            label: '厨房打印'
                        }, {
                            label: '标签打印'
                        }]
                    }]
                }]
            }]
        });
        resolveCancelConfirmView.show();

    },
    resetData : function() {
    	var meituanCategoryCmp = Ext.getCmp('meituan-category-list');
    	meituanCategoryCmp.getStore().removeAll();
    	var meituanDetailCmp = Ext.getCmp('meituan-detail-list');
    	meituanDetailCmp.getStore().removeAll();
    	//this.categoryPage.reset();
    	this.categoryPage = new $.PageUtil({
    		limitCount : meituanPageLimitCount
    	});
    	Ext.getCmp('mt-category-page-label').setHtml('' + this.categoryPage.getCurrPage() + '/' + this.categoryPage.getTotalPage());
    },
    resetDetailData : function() {
    	
    	var meituanDetailCmp = Ext.getCmp('meituan-detail-list');
    	meituanDetailCmp.getStore().removeAll();
    },
    resetDetailStatistics : function() { // 详情统计
    	Ext.getCmp('id-mt-order-sellAmount').setValue('');
    	Ext.getCmp('id-mt-order-number').setValue('');
    	Ext.getCmp('id-mt-order-bill-name').setValue('');
    	Ext.getCmp('id-mt-order-comment').setValue('');
        Ext.getCmp('id-mt-order-fee').setValue('');
        Ext.getCmp('id-mt-order-courier-name').setValue('');
        Ext.getCmp('id-mt-order-courier-phone').setValue('');
        Ext.getCmp('id-mt-order-comment').setValue('');
        Ext.getCmp('id-mt-order-bill-name').setValue('');
        Ext.getCmp('id-mt-order-box-amount').setValue('');
    },
    loadDataFromDwr : function(order) {
    	this.isFromDwr = true;
    	this.beOperatoredOrder = order;
    	this.refreshDataInterceptorStart();
    	this.loadDataFromRadio();
    },
    closeMtOrderView : function() {
    	if(Ext.getCmp('id-resolve-mt-order-view') && !Ext.getCmp('id-resolve-mt-order-view').isHidden())
			Ext.getCmp('id-resolve-mt-order-view').destroy();
    },
    closeMtDeliverView2 : function() {
    	findViewNames = {'SCF_SPECIAL' : 'show-cancel-view-btn'};
    	//findTheView(Ext.Viewport, findViewNames, function(id, isPrefix, orginalId) {
    	findTheViewForLayer(Ext.Viewport, findViewNames, function(id, isPrefix, orginalId) {
    		if((isPrefix && Ext.getCmp(orginalId)) || Ext.getCmp(id)) {
				if(Ext.getCmp(findViewNames[id])) {
					var cmpHandler = Ext.getCmp(findViewNames[id]).getHandler();
					cmpHandler && cmpHandler();
				}
			}
    	});
    },
    closeMtDeliverView : function() {
    	findViewNames = {'SCF_SPECIAL' : 'show-cancel-view-btn'};
    	//findTheView(Ext.Viewport, findViewNames, function(id, isPrefix, orginalId) {
    	findTheViewForLayer(Ext.Viewport, findViewNames, function(id, isPrefix, orginalId) {
    		var tipView = null;
    		if(isPrefix && Ext.getCmp(orginalId)) {
    			tipView = Ext.getCmp(orginalId);
    		} else tipView = Ext.getCmp(id);
    		var cancelId = findConfirmViewId(tipView, 'cancel');
    		if(Ext.getCmp(cancelId)) {
    			var cmpHandler = Ext.getCmp(cancelId).getHandler();
    			cmpHandler && cmpHandler();
    		}
    		/*if((isPrefix && Ext.getCmp(orginalId)) || Ext.getCmp(id)) {
				if(Ext.getCmp(findViewNames[id])) {
					var cmpHandler = Ext.getCmp(findViewNames[id]).getHandler();
					cmpHandler && cmpHandler();
				}
			}*/
    	});
    },
    closeCancelOrderView : function() {
    	if(Ext.getCmp('sel-order-cancel-reason') && !Ext.getCmp('sel-order-cancel-reason').isHidden())
    		Ext.getCmp('sel-order-cancel-reason').destroy();
    },
    closeCancelDeliverView : function() {
    	if(Ext.getCmp('sel-deliver-cancel-reason') && !Ext.getCmp('sel-deliver-cancel-reason').isHidden())
    		Ext.getCmp('sel-deliver-cancel-reason').destroy();
    },
    closePayOffView : function() {
    	if(Ext.getCmp('id-resolve-payoff-mt-order-view') && !Ext.getCmp('id-resolve-payoff-mt-order-view').isHidden())
    		Ext.getCmp('id-resolve-payoff-mt-order-view').destroy();
    },
    closeCancelConfirmView : function() {
    	if(Ext.getCmp('id-resolve-mt-order-cancel-view') && !Ext.getCmp('id-resolve-mt-order-cancel-view').isHidden())
    		Ext.getCmp('id-resolve-mt-order-cancel-view').destroy();
    },
    dwrCancelInterceptor : function(order) { // 接单时被取消
    	if(this.isFromDwr && this.beOperatoredOrder){
    		if(order.orderId == this.beOperatoredOrder.orderId) {
    			//showCloseAlert('提示', '当前订单已被操作!', 10);
    			this.selectedItems = [];
    			//this.closeMtOrderView();
    			this.closeAllViews();
				return false;
    		}
    	}
    	return true;
    },
    dcbOrderInterceptor : function(order) {
    	if(this.isFromDCB && this.beOperatoredOrder) {
    		return this.basicInterceptor(order);
    	}
    	return true;
    },
    closeAllViews : function() {
		this.closeMtOrderView();
		this.closeCancelOrderView();
		this.closeCancelDeliverView();
		this.closePayOffView();
		this.closeCancelConfirmView();
		this.closeMtDeliverView();
    },
    basicInterceptor : function(order, fn) {
    	if(Ext.isArray(this.beOperatoredOrder)) {
			var blen = this.beOperatoredOrder.length;
			for(var bi=0;bi<blen;bi++) {
				if(order.orderId == this.beOperatoredOrder[bi].orderId) {
			    	this.selectedItems = [];
			    	this.closeAllViews();
					return false;
				}
			}
		} else if(Ext.isObject(this.beOperatoredOrder)) {
			if(order.orderId == this.beOperatoredOrder.orderId) {
    			this.selectedItems = [];
    			this.closeAllViews();
				return false;
    		}
		} else { // beOperatoredOrder is String(orderId)
			if(order.orderId == this.beOperatoredOrder) {
				this.selectedItems = [];
    			this.closeAllViews();
				return false;
			}
		}
    	return true;
    },
    loadPushInterceptor : function(order) {
    	//if(this.loadPush) {
    	if(this.isLoadPush && this.beOperatoredOrder) {
    		return this.basicInterceptor(order);
    	}
		return true;
    },
    refreshDataInterceptorStart : function() {
    	this.selectedItems = [];
		if(!Ext.getCmp('meituan-category-list')) return;
		var selectStore = Ext.getCmp('meituan-category-list').getSelection();
		//console.log(selectStore);
		var selectedLen = selectStore.length;
		if(selectedLen <= 0) return;
		for(var si=0;si<selectedLen;si++) {
			var selectRecord = selectStore[si];
			if(!this.dwrCancelInterceptor(selectRecord.getData())) break;
			else if(!this.dcbOrderInterceptor(selectRecord.getData())) break;
			else if(!this.loadPushInterceptor(selectRecord.getData())) break;
			else {
				this.selectedItems.push(selectRecord);
			}
		}
    },
    refreshDataInterceptorEnd : function() {
		if(!Ext.getCmp('meituan-category-list')) return;
		var store = Ext.getCmp('meituan-category-list').getStore();
		if(!store) return;
		if(!this.selectedItems || this.selectedItems.length <= 0) return;
		for(var si=0,slen=this.selectedItems.length;si<slen;si++) {
			var findrecord = store.findRecord('orderId', this.selectedItems[si].get('orderId'));
			if(findrecord) {
				Ext.getCmp('meituan-category-list').select(findrecord, true, false);
			}
		}
		this.selectedItems = [];
		this.isLoadPush = false;
    	this.isFromDwr = false;
    	this.isFromDCB = false;
    	this.beOperatoredOrder = null;
    },
    loadDataFromPush : function(orders) {
    	this.isLoadPush = true;
    	this.beOperatoredOrder = orders;
    	this.refreshDataInterceptorStart();
    	this.loadDataFromRadio();
    },
    loadDataFromDCB : function(orders) {
    	this.isFromDCB = true;
    	this.beOperatoredOrder = orders;
    	this.refreshDataInterceptorStart();
    	this.loadDataFromRadio();
    },
    loadDataFromRadio : function() {
        var radioItems = this.getRadioItems();
        for(var ri=0,rlen=radioItems.length;ri<rlen;ri++) {
            if(Ext.getCmp(radioItems[ri].radioName).getChecked()) {
                this.loadData(radioItems[ri].loadDataType);
                break;
            }
        }
    },
    loadDataFact : function(executeFn, callBackFn) {
    	if(!executeFn) return;
    	var me = this;
    	executeFn(function(success, orders) {
    		if(success && orders && orders.length > 0)
    			me.initData(orders);
    	});
    },
    loadData : function(orderType) {
    	var me = this;
    	me.resetData();
        this.resetDetailData();
        this.resetDetailStatistics();
    	if(orderType == meituanOrderEnum.WAIT_ORDER) {
    		me.loadDataFact(MTOrderDao.loadOrderWaitOrder);
    		/*MTOrderDao.loadOrderWaitOrder(function(success, orders) {
    			if(success && orders && orders.length > 0)
        			me.initData(orders);
    		});*/
    	} else if(orderType == meituanOrderEnum.WAIT_SEND) {
    		me.loadDataFact(MTOrderDao.loadOrderWaitSend);
    		/*MTOrderDao.loadOrderWaitSend(function(success, orders) {
    			if(success && orders && orders.length > 0)
        			me.initData(orders);
    		});*/
    	} else if(orderType == meituanOrderEnum.WAIT_PAYOFF) {
    		me.loadDataFact(MTOrderDao.loadOrderWaitPayOff);
    		/*MTOrderDao.loadOrderWaitPayOff(function(success, orders) {
    			if(success && orders && orders.length > 0)
        			me.initData(orders);
    		});*/
    	} else if(orderType == meituanOrderEnum.CANCEL_ORDER) {
    		me.loadDataFact(MTOrderDao.loadOrderCancel);
    		/*MTOrderDao.loadOrderCancel(function(success, orders) {
    			if(success && orders && orders.length > 0)
        			me.initData(orders);
    		});*/
    	} else if(orderType == meituanOrderEnum.ORDER_WHOLE) {
            //me.loadDataFact(MTOrderDao.loadOrder);
            me.loadDataFact(MTOrderDao.loadOrderAll);
        } else if(orderType == meituanOrderEnum.CANCEL_CONFIRM) {
            me.loadDataFact(MTOrderDao.loadOrderCancelConfirm);
        } else {
    		//me.loadDataFact(MTOrderDao.loadOrder);
            me.loadDataFact(MTOrderDao.loadOrderWaitOrder);
    		/*MTOrderDao.loadOrder(function(success, orders) {
        		if(success && orders && orders.length > 0)
        			me.initData(orders);
        	});*/
    	}
        Ext.getCmp('mtOrderDetailBtn').hide();
    },
    initData : function(orders) {
    	var olen = orders.length;
    	var cDatas = [];
    	for(var oi=0;oi<olen;oi++) {
    		cDatas.push({
    			'orderId' : orders[oi].orderId,
    			'recipientName' : orders[oi].recipientName,
    			'recipientPhone' : orders[oi].recipientPhone,
    			'cTime' : new Date(parseInt(orders[oi].ctime)).format('yyyy-MM-dd hh:mm'),
    			'recipientAddress' : orders[oi].recipientAddress,
                'courierName' : orders[oi].courierName,
                'courierPhone' : orders[oi].courierPhone,
                'status' : orders[oi].status,
                'total' : orders[oi].total,
                'caution' : orders[oi].caution,
                'originalPrice' : orders[oi].originalPrice,
                'payType' : orders[oi].payType,
                'poiAddress' : orders[oi].poiAddress,
                'poiName' : orders[oi].poiName,
                'poiPhone' : orders[oi].poiPhone,
                'isPush' : orders[oi].isPush,
                'dinnersNumber' : orders[oi].dinnersNumber,
                'shippingFee' : orders[oi].shippingFee,
                'shipperPhone' : orders[oi].shipperPhone,
                'logisticsDispatcherName' : orders[oi].logisticsDispatcherName,
                'hasInvoiced' : orders[oi].hasInvoiced,
                'invoiceTitle' : orders[oi].invoiceTitle,
                'logisticsCode' : orders[oi].logisticsCode,
                'logisticsConfirmTime' : orders[oi].logisticsConfirmTime,
                'logisticsCompletedTime' : orders[oi].logisticsCompletedTime,
                'logisticsName' : orders[oi].logisticsName,
                'logisticsId' : orders[oi].logisticsId,
                'logisticsSendTime' : orders[oi].logisticsSendTime,
                'logisticsStatus' : orders[oi].logisticsStatus,
                'isThirdShipping' : orders[oi].isThirdShipping,
                'isPre' : orders[oi].isPre,
                'isReadCancel' : orders[oi].isReadCancel,
                'showStatus' : orders[oi].showStatus,
                'orderIdView' : orders[oi].orderIdView,
                'orderClerkId' : orders[oi].orderClerkId,
                'orderClerkName' : orders[oi].orderClerkName
    		});
    	}
    	this.categoryDatas = cDatas;
        // 加载美团数据
        var meituanCategoryCmp = Ext.getCmp('meituan-category-list');
        var meituanCategoryStore = meituanCategoryCmp.getStore();
        meituanCategoryStore.removeAll();
        //this.resetDetailData();
        //this.resetDetailStatistics();
        this.categoryPage.reset();
        var clen = cDatas.length;
        var pages = parseInt(clen/this.categoryPage.getLimitCount());
        pages = clen % this.categoryPage.getLimitCount() > 0 ? pages + 1 : pages;
        this.categoryPage.setTotalPage(pages);
        for(var ci=0;ci<clen;ci++) {
            if(ci < this.categoryPage.getLimitCount())
                meituanCategoryStore.add(cDatas[ci]);
        }
        Ext.getCmp('mt-category-page-label').setHtml('' + this.categoryPage.getCurrPage() + '/' + this.categoryPage.getTotalPage());
        this.refreshDataInterceptorEnd();
    },
    loadData2 : function() {
        var categoryDatas = [];
        var cDatas = [{
            'recipientName' : '张琦',
            'recipientPhone' : '13296112466',
            'cTime' : '2017-04-06 16:45',
            'recipientAddress' : '广州天河区测试大厦615'
        }, {
            'recipientName' : '王大成',
            'recipientPhone' : '13822932466',
            'cTime' : '2017-04-06 16:45',
            'recipientAddress' : '广州天河区测试大厦615'
        }, {
            'recipientName' : '范晓琪',
            'recipientPhone' : '13536932366',
            'cTime' : '2017-04-06 16:45',
            'recipientAddress' : '广州天河区测试大厦615'
        }, {
            'recipientName' : '刘小明',
            'recipientPhone' : '13716532466',
            'cTime' : '2017-04-06 16:45',
            'recipientAddress' : '广州天河区测试大厦615'
        }, {
            'recipientName' : '张脖肢',
            'recipientPhone' : '13716532488',
            'cTime' : '2017-04-06 16:45',
            'recipientAddress' : '广州天河区测试大厦615'
        }, {
            'recipientName' : '周星星',
            'recipientPhone' : '13716532488',
            'cTime' : '2017-04-06 16:45',
            'recipientAddress' : '广州天河区测试大厦615'
        }, {
            'recipientName' : '刘得花',
            'recipientPhone' : '13716532488',
            'cTime' : '2017-04-06 16:45',
            'recipientAddress' : '广州天河区测试大厦615'
        }, {
            'recipientName' : '张以某',
            'recipientPhone' : '13716532488',
            'cTime' : '2017-04-06 16:45',
            'recipientAddress' : '广州天河区测试大厦615'
        }, {
            'recipientName' : '冯晓岗',
            'recipientPhone' : '13716532488',
            'cTime' : '2017-04-06 16:45',
            'recipientAddress' : '广州天河区测试大厦615'
        }, {
            'recipientName' : '郭得岗',
            'recipientPhone' : '13716532488',
            'cTime' : '2017-04-06 16:45',
            'recipientAddress' : '广州天河区测试大厦615'
        }, {
            'recipientName' : '黄晓山',
            'recipientPhone' : '13716532488',
            'cTime' : '2017-04-06 16:45',
            'recipientAddress' : '广州天河区测试大厦615'
        }, {
            'recipientName' : '李晓路',
            'recipientPhone' : '13716532488',
            'cTime' : '2017-04-06 16:45',
            'recipientAddress' : '广州天河区测试大厦615'
        }];

        this.categoryDatas = cDatas;
        // 加载美团数据
        var meituanCategoryCmp = Ext.getCmp('meituan-category-list');
        var meituanCategoryStore = meituanCategoryCmp.getStore();
        meituanCategoryStore.removeAll();
        this.categoryPage.reset();
        var clen = cDatas.length;
        var pages = parseInt(clen/this.categoryPage.getLimitCount());
        pages = clen % this.categoryPage.getLimitCount() > 0 ? pages + 1 : pages;
        this.categoryPage.setTotalPage(pages);
        for(var ci=0;ci<clen;ci++) {
            if(ci < this.categoryPage.getLimitCount())
                meituanCategoryStore.add(cDatas[ci]);
        }
        Ext.getCmp('mt-category-page-label').setHtml('' + this.categoryPage.getCurrPage() + '/' + this.categoryPage.getTotalPage());
    },
    checkDetailView : function() {
    	// 是否显示详情页(多选不显示)
    	var meituanCategoryCmp = Ext.getCmp('meituan-category-list');
    	var meituanCategoryStore = meituanCategoryCmp.getStore();
    	var selectedItems = meituanCategoryCmp.getSelection();
    	if(selectedItems.length == 1) {
    		return selectedItems[0];
    	}
    	this.resetDetailData();
    	this.resetDetailStatistics();
		return null;
    },
    loadDetailData2 : function(record, index) {
    	var selRecord = this.checkDetailView();
    	if(!selRecord) return;
        // 加载美团详情数据
        var meituanDetailCmp = Ext.getCmp('meituan-detail-list');
        var meituanDetailStore = meituanDetailCmp.getStore();
        meituanDetailStore.removeAll();
        var cNames = ['凉拌木耳', '红烧排骨', '鱼香茄子', '回锅肉', '空心菜', '西红柿炒鸡蛋'];
        var cPrices = [17, 25, 15, 23, 12, 11];
        if(index == 1) {
            meituanDetailStore.add({
            	'commodityId' : '234253243253243',
                'foodName' : cNames[0],
                'quantity' : 2,
                'price' : cPrices[0],
                'sellAmount' : cPrices[0] * 2,
                'unit' : '例'
            });
            meituanDetailStore.add({
            	'commodityId' : '234253243253243111',
                'foodName' : cNames[1],
                'quantity' : 2,
                'price' : cPrices[1],
                'sellAmount' : cPrices[1] * 2,
                'unit' : '例'
            });
            Ext.getCmp('id-mt-order-sellAmount').setValue(parseFloat(cPrices[0]*2 + cPrices[1]*2));
            Ext.getCmp('id-mt-order-number').setValue(parseFloat(2+2));
        } else if(index == 2) {
            meituanDetailStore.add({
            	'commodityId' : '234253243253243222',
            	'foodName' : '凉拌木耳',
                'quantity' : 1,
                'price' : '20',
                'sellAmount' : '20',
                'unit' : '例'
            });
            meituanDetailStore.add({
            	'commodityId' : '234253243253243222',
            	'foodName' : '红烧牛肉',
                'quantity' : 2,
                'price' : '10',
                'sellAmount' : '20'
            });
            meituanDetailStore.add({
            	'commodityId' : '234253243253243333',
            	'foodName' : '空心菜',
                'quantity' : 1,
                'price' : '5',
                'sellAmount' : '5'
            });
            meituanDetailStore.add({
            	'commodityId' : '234253243253243444',
            	'foodName' : cNames[3],
                'quantity' : 5,
                'price' : cPrices[3],
                'sellAmount' : cPrices[3] * 5
            });
            meituanDetailStore.add({
            	'commodityId' : '234253243253243555',
            	'foodName' : cNames[5],
                'quantity' : 1,
                'price' : cPrices[5],
                'sellAmount' : cPrices[5] * 1
            });
            Ext.getCmp('id-mt-order-sellAmount').setValue(parseFloat(20+40+5+cPrices[3]*5 + cPrices[5]*1));
            Ext.getCmp('id-mt-order-number').setValue(parseFloat(1+2+1+5+1));
        } else {
            meituanDetailStore.add({
            	'commodityId' : '234253243253243666',
                'foodName': cNames[2],
                'quantity': 3,
                'price': cPrices[2],
                'sellAmount': cPrices[2] * 3
            });
            meituanDetailStore.add({
            	'commodityId' : '234253243253243666',
            	'foodName': cNames[5],
                'quantity': 5,
                'price': cPrices[5],
                'sellAmount': cPrices[5] * 5
            });
            Ext.getCmp('id-mt-order-sellAmount').setValue(parseFloat(cPrices[2]*3 + cPrices[5]*5));
            Ext.getCmp('id-mt-order-number').setValue(parseFloat(3+5));
        }
    },
    loadDetailData : function(record, index) {
    	var selRecord = this.checkDetailView();
    	if(!selRecord) return;
        // 加载美团详情数据
        var meituanDetailCmp = Ext.getCmp('meituan-detail-list');
        var meituanDetailStore = meituanDetailCmp.getStore();
        meituanDetailStore.removeAll();
        var orderId = selRecord.get('orderId');
        var showSellAmount = 0;
        var showNumber = 0;
        MTOrderDao.loadOrderDetailByOrderId(orderId, function(success, details) {
        	if(success && details && details.length > 0) {
        		var dlen = details.length;
                var boxAmount = 0;
        		for(var di=0;di<dlen;di++) {
        			details[di].sellAmount = details[di].quantity * details[di].price;
        			details[di].sellAmount = roundNumber(details[di].sellAmount, 2);
        			details[di].price = roundNumber(details[di].price, 2);
        			details[di].unit = details[di].unit ? details[di].unit : '例';
        			meituanDetailStore.add(details[di]);
        			showSellAmount += details[di].sellAmount;
        			showNumber += details[di].quantity;
                    boxAmount = boxAmount + (details[di].boxNum?details[di].boxNum:0) * (details[di].boxPrice?details[di].boxPrice:0);
        		}
        	}
        	Ext.getCmp('id-mt-order-sellAmount').setValue(parseFloat(selRecord.get('total')).toFixed(2)); //parseFloat(showSellAmount).toFixed(2));
        	Ext.getCmp('id-mt-order-number').setValue(parseFloat(showNumber).toFixed(2));
            Ext.getCmp('id-mt-order-fee').setValue(parseFloat(selRecord.get('shippingFee')).toFixed(2));
            Ext.getCmp('id-mt-order-courier-name').setValue(selRecord.get('courierName') ? selRecord.get('courierName') : '');
            Ext.getCmp('id-mt-order-courier-phone').setValue(selRecord.get('courierPhone') ? selRecord.get('courierPhone') : '');
            Ext.getCmp('id-mt-order-comment').setValue(selRecord.get('caution') ? selRecord.get('caution') : '');
            Ext.getCmp('id-mt-order-bill-name').setValue(selRecord.get('invoiceTitle') ? selRecord.get('invoiceTitle') : '');
            Ext.getCmp('id-mt-order-box-amount').setValue(parseFloat(boxAmount).toFixed(2));
        });
    },
    takeoutSellInfoBefore : function(orderIds) {
    	takeoutSellInfoCommon(orderIds);
    },
    // category list prev/next page
    prevPage : function() {
        if(this.categoryPage.getCurrPage() <= 1) return;
        this.resetDetailData();
        this.resetDetailStatistics();
        Ext.getCmp('mtOrderDetailBtn').hide();
        // 加载美团数据
        var meituanCategoryCmp = Ext.getCmp('meituan-category-list');
        var meituanCategoryStore = meituanCategoryCmp.getStore();
        meituanCategoryStore.removeAll();
        this.categoryPage.down();
        var pageOffset = this.categoryPage.getOffset();
        var pageLimitCount = this.categoryPage.getLimitCount();
        var startPageIndex = pageOffset * pageLimitCount;
        var endPageIndex = startPageIndex + pageLimitCount;
        if(endPageIndex >= this.categoryDatas.length) endPageIndex = this.categoryDatas.length;
        for(;startPageIndex < endPageIndex; startPageIndex++) {
            meituanCategoryStore.add(this.categoryDatas[startPageIndex]);
        }
        Ext.getCmp('mt-category-page-label').setHtml('' + this.categoryPage.getCurrPage() + '/' + this.categoryPage.getTotalPage());
    },
    nextPage : function() {
        if(this.categoryPage.getCurrPage() >= this.categoryPage.getTotalPage()) return;
        this.resetDetailData();
        this.resetDetailStatistics();
        this.categoryPage.up();
        Ext.getCmp('mtOrderDetailBtn').hide();
        // 加载美团数据
        var meituanCategoryCmp = Ext.getCmp('meituan-category-list');
        var meituanCategoryStore = meituanCategoryCmp.getStore();
        meituanCategoryStore.removeAll();
        var pageOffset = this.categoryPage.getOffset();
        var pageLimitCount = this.categoryPage.getLimitCount();
        var startPageIndex = pageOffset * pageLimitCount;
        var endPageIndex = startPageIndex + pageLimitCount;
        if(endPageIndex >= this.categoryDatas.length) endPageIndex = this.categoryDatas.length;
        for(;startPageIndex < endPageIndex; startPageIndex++) {
            meituanCategoryStore.add(this.categoryDatas[startPageIndex]);
        }
        Ext.getCmp('mt-category-page-label').setHtml('' + this.categoryPage.getCurrPage() + '/' + this.categoryPage.getTotalPage());
    }
});

function takeoutSellInfoCommon(orderIds) {
	if(!orderIds || orderIds.length <= 0) return;
    var olen = orderIds.length;
    var me = this;
    var commodity = [];
    var commodityType = [];
    var mtOrders = [];
    var mtOrderDetails = [];
    var mtOrderIds = [];
    for(var oi=0; oi<olen; oi++) {
        mtOrderIds.push("\'" + orderIds[oi] + "\'");
    }

    MTOrderDao.loadOrderByIds(mtOrderIds.join(','), function(success, orderDatas) {
        if(success && orderDatas && orderDatas.length > 0) {
            var odlen = orderDatas.length;
            mtOrders = orderDatas;
            mtOrderDetails = [];
            MTOrderDao.loadOrderDetailByOrderIds(mtOrderIds.join(','), function(success, orderDetailDatas) {
                if(success && orderDetailDatas && orderDetailDatas.length > 0) {
                    for(var odi=0;odi<odlen;odi++) {
                        var mtOrderDetailDetails = [];
                    	//mtOrders[odi].sourceType = extra.sourceType; /* 收银台与点菜宝的来源不同(deprecated) */
                        for(var oddi=0,oddlen=orderDetailDatas.length;oddi<oddlen;oddi++) {
                            if(orderDetailDatas[oddi].orderId == mtOrders[odi].orderId)
                                mtOrderDetailDetails.push(orderDetailDatas[oddi])
                        }
                        mtOrderDetails.push(mtOrderDetailDetails);
                    }
                    createSellInfoForMtRecursionCommon({
                    	status : '1',
                    	mtOrders : mtOrders,
                    	mtOrderDetails : mtOrderDetails,
                    	commodity : commodity,
                    	commodityType : commodityType,
                    	orderIndex : 0,
                    	callback : function() {}
                    });
                }
            });
        }
    });
}
function createSellInfoForMtRecursionCommon(argsData) {
	if(!argsData) {console.log("meituanMain.js-3077-(createSellInfoForMtMultiCommon)传参错误");return;}
	var me = this;
	var mtArgsData = {};
	mtArgsData.status = argsData.status;
	mtArgsData.mtOrder = argsData.mtOrders[argsData.orderIndex];
	mtArgsData.mtOrderDetails = argsData.mtOrderDetails[argsData.orderIndex];
	mtArgsData.commodity = argsData.commodity;
	mtArgsData.commodityType = argsData.commodityType;
	mtArgsData.callback = function(success) {
		if(argsData.orderIndex+1 == argsData.mtOrders.length) argsData.callback && argsData.callback(true);
		else {
			argsData.orderIndex += 1;
			createSellInfoForMtRecursionCommon(argsData);
		}
	};
    SellerEmployeeDao.getSellerEmployeeByWorkName(mtArgsData.mtOrder.courierName, function (success, res) {
        var commissionScale = res ? res.commissionScale : null;
        var waiterId = res ? res.id : null;
        createSellInfoForMtCommon(mtArgsData, nvlValue(commissionScale, null), nvlValue(waiterId, null));
    });
}
function createSellInfoForMtCommon(argsData, commissionScale, waiterId) {
	if(!argsData) {console.log("meituanMain.js-2951-(createSellInfoForMtCommon)传参错误");return;}
	var sellInfoSellNum = 0;
    var datas = argsData.mtOrderDetails;
    var sellDetail = null;
    var sellDetails = [];
    var date = new Date();
    var sellInfoBoxAmount = 0;
    var mtOrder = argsData.mtOrder;
    var sellInfoCostAmount = null;
    for (var i = 0, len = datas.length; i < len; i++) {
        sellDetail = {
            id : createSellId(date, "SD"),
            sellNum : datas[i].quantity,
            sellPrice : datas[i].price,
            discount : 100,
            commodityPrice : datas[i].price,
            commodityId : datas[i].commodityId,
            commodityTypeId : datas[i].commodityTypeId,
            commodityName : datas[i].commodityName,
            barCode : nvlValue(datas[i].barCode, ''),
            sellerId : seller.id,
            parentSellerId : nvlValue(seller.parentSellerId, ''),
            remark : nvlValue(datas[i].remark, ''),
            remarkIds : nvlValue(datas[i].remarkIds, ''),
            createTime : nvlValue(mtOrder.ctime, ''),
            type : '0',
            unit : nvlValue(datas[i].unit, '例'),
            vbookerVersion : version,
            isTimePrice : '0',
            isDiscount : '0',
            isSpecialPrice : '0',
            orderByTime : new Date().getTime(),
            handoverId : shouYinEmployee.handoverId,
            openId : nvlValue(datas[i].openId, ''),
            unionId : nvlValue(datas[i].unionId, ''),
            kitchenPrint : nvlValue(datas[i].kitchenPrint, '0'),
            labelPrint : nvlValue(datas[i].labelPrint, '0'),
            iskitchenprint : nvlValue(datas[i].iskitchenprint, '0'),
            kitchenPrintJson : nvlValue(datas[i].kitchenPrintJson, Ext.JSON.encode({})),
            skuId : datas[i].skuId,
            category: datas[i].category
        };
        sellInfoSellNum += datas[i].quantity;
        var boxAmount = datas[i].boxNum * datas[i].boxPrice;
        sellInfoBoxAmount += boxAmount;
        sellDetail.totalAmount = datas[i].quantity * datas[i].price;// + boxAmount;
        sellDetail.totalAmount = parseFloat(sellDetail.totalAmount).toFixed(2);
        sellDetail.sellAmount = sellDetail.totalAmount;
        sellDetail.commodityName = sellDetail.commodityName + (sellDetail.skuId ? '(' + sellDetail.skuId + ')' : '');
        var cmCostPrice = datas[i].costPrice;
        sellDetail.costPrice = cmCostPrice;
        calcSellDetailGain(sellDetail);
        if(isValidDigital(sellDetail.costAmount)) {
        	sellInfoCostAmount = sellInfoCostAmount==null?parseFloat(sellDetail.costAmount) : (parseFloat(sellDetail.costAmount)+sellInfoCostAmount);
        }
        delete sellDetail.skuId;
        sellDetails[i] = sellDetail;
    }
    var sellInfo = {
        syned : '0',
        orderId : mtOrder.orderId,
        status : '1',
        payType : '1',
        waiterId : waiterId,
        waiterName : mtOrder.courierName,
        waiterScale : commissionScale,
        customerMobile : mtOrder.recipientPhone,
        customerAddress : mtOrder.recipientAddress,
        //cashAmount : parseFloat(sellData.sellAmount).toFixed(2),
        cashAmount: parseFloat(mtOrder.total).toFixed(2),
        wxpayAmount : 0,
        factAmount : 0,
        unionpayAmount : 0,
        prepayAmount : 0,
        alipayAmount : 0,
        timepayAmount : 0,
        workId : shouYinEmployee.workId,
        workName : shouYinEmployee.workName,
        subscriptionAmount : 0,
        employeeId : shouYinEmployee.id,
        employeeScale : nvlValue(shouYinEmployee.employeeScale, '0'),
        saleId : nvlValue(mtOrder.saleId, ''),
        customerId : '',
        vbookerVersion : version,
        customerName : nvlValue(mtOrder.recipientName, ''),
        sellType : '1',
        sendId : '',
        sourceType : '6',
        couponId : '',
        totalAmount : parseFloat(mtOrder.total).toFixed(2),//parseFloat(mtOrder.sellAmount).toFixed(2),
        sellAmount : parseFloat(mtOrder.total).toFixed(2),
        factAmount : parseFloat(mtOrder.total).toFixed(2),
        commodityNum : sellInfoSellNum,
        combinationAmount : parseFloat(mtOrder.total).toFixed(2),
        discount : 100,
        remark : '',
        remarkIds : '',
        busType : '1', //判断是外卖还是堂食
        sellerId : seller.id,
        personNum : nvlValue(mtOrder.dinnersNumber, 0),
        teaPrice : 0,
        teaAmount : 0,
        handoverId : shouYinEmployee.handoverId,
        parentSellerId : nvlValue(seller.parentSellerId, ''),
        endTime : new Date().format('yyyy-MM-dd hh:mm:ss'),
        boxAmount : numberFormat(sellInfoBoxAmount),
        shippingFee : parseFloat(nvlValue(mtOrder.shippingFee, 0)).toFixed(2)
    };
    if(isValidDigital(sellInfoCostAmount)) {
    	sellInfo.costAmount = sellInfoCostAmount;
    	sellInfo.gainAmount = parseFloat(parseFloat(sellInfo.sellAmount) - parseFloat(sellInfo.costAmount)).toFixed(2);
    	sellInfo.costAmount = parseFloat(sellInfo.costAmount).toFixed(2);
    } else {
    	sellInfo.gainAmount = parseFloat(sellInfo.sellAmount).toFixed(2);
    	sellInfo.costAmount = 0;
    }
    if(mtOrder.orderClerkId) {
    	sellInfo.orderClerkId = mtOrder.orderClerkId;
    }
    if(mtOrder.orderClerkName) {
    	sellInfo.orderClerkName = mtOrder.orderClerkName;
    }
    if(mtOrder && mtOrder.payType == '2') { // 在线支付
    	sellInfo.payType = '10';
    	sellInfo.meituanAmount = parseFloat(mtOrder.total).toFixed(2);
    	sellInfo.cashAmount = 0;
    }
    if(mtOrder && !mtOrder.ctime)
    	sellInfo.sellTime = new Date(parseInt(mtOrder.ctime)).format('yyyy-MM-dd hh:mm:ss');
    else
    	sellInfo.sellTime = new Date().format('yyyy-MM-dd hh:mm:ss');
    
    SellDao.getMaxSellNo(new Date().format("yyyy-MM-dd"), function (success, sellNo) {
        if (success) {
            sellInfo.sellNo = sellNo;
            sellInfo.id = SellDao.createIdBySellNo(sellInfo.sellNo);
            sellInfo.lastUpdateTime = new Date().format("yyyy-MM-dd hh:mm:ss");
            SellDao.transactionInfoDetails(sellInfo, sellDetails, function(success) {
            	if(success) {
                    // 套餐销售明细
                    addComboMealsSelldetail(sellDetails, function() {
                        if(mtOrder.logisticsCode == '0000' && (setting.isMtShouyinPrivatePrint=='true'||setting.isMtShouyinPrivatePrint)) // 自配送的才打结算单
                            PrintDao.printMtOrdersLogic(3, [mtOrder.orderId], sellInfo);
                    });
	            	argsData.callback && argsData.callback(true);
            	} else {
            		console.log(arguments);
                	argsData.callback&&argsData.callback(false);
            	}
            });
            /*fgDB.transaction(function(tx) {
            	if(isAndroid()) { // android 处理方式
            		tx.insert('sellinfo', sellInfo);
            	} else {
            		var siKeys = Object.keys(sellInfo);
            		var siValues = Object.values(sellInfo);
            		var sellInfoSql = "insert into sellInfo (" + siKeys.join(",") + ") select " + new Array(siKeys.length).fill('?').join(',') + " where not exists(select 1 from sellinfo where id='" + sellInfo.id + "')";
            		console.log(sellInfoSql);
            		tx.executeSql(sellInfoSql, siValues, function(){});
            	}
            	for(var i=0,len=sellDetails.length;i<len;i++) {
            		sellDetails[i].sellId = sellInfo.id;
            		if(isAndroid()) { // android 处理方式
            			tx.insert('selldetail', sellDetails[i]);
            		} else {
            			var sdKeys = Object.keys(sellDetails[i]);
                		var sdValues = Object.values(sellDetails[i]);
                		var sellDetailSql = "insert into selldetail (" + sdKeys.join(",") + ") select " + new Array(sdKeys.length).fill('?').join(',') + " where not exists(select 1 from selldetail where id='" + sellDetails[i].id + "')";
                		console.log(sellDetailSql);
                		tx.executeSql(sellDetailSql, sdValues, function(){});
            		}
            	}
            }, function() {
            	if(mtOrder.logisticsCode == '0000' && (setting.isMtShouyinPrivatePrint=='true'||setting.isMtShouyinPrivatePrint)) // 自配送的才打结算单
        			PrintDao.printMtOrdersLogic(3, [mtOrder.orderId], sellInfo);
            	argsData.callback && argsData.callback(true);
            }, function(err) {
            	console.log(arguments);
            	argsData.callback&&argsData.callback(false);
            });*/
        }
    });
}
function takeoutSellInfoForDCB(orderIds) {
	takeoutSellInfoCommon(orderIds);
};
function takeoutSellInfoForDCB2(orderIds) {
	if(!orderIds || orderIds.length <= 0) return;
    var olen = orderIds.length;
    var me = this;
    var commodity = [];
    var commodityType = [];
    CommodityDao.loadCommodityInfo(function(success, commoditys) {
        if(success && commoditys && commoditys.length > 0) commodity = commoditys;
        CommodityDao.loadCommodityType(function(success, commodityTypes) {
            if(success && commodityTypes && commodityTypes.length > 0) commodityType = commodityTypes;
            var mtOrders = [];
            var mtOrderDetails = [];
            var mtOrderIds = [];
            for(var oi=0; oi<olen; oi++) {
                mtOrderIds.push("\'" + orderIds[oi] + "\'");
            }
            MTOrderDao.loadOrderByIds(mtOrderIds.join(','), function(success, orderDatas) {
                if(success && orderDatas && orderDatas.length > 0) {
                    var odlen = orderDatas.length;
                    mtOrders = orderDatas;
                    mtOrderDetails = [];
                    MTOrderDao.loadOrderDetailByOrderIds(mtOrderIds.join(','), function(success, orderDetailDatas) {
                        if(success && orderDetailDatas && orderDetailDatas.length > 0) {
                            var mtOrderDetailDetails = [];
                            for(var odi=0;odi<odlen;odi++) {
                                for(var oddi=0,oddlen=orderDetailDatas.length;oddi<oddlen;oddi++) {
                                    if(orderDetailDatas[oddi].orderId == mtOrders[odi].orderId)
                                        mtOrderDetailDetails.push(orderDetailDatas[oddi])
                                }
                                mtOrderDetails.push(mtOrderDetailDetails);
                            }
                            createSellInfoForMtMultiFromDCB('1', mtOrders, mtOrderDetails, commodity, commodityType, 0, function() {
                            });
                        }
                    });
                }
            });
        });
    });
}
function createSellInfoForMtMultiFromDCB2(status, mtOrders, mtOrderDetails, commodity, commodityType, orderIndex, callback) {
	createSellInfoForMtFromDCB(status, mtOrders[orderIndex], mtOrderDetails[orderIndex], commodity, commodityType, function(success) {
        if(orderIndex+1 == mtOrders.length) callback && callback(true);
        else
        	createSellInfoForMtMultiFromDCB(status, mtOrders, mtOrderDetails, commodity, commodityType, orderIndex+1, callback);
    });
}
function createSellInfoForMtFromDCB2(status, mtOrder, mtOrderDetails, commodity, commodityType, callback) {
	var sellInfoSellNum = 0;
    var datas = mtOrderDetails;
    var sellDetail = null;
    var sellDetails = [];
    var date = new Date();
    var sellInfoBoxAmount = 0;
    for (var i = 0, len = datas.length; i < len; i++) {
        sellDetail = {
            id : createSellId(date, "SD"),
            sellNum : datas[i].quantity,
            sellPrice : datas[i].price,
            discount : 100,
            commodityPrice : datas[i].price,
            commodityId : datas[i].commodityId,
            commodityTypeId : datas[i].commodityTypeId,
            commodityName : datas[i].commodityName,
            barCode : nvlValue(datas[i].barCode, ''),
            sellerId : seller.id,
            parentSellerId : nvlValue(seller.parentSellerId, ''),
            remark : nvlValue(datas[i].remark, ''),
            remarkIds : nvlValue(datas[i].remarkIds, ''),
            createTime : nvlValue(mtOrder.ctime, ''),
            type : '0',
            handoverId : shouYinEmployee.handoverId,
            openId : nvlValue(datas[i].openId, ''),
            unionId : nvlValue(datas[i].unionId, ''),
            kitchenPrint : nvlValue(datas[i].kitchenPrint, '0'),
            labelPrint : nvlValue(datas[i].labelPrint, '0'),
            iskitchenprint : nvlValue(datas[i].iskitchenprint, '0'),
            kitchenPrintJson : nvlValue(datas[i].kitchenPrintJson, Ext.JSON.encode({}))
        };
        sellInfoSellNum += datas[i].quantity;
        var boxAmount = datas[i].boxNum * datas[i].boxPrice;
        sellInfoBoxAmount += boxAmount;
        sellDetail.totalAmount = datas[i].quantity * datas[i].price;// + boxAmount;
        sellDetail.totalAmount = parseFloat(sellDetail.totalAmount).toFixed(2);
        sellDetail.sellAmount = sellDetail.totalAmount;
        for(var cm=0,cmLen=commodity.length;cm<cmLen;cm++) {
            if(sellDetail.commodityId == commodity[cm].id) {
                sellDetail.commodityTypeId = commodity[cm].typeId;
                sellDetail.commodityName = commodity[cm].name;
                break;
            }
        }
        for (var ci = 0, cLen = commodityType.length; ci < cLen; ci++) {
            if (commodityType[ci].id == datas[i].commodityTypeId) {
                sellDetail.kitchenPrint = commodityType[ci].iskitchenprint ? commodityType[ci].iskitchenprint : '0';
                sellDetail.iskitchenprint = commodityType[ci].iskitchenprint;
                if (commodityType[ci].kitchenPrintJson) {
                    sellDetail.kitchenPrintJson = commodityType[ci].kitchenPrintJson;
                }
                break;
            }
        }
        sellDetails[i] = sellDetail;
    }

    var sellInfo = {
        syned : '0',
        orderId : mtOrder.orderId,
        status : '1',
        payType : '1',
        waiterId : '',
        waiterName : mtOrder.courierName,
        customerMobile : mtOrder.recipientPhone,
        customerAddress : mtOrder.recipientAddress,
        //cashAmount : parseFloat(sellData.sellAmount).toFixed(2),
        cashAmount: parseFloat(mtOrder.total).toFixed(2),
        wxpayAmount : 0,
        factAmount : 0,
        unionpayAmount : 0,
        prepayAmount : 0,
        alipayAmount : 0,
        timepayAmount : 0,
        subscriptionAmount : 0,
        employeeId : shouYinEmployee.id,
        saleId : nvlValue(mtOrder.saleId, ''),
        customerId : '',
        customerName : nvlValue(mtOrder.recipientName, ''),
        sellType : '1',
        sendId : '',
        sourceType : '6',
        couponId : '',
        totalAmount : parseFloat(mtOrder.total).toFixed(2),//parseFloat(mtOrder.sellAmount).toFixed(2),
        sellAmount : parseFloat(mtOrder.total).toFixed(2),
        factAmount : parseFloat(mtOrder.total).toFixed(2),
        commodityNum : sellInfoSellNum,
        discount : 100,
        remark : '',
        remarkIds : '',
        busType : '1', //判断是外卖还是堂食
        sellerId : seller.id,
        personNum : nvlValue(mtOrder.dinnersNumber, 0),
        teaPrice : 0,
        teaAmount : 0,
        handoverId : shouYinEmployee.handoverId,
        parentSellerId : nvlValue(seller.parentSellerId, ''),
        endTime : new Date().format('yyyy-MM-dd hh:mm:ss'),
        boxAmount : sellInfoBoxAmount,
        shippingFee : parseFloat(nvlValue(mtOrder.shippingFee, 0)).toFixed(2)
    };
    if(mtOrder.payType == '2') { // 在线支付
    	sellInfo.payType = '10';
    	sellInfo.meituanAmount = parseFloat(mtOrder.total).toFixed(2);
    	sellInfo.cashAmount = 0;
    }
    if(!mtOrder.ctime)
    	sellInfo.sellTime = new Date(parseInt(mtOrder.ctime)).format('yyyy-MM-dd hh:mm:ss');
    else
    	sellInfo.sellTime = new Date().format('yyyy-MM-dd hh:mm:ss');
    
    SellDao.getMaxSellNo(new Date().format("yyyy-MM-dd"), function (success, sellNo) {
        if (success) {
            sellInfo.sellNo = sellNo;
            sellInfo.id = SellDao.createIdBySellNo(sellInfo.sellNo);
            insert("sellinfo", sellInfo, function(success) {
            	if(success) {
            		PrintDao.printMtOrdersLogic(3, [mtOrder.orderId], sellInfo);
            	}
            });
            for (var i = 0, len = sellDetails.length; i < len; i++) {
                sellDetails[i].sellId = sellInfo.id;
                insert("selldetail", sellDetails[i]);
            }

            callback && callback(true);
        }
    });
}
function getMtOrderCount() {
	MTOrderDao.loadOrderCount(function(success, res) {
		if(success && res) {
		    if ($('#takeMeituanDiv'))
			    $('#takeMeituanDiv').html(res.count);
		}
	});
}
function refreshMtOrderView(orders) { // 点菜宝处理的单
	if(Ext.getCmp('meituanMainView') && !Ext.getCmp('meituanMainView').isHidden()) {
		if(Ext.getCmp('take-out-meituan-main') && !Ext.getCmp('take-out-meituan-main').isHidden()) {
			Ext.getCmp('take-out-meituan-main').loadDataFromDCB(orders); //loadDataFromRadio();
		}
	}
}
