/**
 * Created by lf on 2017/8/8.
 */

var PrintTaskDao = {
    /**
     * 加载数据
     * @param param 可选。搜索参数
     * @param callBack function(success, items)
     */
    loadSearchInfo: function(param,callBack) {
        var sql = "SELECT * from printTask where sellerId=? " ;
        var keyArr=[];
        keyArr.push(seller.id);
        if (param >= 1)
        {
            sql=sql+' and  status >= ?  ';
            keyArr.push(param);
        }
        else
        {
            sql=sql+' and  status == ?  ';
            keyArr.push(param);
        }
        //sql=sql+'Order by ktPrintName';

        loadBySqlParam(sql,keyArr, callBack);
    },

    /**
     *增加
     */
    add: function(sqlData, callBack) {
        //console.log(sqlData);
        insertLocal("printTask", sqlData, callBack);
    },
    /**
     * 根据id删除
     */
    delete : function(id, callBack) {
        delLocal("printTask", id, callBack);
    },
    /**
     * 根据id查询
     * @param {Object} callback(success,item)
     */
    getById : function(id, callback) {
        var sql = "SELECT * FROM printTask where id=? ";
        getBySqlParamLocal(sql,[id],callback);
    },
    getAll: function(callback) {
        var sql = "SELECT * FROM printTask where sellerId='" + seller.id + "'";
        loadBySqlLocal(sql, callback);
    },
    /**
     * 更新
     * @param sqlData
     * @param id
     * @param callback function(success)
     */
    update : function(sqlData,id, callback) {
        updateLocal('printTask',sqlData,id,callback);
    },
    /**
     * 查找早于ejectTime时间的数据
     */
    getByEjectTimeRange: function(ejectTime, callback) {
        var sql = "SELECT * FROM printTask where sellerId='" + seller.id + "' and ejectTime<? ";
        getBySqlParamLocal(sql,[ejectTime],callback);
    },

    /**
     * 分页查询总数量
     */
    getPrintTaskCount:function (callback) {
        //var sql="SELECT count(sellId) as totalNum FROM (SELECT sellId FROM printTask WHERE status in ('8','16') and sellerId=? GROUP BY sellId) "
    	var sql = "SELECT count(id) as totalNum FROM printTask WHERE 1=1";
    	sql += " AND status in ('8','16')";
    	sql += " AND sellerId=?";
        loadBySqlParamLocal(sql,[seller.id], callback);
    },

    /**
     * 分页查询总数量
     */
    getPrintTaskTotalCount:function (sellId,callback) {
        if(sellId){
            sellId = replaceSQLiteSpecialSymbol(sellId);
        }
        var sql="SELECT count(sellId) as totalNum FROM (SELECT sellId FROM printTask WHERE status in ('8','16') and sellerId=?";
        var keyArr=[];
        keyArr.push(seller.id);
        if (sellId) {
            sql += " and (sellId like ? ESCAPE '^')";
            keyArr.push('%'+sellId+'%');
        }
        sql+=" GROUP BY sellId)";

        loadBySqlParamLocal(sql,keyArr, callback);
    },

    /**
     * 分页查询数据
     */

    loadPrintTaskPage : function(keyword, limit, offset, callBack) {
        /* 在保证payconfig未删除自定义支付的情况下完全可行,
         * 如若需要保证payconfig删除自定义支付的情况也是可行，请使用下面的注释语句(性能恐有所下降)
         * */
        keyword = replaceSQLiteSpecialSymbol(keyword);
        var sql = "SELECT pt.id as printTaskId,pt.content,s.*,case when ifnull(spt.payTypeName,'null')='null' then pc.payTypeName else spt.payTypeName end payTypeName " +
            "FROM (select * from printTask p WHERE p.status in ('8','16') GROUP BY sellId) pt " +
            "left join sellinfo s on pt.sellId=s.id " +
            "left join (select sellerId,payType,payTypeName from payconfig where sellerId='" + seller.id + "' group by payType) pc using(payType,sellerId) " +
            "left join sellerpaytypes spt on(pc.payType=spt.id) " +
            "where s.status in('1','2','3') and s.sellerId='" + seller.id + "' and ifnull(s.isDelete,'0')='0'";
        var params = [];
        if (keyword) {
            //sql += " and (s.id like '%" + keyword + "%')";
            sql += " and (pt.sellId like ? ESCAPE '^')";
            params.push('%'+keyword+'%');
        }
        sql += "  order by s.sellTime desc LIMIT " + limit + " OFFSET " + (offset * limit);
        /*var sql = "select s.*, case when ifnull(pc.payTypeName, '')='' then null else pc.payTypeName end payTypeName from sellinfo s left join payconfig pc using(payType,sellerId)" +
                " where s.status in ('1','2','3') and s.sellerId='" + seller.id + "' and ifnull(isDelete,'0')='0'";
        if(keyword) {
            sql += " and (s.id like '%" + keyword + "%')";
        }
        sql += " union ";
        sql += "select s.*, case when ifnull(spt.payTypeName,'')='' then null else spt.payTypeName end payTypeName from sellinfo s left join sellerpaytypes spt on(spt.id=s.payType and s.sellerId=spt.sellerId)" +
                " where s.status in('1','2','3') and s.sellerId='" + seller.id + "' and ifnull(isDelete, '0')='0'";
        if(keyword) {
            sql += " and (s.id like '%" + keyword + "%')";
        }
        sql += " order by s.sellTime desc LIMIT " + limit + " OFFSET " + (offset*limit);*/
        //console.log(sql);
        //loadBySql(sql, callBack);

        loadBySqlParamLocal(sql, params, callBack);
    },

    loadPrintTaskAllWithFail:function(keyword, callBack) {
        keyword = replaceSQLiteSpecialSymbol(keyword);
        // var sql = "SELECT pt.id as printTaskId,pt.content,s.*,case when ifnull(spt.payTypeName,'null')='null' then pc.payTypeName else spt.payTypeName end payTypeName " +
        //     "FROM (select * from printTask p WHERE p.status in ('8','16') GROUP BY sellId) pt " +
        //     "left join sellinfo s on pt.sellId=s.id " +
        //     "left join (select sellerId,payType,payTypeName from payconfig where sellerId='" + seller.id + "' group by payType) pc using(payType,sellerId) " +
        //     "left join sellerpaytypes spt on(pc.payType=spt.id) " +
        //     "where s.status in('1','2','3') and s.sellerId='" + seller.id + "' and ifnull(s.isDelete,'0')='0'";

        /*var sql="SELECT * FROM (SELECT * FROM printTask  WHERE status in ('8','16') and  sellerId=? GROUP BY sellId) WHERE 1=1";
        var params = [];
        params.push(seller.id);
        if (keyword) {
            // sql += " and (pt.sellId like ? ESCAPE '^')";
            sql += " and (sellId like ? ESCAPE '^')";
            params.push('%'+keyword+'%');
        }
        sql += "  ORDER BY printTime DESC";
        loadBySqlParamLocal(sql, params, callBack);*/
        var sql = "SELECT * FROM printTask WHERE 1=1";
        sql += " AND sellerId=?";
        var params = [];
        params.push(seller.id);
        if(keyword) {
        	sql += " AND (sellId like ? ESCAPE '^')";
        	params.push('%' + keyword + '%');
        }
        sql += " AND status in ('8','16')";
        sql += " ORDER BY printTime DESC";
        loadBySqlParamLocal(sql, params, callBack);
    },
    loadPrintTaskById : function (id,callBack) {
    	var sql="SELECT * FROM printTask WHERE status in ('8','16') and sellerId=?";
        var params = [];
        params.push(seller.id);
        if(id){
            sql+=" AND id=?";
            params.push(id);
        }
        loadBySqlParamLocal(sql, params, callBack);
    },
    loadPrintTaskBySellId : function (sellId,callBack) {
        var sql="SELECT * FROM printTask WHERE status in ('8','16') and sellerId=?";
        var params = [];
        params.push(seller.id);
        if(sellId){
            sql+=" AND sellId=?";
            params.push(sellId);
        }
        loadBySqlParamLocal(sql, params, callBack);
    },

    delAllPrintTask : function (callBack) {
        deleteAllLocal('printTask',callBack);
    },

    delPrintTaskBySellId : function (sellId,callBack) {
        var sql="delete from printTask where status in ('8','16') and sellerId='" + seller.id + "' and sellId='"+sellId+"'";
        executeSqlLocal(sql,callBack);
    },
    delPrintTaskById : function(id, callBack) {
    	var sql="delete from printTask where status in ('8','16') and sellerId='" + seller.id + "' and id='"+id+"'";
        executeSqlLocal(sql,callBack);
    }

};