/**
 * 收银员或服务员权限管理
 **/
var PERMISSIONS = {};
var TMP_PERMISSIONS = {};  /* 临时授权(Deprecated) */
var PERMISSIONS_NAME = [
	{1:"CASHIERBOX"},{2:"SELLRETURN"},{3:"SELLVOID"},{4:"COMMDISCOUNT"},{5:"COMMDELETE"},
	{6:"SELLCANCEL"},{7:"SELLMODIFY"},{8:"SELLERASEZERO"},{9:"COMMPRESENT"},{10:"COMMCHGPRICE"},
	{11:"PAYOFF"},{12:"SELLDISCOUNT"},{15:"SELLFREE"},{13:"TIMEPRICEMODIFY"},{14:"TEAPRICEMODIFY"},{16:"COMMADD"}, {20:"WXORDERAPPLY"},{21:"WXORDERREJECT"},
	{30:"MTORDERRESOLVE"},{31:"MTORDERREJECT"},{32:"MTORDERDISPATCH"},{33:"MTORDERCANCELDISPATCH"},{34:"MTORDERPAYOFF"},{35:"MTORDERCANCELPAYOFF"},
	{40:"CUSTOMERRECHARGE"},{41:"CUSTOMERPRESENT"},{42:"CUSTOMEREDIT"},{43:"ADDCUSTOMER"}];
for(var pKey in PERMISSIONS_NAME) {
	if(PERMISSIONS_NAME.hasOwnProperty(pKey)) {
		var permissionObj = PERMISSIONS_NAME[pKey];
		var keys = Object.keys(permissionObj);
		var values = Object.values(permissionObj);
		for(var ki=0,klen=keys.length;ki<klen;ki++) {
			if(values.length > ki) {
				PERMISSIONS[PERMISSIONS[values[ki]]=keys[ki]] = values[ki];
			}
		}
	}
}
//PERMISSIONS[PERMISSIONS["CASHIERBOX"]=1] = "CASHIERBOX";     // 钱箱
//PERMISSIONS[PERMISSIONS["SELLRETURN"]=2] = "SELLRETURN";     // 销售退货
//PERMISSIONS[PERMISSIONS["SELLVOID"]=3] = "SELLVOID";         // 销售反结账
//PERMISSIONS[PERMISSIONS["COMMDISCOUNT"]=4] = "COMMDISCOUNT";  // 单品折扣
//PERMISSIONS[PERMISSIONS["COMMDELETE"]=5] = "COMMDELETE";     // 口味/商品/餐桌删除
//PERMISSIONS[PERMISSIONS["SELLCANCEL"]=6] = "SELLCANCEL";     // 订单撤销
//PERMISSIONS[PERMISSIONS["SELLMODIFY"]=7] = "SELLMODIFY";     // 口味/商品/餐桌修改
//PERMISSIONS[PERMISSIONS["SELLERASEZERO"]=8] = "SELLERASEZERO";     // 订单抹零
//PERMISSIONS[PERMISSIONS["COMMPRESENT"]=9] = "COMMPRESENT";     // 商品赠送
//PERMISSIONS[PERMISSIONS["COMMCHGPRICE"]=10] = "COMMCHGPRICE";  // 商品改价
//PERMISSIONS[PERMISSIONS["PAYOFF"]=11] = "PAYOFF";              // 订单收款
//PERMISSIONS[PERMISSIONS["SELLDISCOUNT"]=12] = "SELLDISCOUNT";  // 整单折扣
//PERMISSIONS[PERMISSIONS["TIMEPRICEMODIFY"]=13] = "TIMEPRICEMODIFY";  // 修改时价菜价格
//PERMISSIONS[PERMISSIONS["TEAPRICEMODIFY"]=14] = "TEAPRICEMODIFY";  // 修改茶位费
//PERMISSIONS[PERMISSIONS["WXORDERAPPLY"]=20] = "WXORDERAPPLY";  // 微信订单审核
//PERMISSIONS[PERMISSIONS["WXORDERREJECT"]=21] = "WXORDERREJECT";  // 微信订单驳回
//PERMISSIONS[PERMISSIONS["MTORDERRESOLVE"]=30] = "MTORDERRESOLVE";  // 美团接单
//PERMISSIONS[PERMISSIONS["MTORDERREJECT"]=31] = "MTORDERREJECT";  // 美团拒接单
//PERMISSIONS[PERMISSIONS["MTORDERDISPATCH"]=32] = "MTORDERDISPATCH";  // 美团配送
//PERMISSIONS[PERMISSIONS["MTORDERCANCELDISPATCH"]=33] = "MTORDERCANCELDISPATCH";  // 美团取消配送
//PERMISSIONS[PERMISSIONS["MTORDERPAYOFF"]=34] = "MTORDERPAYOFF";  // 美团订单结算
//PERMISSIONS[PERMISSIONS["MTORDERCANCELPAYOFF"]=35] = "MTORDERCANCELPAYOFF";  // 美团取消结算
//PERMISSIONS[PERMISSIONS["CUSTOMERRECHARGE"]=40] = "CUSTOMERRECHARGE";  // 会员充值
//PERMISSIONS[PERMISSIONS["CUSTOMERPRESENT"]=41] = "CUSTOMERPRESENT";  // 会员赠送
//PERMISSIONS[PERMISSIONS["CUSTOMEREDIT"]=42] = "CUSTOMEREDIT";  // 会员编辑
//PERMISSIONS[PERMISSIONS["ADDCUSTOMER"]=43] = "ADDCUSTOMER";  // 新增会员
// 收银员权限
var employeePermissions = {hint:'您没有该权限,请联系管理员!'}; // 统一提示
employeePermissions[PERMISSIONS.CASHIERBOX] = {hint:'您没有此项权限,请联系管理员!'}; // 单个权限提示


function validatePermission(permissionValue, workType) {
	var workType = workType || '1';
	return new Promise(function(resolve, reject) {
		checkPermissions(permissionValue, true)
		.then(function() {resolve(true);})
		.catch(function() {reject();});
	})
	
	return;
	if (!checkPermissions(permissionValue, false)) {
		showAlert('提示', (permissionValue in employeePermissions) ? 
				employeePermissions[permissionValue].hint:employeePermissions.hint);//'当前收银员没有此项权限！');
		return false;
	}
	return true;
}

/**
 * 检查是否有权限
 * @param {Object} permissions
 */
function checkPermissions(permissionVal, isShow, hintTxt) {
	return checkPermissionsPromise(permissionVal, isShow, hintTxt);
	var cashierPermissions = getPermissions() || '';
	//var p = cashierPermissions + ",";
	try {
		var p = cashierPermissions.split(",");
		//permissionVal = permissionVal || '';
		//permissionVal = permissionVal.toUpperCase();
		if(!(permissionVal in PERMISSIONS)) return true;   // 未加入到权限表
		else if($.inArray(permissionVal, p, 0) != -1||$.inArray(permissionVal+"", p, 0) != -1) return true;
		else if (cashierPermissions && p.indexOf(permissionVal + ",") != -1) {
			return true;
		}
		if (isShow) {
			showPermissionHint(hintTxt);
		}
	} catch(err) {
	} finally {}
	return false;
}
/**
 * 
 * @author v_cjc
 * @createTime 2018年6月7日 上午11:02:54
 * @param permissionVal
 * @param isShow
 * @param hintTxt
 * @returns
 */
function checkPermissionsPromise(permissionVal, isShow, hintTxt) {
	return new Promise(function(resolve, reject) {
		var cashierPermissions = getPermissions() || '';
		//var p = cashierPermissions + ",";
		try {
			var p = cashierPermissions.split(",");
			//permissionVal = permissionVal || '';
			//permissionVal = permissionVal.toUpperCase();
			if(!(permissionVal in PERMISSIONS)) return resolve&&resolve(true);   // 未加入到权限表
			else if($.inArray(permissionVal, p, 0) != -1||$.inArray(permissionVal+"", p, 0) != -1) return resolve&&resolve(true);
			else if (cashierPermissions && p.indexOf(permissionVal + ",") != -1) {
				return resolve&&resolve(true);
			}
			if (isShow) {
				PermissionViewInterceptor(permissionVal)
				.then(function() {
					showPermissionHint(hintTxt, permissionVal, function(success) {
						if(success) resolve&&resolve(true);
						else reject && reject(false);
					});
				}).catch(function() {reject && reject(false);});
				return;
			}
		} catch(err) {
		} finally {}
		return reject && reject(false);
	});
}
/* 权限视图栏截 */
function PermissionViewInterceptor(permissionVal, hintTxt) {
	return new Promise(function(resolve, reject) {
		if(permissionVal == "40") { // 会员充值单独显示
			showAlert("提示",hintTxt ? hintTxt : "对不起，您没有该项权限!");
			reject && reject(false);
		} else
			resolve(true);
	});
}