/*******************************************************************************
 * 获取随机数
 *
 * @param {}
 *            min
 * @param {}
 *            max
 * @return {}
 */
function getRandomInt(min, max) {
	return Math.floor(Math.random() * (max - min + 1)) + min;
}

String.prototype.startWith = function(str) {
	var reg = new RegExp("^" + str);
	return reg.test(this);
};

String.prototype.endWith = function(str) {
	var reg = new RegExp(str + "$");
	return reg.test(this);
};

Date.prototype.format = function(format) {
	var o = {
		"M+" : this.getMonth() + 1, // month
		"d+" : this.getDate(), // day
		"h+" : this.getHours(), // hour
		"m+" : this.getMinutes(), // minute
		"s+" : this.getSeconds(), // second
		"q+" : Math.floor((this.getMonth() + 3) / 3), // quarter
		"S" : this.getMilliseconds()
		// millisecond
	};

	if (/(y+)/.test(format)) {
		format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	}

	for (var k in o) {
		if (new RegExp("(" + k + ")").test(format)) {
			format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
		}
	}
	return format;
};

/**
 * 时间戳转日期
 * @param timestamp
 * @param format
 * @returns
 */
function timestampToDate(timestamp, format) {
	if(!timestamp){
		return "";
	}
	format = format ? format : 'yyyy-MM-dd hh:mm:ss';
	return new Date(parseInt(timestamp)).format(format);
}

/*验证正数(最多两位小数)*/
function checkPositiveNumber(obj) {
	var re = /^(?:(?:(?:[1-9]\d{0,2}(?:,\d{3})*)|[1-9]\d*|0))(?:\.\d{1,2})?$/;
	if ( typeof obj == "object") {
		if (!re.test(obj.value)) {
			return false;
		} else {
			return true;
		}
	} else {
		if (!re.test(obj)) {
			return false;
		} else {
			return true;
		}
	}
}
/* 验证整型(最多两位人数) */
function checkIntegerNumber(obj) {
	var re = /^(?:(?:\-{0,1}(?:[1-9]\d{0,2}(?:,\d{3})*)|[1-9]\d*|0))(?:\.\d{1,2})?$/;
	if(typeof obj == 'object') {
		if(!re.test(obj.value)) {
			return false;
		} else return true;
	} else {
		if(!re.test(obj)) return false;
		else return true;
	}
}
/* 验证正数 */
function checkNumber(value) {
	var re = /^[0-9]\d*$/;
	if (!re.test(value)) {
		return false;
	} else {
		return true;
	}
}

/* 验证整数 */
function isInteger(str) {
	var regu = /^[-]{0,1}[0-9]{1,}$/;
	return regu.test(str);
}

/* 正整数 */
function isPositiveInteger(str) {
	var regu = /^[1-9]{1}[0-9]{0,}$/;
	return regu.test(str);
}

/**
 * 验证微信付款二维码
 */
function isWxQRCode(barCode) {
	var reg = /^1[0-5]\d{16}$/;
	if (reg.test(barCode)) return true;
	else return false;
}
/**
 * 验证支付宝付款二维码
 */
function isAliQRCode(barCode) {
	var reg = /^28\d{16}$/;
	if (reg.test(barCode)) return true;
	else return false;
}

/**
 * 验证IP地址
 */
function isIPAddress(ip) {
	var reg = /^((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))))$/;
	if (ip) {
		if (!reg.test(ip))
			return false;
	} else
		return false;
	return true;
}

/**
 * 验证textfield是否有空格
 */
function isHasSpace(str) {
    var reg=/\s/g;
    if (str) {
        if (!reg.test(str))
            return false;
    } else
        return false;
    return true;
}

/**
 * 验证textfield首尾是否有空格
 */
function isSpaceAtSides(str) {
    var reg=/(^\s+)|(\s+$)/g;
    if (str) {
        if (!reg.test(str))
            return false;
    } else
        return false;
    return true;
}

/**
 * 验证是否手机号码
 */
function isMobile(mobile) {
	//定义手机号码正规表达式
	//var reg = /^(130|131|132|133|134|135|136|137|138|139|140|141|142|143|144|145|146|147|148|149|150|151|152|153|155|156|157|158|159|180|181|182|183|184|185|186|187|188|189)\d{8}$/;
	//var reg = /^(13[0-9]|14[579]|15[012356789]|17[0135678]|18[0-9])\d{8}$/;
	//var reg = /^(13[0-9]|14[0-9]|15[012356789]|166|17[0135678]|18[0-9]|19[8-9])\d{8}$/;
	var reg = /^(13[0-9]|14[0-9]|15[0-9]|16[0-9]|17[0-9]|18[0-9]|19[0-9])\d{8}$/;
	if (mobile) {
		if (!reg.test(mobile)) {
			return false;
		}
	} else {
		return false;
	}
	return true;
}

/**
 * 验证用户名
 */
function isUserName(value) {
	var re = /^[a-zA-Z]+[a-zA-Z0-9_]*$/;
	if (!re.test(value)) {
		return false;
	} else {
		return true;
	}
}

/**
 * 创建商品的条形码
 */
function createBarCode(date) {
	var random = "";
	for (var i = 0; i < 1; i++) {
		random += getRandomInt(0, 9);
	}

	return date.format('yyMMddhhmmss') + random;
}

function createUUIDForId() {
	var uuid = new Ext.data.identifier.Uuid().generate();
	return uuid.replace(/-+/gi,"");
}
/**
 * 创建销售单ID
 */
function creatId(date, prefix) {
	var random = "";
	for (var i = 0; i < 8; i++) {
		random += getRandomInt(0, 9)+"";
	}
	var ms = date.getMilliseconds() + "";
	if (ms.length < 3) {
		for (var i = 0; i < 3; i++) {
			ms = '0' + ms;
		}
	}

	return prefix + date.format("yyyyMMddhhmmss") + ms + random;
}
function createIntegerIdByDate() {
	var random = "";
	for(var i=0;i<1;i++) {
		random += getRandomInt(0,9) + "";
	}
	var date = new Date();
	var integerId = date.format("yyyyMMddhhmmss");
	return parseInt(integerId);
}
/**
 * 生成销售音ID
 */
function createSellId(date, prefix) {
	if (!date) {
		date = new Date();
	}
	var random = "";
	for (var i = 0; i < 8; i++) {
		random += getRandomInt(0, 9)+"";
	}
	return seller.userName + prefix + date.format("yyyyMMddhhmmss") + random;
}

/**
 * 生成系统ID
 */
function createSysId(prefix) {
	var randomLength=14;
	if(prefix){
		randomLength-=prefix.length;
	}else{
		prefix="";
	}
	var date = new Date();
	var random = "";
	for (var i = 0; i < 4; i++) {
		random += getRandomInt(0, 9)+"";
	}
	var sellerNo=seller.id;
	if(sellerNo.length>randomLength){
		sellerNo=seller.userName;
	}
	if(sellerNo.length>randomLength){
		sellerNo=sellerNo.substring(0,randomLength);
	}
	return prefix+sellerNo + date.format("yyyyMMddhhmmss") + random;
}

/**
 * 生成打印模板ID
 */
function createPrintTemplateId(index) {
	var randomLength=14;
	var date = new Date();
	index+="";
	while(index.length<=4){
		index="0"+index;
	}
	var sellerNo=seller.id;
	if(sellerNo.length>randomLength){
		sellerNo=seller.userName;
	}
	if(sellerNo.length>randomLength){
		sellerNo=sellerNo.substring(0,randomLength);
	}
	return sellerNo + date.format("yyyyMMddhhmmss") + index;
}

/**
 * 销售明细类型
 * @param {Object} type0下单，1追加
 */
function getSellDetailType(type) {
	if (type == '1') {
		return "追加";
	} else {
		return "下单";
	}
}

/**
 * 校验数据，如果为空则设置成默认值
 * @param {Object} value
 * @param {Object} defaultValue
 */
function nvlValue(value, defaultValue) {
    if(value === 0||value === '0'){
        return defaultValue;
    }
	if (!value || 
		(value === 'null') || 
		(value === 'undefined') || 
		(value === 'NaN') ||
		(value === '') ||
		(value === 'false') ||
		(value === false)
		) {
        if(defaultValue==0||defaultValue=='0'){
            value=defaultValue;
        }else{
            value = defaultValue||"";
        }
    }
    return value;
}

function isValValue(value) {
	if (!value || 
		(value === 0) || 
		(value === 'null') || 
		(value === 'undefined') || 
		(value === '') ||
		(value === 'NaN') ||
		(value === 'false') ||
		(value === false)
		) {
        return false;
    }
    return true;
}

/**
 * 格式化数字
 */
function numberFormat(value){
    var temNumber=value+"";
    if(temNumber.indexOf(".")!=-1){
        temNumber=parseFloat(temNumber).toFixed(2);
    }else{
        temNumber=value;
    }
    return temNumber;
}

/**
 * 格式化数字
 */
function numberFixed(value){
    if(!value){
        return value;
    }
    return parseFloat(value).toFixed(2);
}

var zindex = 1000;

function showConfirmPay(title, message, fn, width, height) {
	var id = creatId(new Date(), 'SCFPAY_SPECIAL');
	//var id = "SCF-DATE-CONFIRM-PAY-VIEW";
	var msgView = Ext.Viewport.add({
		xtype : 'panel',
		centered : true,
		modal : true,
		id : id,
		hideOnMaskTap : false,
		width : width ? width : 200,
		height : height ? height : 150,
		zIndex : zindex++,
		scrollable : false,
		layout : 'vbox',
		items : [{
			xtype : 'toolbar',
			title : title,
			docked : 'top'
		}, {
			xtype : "label",
			margin : '10 0 0 0',
			flex : 1,
			html : "<center>" + message + "</center>"
		}, {
			xtype : 'panel',
			height : 35,
			layout : 'hbox',
			items : [{
				xtype : 'spacer'
			}, {
				xtype : 'button',
				height : 30,
				width : 80,
				text : '取消',
				cls : 'white-button',
				id : 'show-cancel-view-pay-btn',
				handler : function() {
					if (fn) {
						fn('no');
					}
					Ext.getCmp(id).destroy();
				}
			}, {
				xtype : 'button',
				height : 30,
				width : 80,
				margin : '0 0 0 5',
				cls : 'red-button',
				text : '确定',
				id : 'show-confirm-view-pay-btn',
				handler : function() {
					if (fn) {
						fn('yes');
					}
					Ext.getCmp(id).destroy();
				}
			}, {
				xtype : 'spacer'
			}]
		}]
	});
	msgView.show();
	msgView.setAutoDestroy(true);

	return id;
}

function destroyAllConfirmView() {
	for (var i = 0; i < showConfirmCancelBtn.length; i++) {
		var targetId = showConfirmCancelBtn[i];
        var targetHandler = Ext.getCmp(targetId).getHandler();
        targetHandler && targetHandler();
	}
	showConfirmId = [];
	showConfirmCancelBtn = [];
	showConfirmConfirmBtn = [];
}

/**
 * 弹出确定
 * @param {Object} title
 * @param {Object} message
 * @param {Object} fn
 */
function showConfirm(title, message, fn, width, height) {
	var tempId = creatId(new Date(), 'SCF_SPECIAL');
	var tempConfirmBtn = 'show-confirm-view-btn' + new Date().getTime();
	var tempCancelBtn = 'show-cancel-view-btn' + new Date().getTime();
	showConfirmId.push(tempId);
    showConfirmConfirmBtn.push(tempConfirmBtn);
	showConfirmCancelBtn.push(tempCancelBtn);
	//var id = "SCF-DATE-CONFIRM-VIEW";
	var msgView = Ext.Viewport.add({
		xtype : 'panel',
		centered : true,
		modal : true,
		id : tempId,
		hideOnMaskTap : false,
		width : width ? width : 200,
		height : height ? height : 150,
		zIndex : zindex++,
		scrollable : false,
		layout : 'vbox',
		items : [{
			xtype : 'toolbar',
			title : title,
			docked : 'top'
		}, {
			xtype : "container",
			margin : '10 0 0 0',
			flex : 1,
			html : "<center>" + message + "</center>"
		}, {
			xtype : 'container',
			height : 35,
			layout : 'hbox',
			items : [{
				xtype : 'spacer'
			}, {
				xtype : 'button',
				height : 30,
				width : 80,
				text : '取消',
				cls : 'white-button',
				id : tempCancelBtn,
				handler : function() {
					if (fn) {
						fn('no');
					}
					Ext.getCmp(tempId) && Ext.getCmp(tempId).destroy();
					removeByValue(showConfirmId, tempId);
                    removeByValue(showConfirmCancelBtn, tempCancelBtn);
                    removeByValue(showConfirmConfirmBtn, tempConfirmBtn);
				}
			}, {
				xtype : 'button',
				height : 30,
				width : 80,
				margin : '0 0 0 5',
				cls : 'red-button',
				text : '确定',
				id : tempConfirmBtn,
				handler : function() {
					if (fn) {
						fn('yes');
					}
					Ext.getCmp(tempId) && Ext.getCmp(tempId).destroy();
                    removeByValue(showConfirmId, tempId);
                    removeByValue(showConfirmCancelBtn, tempCancelBtn);
                    removeByValue(showConfirmConfirmBtn, tempConfirmBtn);
				}
			}, {
				xtype : 'spacer'
			}]
		}]
	});
	msgView.show();
	msgView.setAutoDestroy(true);

	return showConfirmId;
}

function showCloseConfirmWithWx(title, message, fn) {
	var idCmp = creatId(new Date(), 'SCCF_WX_SPECIAL');
	//var idCmp = "SCCF-DATE-DIALOG-WX-VIEW";
	var msgView = Ext.Viewport.add({
		xtype : 'panel',
		centered : true,
		modal : true,
		zIndex : zindex++,
		hideOnMaskTap : false,
		width : 200,
		height : 150,
		id : idCmp,
		scrollable : false,
		layout : 'vbox',
		items : [{
			xtype : 'toolbar',
			title : title,
			docked : 'top'
		}, {
			xtype : "container",
			margin : '10 0 0 0',
			flex : 1,
			html : "<center>" + message + "</center>"
		}, {
			xtype : 'container',
			height : 35,
			layout : 'hbox',
			items : [{
				xtype : 'spacer'
			}, {
				xtype : 'button',
				height : 30,
				width : 80,
				text : '取消',
				cls : 'white-button',
				handler : function() {
					if (fn) {
						fn('no');
					}
					Ext.getCmp(idCmp).destroy();
				}
			}, {
				xtype : 'button',
				height : 30,
				width : 80,
				margin : '0 0 0 5',
				cls : 'red-button',
				text : '确定',
				//id : idCmp + 'btn',
				id : 'show-close-confirm-wx-btn' + new Date().getTime(),
				handler : function() {
					if (fn) {
						fn('yes');
					}
					Ext.getCmp(idCmp).destroy();
				}
			}, {
				xtype : 'spacer'
			}]
		}]
	});
	msgView.show();
	//closeAlertInterval(idCmp, 10);
	closeConfirmWxInterval(idCmp, 10);
}

/**
 * 弹出确定
 * @param {Object} title
 * @param {Object} message
 * @param {Object} fn
 */
function showCloseConfirm(title, message, fn,timeout) {
	var idCmp = creatId(new Date(), 'SCCF_SPECIAL');
	//var idCmp = "SCCF-DATE-DIALOG-VIEW";
	var msgView = Ext.Viewport.add({
		xtype : 'panel',
		centered : true,
		modal : true,
		zIndex : zindex++,
		hideOnMaskTap : false,
		width : 200,
		height : 150,
		id : idCmp,
		scrollable : false,
		layout : 'vbox',
		items : [{
			xtype : 'toolbar',
			title : title,
			docked : 'top'
		}, {
			xtype : "container",
			margin : '10 0 0 0',
			flex : 1,
			html : "<center>" + message + "</center>"
		}, {
			xtype : 'container',
			height : 35,
			layout : 'hbox',
			items : [{
				xtype : 'spacer'
			}, {
				xtype : 'button',
				height : 30,
				width : 90,
				text : '取消',
				cls : 'white-button',
				id : idCmp+'-cancle-btn',
				handler : function() {
					if (fn) {
						fn('no');
					}
					Ext.getCmp(idCmp).destroy();
				}
			}, {
				xtype : 'button',
				height : 30,
				width : 90,
				margin : '0 0 0 5',
				cls : 'red-button',
				text : '确定',
				//id : idCmp + 'btn',
				id : idCmp+'-confirm-btn',
				handler : function() {
					if (fn) {
						fn('yes');
					}
					Ext.getCmp(idCmp).destroy();
				}
			}, {
				xtype : 'spacer'
			}]
		}]
	});
	msgView.show();
	//closeAlertInterval(idCmp, 10);
	closeConfirmInterval(idCmp, timeout?timeout:10);
}

function showAlertWidthCallback(title, message, fn) {
	showAlert(title, message, 0, 0, 0, fn);
}

function showAlertWithWH(title, message, width, height, fn) {
	showAlertWH(title, message, 0, 0, width, height, fn);
}

function showAlertWH(title, message, left, top, width, heigth, fn, parent) {
	if(isExistMaxPriorityWarn()) return;
	var idCmp = creatId(new Date(), 'SAWH_SPECIAL');
	//var idCmp = "SCCF-DATE-ALERT-VIEW";
	var msgView = Ext.Viewport.add({
		xtype : 'panel',
		centered : true,
		modal : true,
		hideOnMaskTap : false,
		id : idCmp,
		width : width ? width : 200,
		zIndex : zindex++,
		height : heigth ? heigth : 150,
		scrollable : false,
		layout : 'vbox',
		items : [{
			xtype : 'toolbar',
			title : title,
			docked : 'top'
		}, {
			xtype : "container",
			margin : '10 0 0 0',
			flex : 1,
			html : "<center>" + message + "</center>"
		}, {
			xtype : 'container',
			height : 40,
			layout : 'hbox',
			items : [{
				xtype : 'spacer'
			}, {
				xtype : 'button',
				iconMask : true,
				margin : '0 0 0 1',
				height : 30,
				width : 100,
				cls : 'red-button',
				text : '确定',
				id : 'show-alert-view-btn',
				handler : function() {
					if (fn) {
						fn();
					}
					Ext.getCmp(idCmp).destroy();
				}
			}, {
				xtype : 'spacer'
			}]
		}]
	});
	if (parent) {
		msgView.showBy(parent);
	} else {
		msgView.show();
	}
	if (left) {
		msgView.setLeft(left);
	}
	if (top) {
		msgView.setTop(top);
	}
}

/**
 * 弹出确定
 * @param {Object} title
 * @param {Object} message
 * @param {Object} fn
 */
function showAlertWithHeight(title, message, heigth, fn) {
	showAlert(title, message, 0, 0, heigth, fn);
}

/**
 * 弹出确定
 * @param {Object} title
 * @param {Object} message
 * @param {Object} fn
 */
function showAlertWithParent(parent, title, message, heigth, fn) {
	showAlert(title, message, 0, 0, heigth, fn, parent);
}

/**
 * 弹出确定
 * @param {Object} title
 * @param {Object} message
 * @param {Object} fn
 */
function showAlert(title, message, left, top, heigth, fn, parent, width) {
	if(isExistMaxPriorityWarn()) return;
	var tempId = creatId(new Date(), 'SA_SPECIAL');
	var tempConfirmBtn = creatId(new Date(), 'SAVB');
	showAlertId.push(tempId);
    showAlertConfirmBtn.push(tempConfirmBtn);
	//var idCmp = "SCCF-DATE-ALERT-VIEW";
	var msgView = Ext.Viewport.add({
		xtype : 'panel',
		centered : true,
		modal : true,
		hideOnMaskTap : false,
		id : tempId,
		width : width ? width : 200,
		zIndex : zindex++,
		height : heigth ? heigth : 150,
		scrollable : false,
		layout : 'vbox',
		items : [{
			xtype : 'toolbar',
			title : title,
			docked : 'top'
		}, {
			xtype : "container",
			margin : '10 0 0 0',
			flex : 1,
			html : "<center>" + message + "</center>"
		}, {
			xtype : 'container',
			height : 40,
			layout : 'hbox',
			items : [{
				xtype : 'spacer'
			}, {
				xtype : 'button',
				iconMask : true,
				margin : '0 0 0 1',
				height : 30,
				width : 100,
				cls : 'red-button',
				text : '确定',
				id : tempConfirmBtn, //'show-alert-view-btn',
				handler : function() {
					if (fn) {
						fn();
					}
					Ext.getCmp(tempId).destroy();
                    removeByValue(showAlertId, tempId);
                    removeByValue(showAlertConfirmBtn, tempConfirmBtn);
				}
			}, {
				xtype : 'spacer'
			}]
		}],
		/*listeners : {
			painted : function () {
				$('#ext-viewport').keypress(function () {
					if (event.keyCode == 13) {
						var target = Ext.getCmp(idConfirmBtn);
						target.fireEvent('tap');
					}
                })
            }
		}*/
	});
	if (parent) {
		msgView.showBy(parent);
	} else {
		msgView.show();
	}
	if (left) {
		msgView.setLeft(left);
	}
	if (top) {
		msgView.setTop(top);
	}
}

function showToast(message, sec, left, top, height, fn, parent) {
    var tempId = creatId(new Date(), 'toastId');
    sec = sec || 5000;
    // var tempConfirmBtn = creatId(new Date(), 'SAVB');
    // showAlertId.push(tempId);
    // showAlertConfirmBtn.push(tempConfirmBtn);
    var msgView = Ext.Viewport.add({
        xtype : 'panel',
		bottom : 80,
		left : '25%',
        showAnimation : 'pop',
		hideAnimation : 'fadeOut',
        modal : false,
		style : 'background:transparent;box-shadow:none;pointer-events: none;',
        hideOnMaskTap : false,
        id : tempId,
        width : '50%',
        height : height ? height : 100,
        scrollable : false,
        items : {
            xtype : "label",
			margin : '10 0 0 0',
            // style : 'background:rgba(0,0,0,0.6);border-radius:9px;color:#D0D0D0;',
            html : "<center><div style='display:inline-block;background:rgba(0,0,0,0.6);border-radius:9px;color:#D0D0D0;padding: 10px 15px 10px 15px;'>" + message + "</div></center>"
        },
    });
    if (parent) {
        msgView.showBy(parent, 'cc-cc?');
    } else {
        msgView.show();
    }
    if (left) {
        msgView.setLeft(left);
    }
    if (top) {
        msgView.setTop(top);
    }
    setTimeout(function () {
		if(Ext.getCmp(tempId)) {
            Ext.getCmp(tempId).hide();
            setTimeout(function () {
                Ext.getCmp(tempId).destroy();
            },1000);
            if(fn) fn();
		}
    },sec);
}

function removeByValue(arr, val) {
    for(var i=0; i<arr.length; i++) {
        if(arr[i] == val) {
            arr.splice(i, 1);
            i--;
            break;
        }
    }
}

function isInArray(array, element, searchType) {
	searchType = searchType || 'all';
	if (typeof element == 'object') {
		var isinArray;
		var ei, eLen = element.length;
		if (searchType == 'all') {
			isinArray = true;
            for (ei = 0; ei < eLen; ei++) {
                if (array.indexOf(element[ei]) == -1) {
                    isinArray = false;
                }
            }
            return isinArray;
        } else if (searchType == 'one') {
			isinArray = false;
            for (ei = 0; ei < eLen; ei++) {
                if (array.indexOf(element[ei]) != -1) {
                    isinArray = true;
                }
            }
            return isinArray;
		}
	} else {
		return array.indexOf(element) != -1 ? true : false;
	}
}

function showCloseAlert(title, message, ti, fn) {
	var id = creatId(new Date(), 'SCA_SPECIAL');
	//var id = "SCA-DATE-ALERT-VIEW";
	var idConfirmBtn = creatId(new Date(), 'SCACB');
	var msgView = Ext.Viewport.add({
		xtype : 'panel',
		centered : true,
		id : id,
		modal : true,
		hideOnMaskTap : false,
		width : 200,
		height : 150,
		zIndex : zindex++,
		scrollable : false,
		layout : 'vbox',
		items : [{
			xtype : 'toolbar',
			title : title,
			docked : 'top'
		}, {
			xtype : "container",
			margin : '10 0 0 0',
			flex : 1,
			html : "<center>" + message + "</center>"
		}, {
			xtype : 'container',
			height : 40,
			layout : 'hbox',
			items : [{
				xtype : 'spacer'
			}, {
				xtype : 'button',
				iconMask : true,
				margin : '0 0 0 1',
				height : 30,
				width : 100,
				text : '确定',
				cls : 'red-button',
				id : id + '-confirm-btn',
				//id : idConfirmBtn, //'show-close-alert-confirm-btn',
				handler : function() {
					if (fn) {
						fn();
					}
					Ext.getCmp(id).destroy();
				}
			}, {
				xtype : 'spacer'
			}]
		}]
	});
	msgView.show();
	closeAlertInterval(id, ti);
}

var wxInterval = null;
function closeConfirmWxInterval(id, ti) {
	var k = ti - 1;
	if (wxInterval) {
		clearInterval(wxInterval);
		wxInterval = null;
	}
	wxInterval = setInterval(function() {
		if (k < 1) {
			window.clearInterval(wxInterval);
			wxInterval = null;
			if (Ext.getCmp(id)) {
				Ext.getCmp(id).destroy();
			}
			return;
		}
		//if (Ext.getCmp(id + 'btn')) {
		//	Ext.getCmp(id + 'btn').setText("确定" + "(" + k + "秒)");
		//} else {
		if (Ext.getCmp('show-close-confirm-btn')) {
			Ext.getCmp('show-close-confirm-btn').setText('确定' + "(" + k + "秒)");
		} else {
			window.clearInterval(wxInterval);
			wxInterval = null;
			if (Ext.getCmp(id)) {
				Ext.getCmp(id).destroy();
			}
			return;
		}
		k--;
	}, 1000);
}

function closeConfirmInterval(id, ti) {
	var k = ti - 1;
	var tapCancelCmp = function() {
        if (Ext.getCmp(id+'-cancle-btn')) {
            var handler = Ext.getCmp(id + '-cancle-btn').getHandler();
            handler && handler();
        }
	}
	var st = setInterval(function() {
		if (k < 1) {
			window.clearInterval(st);
            tapCancelCmp();
			if (Ext.getCmp(id)) {
				Ext.getCmp(id).destroy();
			}
			return;
		}
		//if (Ext.getCmp(id + 'btn')) {
		//	Ext.getCmp(id + 'btn').setText("确定" + "(" + k + "秒)");
		//} else {
		if (Ext.getCmp(id+'-cancle-btn')) {
			Ext.getCmp(id+'-cancle-btn').setText('取消' + "(" + k + "秒)");
		} else {
			window.clearInterval(st);
            tapCancelCmp();
			if (Ext.getCmp(id)) {
				Ext.getCmp(id).destroy();
			}
			return;
		}
		k--;
	}, 1000);
}

function closeAlertInterval(id, ti) {
	var k = ti - 1;
	var st = setInterval(function() {
		if (k < 1) {
			window.clearInterval(st);
			if (Ext.getCmp(id)) {
				Ext.getCmp(id).destroy();
			}
			return;
		}
		//if (Ext.getCmp(id + 'btn')) {
		//	Ext.getCmp(id + 'btn').setText("确定" + "(" + k + "秒)");
		//} else {
		if (Ext.getCmp(id+'-confirm-btn')) {
			Ext.getCmp(id+'-confirm-btn').setText('确定' + "(" + k + "秒)");
		}  else {
			window.clearInterval(st);
			if (Ext.getCmp(id)) {
				Ext.getCmp(id).destroy();
			}
			return;
		}
		k--;
	}, 1000);
}

function alertView(/*title, message, left, top, height, fn, parent*/viewInfo, callback) {
	var idCmp = creatId(new Date(), 'SA_SPECIAL');
	//var idCmp = "SCCF-DATE-ALERT-VIEW";
	var idConfirmBtn = creatId(new Date(), 'SAVB');
	var msgView = Ext.Viewport.add({
		xtype : 'panel',
		centered : true,
		modal : true,
		hideOnMaskTap : false,
		id : idCmp,
		width : viewInfo.width ? viewInfo.width : 200,
		zIndex : 9999,
		height : viewInfo.heigth ? viewInfo.heigth : 150,
		scrollable : false,
		layout : 'vbox',
		items : [{
			xtype : 'toolbar',
			title : viewInfo.title,
			docked : 'top'
		}, {
			xtype : "container",
			margin : '10 0 0 0',
			flex : 1,
			html : "<center>" + viewInfo.message + "</center>"
		}, {
			xtype : 'container',
			height : 40,
			layout : 'hbox',
			items : [{
				xtype : 'spacer'
			}, {
				xtype : 'button',
				iconMask : true,
				margin : '0 0 0 1',
				height : 30,
				width : 100,
				cls : 'red-button',
				text : '确定',
				id : idConfirmBtn, //'show-alert-view-btn',
				handler : function() {
					if (viewInfo.fn) {
						viewInfo.fn();
					}
					callback && callback();
					Ext.getCmp(idCmp).destroy();
				}
			}, {
				xtype : 'spacer'
			}]
		}]
	});
	if (viewInfo.parent) {
		msgView.showBy(viewInfo.parent);
	} else {
		msgView.show();
	}
	if (viewInfo.left) {
		msgView.setLeft(viewInfo.left);
	}
	if (viewInfo.top) {
		msgView.setTop(viewInfo.top);
	}
}
function showSingletonAlert(singleObject) {
	/* generator singleton object */
	var alertSingleton = null;
	return function(viewInfo){
		if(!alertSingleton) {
			alertSingleton = new window[singleObject](viewInfo, function() {
				alertSingleton = null;
			});
		}
		return alertSingleton;
	};
}
function showSingletonAlertPriority(singleObject, priority) {
	/* generator singleton object */
	var alertSingleton = null;
	return function(viewInfo){
		if(priority && priority === "infinite") {
			if(window.isMaxPriorityWarn !== true) window.isMaxPriorityWarn = true;
		}
		if(!alertSingleton) {
			alertSingleton = new window[singleObject](viewInfo, function() {
				alertSingleton = null;
				if(window.isMaxPriorityWarn === true)
					window.isMaxPriorityWarn = false;
			});
		}
		return alertSingleton;
	};
}
function isExistMaxPriorityWarn() {
	return window.isMaxPriorityWarn === true;
}
/**
 * 最高优先级警告框, 禁止其他alert弹框
 * */
var SingletonAlertViewMaxPriorityWarn = showSingletonAlertPriority('alertView', "infinite");
/**
 * 硬盘空间不足错误信息单例提示
 */
var SingletonAlertView = showSingletonAlert('alertView');
function showSqliteError(err) { 
	/*
	 * 1. sqlite3 硬盘空间不足提示错误信息
	 * */
    if(err && typeof(err.message)==='string' && err.message.indexOf('not enough remaining storage space') > -1) {
    	/* 只有在登录后才会提示 */
    	if((seller && seller.id) && (shouYinEmployee && shouYinEmployee.id)) 
    		if(window.SingletonAlertView)
    			SingletonAlertView({title:"提示", message:"硬盘没有足够的空间!"});
    }
}
/**
 * 组装查询条件
 */
function mkWhere(data) {
	var arr = [];
	if ( typeof data === 'object') {
		for (var i in data) {
			if (isNaN(data[i])) {
				arr.push(i + "='" + data[i] + "'");
			} else {
				arr.push(i + "=" + data[i] + "");
			}
		}
	}
	return arr.join(' , ');
}

function toUtf8(str) {
	var out, i, len, c;
	out = "";
	len = str.length;
	for ( i = 0; i < len; i++) {
		c = str.charCodeAt(i);
		if ((c >= 0x0001) && (c <= 0x007F)) {
			out += str.charAt(i);
		} else if (c > 0x07FF) {
			out += String.fromCharCode(0xE0 | ((c >> 12) & 0x0F));
			out += String.fromCharCode(0x80 | ((c >> 6) & 0x3F));
			out += String.fromCharCode(0x80 | ((c >> 0) & 0x3F));
		} else {
			out += String.fromCharCode(0xC0 | ((c >> 6) & 0x1F));
			out += String.fromCharCode(0x80 | ((c >> 0) & 0x3F));
		}
	}
	return out;
}

/**
 * 限制输入长度
 * @param {Object} content
 * @param {Object} len
 * @param {Object} type1左2右对齐
 */
function limitLen(content, len, type) {
    if (!content) {
        if ( typeof (content) == 'number') {
            content = '0';
        } else {
            content = "";
        }
    }
    content = content + '';
    var blen = getBLen(content,0);
    if (blen > len) {
        return content.substring(0, len) + "... ";
    } else {
        for (var i = blen; i < (len + 1); i++) {
            if (type == 2) {
                content = " " + content;
            } else {
                content += " ";
            }
        }
        return content;
    }
}

function limitLen2(content, len, type) {
    if (!content) {
        if ( typeof (content) == 'number') {
            content = '0';
        } else {
            content = "";
        }
    }
    content = content + '';
    var blen = getBLen(content, 0);
    if (blen > len) {
        return content.substring(0, len);
    } else {
        var dif = len - blen;

        for (var i = 0; i < dif; i++) {
            if (type == 2) {
                content = ' ' + content;
            } else {
                content += ' ';
            }
        }
        return content;
    }
}

function limitLenDoubleWidth(content, len, type) {
    if (!content) {
        if ( typeof (content) == 'number') {
            content = '0';
        } else {
            content = "";
        }
    }
    content = content + '';
    var blen = getBLen(content, 1);

    if (blen > len) {
        return content.substring(0, len);
    } else {
        var dif = len - blen;

        for (var i = 0; i < dif; i++) {
            if (type == 2) {
                content = '  ' + content;
            } else {
                content += '  ';
            }
        }
        return content;
    }
}

/**
 * 判断版本是否更新
 * @param {Object} callBack
 */
function isVersionUpdate(callBack) {
	Ext.Ajax.request({
		url : webHostVersionInterface + '/version/checkVersionNew?time=' + new Date().getTime(),
		useDefaultXhrHeader : false,
		params : {
			isWindows : isAndroidSys()?"false" : Ext.os.is.Windows,
			brand : brand
		},
		success : function(response) {
			var result = Ext.JSON.decode(response.responseText);
			if (result.state) {
				var versionCode = parseFloat(result.versionCode);
				if (versionCode > parseFloat(version)) {
					if (callBack) {
						callBack(true, null, result.versionCode, result.packgeName, result.content);
					}
				} else {
					if (callBack) {
						callBack(false, "当前已是最新版本!");
					}
				}
			} else {
				if (callBack) {
					callBack(false, result.msg);
				}
			}
		},
		failure : function(response, opts) {
			if (callBack) {
				callBack(false, "检查新版本出错，<br/>未连接到服务器，请检查网络状态！");
			}
		}
	});
}

/**
 * 打开升级提示
 */
function showUpgrade(versionCode, packgeName, content) {
	var upgradeView = Ext.Viewport.add({
		xtype : 'panel',
		id : 'upgradeView',
		centered : true,
		modal : true,
		hideOnMaskTap : false,
		hidden : true,
		width : 350,
		height : 255,
		scrollable : false,
		items : [{
			xtype : 'toolbar',
			title : '版本更新',
			docked : 'top'
		}, {
			xtype : 'formpanel',
			scrollable : false,
			width : '100%',
			height : 210,
			items : [{
				xtype : "panel",
				height : 30,
				html : '检测到新版本【' + versionCode + '】，立即更新吗?'
			}, {
				xtype : "fieldset",
				padding : 0,
				margin : 0,
				defaults : {
					labelWidth : 70
				},
				items : [{
					xtype : 'textareafield',
					name : 'content',
					height : 135,
					readOnly : true,
					value : content ? content : '未填写更新内容',
					label : '详情'
				}]
			}, {
				xtype : 'spacer'
			}, {
				xtype : 'container',
				layout : 'hbox',
				padding : '3 0 0 0',
				margin : 0,
				defaults : {
					height : 40,
					flex : 1
				},
				items : [{
					xtype : 'button',
					cls : 'white-button',
					iconMask : true,
					text : '取消',
					handler : function() {
						Ext.getCmp('upgradeView').destroy();
					}
				}, {
					xtype : 'button',
					cls : 'red-button',
					iconMask : true,
					margin : '0 0 0 1',
					text : '更新',
					handler : function() {
						var apkUrl = webHostVersionInterface + "/version/downPadPackge?brand=" + brand + "&fileName=" + packgeName;
						console.log(apkUrl);
						if(isAndroidSys()) {
							showLoading("正在下载文件中...");
                            downloadAndroidInstaller(apkUrl, packgeName);
						} else {
                            window.CommonPlugin.upgradeVersion(apkUrl, packgeName, function (successData) {
                            }, function (msg) {
                                showAlert('升级出错', msg);
                            });
                        }
						Ext.getCmp('upgradeView').destroy();
					}
				}]
			}]
		}]
	});
	upgradeView.show();
}

function downloadAndroidInstaller(url, fileName) {
    var targetPath = "cdvfile://localhost/sdcard/edge/package/" + fileName;// + ".apk";
    var fileTransfer = new FileTransfer();
    fileTransfer.download(url, targetPath, function (entry) {
        //callBack(commodityId, targetPath);
        closeLoading();
        window.cordova.plugins.FileOpener.canOpenFile(targetPath, function() {
        	var openCallBack = {
                error : function(e) {
                    console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                    console.log(targetPath + "_文件打开失败!");
                    showAlert("提示", "安装包损坏,打开安装包失败!");
                },
                success : function () {
                    //console.log('file opened successfully');
                    console.log(targetPath + "_文件打开成功!");
                }
			};
            cordova.plugins.fileOpener2.open(targetPath,'application/vnd.android.package-archive',openCallBack);
		}, function() {console.log(targetPath + "_文件不能打开!")});
    }, function (error) {
        console.log("download error code" + error.code);
        closeLoading();
        showAlert("提示", "下载安装包失败!");
    });
}
/**
 * 判断激活码是否过期
 */
function isActivationOverdue() {
	//alert(new Date(parseInt(activationinfo.expirationDate)).format("yyyy-MM-dd hh:mm:ss"));
	return (parseInt(activationinfo.expirationDate) < new Date().getTime());
}

function showActivationInfo() {
	var activationView = Ext.Viewport.add({
		xtype : 'panel',
		id : 'activationView',
		centered : true,
		modal : true,
		hideOnMaskTap : false,
		hidden : true,
		width : 350,
		height : 200,
		top : 0,
		left : (clientWidth - 400) / 2,
		scrollable : false,
		items : [{
			xtype : 'toolbar',
			title : '收银系统激活',
			docked : 'top'
		}, {
			xtype : 'formpanel',
			scrollable : false,
			cls : 'bggreen',
			width : '100%',
			height : 150,
			items : [{
				xtype : "fieldset",
				margin : '5 0 5 0',
				defaults : {
					labelWidth : 70
				},
				items : [{
					xtype : 'textfield',
					id : 'activationCode',
					name : 'activationCode',
					label : '激活码'
				}]
			}, {
				xtype : 'fieldset',
				layout : 'hbox',
				padding : '0 0 0 0',
				margin : '0 0 0 0',
				defaults : {
					height : 40,
					width : '100%'
				},
				items : [{
					xtype : 'button',
					cls : 'red-button',
					iconMask : true,
					margin : '0 0 0 1',
					text : '激活',
					handler : function() {
						var activationCode = Ext.getCmp('activationCode').getValue();
						nativePostRequest('/syndata/validateActivation?time=' + new Date().getTime(), {
							activationCode : activationCode
						}, function(response) {
							var result = Ext.JSON.decode(response.responseText);
							if (result.state) {
								var newactivationinfo = {
									ecode : result.activationInfo.ecode,
									activationCode : activationCode + "",
									activationDate : new Date().format("yyyy-MM-dd hh:mm:ss"),
									isRegister : '0',
									activationStatus : result.activationInfo.activationStatus + "",
									expirationDate : result.activationInfo.expirationDate + ""
								};
								if (activationinfo && activationinfo.id) {
									SellerDao.updateActivationInfo(newactivationinfo, activationinfo.id);
								} else {
									SellerDao.addActivationInfo(newactivationinfo);
								}
								seller.activationCode = activationCode + "";
								showAlert('提示', "激活成功！");
								Ext.getCmp('activationView').destroy();
								isLogin();
							} else {
								showAlert('提示', result.msg ? result.msg : "激活失败，<br/>该激活码无效！");
							}
						}, function(msg) {
							showAlert('提示', "激活失败，<br/>未连接到服务器，请检查网络状态！");
						});
					}
				}]
			}]
		}]
	});
	activationView.show();
}

/**
 * 判断版本是否更新
 * @param {Object} callBack
 */
function isActivation(callBack) {
	SellerDao.getActivationInfo(function(success, res) {
		if (!res) {
			showActivationInfo();
		} else {
			seller.activationCode = res.activationCode;
			activationinfo = {
				id : res.id,
				ecode : res.ecode,
				activationCode : res.activationCode,
				activationDate : res.activationDate,
				isRegister : res.isRegister,
				expirationDate : res.expirationDate
			};
			if (isActivationOverdue()) {
				showActivationInfo();
				showAlert("登录失败", "激活码【" + activationinfo.activationCode + "】已过期，请购买正式版或者续费！");
			} else {
				isLogin();
			}

		}
	});
}

function isLogin() {
	SellerDao.getLocalUser(function(success, sellerItem) {
		if (!success || !sellerItem) {
			showLogin();
		}
	});
}

function addViewportCenter(id, xtype, width, height, modal) {
	return Ext.Viewport.add({
		xtype : 'panel',
		id : id,
		modal : modal ? modal : true,
		hideOnMaskTap : false,
		centered : true,
		width : width,
		height : height,
		style : 'padding:0',
		layout : {
			type : 'vbox',
			align : 'center'
		},
		items : [{
			xtype : xtype
		}]
	});
}

function addViewport(xtype, id, width, height, left, top, modal) {
	return Ext.Viewport.add({
		xtype : 'panel',
		id : id,
		modal : modal ? modal : true,
		width : width,
		centered : true,
		top : top,
		left : left,
		height : height,
		style : 'padding:0',
		layout : {
			type : 'vbox',
			align : 'center'
		},
		items : [{
			xtype : xtype
		}]
	});
}

/**
 * 读取地址参数
 * @param {Object} strName
 */
function getRequestParam(paramName) {
	var strHref = location.href;
	var intPos = strHref.indexOf("?");
	if (intPos == -1) {
		return "";
	}
	var strRight = strHref.substr(intPos + 1);
	var arrTmp = strRight.split("&");
	for (var i = 0, len = arrTmp.length; i < len; i++) {
		var arrTemp = arrTmp[i].split("=");
		if (arrTemp[0].toUpperCase() == paramName.toUpperCase()) {
			return arrTemp[1];
		}
	}
	return "";
}

// function getBLen(str) {
// 	if (str == null)
// 		return 0;
// 	if ( typeof str != "string") {
// 		str += "";
// 	}
// 	return str.replace(/[^x00-xff]/g, "01").length;
// }

function getBLen(str, flag) {
    if (str == null)
        return 0;
    if ( typeof str != "string") {
        str += "";
    }
    if (flag == 0){
        return str.replace(/[^x00-xff]/g, "01").length;
    } else if (flag == 1) {
        return str.replace(/[^x00-xff]/g, "01").length * 2;
    }

}

function showLoading(title, context, timeout) {
	if(!Ext || !Ext.Viewport) return;
	task = Ext.create('Ext.util.DelayedTask', function() {
		Ext.Viewport.mask({
			xtype : 'loadmask',
			centered : true,
			fullscreen : true,
			showAnimation : 'slideIn',
			transparent : false,
			zIndex : 9999,
			message : title ? title : "正在处理，请稍后.."
		});
	}, context);
	task.delay(100);
	if(timeout > 0) {
		setTimeout(function() {
			closeLoading();
		}, timeout);
	}
}

function showLoadingOnly(title) {
	Ext.Viewport.mask({
		xtype : 'loadmask',
		centered : true,
		fullscreen : true,
		showAnimation : 'slideIn',
		transparent : false,
		message : title ? title : "正在处理，请稍后.."
	});
}

function closeLoading() {
	if (task) {
		task.cancel();
		task = null;
	}
    if(Ext && Ext.Viewport) Ext.Viewport.unmask();
}

var PlayAudio = {};
PlayAudio[PlayAudio["START"]=0] = "START";
PlayAudio[PlayAudio["STARTING"]=1] = "STARTING";
PlayAudio[PlayAudio["END"]=2] = "END";
function AudioMedia() {
	this.playStatus = PlayAudio.END;
	this.uuid = null;
	this.getPlayStatus = function() {
		return this.playStatus;
	};
	this.setPlayStatus = function(status, uuid) {
		// 不同操作,第一操作结束，第二操作才开始或正在进行(有可能二个操作重叠)
		if(this.uuid === null) this.uuid = uuid;
		else if(this.uuid != uuid && status == PlayAudio.END && status != this.playStatus) {
			return;
		}
		//console.log(uuid +"__"+ PlayAudio[status]);
		this.uuid = uuid;
		if(status === PlayAudio.END) sendMsg2AdsAVVolume(1);
		return this.playStatus = status;
	};
}
var mediaController = new AudioMedia();
function beep(path) {
	//console.log(path);
	if ( typeof path == 'undefined' || !path) {
		path = 'apple.mp3';
	}

	if (!audio) {
		audio = new Ext.Audio();
		audio.setUrl(path);
	} else {
		if(audio.getUrl() != path) {
			audio.setUrl(path);
		}
	}
	var uuid = new Ext.data.identifier.Uuid().generate();
	audio.addListener("ended", function(currView) {
		mediaController.setPlayStatus(PlayAudio.END, uuid);
	});
	sendMsg2AdsAVVolume(0);
	mediaController.setPlayStatus(PlayAudio.STARTING, uuid);
	audio.play();
}
function beepPayOff(path) {
	if(typeof path== 'undefined' || !path)
		path = "payoff.mp3";
	beep(path);
}

/**
 * 更茶位费单价
 * @param {Object} teaPrice
 */
function updateTeaPrice(teaPrice) {
	SellerDao.updateSeller({
		teaPrice : teaPrice
	}, seller.id, function(success) {
		seller.teaPrice = teaPrice;
	});
}

function createRedMask(message, color) {
	Ext.Viewport.mask({
		xtype : 'loadmask',
		centered : true,
		showAnimation : 'slideIn',
		fullscreen : true,
		message : "<font color='" + color + "'>" + message + "</font>"
	});
}

var util = {
	getAfterOneHourTimeByTime : function(date) {
		var dt = new Date(date);
		var ms = new Date(dt).getTime();
		return new Date(ms + 3600000);
	},

	addZero : function(num) {
		return num < 10 ? "0" + num : num;
	},

	isLeapYear : function(pYear) {
		if (!isNaN(parseInt(pYear))) {
			if ((pYear % 4 == 0 && pYear % 100 != 0) || (pYear % 100 == 0 && pYear % 400 == 0)) {
				return true;
			}
		}
		return false;
	},
	getDateStr : function(addDayCount) {
		var dd = new Date();
		dd.setDate(dd.getDate() + addDayCount);
		//获取AddDayCount天后的日期
		var y = dd.getFullYear();
		var m = dd.getMonth() + 1;
		//获取当前月份的日期
		var d = dd.getDate();
		return y + "-" + (m < 10 ? ("0" + m) : m) + "-" + (d < 10 ? ("0" + d) : d);
	},
	toDate : function(timestamp) {
		if (!timestamp) {
			return "";
		}
		timestamp = parseInt(timestamp);
		// 将当前时间换成时间格式字符串
		var newDate = new Date();
		newDate.setTime(timestamp);
		return newDate.format("yyyy-MM-dd hh:mm:ss");
	}
};

function urlInterceptor(url) {
	if (!url)
		return false;
	if ((url.indexOf('updateData') > -1) || (url.indexOf('updateOtherData') > -1) || (url.indexOf('validateActivation') > -1) || 
		(url.indexOf('loadPushOrder') > -1) || (url.indexOf('dealOrder') > -1) || (url.indexOf('updateCommodityType') > -1) || 
		(url.indexOf('updateCommodity') > -1) || (url.indexOf('updateCustomer') > -1) || (url.indexOf('updateDataNew') > -1)|| 
		(url.indexOf("loadSellerPrintTemplateList") > -1) || (url.indexOf("loadSellerTipsDetailList") > -1))
		return true;

	return false;
}

/**
 * 原生post request请求
 * @param {Object} url
 * @param {Object} params
 * @param {Object} callBack
 */
function nativePostRequest(url, params, success, failure, timeout) {
	 if (isPreviewVersion) {
	 	if (!urlInterceptor(url)) {
	 		//console.log('interceptor url');
	 		success && success({
	 			state : false,
	 			msg : '测试账号访问被拒绝,请注册商家账号!'
	 		});
	 		return;
	 	}
	 }
	nativeRequest(url, params, 'post', success, failure, timeout);
}
/**
 * POST 请求单独通道(暂时处理，后续修改)
 * @author v_cjc
 * @createTime 2018年5月16日 下午12:17:08
 * @param url
 * @param params
 * @param success
 * @param failure
 * @param timeout
 * @returns
 */
function nativePostRequestOnly(url, params, success, failure, timeout) {
	if (isPreviewVersion) {
	 	if (!urlInterceptor(url)) {
	 		//console.log('interceptor url');
	 		success && success({
	 			state : false,
	 			msg : '测试账号访问被拒绝,请注册商家账号!'
	 		});
	 		return;
	 	}
	 }
	console.log("nativeRequestOnly...");
	nativeRequestOnly(url, params, 'post', success, failure, timeout);
}

/**
 * 原生get request请求
 * @param {Object} url
 * @param {Object} params
 * @param {Object} callBack
 */
function nativeGetRequest(url, params, success, failure, timeout) {
	nativeRequest(url, params, 'get', success, failure);
}

/**
 * 检查是否有权限
 * @param {Object} permissions
 */
function checkPermissions2(permissions, isShow) {
	var p = cashierPermissions + ",";
	if($.inArray(permissions, cashierPermissions, 0) != -1) return true;
	else if (cashierPermissions && p.indexOf(permissions + ",") != -1) {
		return true;
	}
	if (isShow) {
		showAlert('提示', '对不起，您没有该项权限！');
	}
	return false;
}
/**
 * 获取收银权限
 * @param {Object} workType (收银员或服务员或外卖员或采购员)
 */
function getPermissions(workType) {
	return cashierPermissions;
}
/**
 * 提示权限不足
 * @param {Object} hintTxt (提示文本)
 */
function showPermissionHint(hintTxt, permissionVal, cb) {
	//showAlert('提示', hintTxt ? hintTxt : '对不起，您没有该项权限！');
	var tmpHintTxt = hintTxt ? hintTxt : '对不起，您没有该项权限!';
	tmpHintTxt += "<br/>是否临时授权?";
	//console.log(PERMISSIONS[permissionVal], "权限不足, 等待授权...");
	OPLogger.info(PERMISSIONS[permissionVal], "权限不足, 等待授权...");
	/*showConfirm("提示", tmpHintTxt, function(btnId) {
		if(btnId === "yes") {
			showAuthorizationView(permissionVal, function(success) {
				cb && cb(success);
			});
		} else {
			//console.log("取消" + PERMISSIONS[permissionVal]+"授权...");
			OPLogger.info("取消" + PERMISSIONS[permissionVal]+"授权...");
			cb&&cb(false);
		}
	}, 280, 160);*/
	showAuthorizationView(permissionVal, function(success) {
		cb && cb(success);
	});
}
function authorizationValidator(userName, password) {
	return new Promise(function(resolve, reject) {
		if(isTestIdentity()){
			return resolve && resolve({success:true, data:seller, permissions:"ALL_PERMISSIONS"});
		}
		var selectSql = "SELECT * FROM seller WHERE userName=? AND password=? AND id=?";
		var selectParams = [userName, hex_md5(password), seller.id];
		if(seller.userName === "test") { /* 测试账号不验证密码 */
			selectSql = "SELECT * FROM seller WHERE userName=? AND id=?";
			selectParams = [userName, seller.id];
		}
		getBySqlParam(selectSql, selectParams, function(success, sellerData) {
		//getBySqlParam("SELECT * FROM seller WHERE userName=? AND password=? AND id=?", [userName, hex_md5(password), seller.id], function(success, sellerData) {
			if(success && sellerData) {
				//console.log(sellerData.id + ":" + sellerData.userName + " <<授权>>");
				//OPLogger.info(sellerData.id + ":" + sellerData.userName + " <<授权>>");
				resolve && resolve({success:true, data:sellerData, permissions:"ALL_PERMISSIONS"});
			} else {
				/* 未找到商家信息，再查询员工 */
				getBySqlParam("SELECT * FROM selleremployee WHERE workId=? AND password=? AND sellerId=?", [userName, hex_md5(password), seller.id], function(success, employee) {
				//getBySqlParam("SELECT * FROM selleremployee WHERE password=? AND sellerId=?", [hex_md5(password), seller.id], function(success, employee) {
					if(success && employee) {
						var tpermissions = [];
						try {
							tpermissions = (employee.permissions?employee.permissions:"").split(",");
						} catch(err) {} finally {							
							resolve && resolve({success:true, data:employee, permissions:tpermissions});
						}
					} else {
						showAlert("提示", "账号或密码错误!");
						reject && reject({success:false});
					}
				});
			}
		});
	});
}

/**
 * 隐藏安卓键盘
 */
function hideSystemKeyboard() {
	if(!isAndroid()) return;
	try {
	    //setTimeout(function() {
            if (window.Keyboard) {
                window.Keyboard.hide && window.Keyboard.hide();
            }
        //}, 20);
    } catch(err) {console.log(err);}
}
function showAuthorizationView(permissionVal, callback) {
	var authorizationView = Ext.Viewport.add({
		xtype : 'panel',
		modal : true,
		hideOnMaskTap : false,
		width : 380,
		id : 'authorizationView',
		height : 300,
		top : 180,
        left : (clientWidth - 380) / 2,
        zIndex : zindex++,
		centered : true,
		layout : {
			type : "vbox",
			align : 'center'
		},
		showAnimation : {
			type : 'fadeIn',
		},
		items : [{
			xtype : 'toolbar',
			dock : 'top',
			width : '100%',
			title : '管理员授权',
			items : [{
				xtype : 'button',
				cls : 'close-button',
				hidden : true,
				handler : function(currView, e, eOpts) {
					preventEventBubble(e);
					callback && callback(false);
					Ext.getCmp('authorizationView').destroy();
				}
			}]
		}, {
			xtype : 'fieldset',
			width : 340,
			margin : '30 0 0 0',
			defaults : {
				labelWidth : 146,
				listeners : {
				}
			},
			items : [{
				xtype : 'textfield',
				name : 'authUserName',
				id : 'authUserName',
				label : '商户号/授权账号',
				placeHolder : '请输入商户号/授权账号',
				value : seller.userName,
				required : true,
				listeners : {
					keyup : function(filed, e, eOpts) {
						if (event && event.keyCode == 13) {
							Ext.getCmp('authPassword').focus();
							event.preventDefault();
						}
					},
					focus : function(filed, e, eOpts) {
						//sySellerLoginUserName();
						getFocusValue="authUserName";
					}
				}
			}, {
                xtype : 'passwordfield',
                name : 'authPassword',
                id : 'authPassword',
                label : '密      码',
                placeHolder : '请输入密码',
                value : '',
                required : true,
                listeners : {
                    keyup : function(filed, e, eOpts) {
                        if (event && event.keyCode == 13) {
                        	if (Application.Ftype==Application.MASTER) {
                        		//loginSubmit();
                            }
                        	else {
                        		//if (!$('#ip-label-input').is(':hidden'))
                        		//	$('#user_input1').focus();
                        		//else loginSubmit();
                            }
                            event.preventDefault();
                        }
                    },
                    focus : function(filed, e, eOpts) {
                        //sySellerLoginPassword();
                        getFocusValue="authPassword";
                    }
                }
            }]
		}, {
			xtype : 'panel',
			layout : 'vbox',
			margin : '20 0 0 0',
			defaults : {
				padding : 10,
				defaults : {
					margin : 10
				},
				xtype : 'button',
				width : 340,
				height : 40,
			},
			items : [{
				id : 'btnAuthorization',
				cls : 'red-button',
				iconMask : true,
				text : '授权',
				handler : function(currView, e, eOpts) {
					preventEventBubble(e);
					timeoutDisable('btnAuthorization');
					var userCmp = Ext.getCmp("authUserName");
					var passwordCmp = Ext.getCmp("authPassword");
					var userName = userCmp?userCmp.getValue():"";
					var password = passwordCmp?passwordCmp.getValue():"";
					authorizationValidator(userName, password).then(function(retVal) {
						var authorData = {};
						if(retVal && retVal.permissions === "ALL_PERMISSIONS") {
							authorData.msg = " <<授权>>成功";
							callback && callback(true);
							if(Ext.getCmp('authorizationView')) Ext.getCmp('authorizationView').destroy();
						}
						else if(retVal && ($.inArray(permissionVal, retVal.permissions, 0) != -1||$.inArray(permissionVal+"", retVal.permissions, 0) != -1)) {
							authorData.msg = " <<授权>>成功";
							callback && callback(true);
							if(Ext.getCmp('authorizationView')) Ext.getCmp('authorizationView').destroy();
						} else {
							authorData.msg = " <<授权>>失败,无权限!";
							showAlert("提示","当前账号无此项权限!");
						}
						/* 记录操作日志 */
						if(retVal && retVal.data) {
							if("workId" in retVal.data) {
								authorData.id = retVal.data.workId;
								authorData.name = retVal.data.workName;
							} else {
								authorData.id = retVal.data.id;
								authorData.name = retVal.data.userName;
							}
						}
						OPLogger.info(authorData.id + ":" + authorData.name + authorData.msg);
					}).catch(function(retVal) {
						
					});
					//permissionAuthorization();
					//loginSubmit();
				}
			}, {
				id : 'btnAuthCancel',
				cls : 'white-button',
				margin : '10 0 0 0',
				iconMask : true,
				text : '取消',
				handler : function(currView, e, eOpts) {
					preventEventBubble(e);
					OPLogger.info("取消" + PERMISSIONS[permissionVal]+"授权...");
					callback && callback(false);
					Ext.getCmp('authorizationView').destroy();
				}
			}]
		},{
		xtype : 'panel',
		margin : '35 0 10 -270',
		padding:'10 20 10 20',
		id : 'number-middle-content-view',
		width:900,
		height : 270,
		style:'background:rgba(245,245,220,0.7);border-radius:0.5em;',
		layout : 'hbox',
		defaults : {
			xtype : 'panel',
			layout : 'vbox',
			flex : 1,
			defaults : {
				flex : 1,
				margin : 4,
				height : 100,
				xtype : 'button',
				cls : 'white-button',
				handler : function(){
				}
			}
		},
		items : [{
			items : [{
				text : 'q',
				handler : shouQuanKeyValue
			}, {
				text : 'a',
				handler : shouQuanKeyValue
			}, {
				text : 'z',
				handler : shouQuanKeyValue
			}]
		},{
			items : [{
				text : 'w',
				handler : shouQuanKeyValue
			}, {
				text : 's',
				handler : shouQuanKeyValue
			}, {
				text : 'x',
				handler : shouQuanKeyValue
			}]
		},{
			items : [{
				text : 'e',
				handler : shouQuanKeyValue
			}, {
				text : 'd',
				handler : shouQuanKeyValue
			}, {
				text : 'c',
				handler : shouQuanKeyValue
			}]
		},{
			items : [{
				text : 'r',
				handler : shouQuanKeyValue
			}, {
				text : 'f',
				handler : shouQuanKeyValue
			}, {
				text : 'v',
				handler : shouQuanKeyValue
			}]
		},{
			items : [{
				text : 't',
				handler : shouQuanKeyValue
			}, {
				text : 'g',
				handler : shouQuanKeyValue
			}, {
				text : 'b',
				handler : shouQuanKeyValue
			}]
		},{
			items : [{
				text : 'y',
				handler : shouQuanKeyValue
			}, {
				text : 'h',
				handler : shouQuanKeyValue
			}, {
				text : 'n',
				handler : shouQuanKeyValue
			}]
		},{
			items : [{
				text : 'u',
				handler : shouQuanKeyValue
			}, {
				text : 'j',
				handler : shouQuanKeyValue
			}, {
				text : 'm',
				handler : shouQuanKeyValue
			}]
		},{
			items : [{
				text : 'i',
				handler : shouQuanKeyValue
			}, {
				text : 'k',
				handler : shouQuanKeyValue
			}, {
				text : 'l',
				handler : shouQuanKeyValue
			}]
		},{
			items : [{
				text : 'o',
				handler : shouQuanKeyValue
			}, {
				text : 'p',
				handler : shouQuanKeyValue
			}, {
				text : '@',
				handler : shouQuanKeyValue
			}]
		},{
			items : [{
				text : '1',
				handler : shouQuanKeyValue
			}, {
				text : '4',
				handler : shouQuanKeyValue
			}, {
				text : '7',
				handler : shouQuanKeyValue
			}]
		}, {
			items : [{
				text : '2',
				handler : shouQuanKeyValue
			}, {
				text : '5',
				handler : shouQuanKeyValue
			}, {
				text : '8',
				handler : shouQuanKeyValue
			}]
		}, {
			items : [{
				text : '3',
				handler : shouQuanKeyValue
			}, {
				text : '6',
				handler : shouQuanKeyValue
			}, {
				text : '9',
				handler : shouQuanKeyValue
			}]
		}, {
			items : [{
				text : '0',
				handler : shouQuanKeyValue
			}, {
				text : '00',
				handler : shouQuanKeyValue
			}, {
				text : '.',
				handler : shouQuanKeyValue
			}]
		}, {
			items : [{
				width:55,
				text : '退格',
				handler : shouQuanKeyValue
			}, {
				width:55,
				text : '清空',
				handler : shouQuanKeyValue
			}, {
				flex : 2,
				text : '确认',
				width:55,
				cls : 'red-button',
				handler :function(currView, e, eOpts) {
					/*confirmHandler && confirmHandler();*/
					//开始
					preventEventBubble(e);
					
					var userCmp = Ext.getCmp("authUserName");
					var passwordCmp = Ext.getCmp("authPassword");
					var userName = userCmp?userCmp.getValue():"";
					var password = passwordCmp?passwordCmp.getValue():"";
					authorizationValidator(userName, password).then(function(retVal) {
						var authorData = {};
						if(retVal && retVal.permissions === "ALL_PERMISSIONS") {
							authorData.msg = " <<授权>>成功";
							callback && callback(true);
							if(Ext.getCmp('authorizationView'))Ext.getCmp('authorizationView').destroy();
												}
						else if(retVal && ($.inArray(permissionVal, retVal.permissions, 0) != -1||$.inArray(permissionVal+"", retVal.permissions, 0) != -1)) {
							authorData.msg = " <<授权>>成功";
							callback && callback(true);
							if(Ext.getCmp('authorizationView')) Ext.getCmp('authorizationView').destroy();
						} else {
							authorData.msg = " <<授权>>失败,无权限!";
							showAlert("提示","当前账号无此项权限!");
						}
						/* 记录操作日志 */
						if(retVal && retVal.data) {
							if("workId" in retVal.data) {
								authorData.id = retVal.data.workId;
								authorData.name = retVal.data.workName;
							} else {
								authorData.id = retVal.data.id;
								authorData.name = retVal.data.userName;
							}
						}
						OPLogger.info(authorData.id + ":" + authorData.name + authorData.msg);
					}).catch(function(retVal) {
					});
				}
			}] 
		}]
	}
		//结束
		]
	});
	authorizationView.show();
}

var getFocusValue; //输入框的焦点
function shouQuanKeyValue(){
	var value = this.getText(); // 获取点击的值
	//Ext.getCmp('authPassword').setValue(value);	
    var customerValue;
    if(!Ext.getCmp(getFocusValue)) return;
    Ext.getCmp(getFocusValue).focus();
    if(value=='清空'){
        if (!Ext.getCmp(getFocusValue)) return;
        Ext.getCmp(getFocusValue).setValue('')
    }else if(value=='退格'){
        if (!Ext.getCmp(getFocusValue)) return;
        customerValue =  Ext.getCmp(getFocusValue).getValue()+'';
        if(customerValue && customerValue.length>0){
            customerValue = customerValue.substring(0, customerValue.length - 1);
        }else {
            customerValue = '';
        }
        Ext.getCmp(getFocusValue).setValue(customerValue);
    }else{
        if (!Ext.getCmp(getFocusValue)) return;
        customerValue =  Ext.getCmp(getFocusValue).getValue();
        customerValue = customerValue ? customerValue : '';
        Ext.getCmp(getFocusValue).setValue(customerValue + value);
    }
}
/**
 * 保存设置
 * @param {Object} data
 * @param {Object} callBack
 */
function updateSetting(data, callBack) {
	callBack = callBack || emFunc;
	SettingDao.updateSetting(data, setting.id, function(success, msg) {
		if (success) {
			SettingDao.getSetting(function(success, res) {
				if (success && res) {
					setting = res;
					callBack(true);
				} else {
					callBack(false);
				}
			});
		} else {
			callBack(false);
		}
	});
}

//暂时停用一会
function timeoutDisable(id, sec) {
    if (Ext.getCmp(id)) {
        Ext.getCmp(id).setDisabled(true);
    } else if ($('#'+id)) {
        $('#'+id).attr("disabled", true);
    }
    timeOutSet(id, sec);
}

function timeOutSet(id, sec) {
    sec = sec ? sec : 2000;
    setTimeout(function() {
        if (Ext.getCmp(id)) {
            Ext.getCmp(id).setDisabled(false);
        }else if ($('#'+id)) {
            $('#'+id).removeAttr("disabled");
        }
    }, sec);
}

function setDisable(id, bFlag) {
	if (bFlag) {
        if (Ext.getCmp(id)) {
            Ext.getCmp(id).setDisabled(true);
        }else if ($('#'+id)) {
            $('#'+id).attr("disabled", true);
        }
	} else if (!bFlag) {
        if (Ext.getCmp(id)) {
            Ext.getCmp(id).setDisabled(false);
        } else if ($('#' + id)) {
            $('#' + id).removeAttr("disabled");
        }
    }
}

/*验证正数(最多两位小数)*/
function checkPositiveNumber(obj) {
	var re = /^(?:(?:(?:[1-9]\d{0,2}(?:,\d{3})*)|[1-9]\d*|0))(?:\.\d{1,2})?$/;
	if ( typeof obj == "object") {
		if (!re.test(obj.value)) {
			return false;
		} else {
			return true;
		}
	} else {
		if (!re.test(obj)) {
			return false;
		} else {
			return true;
		}
	}
}

//空函数
var emFunc = function() {

};

//创建分类工具
function createPage() {
	return {

	};
}

(function($) {
	$.PageUtil = function(arg) {
		this.page = {
			currPage : 1, //当前分页
			totalPage : 1, //总页数
			limitCount : (arg.limitCount ? arg.limitCount : 12)
		};
		//这个是私有变量，外部无法访问
		this.up = function() {//this.testFun方法，加上了this，就是公有方法了，外部可以访问。
			if (this.page.currPage < this.page.totalPage) {
				this.page.currPage += 1;
			}
		};
		this.down = function() {
			if (this.page.currPage < 2) {
				this.page.currPage = 1;
			} else {
				this.page.currPage -= 1;
			}
		};
		this.getTotalPage = function() {
			return this.page.totalPage;
		};
		this.getCurrPage = function() {
			return this.page.currPage;
		};
		this.setCurrPage = function(currPage) {
			this.page.currPage = currPage;
		};
		this.setTotalPage = function(totalPage) {
			this.page.totalPage = totalPage;
		};
		this.setLimitCount = function(limitCount) {
			this.page.limitCount = limitCount;
		};
		this.getLimitCount = function() {
			return this.page.limitCount;
		};
		this.getOffset = function() {
			var offset = this.page.currPage - 1;
			if (offset < 0) {
				offset = 0;
			}
			return offset;
		};
		this.reset = function() {
			this.page.currPage = 1;
		};
		this.countPage = function(totalCount) {
			this.page.totalPage = parseInt(totalCount / this.page.limitCount);
			if (totalCount > 0 && totalCount % this.page.limitCount > 0) {
				this.page.totalPage += 1;
			}
			if (this.page.totalPage < 2) {
				this.page.totalPage = 1;
			}
		};
	};
})(jQuery);

Array.prototype.remove = function(val) {
	var index = this.indexOf(val);
	if (index > -1) {
		this.splice(index, 1);
	}
};

String.prototype.repeat = function(n) {
	if (!isInteger(n)) return;
	else return new Array(n + 1).join(this);
};

function isArray(o) {
	return Object.prototype.toString.call(o) === '[object Array]';
}

function encodeJSON(value) {
	try {
		return JSON.stringify(value);
	} catch(err) {
		console.dir(err);
	}
	return '';
}

function decodeJSON(value) {
	try {
		return JSON.parse(value);
	} catch(err) {
		console.dir(err);
	}

	return '';
}

function upThingPage(thingPage, operator) {
	if (!thingPage)
		return;
	var totalPage = thingPage.getTotalPage();
	var curPage = thingPage.getCurrPage();
	if (curPage >= totalPage)
		return;
	thingPage.up();
	var limitCount = thingPage.getLimitCount();
	var startPage = thingPage.getOffset() * limitCount;
	var endPage = startPage + limitCount;
	operator(startPage, endPage);
}

function downThingPage(thingPage, operator) {
	if (!thingPage)
		return;
	var totalPage = thingPage.getTotalPage();
	var curPage = thingPage.getCurrPage();
	if (curPage <= 1)
		return;
	thingPage.down();
	var limitCount = thingPage.getLimitCount();
	var startPage = thingPage.getOffset() * limitCount;
	var endPage = startPage + limitCount;
	operator(startPage, endPage);
}

function gotoThingPage(thingPage, operator, position){
	if (!thingPage)
		return;
	var limitCount = thingPage.getLimitCount();
	var targetPage = Math.ceil((position + 1)/limitCount);
	if(targetPage <= 0){
		targetPage = 1;
	}
	thingPage.setCurrPage(targetPage);
	var startPage = thingPage.getOffset() * limitCount;
	var endPage = startPage + limitCount;
	operator(startPage, endPage);
}

function generatorEnumObject(obj, keys) {
	for (var ki = 0, klen = keys.length; ki < klen; ki++) {
		Object.defineProperty(obj, keys[ki], {
			value : ki + 1,
			writable : false,
			configurable : false
		});
	}
}

/**
 * 抛物线
 * @param {Object} x
 * @param {Object} y
 * @param {Object} name
 */
function ParabolaUtil(x, y, name) {
	if (!x || !y) {
		return {
			init : function() {
			}
		};
	}
	var width = 50;
	var height = 50;
	var oDiv = document.createElement("div");
	//创建一个div元素，因为是document对象的方法。  <body>元素
	var style = "display:block;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;text-align:center;width:50px;height:50px;z-index:999;position:absolute;border-radius:50%;font-size:12px;line-height:20px;";
    try {
        if(isAndroid && isAndroid());
        else style += "background:#FF8C69;";
    } catch(err) {}
	style += "top:" + y + "px;left:" + x + "px;";
	oDiv.style = style;
	try {
        if (isAndroid && isAndroid()) ;
        else
            oDiv.innerHTML = "<img src='resources/img/parabola.png' style='width:50px;height:50px;'></img>";
    } catch(err) {}
	document.body.appendChild(oDiv);

	var el = Ext.getDom("parabolaStart");
	targetEl = Ext.getDom("showyin_totalamount0");
	//console.log(targetEl);
	return {
		init : function() {
			var parabola = funParabola(oDiv, targetEl, {
				speed : 3000,
				curvature : 0.001,
				complete : function() {
					document.body.removeChild(oDiv);
				},
				progress : function(px, py) {
					width = width * 0.95;
					height = height * 0.95;
					oDiv.style.width = width + "px";
					oDiv.style.height = height + "px";
					oDiv.innerHTML = "<img src='resources/img/parabola.png' style='width:" + width + "px;height:" + height + "px;'></img>";
				}
			}).mark();
			parabola.init();
		}
	};
}

//将图片转成流
function getBase64Image(img) {
    var canvas = document.createElement("canvas");
    canvas.width = img.width;
    canvas.height = img.height;
    var ctx = canvas.getContext("2d");
    ctx.drawImage(img, 0, 0, img.width, img.height);
    var dataURL = canvas.toDataURL();
	return dataURL;
	//return dataURL.replace("data:image/png;base64,", "");
}

//图片
function ImageUtil(recordId, src, callBack) {
	return {
		load : function() {
			var img = document.createElement('img');
			img.setAttribute('crossOrigin', 'anonymous');

            img.onerror = function() {
            	console.log("onerror");
                callBack && callBack(recordId, "");
            };
			img.src = src;
			img.onload = function() {
				var data = getBase64Image(img);
				if(callBack){
					callBack(recordId, data);
				}
			};
		}
	};
}
/* 安卓下载文件 */
function AndroidImageUtil(sellerId,commodityId, src, callBack) {
    return {
        load : function() {
            var targetPath = "cdvfile://localhost/sdcard/vpos/image/" + sellerId+"/"+commodityId+".png";
            var fileTransfer = new FileTransfer();
            fileTransfer.download(src, targetPath, function (entry) {
                callBack(commodityId, targetPath);
            }, function (error) {
                console.log("download error code" + error.code);
            });
        }
    };
}
function importJs(jsArray){
	if(jsArray){
		for(var i in jsArray){
			//document.write("<script language='javascript' src='"+jsArray[i]+"'></script>");
			//$.getScript(jsArray[i]);  
			loadScript(jsArray[i]);
		}
	}
}

function loadScript(url, callback){
    var script = document.createElement("script");
    script.type = "text/javascript";
    if(script.readyState){ // IE
        script.onreadystatechange = function(){
            if(script.readyState == "loaded" || script.readyState == "complete"){
                script.onreadystatechange = null;
                callback&&callback();
            }
        };
    }else{ // FF, Chrome, Opera, ...
        script.onload = function(){
        	callback&&callback();
        };
    }
    script.src = url;
    document.getElementsByTagName("head")[0].appendChild(script);
}

/**选择框单击事件*/
function checkOnClick(id,callBackName){
	var isCheck=$('#'+id+' input[name="'+id+'"]')[0].checked;
	if(isCheck){
		$('#'+id).removeClass('c_on');
		$('#'+id+' input[name='+id+']').attr("checked",false);
		$('#'+id+' input[name="'+id+'"]')[0].checked=false;
	}else{
		 $('#'+id).addClass('c_on');
		 $('#'+id+' input[name='+id+']').attr("checked",true);
		 $('#'+id+' input[name="'+id+'"]')[0].checked=true;
	}
	if(window[callBackName])
		callBackName&&eval(callBackName+"('"+id+"',"+!isCheck+")");
}
/**选择目标*/
function checkTarget(id,checked){
	if(checked){
		 $('#'+id).addClass('c_on');
		 $('#'+id+' input[name='+id+']').attr("checked",true);
		 $('#'+id+' input[name="'+id+'"]')[0].checked=true;
	}else{
		$('#'+id).removeClass('c_on');
		$('#'+id+' input[name='+id+']').attr("checked",false);
		$('#'+id+' input[name="'+id+'"]')[0].checked=false;
	}
}
//显示
function showCheck(id){
	 $('#'+id)[0].display="";
}
//隐藏
function hideCheck(id){
	$('#'+id)[0].display="none";
}
/**
 * checkbox是否选中
 * @returns
 */
function isDefineChecked(parentId, checkName) {
	if($('#'+parentId + ' input[name=' + checkName + ']').attr('checked')) {
		return true;
	}
	return false;
}
/**
 * 防止事件冒泡
 * @params e (extend browserEvent)
 * @returns
 */
function preventEventBubble(e) {
	if (e) {
        if (e.stopPropagation) e.stopPropagation();
        if (e.stopEvent) e.stopEvent();
    }
}

/**
 * 显示组件
 * @params viewName or object
 */
function showBy(viewName,byViewName,zIndex) {
	var view=null;
	if (typeof viewName == 'string') {
		view=Ext.getCmp(viewName);
    }else{
    	view=viewName;
    }
	if(byViewName){
		var byView=null;
		if (typeof byViewName == 'string') {
			byView=Ext.getCmp(byViewName)
			//view.showBy(byView,'cc-cc?');
	    }else{
	    	byView=byViewName;
	    	//view.showBy(byViewName,'cc-cc?');
	    }
		if(!zIndex){
			zIndex=2;
		}
		view.setZIndex(byView.getZIndex()+zIndex);
	}
	view.show();
}
function isIntegerDigital(value) {
	var regu = /^[-]?[0-9]+(.[0]+|)$/;
	return regu.test(value);
}
/**
 * 是否是数字
 * @param value
 * @returns
 */
function isDigital(value) {
	var regu = /^[-]?[0-9]+(.[0-9]+|)$/;
	return regu.test(value);
}
/**是否算式*/
function iscalculation(value) {
    var reg = /^[\+\-]?\d+(\.\d+)?([\+\-\*\/]\d+(\.\d+)?)*$/;
    return reg.test(value);
}
/**
 * @param number 数字型
 * @param decimal  小数位数
 * @returns 原值或整型或浮点型
 */
function roundNumber(number, decimal) {
	if(!number && number != 0) return number;
	if(!isDigital(number)) return number;
	if(!decimal) return parseInt(number);  // 转整型
	// 转指定小数位数的浮点数!
	return parseFloat(parseFloat(number).toFixed(decimal));
}
/**
 * 分离图片源，取出后缀名
 * @param src
 * @param splitSymbols(Array)
 * @param positions(Array): 取位置, -1=length,其他相同
 * @returns src suffix
 */
function splitImageSrc(src, splitSymbols, positions) {
	if(!src) return src;
	if(!splitSymbols || !(splitSymbols instanceof Array && splitSymbols.length>0)) return src;
	var splitSymbol = splitSymbols.shift();
	var position = positions && positions.length>0 ? positions.shift() : 0;
	var splitSrc = src.split(splitSymbol);
	var splitPos = position || 0;
	var splitValue = splitSrc && splitSrc.length > 0 ? splitSrc[splitPos==-1?splitSrc.length-1:splitPos] : null;
	if(splitValue) {
		return splitImageSrc(splitValue, splitSymbols, positions);
	}
	return src;
}

/**
 * 返回值的位数
 * @param num
 * Edit by bobol
 * 格式：[ 整数长度, 小数长度 ]
 */
function getNumDigitLength(num) {
	var temp = num.split('.');
	var res = [];
	for (var ti = 0; ti < temp.length; ti++) {
		res.push(temp[ti].length);
	}
	return res;
}

/**
 * 生成GUID
 * @returns {string}
 */
function guid() {
    function S4() {
        return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
    }
    return (S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4());
}

/**
 * 定义各屏幕大小规格(均以高度作比较)
 * 0. height > 900
 * 1. height > 800
 * 2. 700 - 800
 * 3. 600 - 700
 * 4. 600 (视为最小)
 */
var SCREEN_H = {};
(function(keys, values) {
	for(var ki=0,klen=keys.length;ki<klen;ki++) {
		Object.defineProperty(SCREEN_H, keys[ki], {
			value : values[ki],
			writable : false,
			configurable : false
		});
	}
})(["SMALLER", "SMALL", "MID", "BIG", "BIGGER"], [0, 1, 2, 3, 4]);
/**
 * 获取屏幕规格大小
 * @returns
 */
function getScreenDimensions() {
	if(!clientHeight || clientHeight <0) return SCREEN_H.SMALLER;
	if(clientHeight >= 900)
		return SCREEN_H.BIGGER;
	else if(clientHeight >= 800)
		return SCREEN_H.BIG;
	else if(clientHeight > 700 && clientHeight < 800)
		return SCREEN_H.MID;
	else if(clientHeight > 600 && clientHeight < 700)
		return SCREEN_H.SMALL;
	else return SCREEN_H.SMALLER;
}
function getHtmlElementHeight(selector) {
	var element = document.querySelector(selector);
	if(!element) return 0;
	if(element instanceof Array) return element[0].clientHeight;
	return element.clientHeight;
}
/**
 * 计算列表最大容纳数量(不使用滚动条)
 * @param eleData [Object]
 * @returns
 */
function calcListMaxContainNumEle(eleData) {
	if(!eleData) throw new Error("非正确参数对像");
	var id = eleData.id;
	var element = document.getElementById(id);
	if(!element) {return eleData.defaultVal;}
	var eleHeight = element.clientHeight;
	if(!eleData.itemHeight) throw new Error("itemHeight数据值不正确(非零)!");
	if(!eleHeight || eleHeight < 0) return calcListMaxContainNum(eleData.listHeight, eleData.itemHeight);
	
	return parseInt(eleHeight/eleData.itemHeight);
}
/**
 * 计算列表最大容纳数量(不使用滚动条)
 * @returns
 */
function calcListMaxContainNum(listHeight, itemHeight) {
	return parseInt(listHeight/itemHeight);
}

/**
 * 获取datas中相应id的值
 * @param datas
 * @param id
 * @returns
 */
function getDataById(datas,id){
	if(!datas){
		return null;
	}
	for(var j=0;j<datas.length;j++){
		if(datas[j]&&datas[j].id==id){
			return datas[j];
		}
	}
	return null;
}
/**
 * 验证输入值是否规范
 * @param curValue
 * @param inputValue
 * @returns
 */
function validatorInputNumber(curValue, inputValue) {
	// default 数字保留两位小数
	var rules = {
		"S" : /^[\d\.]$/g,
		"D" : /^$/g,
		"C" : /^$/g
	};
	
	if(!/^[\d\.]$/g.test(inputValue+"")) return false;// 非数字和点
	else if(/^\d+\.[0-9]{2}$/g.test(curValue+"")) return false;// 已经存在两位小数了
	else if(/^\d+\.$/g.test(curValue+"") && /^\.$/g.test(inputValue+"")) return false;// 已经有小数点了
	return true;
}
/**
 * 替换SQLite特殊符号
 * @param replaceVal
 * @returns
 */
function replaceSQLiteSpecialSymbol(replaceVal) {
	var re = /%|_|\[|\]|\^/g;
	return replaceVal.replace(re, function(match) { return '^'+match; });	
}
/**
 * 创建时间
 */
function createDateStr(){
	return new Date().format('yyyy-MM-dd hh:mm:ss');
}
/**
 * 比较对象
 * @param source
 * @param taget
 * @returns {Boolean}true|false
 */
function compareObject(source,taget){
	var sourcePropertyNames = Object.getOwnPropertyNames(source);
	var tagetPropertyNames = Object.getOwnPropertyNames(taget);
	//console.log(sourcePropertyNames);
	//console.log(tagetPropertyNames);
	if(sourcePropertyNames.length != tagetPropertyNames.length){
	  return false;    
	}     
	for(var i=0;i<sourcePropertyNames.length;i++){
		var propName=sourcePropertyNames[i];       
		//如果对应属性对应值不相等，则返回false       
		if(nvlValue(source[propName],'') !== nvlValue(taget[propName],'')){
			console.log("------"+ propName);
			console.log(source[propName] +"------"+ taget[propName]);
			return false;       
	    }     
	}
	return true;
}
/**
 * 是否是可用的数字(用于判断纯数字包括零)
 * @returns
 */
function isValidDigital(value) {
	if(/^(|-)\d+(|\.[0-9]+)$/g.test(value+"")) return true;
	return false;
}
/**
 * JS中不准确的浮点数,如下:
 * 0.00000000003/1.00000000002 转成整型
 * 0.10000002/1.2000000004    转两位浮点数
 * @param value
 * @returns
 */
function convertErrorFloatDigital(value) {
	if(!isValidDigital(value)) return value;
	if(/\.[0]{3,}/g.test(value+"")) return parseInt(value);
	return value;
}
/*
* 四舍五入
* @param unit保留小数位数，0,1,2
* @returns string
*/
function roundByUnit(num, unit){
	if(!num || 0/parseFloat(num) != 0 || num <= 0){
		return 0;
	}
	unit = parseInt(unit);
	var newNum = num;
	switch(unit){
		case 0:
			newNum = Math.round(num).toFixed(0);
			break;
		case 1:
			newNum = (Math.round(num * 10)/10).toFixed(1);
			break;
		default:
			newNum = (Math.round(num * 100)/100).toFixed(2);
			break;
	}
	return newNum;
}
function getMacAddress() {
	var mac = null;
	if(window.getMacAddr) {
		mac = window.getMacAddr();
	}
	return mac;
}
/**
 * 检测设备是否正常运行
 * @author v_cjc
 * @createTime 2018年1月10日 下午2:52:17
 * @param callback
 * @returns
 */
function isMasterSlaveDeviceNormal(callback) {
	if(!isWsServerOnline()) {
		callback && callback(false, connFailedMessage);
		return;
	}
	if(isConfigSlave()) {
		sendMasterSocket({isRollBackMessage:true,reqData:{}}, function(rtData) {
			if(rtData.success) {
				//callback && callback(true, rtData.msg);
				sendMasterSocket({SQL:[{sql:"SELECT count(*) FROM sellercustomerinfo WHERE 1<>0", params:[]}]}, function(rtData) {
					callback && callback(rtData.success, rtData.msg);
				}, "SELLER_IS_CHANGE");
			} else callback && callback(false, rtData.msg);
		}, "MASTER_IS_ONLINE");
	} else {
		sendMasterSocket({isRollBackMessage:true,reqData:{}}, function(rtData) {
			if(rtData.success) callback && callback(true, rtData.msg);
			else callback && callback(false, rtData.msg);
		}, "SLAVE_IS_CONNECTING");
	}
}
/**
 * 通过分隔符产生Map-Key
 * @author v_cjc
 * @createTime 2018年4月17日 下午4:38:37
 * @param keys
 * @returns
 */
function getMapKeyBySeperator(keys) {
	if(keys instanceof Array) {
		return keys.join("_");
	} else return keys;
}

//数组去重
function uniqueArray(arr){
	var res =[];
	var json = {};
	for(var i=0;i<arr.length;i++){
		if(!json[arr[i]]){
			res.push(arr[i]);
			json[arr[i]] = 1;
		}
	}
	return res;
}


/**
 * 检测是否账号停用或过期
 */
function checkSellerAccountValid(message) {
    if(!message) return true;
    if(toString(message).indexOf("停用")>-1 || toString(message).indexOf("过期")>-1) return false;
    return true;
}

/**
 * 字符串转字节
 * @param str
 * @returns {Array}
 */
function stringToByte(str) {
    var bytes = new Array();
    var len, c;
    len = str.length;
    for (var i = 0; i < len; i++) {
        c = str.charCodeAt(i);
        if (c >= 0x010000 && c <= 0x10FFFF) {
            bytes.push(((c >> 18) & 0x07) | 0xF0);
            bytes.push(((c >> 12) & 0x3F) | 0x80);
            bytes.push(((c >> 6) & 0x3F) | 0x80);
            bytes.push((c & 0x3F) | 0x80);
        } else if (c >= 0x000800 && c <= 0x00FFFF) {
            bytes.push(((c >> 12) & 0x0F) | 0xE0);
            bytes.push(((c >> 6) & 0x3F) | 0x80);
            bytes.push((c & 0x3F) | 0x80);
        } else if (c >= 0x000080 && c <= 0x0007FF) {
            bytes.push(((c >> 6) & 0x1F) | 0xC0);
            bytes.push((c & 0x3F) | 0x80);
        } else {
            bytes.push(c & 0xFF);
        }
    }
    return bytes;
}
/**
 * isValidValue
 * @value
 */
function isValidValue(value) {
	var tmpValue = value + "";
	return !(tmpValue.toLowerCase()==="NaN".toLowerCase()
		||tmpValue.toLowerCase()==="null".toLowerCase()
		||tmpValue.toLowerCase()==="undefined");
}

/**
 * 获取打印流水号
 * @param evalValue
 * @returns {Number}
 */
function getTransAccNo() {
	if (window.billSetting) {
		var printTransNo = billSetting.streamName + ":";
		printTransNo += billSetting.accumulateNum.toString();
		billSetting.accumulateNum = parseInt(billSetting.accumulateNum) + 1 + '';
		return printTransNo;
	} else return "printTransNo";
}
/**
 * 保留数字小数点位数
 * @param value
 * @param fixCounts(可以不传值)
 * @returns {*}
 */
function parseDigitalDecimal(value, fixCounts) {
	var fixCounts = fixCounts || 2;
	// if (isIntegerDigital(value)) return parseInt(value);
	if (isDigital(value)) {
		return parseFloat(value).toFixed(fixCounts);
	}
	return String(value); // 非数字返回原值
}

/**
 * 数字转整型或浮点型
 * @param value
 * @returns {*}
 */
function digitalToIntOrFloat(value) {
	if(!isValidDigital(value)) return 0;
	if(parseInt(value) == parseFloat(value)) return parseInt(value);

	return parseFloat(value).toFixed(2);
}
function isAndroidSqliteNull(value) {
	if(new String(value).valueOf().toLowerCase() === "null") return true;
	return false;
}

/**
 * 保留数字小数点位数或取整
 * @param value
 * @param fixCounts(可以不传值)
 * @returns {*}
 */
/*function parseDigitalDecimal(value, fixCounts) {
	var fixCounts = fixCounts || 2;
	if(isIntegerDigital(value)) return parseInt(value);
	else if(isDigital(value)) {
		return parseFloat(value).toFixed(fixCounts);
	}
	return value; // 非数字返回原值
}*/
var twoPow14 = Math.pow(2, 14);
var twoPow16 = Math.pow(2, 16);
var twoPow28 = Math.pow(2, 28);
var twoPow32 = Math.pow(2, 32);
var UUID = {
    salt : {},
    time : {},
    clockSeq : null,
    uuidVersion : 4,
    init : function() {
        var me = this;
        me.salt = {};
        me.time = {};
        me.clockSeq = me.rand(0, twoPow14 - 1);
        me.salt.lo = me.rand(0, twoPow32-1);
        me.salt.hi = me.rand(0, twoPow16-1);
        me.time.lo = me.rand(0, twoPow32-1);
        me.time.hi = me.rand(0, twoPow28-1);
    },

    generator : function() {
        var me = this;
        var parts = [];
        var salt = this.salt;
        var time = this.time;
        var clockSeq = this.clockSeq;
        parts.push(me.toHex(time.lo, 8));
        parts.push(me.toHex(time.hi & 0xFFFF, 4));
        parts.push(me.toHex(((time.hi>>>16) & 0xFFF) | (me.uuidVersion<<12), 4));
        parts.push(me.toHex(0x80 | ((clockSeq>>>8) & 0x3F), 2) + me.toHex(clockSeq & 0xFF, 2));
        parts.push(me.toHex(salt.hi, 4) + me.toHex(salt.lo, 8));

        me.init();

        return parts.join("-").toLowerCase();
    },
    toHex : function(value, length) {
        var ret = value.toString(16);
        if (ret.length > length) {
            ret = ret.substring(ret.length - length); // right-most digits
        } else if (ret.length < length) {
            ret = this.leftPad(ret, length, '0');
        }
        return ret;
    },
    rand : function(lo, hi) {
        var v = Math.random() * (hi-lo+1);
        return Math.floor(v) + lo;
    },
    leftPad : function(string, size, character) {
        var result = String(string);
        character = character || " ";
        while(result.length < size) {
            result = character + result;
        }
        return result;
    },
    split : function(bignum) {
        if(typeof(bignum) == "number") {
            var hi = Math.floor(bignum/twoPow32);
            return {
                lo : Math.floor(bignum - hi * twoPow32),
                hi : hi
            };
        }
        return bignum;
    }

}

//UUID.init();

/* 获取系统类型 */
function getSystemTypeUserAgent() {
    try {
        var userAgent = navigator.userAgent;
        if(userAgent.indexOf("Android")>-1) return "Android";
        else if(userAgent.indexOf("And") >-1) return "Android";
        else if(userAgent.indexOf("Mac OS") > -1) return "Mac OS";
        else return "Windows";
    } catch(err) {
        return false;
    }
}
/* PC苹果系统 */
function isMacOSUserAgent() {
    try {
        var userAgent = navigator.userAgent;
        if(userAgent.indexOf("Mac OS") > -1) return true;
        else return false;
    } catch(err) {return false;}
}