/**
 * 更新明细
 */
function updateSellDetail(sellDetail, id, sellId, callBack) {
	if (!sellDetail.discount && sellDetail.discount != 0) {
		sellDetail.discount = 100;
	}
	if (!sellDetail.remarkPrice) {
		sellDetail.remarkPrice = 0;
	}
	if(!isValidDigital(sellDetail.remarkPrice)) sellDetail.remarkPrice = 0;
	sellDetail.remarkPrice = parseFloat(sellDetail.remarkPrice);

	//sellDetail.sellNum = parseInt(sellDetail.sellNum);
	sellDetail.sellNum = parseFloat(sellDetail.sellNum);
	//sellDetail.sellPrice = ((parseFloat(sellDetail.commodityPrice) - sellDetail.remarkPrice) * parseFloat(sellDetail.discount) / 100 + sellDetail.remarkPrice).toFixed(2);
	if(sellDetail.hasChangePrice === "1") {
		sellDetail.sellPrice = (parseFloat(sellDetail.changePrice) + parseFloat(sellDetail.remarkPrice)).toFixed(2);
	} else
		sellDetail.sellPrice = ((parseFloat(sellDetail.commodityPrice) * parseFloat(sellDetail.discount) / 100) + sellDetail.remarkPrice).toFixed(2);
	sellDetail.totalAmount = ((parseFloat(sellDetail.commodityPrice) + sellDetail.remarkPrice) * sellDetail.sellNum).toFixed(2);
	sellDetail.sellAmount = (parseFloat(sellDetail.sellPrice) * sellDetail.sellNum).toFixed(2);
	sellDetail.remarkAmount = (parseFloat(sellDetail.remarkPrice) * sellDetail.sellNum).toFixed(2);
	SellDao.updateSellDetail(sellDetail, id, sellId, function(success) {
		if (success) {
			callBack(true, sellDetail);
		} else {
			callBack(false);
		}
	});
}

/*
 * 判断是否可以切换页面
 */
function canChangePage() {
	var store = getPageStore();
	if (store.getAllCount() > 0) {
		return false;
	} else {
		return true;
	}
}

/**
 * 提交员工登录
 */
function loginSystemManage(employeeUserName, employeePwd) {
	showLoading("正在加载管理后台数据, 请稍侯...");
    SellerEmployeeDao.loadMPosOpenPermission(seller.id, function(success, info) {
        if (success && info && info.length > 0) {
            SellerEmployeeDao.loadPermissionByEmpId(shouYinEmployee.id,function(success,items)
            {
            	closeLoading();
                if(success)
                {
                    if (items == undefined || items.length <= 0) {
                        showAlert('提示', '用户未授权,请联系管理员!');
                        return;
                    }
                    var mainView=Ext.getCmp('mainView');
                    if (mainView) {
                        showBy(mainView,Ext.getCmp('shouyinMainView'));
                    } else {
                        mainView=Ext.Viewport.add(Ext.create('Seller.view.Main'));
                        showBy(mainView,Ext.getCmp('shouyinMainView'));
                        mainView.openMPOS(employeeUserName, employeePwd, '0', seller.id);
                    }
                    mainView.parentContainer = Ext.getCmp('shouyinMainView');

                }
            });
        } else {
        	closeLoading();
        	showAlert('提示', '收银员无权限，请使用商家账号登录<br>管理后台&nbsp;&nbsp;→&nbsp;&nbsp;员工&nbsp;&nbsp;→&nbsp;&nbsp;收银员权限<br>进行设置', null, null, 170, null, null, 280)
		}
    });
}

function destroyLoginManageSystem() {
	var managerSystemCmp = Ext.getCmp("mainView");
	if (managerSystemCmp) {
		managerSystemCmp.releaseIframe();
		managerSystemCmp.destroy();
    }
}
function autoLoginManageSystem(employeeUserName, employeePwd) {
	SellerEmployeeDao.loadMPosOpenPermission(seller.id, function(success, info) {
		if (success && info && info.length > 0) {
            SellerEmployeeDao.loadPermissionByEmpId(shouYinEmployee.id,function(success,items)
            {
                if(success)
                {
                    if (items == undefined || items.length <= 0) {
                        return;
                    }

                    var mainView=Ext.getCmp('mainView');
                    if(!mainView) {
                    	mainView=Ext.Viewport.add(Ext.create('Seller.view.Main'));
                    }
                    showBy(mainView,Ext.getCmp('shouyinMainView'));
                    Ext.getCmp('mainView').parentContainer = Ext.getCmp('shouyinMainView');
                    Ext.getCmp('mainView').openMPOS(employeeUserName, employeePwd, '0', seller.id);
                }
            });
		}
	});
}

function getOrderCount() {
	OrderDao.getOrderCount(function(success, res) {
		if (success) {
			//document.getElementById('wxOrderDiv').innerHTML = res;
			var wxOrderNumEle = $("#wxOrderDiv");
			if(wxOrderNumEle) wxOrderNumEle.html(res);
		}
	});
}

function getMessageCount(operatorData) {
	if(typeof operatorData === "object") {
		if(isConfigSlave()) { /* 副机刷新铃声 */
			if("isNewMessage" in operatorData && operatorData["isNewMessage"] === true)
				beep(setting.ringtone);
		}
	}
	MessageDao.getMessageCount(function(success, res) {
		if (success) {
			var htmlEle = document.getElementById('messageDiv');
			if(htmlEle) htmlEle.innerHTML = res;
			if(Ext.getCmp('message-view')) {
				Ext.getCmp('message-view').loadData();
			}
		}
	});
}

function getPrintTaskCount() {
    PrintTaskDao.getPrintTaskCount(function(success, res) {
    	console.log(success);
    	console.log(res);
        if (success) {
            document.getElementById('printTask-messageDiv').innerHTML = res[0].totalNum;
        }
    });
}



/**
 * 计算商品明细
 */
function countDetail(record) {
	var sellPrice = parseFloat(record.get("sellPrice"));
	var commodityPrice = parseFloat(record.get("commodityPrice"));
	//var sellNum = parseInt(record.get("sellNum"));
	var hasChangePrice = record.get("hasChangePrice");
	var changePrice = record.get("changePrice");
	var sellNum = parseFloat(record.get('sellNum'));
	var remarkPrice = record.get("remarkPrice");
	var costPrice = record.get("costPrice");
	var isWeight = record.get("isWeight");
	if (remarkPrice) {
		remarkPrice = parseFloat(remarkPrice);
	} else {
		remarkPrice = 0;
	}
	var discount = record.get('discount');
	discount = getDiscountValueRange(discount);
	var sellDetail = {
		sellNum : sellNum,
		remarkPrice : remarkPrice,
		commodityPrice : commodityPrice,
		discount : discount,
		hasChangePrice : hasChangePrice,
		changePrice : changePrice,
		isWeight: isWeight
	};
	if(isValidDigital(costPrice)) sellDetail.costPrice = costPrice;
	calcDetailAmountForAlgo(sellDetail);
	record.set(sellDetail);
	/*record.set("sellAmount", (sellPrice * sellNum).toFixed(2));
	record.set("totalAmount", ((commodityPrice+remarkPrice) * sellNum).toFixed(2));
	record.set("remarkAmount", (remarkPrice * sellNum).toFixed(2));*/
}

function updateBuyCartForRemark(record, sellDetailData) {
	record.set('sellPrice', parseFloat(sellDetailData.sellPrice).toFixed(2));
	record.set('sellAmount', parseFloat(sellDetailData.sellAmount).toFixed(2));
	record.set('totalAmount', parseFloat(sellDetailData.totalAmount).toFixed(2));
	record.set('remarkPrice', parseFloat(sellDetailData.remarkPrice).toFixed(2));
	record.set('remarkAmount', parseFloat(sellDetailData.remarkAmount).toFixed(2));
	record.set("remark", sellDetailData.remark);
	record.set("remarkIds", sellDetailData.remarkIds);
	console.log('操作单据：' + record.get('commodityName') + '在购物车的口味被修改为' + sellDetailData.remark + '，商品单价变为' + record.get('sellPrice') + '--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
	showCustomerDisplay(0x31, parseFloat(sellDetailData.sellPrice).toFixed(2));
}

/**
 * 口味设置
 */
function setRemarkDetail(record, remark, remarkIds) {
	Ext.getCmp('buyCarOptBtn').hide();
	var oldRemarkIds = record.get("remarkIds");
	var remarkPrice = record.get("remarkPrice");
	remarkIds = remarkIds ? remarkIds : '';
	oldRemarkIds = oldRemarkIds ? oldRemarkIds : '';
	remarkPrice = remarkPrice ? parseFloat(remarkPrice) : 0;
	var sellDetail = {};
	//sellDetail.sellNum = parseInt(record.get("sellNum"));
	sellDetail.sellNum = parseFloat(record.get("sellNum"));
	sellDetail.discount = parseFloat(record.get("discount"));
	sellDetail.sellPrice = parseFloat(record.get("sellPrice"));
	sellDetail.commodityPrice = parseFloat(record.get("commodityPrice"));
	sellDetail.sellPrice = sellDetail.sellPrice - remarkPrice;  //
	sellDetail.hasChangePrice = record.get("hasChangePrice");
	sellDetail.isWeight = record.get("isWeight");
	var changePrice = record.get("changePrice");
	changePrice = isValidDigital(changePrice) ? changePrice : 0;
	sellDetail.changePrice = parseFloat(changePrice);
	sellDetail.remark = remark;
	sellDetail.remarkIds = remarkIds;

	var remarkIdArr = remarkIds.split(',');
	for(var ri=0,rlen=remarkIdArr.length;ri<rlen;ri++) {
		remarkIdArr[ri] = "'" + remarkIdArr[ri] + "'";
	}
	SellerRemarkDao.staticsSellerRemark(remarkIdArr.join(','), function(success, remarkData) {
		if(success && remarkData) {
			sellDetail.remarkPrice = remarkData.remarkPrice;
			remarkData.price = remarkData.remarkPrice;
			calcAmountForRemark(sellDetail, remarkData);
			if (Ext.getCmp('shouyinMainView').sellInfo) {
				updateSellDetail(sellDetail, record.get('id'), Ext.getCmp('shouyinMainView').sellInfo.id, function(success, res) {
					if (success) {
						updateBuyCartForRemark(record, sellDetail);
						countDetail(record);
						countStoreTimeout();
					} else {
						showAlert("提示", "设置失败！");
					}
				});
			} else {
				updateBuyCartForRemark(record, sellDetail);
				countStoreTimeout();
			}
		}
	});
}

var syCountStoreTimeout;

function countStoreTimeout() {
	if (syCountStoreTimeout) {
		clearTimeout(syCountStoreTimeout);
	}
	syCountStoreTimeout = setTimeout(function() {
		Ext.getCmp('shouyinMainView').countStore();
		syCountStoreTimeout = null;
	}, 100);
}
/* Main Store Operator */
function operatorMainStore() {}
/* 增加recordToStore*/
function addCartPageStore(recordData) {
	var me = Ext.getCmp('shouyinMainView');
	var addRecords = me.shoppingStore.add(recordData);
	var tmpCount = me.shoppingStore.getCount();
	/*var sTotalPage = me.shoppingPage.getTotalPage();
	var tmpLimitCount = me.shoppingPage.getLimitCount();
	var tmpTotalPage = parseInt(tmpCount / tmpLimitCount);
	tmpTotalPage = (tmpCount%tmpLimitCount) > 0 ? tmpTotalPage+1 : tmpTotalPage;*/
	me.shoppingPage.countPage(tmpCount);
	if(me.shoppingPage.getCurrPage() != me.shoppingPage.getTotalPage()) {
	//if(tmpTotalPage > sTotalPage || me.shoppingPage.getCurrPage() != sTotalPage) {
		//me.shoppingPage.setTotalPage(tmpTotalPage);
		me.lastShoppingCommodity();
		curPage++;
	}
	refreshAdsDoubleScreen();
	return addRecords[0];
}
function addCartStore(recordData) {
	Ext.getCmp('buyCarOptBtn').hide();
	return addCartPageStore(recordData);
}
function addCartStore(recordData) {
	var buyCartPanel = Ext.getCmp('buyCarGridPanel');
	var buyCartPanelStore = buyCartPanel ? buyCartPanel.getStore() : null;
	if(!buyCartPanelStore) return;
	var addRecord = buyCartPanelStore.add(recordData);
	Ext.getCmp('buyCarOptBtn').hide();

	addCartPageStore(addRecord[0]);
	/*var sTotalPage = me.shoppingPage.getTotalPage();
	var tmpLimitCount = me.shoppingPage.getLimitCount();
	var tmpTotalPage = parseInt(tmpCount / tmpLimitCount);
	tmpTotalPage = (tmpCount%tmpLimitCount) > 0 ? tmpTotalPage+1 : tmpTotalPage;
	me.shoppingPage.countPage(tmpCount);*/
	return addRecord;
}
/* 删除recordFromStore */
function removeCartStore(recordData) {
	var buyCartPanel = Ext.getCmp('buyCarGridPanel');
	var buyCartPanelStore = buyCartPanel ? buyCartPanel.getStore() : null;
	if(!buyCartPanelStore) return;
	if(!(recordData instanceof Ext.data.Model)) {
		throw new Error('arguments must be Ext.data.Model instance!');
	}
	console.log('操作单据：' + recordData.getData().commodityName + '在购物车被删除--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
	var removeRecord = buyCartPanelStore.remove(recordData);
	// 增加到列表中
	var me = Ext.getCmp('shouyinMainView');
	me.shoppingStore.remove(recordData);
	var count = me.shoppingStore.getCount();
	me.shoppingPage.countPage(count);
	me.reSetShoppingPage();
	return removeRecord;
}
function updateCartStore(record, recordData) {
	// update record
	record.set(recordData);
	var me = Ext.getCmp('shouyinMainView');
	var pageStore = me.shoppingStore;
	var pageRecord = pageStore.findRecord('id', record.get('id'));
	pageRecord.set(recordData);
}
function getPageStore() {
	var me = Ext.getCmp('shouyinMainView');
	return me.shoppingStore;
	//return Ext.getCmp('buyCarGridPanel').getStore();  -- restore
}

function removeDetail(record) {
	// 购物车
	//var carStore = Ext.getCmp('buyCarGridPanel').getStore();
	//var index = carStore.find('id', record.get('id'));
	//carStore.remove(record);
	removeCartStore(record);

	Ext.getCmp('shouyinMainView').countStore();
}
/**
 * 删除商品
 */
function removeDetail2(record) {
	var categoryList = Ext.getCmp("buyCarGridPanel");
	var store = categoryList.getStore();
	var index = store.find('id', record.get('id'));
	//store.remove(record);
	removeCartStore(record);
	if (index > 0) {
		var newRecord = store.getAt(index - 1);
		Ext.getCmp('buyCarGridPanel').select(store.getAt(index - 1), false, false);
		setTimeout(function() {
			categoryList.scrollToRecord(newRecord, false, false);
		}, 100);
	}
	/*if(store.getCount() == 0) {
		Ext.getCmp('shouyinMainView').setButtonStatus(true);
	}*/
	Ext.getCmp('shouyinMainView').countStore();
}

function copyCommodityProperty(record) {
	var recordObj = record.getData();
	if(record.get('expectedTime'))
	    recordObj.expectedTime = record.get('expectedTime');
	if(record.get('orderByTime')) {
		recordObj.orderByTime = record.get("orderByTime");
	}
	return recordObj;
}

/**
 * 查询删除数量
 */
function checkCanDelete(store, commodityId, commodityName, num) {
	var sellNum = 0;
	var delNum = 0;
	store.findBy(function(re, id) {
		if (commodityId == re.get("commodityId") && commodityName == re.get("commodityName")) {
			if (re.get("isDelete") == "1") {
				//delNum -= parseInt(re.get("sellNum"));
				delNum -= parseFloat(re.get("sellNum"));
			} else {
				//sellNum += parseInt(re.get("sellNum"));
				sellNum += parseFloat(re.get("sellNum"));
			}
		}
	});
	delNum = parseFloat(parseFloat(delNum).toFixed(2));
	sellNum = parseFloat(parseFloat(sellNum).toFixed(2));
	var remainNum = parseFloat(parseFloat(sellNum-parseFloat(num)).toFixed(2));
	return delNum <= remainNum;
	//return delNum <= (sellNum - parseFloat(num));
	//return delNum <= (sellNum - parseInt(num));
}
/**
 * 修改的数量是否使总数大于等于零
 * @param store
 * @param commodityId
 * @param commodityName
 * @param num
 * @returns
 */
function checkCommodityNumPositive(store, commodityId, commodityName, num) {
	var sellNum = 0;
	var delNum = 0;
	store.findBy(function(re, id) {
		if (commodityId == re.get("commodityId") && commodityName == re.get("commodityName")) {
			if (re.get("isDelete") == "1") {
				//delNum -= parseInt(re.get("sellNum"));
				delNum -= parseFloat(re.get("sellNum"));
			} else {
				//sellNum += parseInt(re.get("sellNum"));
				sellNum += parseFloat(re.get("sellNum"));
			}
		}
	});
	delNum = parseFloat(parseFloat(delNum).toFixed(2));
	sellNum = parseFloat(parseFloat(sellNum).toFixed(2));
	var remainNum = parseFloat(parseFloat(sellNum)+parseFloat(num)).toFixed(2);
	return delNum <= remainNum;
	//return delNum <= (sellNum - parseFloat(num));
	//return delNum <= (sellNum - parseInt(num));
}

function optionPageRecord(record, recordData) {
	// no use
	var pageStore = getPageStore();
	for(key in recordData) {
		//console.log(key + " : " + recordData.hasOwnProperty(key));
		if(recordData.hasOwnProperty(key))
			record.set(key, recordData[key]);
	}
	pageStore.add(record);
}
//操作一定数量之后检测商品是否销售一空或不足
function operatorCommodityView(record, sellNum) {
	var commodityInfoStore = Ext.getStore('showyin-commodity-store');
	if(!commodityInfoStore) return true;
	//if(!record.get('commodityId') || record.get('commodityId') == '') return true;
	var tmpCommodityInfoRecord = commodityInfoStore.findRecord('id', record.get('commodityId'));
	if(!tmpCommodityInfoRecord) return true;
	var isSoldoutStatus = tmpCommodityInfoRecord.get('soldoutStatus');
	if(isSoldoutStatus != '1') return true;
	var remainNum = parseFloat(tmpCommodityInfoRecord.get('remainNum'));
	if(remainNum <= 0 && sellNum > 0) {
		showAlert('提示', '对不起客官, 该商品已经销售一空了!');
		return false;
	} else if(remainNum - sellNum < 0) {
		showAlert('提示', '对不起客官, 该商品不足了!');
		return false;
	} else {
		remainNum = parseFloat(remainNum - parseFloat(sellNum)).toFixed(2);
		tmpCommodityInfoRecord.set('remainNum', remainNum);
		return true;
	}
}
/**
 * @param record
 * @param type  1.加, 2.减, 3.替换
 * @returns true/false
 */
function operatorCommodityView2(record, type, sellNum, oldSellNum) {
	//console.log(sellNum)
	type = type ? type : 1;   // 默认为加
	var commodityInfoStore = Ext.getStore('showyin-commodity-store');
	if(commodityInfoStore) {
		var tmpCommodityInfoRecord = commodityInfoStore.findRecord('id', record.get('commodityId'));
		if(tmpCommodityInfoRecord) {
			var isSoldoutStatus = tmpCommodityInfoRecord.get('soldoutStatus');
			if(isSoldoutStatus=='1') {
				var remainNum = parseFloat(tmpCommodityInfoRecord.get('remainNum'));
				if(type == 1) {
					if(remainNum <= 0) {
						showAlert('提示', '对不起客官, 该商品已经销售一空了!');
						return false;
					} else if(remainNum - sellNum < 0) {
						showAlert('提示', '对不起客官, 该商品不足了!');
						return false;
					} else {
						remainNum = parseFloat(remainNum - parseFloat(sellNum)).toFixed(2);
						tmpCommodityInfoRecord.set('remainNum', remainNum);
					}
				} else if(type == 2) {
					remainNum = parseFloat(remainNum + parseFloat(sellNum)).toFixed(2);
					tmpCommodityInfoRecord.set('remainNum', remainNum);
				} else if(type == 3) {
					var replaceSellNum = sellNum - oldSellNum;
					if(replaceSellNum > 0) {
						if(remainNum <= 0) {
							showAlert('提示', '对不起客官, 该商品已经销售一空了!');
							return false;
						} else if(replaceSellNum > remainNum) {
							showAlert('提示', '对不起客官, 该商品不足了!');
							return false;
						} else {
							remainNum = parseFloat(remainNum - replaceSellNum).toFixed(2);
							tmpCommodityInfoRecord.set('remainNum', remainNum);
						}
					} else if(replaceSellNum <= 0) {
						remainNum = parseFloat(remainNum - replaceSellNum).toFixed(2);
						tmpCommodityInfoRecord.set('remainNum', remainNum);
					}
				}
			}
		}
	}
	return true;
}
// 移除选中的商品状态
function syOptionUpdateCommodityView(record) {
	if (!Ext.getCmp('shouyinMainView').isContainCommodity(record.get('commodityId'))) {
		Ext.getCmp('select-commodity-view').removeSelectCommodity(record.get('commodityId'));
	}
	if (!Ext.getCmp('shouyinMainView').isContainCommodityType(record.get('commodityTypeId'))) {
		Ext.getCmp('shouyinMainView').removeCommodityNum(record.get('commodityId'), record.get('commodityTypeId'));
	}
}
function syOptionResumeSellInfoDel(sellId, record, optionData, callback) { // 单一职责
	if(!operatorCommodityView(record, optionData.sellNum)) return;
	// 挂起的单
	SellDao.deleteSellDetailById(record.get("id"), sellId, function(success, res, resultData) {
		if (success) {
			removeDetail(record);
			Ext.getCmp('shouyinMainView').addCommodityNum(record.get('commodityId'), record.get('commodityTypeId'), optionData.sellNum);
			callback && callback(true);
			var mainSellInfo = Ext.getCmp('shouyinMainView').sellInfo;
			if(mainSellInfo) {
				SellDao.getSellInfoById(sellId, function(success, sellInfo) {
					mainSellInfo.notDiscountAmount = sellInfo.notDiscountAmount;
					mainSellInfo.discountAmount = sellInfo.discountAmount;
				});
			}
		} else {
			showAlert("提示", "删除失败！");
		}
	});
}
function syOptionResumeSellInfoUpdate(sellId, record, optionData) {
	var sellNum = optionData.sellNum;
	var sellDetail = {
		sellNum : sellNum,
		sellPrice : record.get("sellPrice"),
		commodityPrice : record.get("commodityPrice"),
		discount : record.get("discount"),
		remarkPrice : record.get('remarkPrice')
	};
	if(optionData.type == OptionEnum.SUB);
	else if(optionData.type == OptionEnum.ADD);

	//if(!operatorCommodityView(record, 1, optionData.operatorNum)) return;
	if(!operatorCommodityView(record, optionData.operatorNum)) return;
	updateSellDetail(sellDetail, record.get('id'), sellId, function(success, res) {
		if (success) {
			record.set("sellNum", parseFloat(sellNum).toFixed(2));
			record.set("sellPrice", parseFloat(res.sellPrice).toFixed(2));
			record.set("sellAmount", parseFloat(res.sellAmount).toFixed(2));
			console.log('操作单据：' + record.get('commodityName') + '在购物车的数量被更改为' + sellNum + '--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
			countDetail(record);
			Ext.getCmp('shouyinMainView').countStore();
			Ext.getCmp('shouyinMainView').addCommodityNum(record.get('commodityId'), record.get('commodityTypeId'), optionData.operatorNum);
			var mainSellInfo = Ext.getCmp('shouyinMainView').sellInfo;
			if(mainSellInfo) {
				SellDao.getSellInfoById(sellId, function(success, sellInfo) {
					mainSellInfo.notDiscountAmount = sellInfo.notDiscountAmount;
					mainSellInfo.discountAmount = sellInfo.discountAmount;
				});
			}
		} else {
			showAlert("提示", "减1失败！");
		}
	});
}

var OptionEnum = {};
(function(keys, values) {
	if(keys.length != values.length) throw new Error("property's length not equals value's length!");
	for(var ki=0,klen=keys.length;ki<klen;ki++) {
		Object.defineProperty(OptionEnum, keys[ki], {
			value : values[ki],
			configurable: false,
			writable  : false
		});
	}
})(['DEL', 'ADD', 'SUB'], [0, 1, 2]);

// 删除操作
function syOptionButtonDel(shoppingStore, store, record) {
	// var firstTimeIn = true;
	var me = this;
	var sellInfo = this.sellInfo;
	var commodityId = record.get('commodityId');
	var commodityTypeId = record.get('commodityTypeId');
	var sellNum = parseFloat(record.get('sellNum'));
	var type = record.get('type');
	//sellId不为空是追加模式
	if (sellInfo) {
	    var num = isOptCommodityReason() ? 0 : 1;
		if(sellNum > num && type != '1' && type != '2' && sellInfo.status != '-1') {
            var delCommodityNumView=Ext.Viewport.add(Ext.create('Seller.view.shouyin.DelCommodityNum'));
            delCommodityNumView.setData(record,sellInfo,shoppingStore, store);
        	Ext.getCmp('input-num-commodity-del-view-input').focus();
			return;
		}
		var sellId = sellInfo.id;
		if (sellInfo.status == '-1') {
			//if(!operatorCommodityView(record, -record.get('sellNum'))) return;
			syOptionResumeSellInfoDel(sellId, record, {sellNum:-record.get('sellNum')}, function() {
				setTimeout(function() {
					syOptionUpdateCommodityView(record);
				}, 100);
			});
		} else {
			if (!checkCanDelete(shoppingStore, record.get("commodityId"), record.get("commodityName"), record.get("sellNum"))) {
				showAlert("提示", "删除超过实际数量!");
				return;
			}
			if (record.get('type') == "1" || record.get('type') == "2") {
				if(!operatorCommodityView(record, -record.get('sellNum'))) return;
				removeDetail(record);
				//refreshCartAndCommodity(record, -record.get('sellNum'));
				Ext.getCmp('shouyinMainView').addCommodityNum(record.get('commodityId'), record.get('commodityTypeId'), -record.get('sellNum'));
				pushUpdateSellInfo(sellId);
                setTimeout(function() {
                    syOptionUpdateCommodityView(record);
                }, 300);
				return;
			}
			generatorNewRecordForOption(store, record, {type:OptionEnum.DEL, sellNum : -record.get('sellNum')});
			operatorCommodityView(record, -parseFloat(record.get("sellNum")));

			//me.countStore();
			refreshCartAndCommodity(record, -record.get('sellNum'));
			pushUpdateSellInfo(sellId);
		}
		setTimeout(function() {
            syOptionUpdateCommodityView(record);
        }, 300);
	} else {
		operatorCommodityView(record, -sellNum);
		removeDetail(record);
		me.addCommodityNum(record.get('commodityId'), record.get('commodityTypeId'), -sellNum);
		setTimeout(function() {
			syOptionUpdateCommodityView(record);
		}, 300);
	}
}
// 口味操作
function syOptionButtonRemark(record) {
	var me = this;
	var buyCarRemarkView=Ext.getCmp('buyCarRemarkView');
	if (!buyCarRemarkView) {
		buyCarRemarkView=Ext.Viewport.add(Ext.create('Ext.ux.BuyCarRemarkEditor'));
	}
	showBy(buyCarRemarkView,Ext.getCmp('shouyinMainView'));
	Ext.getCmp('buyCarRemarkView').setParentContainer(me);
	Ext.getCmp('buyCarRemarkView').setBuyCarRecord(record);
}
// 增加操作
function syOptionButtonAdd(store, record) {
	var me = this;
	var sellInfo = me.sellInfo;
	var sellNum = parseFloat(record.get('sellNum'));
	if(!sellInfo) {
        var cmList = Ext.getCmp('showyin-commodity-list');
        var cmStore = cmList.getStore();
        var cmRecord;
        CommodityDao.getCommodityInfoById(record.get('commodityId'),function(success,items) {
            /*if(success && items.category == '2'){
                var jsonData = items.comboMealsJson;
                var jsonDataPar = JSON.parse(jsonData);
                // alert(jsonDataPar);
                for(var i = 0; i < jsonDataPar.length; i++){
                    cmRecord = cmStore.findRecord('id', jsonDataPar[i].commodityId);
                    if(cmRecord && cmRecord.get('soldoutStatus') == '1' && cmRecord.get('remainNum') < jsonDataPar[i].commodityNum) {
                        // ifcanOrder = false;
                        showAlert('提示', '该商品剩余数量不足！');
                        return;
                    }
                }
                canOrder(jsonData, 1, 1,function (canOrdersuccess) {
                    if (canOrdersuccess){
                        for (var i = 0, length = jsonDataPar.length - 1; i < jsonDataPar.length; i++) {
                            cmRecord = cmStore.findRecord('id', jsonDataPar[i].commodityId);
                            if (cmRecord && cmRecord.get('soldoutStatus') == '1' && cmRecord.get('remainNum') >= jsonDataPar[i].commodityNum) {
                                cmRecord.set('remainNum', parseFloat(cmRecord.get('remainNum') - jsonDataPar[i].commodityNum).toFixed(2));
                            }
                            else {
                                // countStoreResult(record, {sellNum: sellNum, operatorNum: 1});
                                // break;
                            }
                            if (i >= length) {
                                countStoreResult(record, {sellNum: sellNum, operatorNum: 1});
                                break;
                            }
                        }
                    }else{
                        // ifcanOrder = false;
                        showAlert('提示','该商品剩余数量不足！');
                        return;
                    }
                })
            }else */
        	if(success && !items) { // 临时菜
        		countStoreResult(record, {sellNum:sellNum,operatorNum:1});
        	} else if(/** && items.category != '2' && */items.soldoutStatus == '1') {
                /**注释在套餐内商品沽清是应取消*/
                cmRecord = cmStore.findRecord('id', record.get('commodityId'));
                if(cmRecord){
                    countStoreResult(record, {sellNum:sellNum,operatorNum:1});
                    return;
                }else{
                    canOrder(record,2,1,function(canOrderSuccess){
                        if (canOrderSuccess){
                            countStoreResult(record, {sellNum:sellNum,operatorNum:1});
                            return;
                        }else {
                            showAlert('提示','该商品剩余数量不足！');
                            return;
                        }
                    });
                }

            }else if(/**success && items.category != '2' && */items.soldoutStatus != '1') {
                countStoreResult(record, {sellNum:sellNum,operatorNum:1});
                return;
            }
        });
		return;
    }
	var sellId = sellInfo.id;
	if (sellInfo.status == '-1') {
		syOptionResumeSellInfoUpdate(sellId, record, {sellNum:sellNum+1,operatorNum:1,type:OptionEnum.ADD});
		//me.countStore();
		//refreshCartAndCommodity(record, 1);
	} else {
		if (record.get("type") != "1") {
			if(!operatorCommodityView(record, 1)) return;
			generatorNewRecordForOption(store, record, {type:OptionEnum.ADD,sellNum:1});
			refreshCartAndCommodity(record, 1);
			/*me.countStore();
			Ext.getCmp('shouyinMainView').addCommodityNum(record.get('commodityId'), record.get('commodityTypeId'), optionData.operatorNum);*/
		} else {
			countStoreResult(record, {sellNum:sellNum,operatorNum:1});
		}
	}
}
// 减少操作
function syOptionButtonSub(shoppingStore, store, record) {
	if (parseFloat(record.get('sellNum')) <= 1) {
		Ext.getCmp('buyCarOptBtn').hide();
	}
	var me = this;
	var sellInfo = me.sellInfo;
	var sellNum = parseFloat(record.get('sellNum'));
	if(!sellInfo) {
		countStoreResult(record, {sellNum:sellNum, operatorNum:sellNum<=1?-record.get('sellNum'):-1});
		if(sellNum <= 1) {
			setTimeout(function() {
				syOptionUpdateCommodityView(record);
			}, 200);
		}
		return;
	}

	var sellId = sellInfo.id;
	if (sellInfo.status == '-1') { // 挂单
		if (sellNum <= 1) {
			syOptionResumeSellInfoDel(sellId, record, {sellNum:-sellNum}, function() {
				setTimeout(function() {
					syOptionUpdateCommodityView(record);
				}, 100);
			});
		} else {
			syOptionResumeSellInfoUpdate(sellId, record, {sellNum:sellNum-1,operatorNum:-1,type:OptionEnum.SUB});
		}
	} else {
		if (record.get("type") == "1") {
			var subNum = parseFloat(record.get('sellNum')) < 1 ? parseFloat(record.get('sellNum')) : 1;
            if (!checkCanDelete(shoppingStore, record.get("commodityId"), record.get("commodityName"), subNum)) {
                showAlert("提示", "删除超过实际数量!");
                return;
            }
			countStoreResult(record, {sellNum:sellNum, operatorNum:-1});
            setTimeout(function() {
                syOptionUpdateCommodityView(record);
            }, 100);
			if(sellNum <= 1) Ext.getCmp('buyCarOptBtn').hide();
		} else {
			if(!checkCanDelete(shoppingStore, record.get('commodityId'), record.get('commodityName'), 1)) {
				showAlert('提示', '删除超过实际数量!');
				return;
			}
            if(isOptCommodityReason()){
                //显示退菜原因Component
                var optReturnCommodityReasonDatas = [
                    {reason: '顾客要求取消'},
                    {reason: '顾客等待时间长'},
                    {reason: '操作员下单失误'},
                    {reason: '菜品数量下多了'},
                    {reason: '厨房出不了菜品'},
                    {reason: '菜品已售罄'}
                ];
                showOptCommodityReasonView('退菜原因', optReturnCommodityReasonDatas, function(){
                    var optCommInput = Ext.getCmp('opt-commodity-reason-input');
                    if(!$.trim(optCommInput.getValue())){
                        showAlert('提示', '请输入退菜原因');
                        return;
                    }
                    Ext.getCmp('optCommodityReasonView').destroy();
                    record.set('optReason', optCommInput.getValue());
                    generatorNewRecordForOption(store, record, {type:OptionEnum.SUB, sellNum : -1});
                    operatorCommodityView(record, -1);
                    refreshCartAndCommodity(record, -1);
                    refreshDoubleScreen(); // 同步副屏数据
                });
            }else {
                generatorNewRecordForOption(store, record, {type:OptionEnum.SUB, sellNum : -1});
                operatorCommodityView(record, -1);
                refreshCartAndCommodity(record, -1);
            }
		}
	}
}
function countStoreResult(record, optionData) {
	if(!operatorCommodityView(record, optionData.operatorNum)) return;
	//if(optionData.sellNum <= 0 && (optionData.sellNum + optionData.operatorNum) <= 0) { // 删除购物车的一条记录
	if((optionData.sellNum + optionData.operatorNum) <= 0) { // 删除购物车的一条记录
		removeDetail(record);
	}else {
		//record.set("sellNum", optionData.sellNum);
		record.set("sellNum", parseFloat(optionData.sellNum+optionData.operatorNum).toFixed(2));
		console.log('操作单据：' + record.get('commodityName') + '在购物车的数量被更改为' + record.get('sellNum') + '--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
		countDetail(record);
	}
	//if(!record.get('commodityId') || record.get('commodityId') == '') {
		//Ext.getCmp('shouyinMainView').countStore();
		//Ext.getCmp('shouyinMainView').addCommodityNum(record.get('commodityId'), record.get('commodityTypeId'), optionData.operatorNum);
	refreshCartAndCommodity(record, optionData.operatorNum);
	//}
}
function refreshCartAndCommodity(record, operatorNum) {
	Ext.getCmp('shouyinMainView').countStore();
	Ext.getCmp('shouyinMainView').addCommodityNum(record.get('commodityId'), record.get('commodityTypeId'), operatorNum);
}
// 数量操作
function syOptionButtonNum(shoppingStore, store, record) {
    var sellNum = record.get('sellNum');
	var me = this;
	var sellInfo = me.sellInfo;
	var commodityNumView = Ext.getCmp('self-input-commodity-num');
	if (commodityNumView)
		commodityNumView.show();
	else
		commodityNumView = Ext.Viewport.add(Ext.create('Seller.view.shouyin.CommodityNum'));
	commodityNumView.setData(record, sellInfo, shoppingStore, store);
}
// 商品赠送
function syOptionButtonPresented(shoppingStore, store, record) {
	// 删除、增加、特价菜商品是否可以操作, 口味、打折、增加、减少、数量
	var commodityPrice = 0;
	var presentedData = {
		sellNum : parseFloat(record.get('sellNum')).toFixed(2),
		commodityPrice : record.get('commodityPrice'),
		remarkPrice : record.get('remarkPrice'),
		discount : 0
	};
	presentedData.remarkPrice = presentedData.remarkPrice ? presentedData.remarkPrice : 0;
	presentedData.sellPrice = parseFloat(parseFloat(presentedData.commodityPrice)*parseFloat(presentedData.discount) + parseFloat(presentedData.remarkPrice ? presentedData.remarkPrice : 0)).toFixed(2);
	presentedData.sellAmount = parseFloat(parseFloat(presentedData.sellPrice) * parseFloat(presentedData.sellNum)).toFixed(2);
	//presentedData.totalAmount = presentedData.sellAmount;
	presentedData.totalAmount = parseFloat((parseFloat(presentedData.commodityPrice) + parseFloat(presentedData.remarkPrice))*parseFloat(presentedData.sellNum)).toFixed(2);
	presentedData.isPresented = '1';
	//presentedData.isOperatored = '1';
    // 记录赠送操作员
    presentedData.operatorId = shouYinEmployee.id;
    presentedData.optWorkId = shouYinEmployee.workId;
    presentedData.optWorkName = shouYinEmployee.workName;
    //操作来源，主机、副机、点菜宝
    if(Application.Ftype == Application.MASTER){
        presentedData.optSource = 'M';
    }else if(Application.Ftype == Application.SLAVE){
        presentedData.optSource = 'S';
    }else {
        presentedData.optSource = 'D';
    }

	var updateCartView = function() {
		console.log('操作单据：' + presentedData.sellNum + record.get('unit') + record.get('commodityName') + '在购物车被赠送--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
		record.set(presentedData);
		showCustomerDisplay(0x31, parseFloat(presentedData.sellPrice).toFixed(2));
		Ext.getCmp('shouyinMainView').countStore();
	};
	//updateCartView();
	//return;
	if(Ext.getCmp('shouyinMainView').sellInfo) {
		updateSellDetail(presentedData, record.get('id'), Ext.getCmp('shouyinMainView').sellInfo.id, function(success) {
			if(success) {
				updateCartView();
			}
			else showAlert('提示', '赠送操作失败!');
		});
	} else {
		updateCartView();
	}
}
// 单品折扣操作
function syOptionButtonDiscount(record) {
	if(record.get('isSpecialPrice') == '1') {
		showAlert('提示', '特价菜不能打折!');
		return;
	} else if(record.get('isDiscount') != '1') {
		showAlert('提示', '当前商品不支持打折!');
		return;
	}
	showDetailDiscountPanel(record);
}
// 改价操作
function syOptionButtonChgPrice(shoppingStore, store, record) {
	//var sellNum = record.get('sellNum');
	var me = this;
	var sellInfo = me.sellInfo;
	var commodityPriceView = Ext.getCmp('self-input-commodity-price');
	if (commodityPriceView)
		commodityPriceView.show();
	else
		commodityPriceView = Ext.Viewport.add(Ext.create('Seller.view.shouyin.CommodityPrice'));
	commodityPriceView.setData(record, sellInfo, shoppingStore, store);
}
/* 刷新副屏广告 */
function refreshAdsDoubleScreen() {
	//console.log("refreshAdsDoubleScreen");
	if (monitors == 2) {
		var cartCmp = Ext.getCmp("buyCarGridPanel");
		if(!cartCmp) return;
		var cartStore = cartCmp.getStore();
		if(!cartStore) return;
		var cartCount = cartStore.getCount();
		if(adsSetting.isShowInOrderring === true) { // 点餐播放广告
			if(cartCount>0) { //
				adsSetting.isShowAds = true;
				adsSetting.showAdsSize = ADS_SIZE.PARTSCREEN;
			} else if(cartCount<=0) {
				adsSetting.isShowAds = true;
				adsSetting.showAdsSize = ADS_SIZE.FULLSCREEN;
			}
		} else {
			if(cartCount>0) { //
				if(adsSetting.isShowAds === true) {
					adsSetting.isShowAds = false;
					adsSetting.showAdsSize = ADS_SIZE.FULLSCREEN;
				} else return;
			} else if(cartCount <= 0) {
				if(adsSetting.isShowAds === false) {
					adsSetting.isShowAds = true;
					adsSetting.showAdsSize = ADS_SIZE.FULLSCREEN;
				} else return;
			}
		}
		if(sendMsg2AdsUpdate)
			sendMsg2AdsUpdate(adsSetting);

		if (cartCount > 0 && adsSetting.isShowInOrderring == false) {
			sendMsg2AdsAVVolume(0); // 更新视频声音
		} else {
			sendMsg2AdsAVVolume(1);
		}
	}
}
/* 同步副屏数据(2018.08.03) */
function refreshDoubleScreen(){
	if(monitors == 2){
		var store = Ext.getCmp('buyCarGridPanel').getStore();
		var doubleScreenShowData = [];
		var doubleScreenSellAmount = 0.00;
		var doubleScreensellNum = 0;
		var total = store.getAllCount();
		var k = 0;
		var selectionRecord = Ext.getCmp('buyCarGridPanel').getSelection()[0]; // 当前操作商品
		for (var i = 0; i < total; i++) {
            var record = store.getAt(i);
            doubleScreenShowData[k] = {};
            doubleScreenShowData[k].commodityName = record.get('commodityName');
            doubleScreenShowData[k].commodityNum = record.get('sellNum');
            doubleScreenShowData[k].commodityPrice = record.get('sellPrice');
            doubleScreenShowData[k].commodityAmount = record.get('sellAmount');
            doubleScreenShowData[k].status = '0';
            if(selectionRecord == record ){
            	doubleScreenShowData[k].status = '1';
            }
			if (!selectionRecord) {
            	selectionRecord = store.getAt(total-1);
            }
            k++;
        }
		if (!selectionRecord) return;
		var commodityId = selectionRecord.get('commodityId');
		var sendInfo = Ext.getCmp('shouyinMainView');
		doubleScreenSellAmount = roundByUnit(sendInfo.sellAmount, roundSetting.unit);
		doubleScreensellNum = sendInfo.commodityNum;
		var pageValue = document.getElementById('shoppingPanelId').innerHTML;

        if (commodityId){
			CommodityDao.getCommodityInfoById(commodityId, function(success, res) {
				if (success && res) {
					sendMsg2SetCommodityImg(selectionRecord.get('commodityName'), selectionRecord.get('sellPrice'), res.define1) // 商品图片
				}
			})
        } else{
        	sendMsg2SetCommodityImg(selectionRecord.get('commodityName'), selectionRecord.get('sellPrice'), '');
        }
		sendMsg2SetShopInfo(seller.ename, seller.phone); // 商家名字
        sendMsg2SetCommodityList(doubleScreenShowData);// 商品列表
        sendMsg2SetTotalAmount(parseFloat(doubleScreenSellAmount).toFixed(2));// 总额
        sendMsg2SetTotalNum(parseFloat(doubleScreensellNum).toFixed(2));// 总件数
        sendMsg2SetPageNum(pageValue); // 页数
        refreshAdsDoubleScreen(); // 刷新广告
	}
}
/* 刷新两屏数据(2018.03.27) */
/*function refreshOptionDoubleScreen() {
	if (monitors == 2) {
        var store = Ext.getCmp('buyCarGridPanel').getStore();  // 客显
        var doubleScreenShowData = [];
        var doubleScreenSellAmount = 0.00;
        var total = store.getAllCount();
        var k = 0;
        for (var i = 0; i < total; i++) {
            var record = store.getAt(i);
            doubleScreenShowData[k] = {};
            doubleScreenShowData[k].commodityName = record.get('commodityName');
            doubleScreenShowData[k].commodityNum = record.get('sellNum');
            doubleScreenShowData[k].commodityPrice = record.get('sellPrice');
            doubleScreenShowData[k].commodityAmount = record.get('sellAmount');
            doubleScreenSellAmount += parseFloat(record.get('sellAmount'));
            k++;
        }

        sendMsg2SetCommodityList(doubleScreenShowData);
        sendMsg2SetTotalAmount(doubleScreenSellAmount.toFixed(2));
        var part = parseInt(total / divNum);
        var mod = k % divNum;
        var totalPage = (mod > 0) ? part + 1 : part;
        sendMsg2SetPageNum(curPage+1, totalPage);
    }
}*/
/*function syOptionDoubleScreen() {
	if (monitors == 2) {
        var store = Ext.getCmp('buyCarGridPanel').getStore();  // 客显
        var doubleScreenShowData = [];
        var doubleScreenSellAmount = 0.00;
        var total = store.getAllCount();
        var k = 0;
        for (var i = 0; i < total; i++) {
            var record = store.getAt(i);
            doubleScreenShowData[k] = {};
            doubleScreenShowData[k].commodityName = record.get('commodityName');
            doubleScreenShowData[k].commodityNum = record.get('sellNum');
            doubleScreenShowData[k].commodityPrice = record.get('sellPrice');
            doubleScreenShowData[k].commodityAmount = record.get('sellAmount');
            doubleScreenSellAmount += parseFloat(record.get('sellAmount'));
            k++;
        }

        sendMsg2SetCommodityList(doubleScreenShowData);
        sendMsg2SetTotalAmount(doubleScreenSellAmount.toFixed(2));
        var part = parseInt(total / divNum);
        var mod = k % divNum;
        var totalPage = (mod > 0) ? part + 1 : part;
        sendMsg2SetPageNum(1, totalPage);
    }
}*/
/**
 * @params optionData
 * @params sellDetail 当前需要修改的记录
 * 降低耦合
 */
function generatorNewRecordForOptionSingle(optionData, sellDetail) {
	var newSellDetailData = {};
	if(optionData.type == OptionEnum.DEL) {
		newSellDetailData.type = '2';
		newSellDetailData.isDelete = '1';
		// 记录退菜操作员
        newSellDetailData.operatorId = shouYinEmployee.id;
        newSellDetailData.optWorkId = shouYinEmployee.workId;
        newSellDetailData.optWorkName = shouYinEmployee.workName;
        //操作来源，主机、副机、点菜宝
        if(Application.Ftype == Application.MASTER){
            newSellDetailData.optSource = 'M';
		}else if(Application.Ftype == Application.SLAVE){
            newSellDetailData.optSource = 'S';
		}else {
            newSellDetailData.optSource = 'D';
		}
	} else if(optionData.type == OptionEnum.SUB) {
		newSellDetailData.type = '2';
		newSellDetailData.isDelete = '1';
        // 记录退菜操作员
        newSellDetailData.operatorId = shouYinEmployee.id;
        newSellDetailData.optWorkId = shouYinEmployee.workId;
        newSellDetailData.optWorkName = shouYinEmployee.workName;
        //操作来源，主机、副机、点菜宝
        if(Application.Ftype == Application.MASTER){
            newSellDetailData.optSource = 'M';
        }else if(Application.Ftype == Application.SLAVE){
            newSellDetailData.optSource = 'S';
        }else {
            newSellDetailData.optSource = 'D';
        }
	} else if(optionData.type == OptionEnum.ADD) {
		newSellDetailData.type = '1';
	}
	optionData.sellNum = optionData.sellNum ? optionData.sellNum : 1;
	newSellDetailData.discount = getDiscountValueRange(sellDetail.discount);
	newSellDetailData.remarkPrice = sellDetail.remarkPrice ? sellDetail.remarkPrice : 0;
	newSellDetailData.commodityPrice = sellDetail.commodityPrice ? sellDetail.commodityPrice : 0;
	newSellDetailData.sellNum = parseFloat(optionData.sellNum).toFixed(2);
	newSellDetailData.costPrice = sellDetail.costPrice;
	var sellAmount = parseFloat(sellDetail.sellPrice) * optionData.sellNum;
	newSellDetailData.sellAmount = parseFloat(sellAmount).toFixed(2);
	var tmpCommodityAmount = parseFloat(sellDetail.commodityPrice) + parseFloat(newSellDetailData.remarkPrice);
	tmpCommodityAmount = tmpCommodityAmount * optionData.sellNum;
	newSellDetailData.totalAmount = parseFloat(tmpCommodityAmount).toFixed(2);
	var tmpRemarkAmount = parseFloat(newSellDetailData.remarkPrice);
	tmpRemarkAmount = tmpRemarkAmount * optionData.sellNum;
	newSellDetailData.remarkAmount = parseFloat(tmpRemarkAmount).toFixed(2);
	newSellDetailData.createTime = new Date().format("yyyy-MM-dd hh:mm:ss");
	newSellDetailData.orderByTime = new Date().getTime();
	newSellDetailData.isPresented = sellDetail.isPresented ? sellDetail.isPresented : '0';
	newSellDetailData.hasChangePrice = sellDetail.hasChangePrice==='1' ? sellDetail.hasChangePrice : '0';
	newSellDetailData.changePrice = sellDetail.changePrice;
	newSellDetailData.chgPriceOperator = sellDetail.chgPriceOperator;
	newSellDetailData.isAlreadyOrder = '0';
	if(isValidDigital(newSellDetailData.costPrice))
		newSellDetailData.costAmount = parseFloat(parseFloat(newSellDetailData.costPrice) * parseFloat(optionData.sellNum)).toFixed(2);
	calcDetailAmountForAlgo(newSellDetailData);

	return newSellDetailData;
}
function generatorNewRecordForOption(store, record, optionData) {
    var newRecord = record.copy();
    var newRecordData = generatorNewRecordForOptionSingle(optionData, newRecord.getData());
    newRecord.set(newRecordData);
    //store.add(newRecord);
    addCartStore(newRecord);
	if (newRecord.get('sellNum') > 0) {
		console.log('操作单据：' + newRecord.get('sellNum') + newRecord.get('unit') + newRecord.get('commodityName') + '被添加进购物车--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
	} else {
		console.log('操作单据：' + -newRecord.get('sellNum'), newRecord.get('unit') + newRecord.get('commodityName') + '在购物车被退菜--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
	}
    return;

    if(optionData.type == OptionEnum.DEL) {
        newRecord.set("type", "1");
        newRecord.set("isDelete", "1");
    } else if(optionData.type == OptionEnum.SUB) {
        newRecord.set("type", "2");
        newRecord.set("isDelete", "1");
    } else if(optionData.type == OptionEnum.ADD) {
        newRecord.set("type", "1");
    }
    optionData.sellNum = optionData.sellNum ? optionData.sellNum : 1;
    newRecord.set("sellNum", parseFloat(optionData.sellNum).toFixed(2));
    var sellAmount = parseFloat(newRecord.get('sellPrice')) * optionData.sellNum;
    newRecord.set("sellAmount", parseFloat(sellAmount).toFixed(2));
    var tmpCommodityAmount = parseFloat(newRecord.get('commodityPrice')) + parseFloat(newRecord.get('remarkPrice') ? newRecord.get('remarkPrice') : 0);
    tmpCommodityAmount = tmpCommodityAmount * optionData.sellNum;
    newRecord.set("totalAmount", parseFloat(tmpCommodityAmount).toFixed(2));
    var tmpRemarkAmount = parseFloat(newRecord.get('remarkPrice') ? newRecord.get('remarkPrice') : 0);
    tmpRemarkAmount = tmpRemarkAmount * optionData.sellNum;
    newRecord.set("remarkAmount", tmpRemarkAmount);
    newRecord.set("createTime", new Date().format("yyyy-MM-dd hh:mm:ss"));
    newRecord.set('orderByTime', new Date().getTime());
    store.add(newRecord);
}
/**
 * 计算小计、总额
 * @param data
 * @returns
 */
function calcCartAmount(data) {
	if(data.isPresented == '1') {
		data.sellPrice = parseFloat(0 + parseFloat(data.remarkPrice ? data.remarkPrice : 0)).toFixed(2);
		data.sellAmount = parseFloat(parseFloat(data.sellPrice) * parseFloat(data.sellNum)).toFixed(2);
		data.totalAmount = data.sellAmount;
	} else {
		data.discount = data.discount==0 ? data.discount : (data.discount ? data.discount : 100);
		data.remarkPrice = data.remarkPrice ? data.remarkPrice : 0;
		data.sellPrice = parseFloat(parseFloat(data.commodityPrice)*parseFloat(data.discount) + parseFloat(data.remarkPrice)).toFixed(2);
		data.sellAmount = parseFloat(parseFloat(data.sellPrice) * parseFloat(data.sellNum)).toFixed(2);
		data.totalAmount = data.sellAmount;
	}
}
/**
 * 分页操作
 * @returns
 */
function syOptionButton() {
	var me = Ext.getCmp('shouyinMainView');
	var text = this.getText();
	var categoryList = Ext.getCmp("buyCarGridPanel");
	var store = categoryList.getStore();
	var shoppingStore = getPageStore();
	if (categoryList.getSelection().length < 1) {
		return;
	}
	var record = categoryList.getSelection()[0];
	var commodityId = record.get('commodityId');
	var commodityTypeId = record.get('commodityTypeId');
	var isDelete = parseInt(record.get("isDelete"));
	if (isDelete == '1') {
		if (record.get("type") != "1" && record.get('type') != '2') {
			return;
		} else {
			if (text != "删除") {
				return;
			}
		}
	}
	//var sellNum = parseInt(record.get('sellNum'));
	var sellNum = parseFloat(record.get('sellNum'));
	var sellInfo = me.sellInfo;
	var sellId;
	var isOrderedCommodity = false;  // 非已下单商品
	if (sellInfo) {
		sellId = sellInfo.id;
		var sellDetailId = record.get("id");
		/* 已在订单内 */
		if(isOrderedToCart(sellDetailId)) isOrderedCommodity = true;
	}

	var pageRecord = shoppingStore.findRecord('id', record.get('id'));
	var newPageRecord = pageRecord.copy();

	if (text == "删除"||text == "退菜") {
		syOptionButtonDel.call(me, shoppingStore, store, record);
        Ext.getCmp('buyCarOptBtn').hide();
	} else if(text == "口味") {
		if(isOrderedCommodity === true) return;
		syOptionButtonRemark.call(me, record);
        Ext.getCmp('buyCarOptBtn').hide();
	} else if(text == "+") {
		syOptionButtonAdd.call(me, store, record);
	} else if(text == "-") {
        syOptionButtonSub.call(me, shoppingStore, store, record);
        Ext.getCmp('buyCarOptBtn').hide();
	} else if (text == "折扣") {
		if(isOrderedCommodity === true) return;
		syOptionButtonDiscount.call(me, record);
        Ext.getCmp('buyCarOptBtn').hide();
	} else if(text == "数量") {
		if(isDelete == '1') return;
		syOptionButtonNum.call(me, shoppingStore, store, record);
        Ext.getCmp('buyCarOptBtn').hide();
	} else if(text == "赠送") {
		if(isDelete == '1') return;
		if(isOrderedCommodity === true) return;
		//if(!validatePermission(PERMISSIONS.COMMPRESENT)) return;
		validatePermission(PERMISSIONS.COMMPRESENT)
		.then(function() {
            if(isOptCommodityReason()){
                var optPresentCommodityReasonDatas = [
                    {reason: '活动赠送'},
                    {reason: '老顾客赠送'},
                    {reason: '节日促销赠送'},
                    {reason: '买一送一'},
                    {reason: '服务补偿'},
                    {reason: '消费满额送'}
                ];
                showOptCommodityReasonView('赠送原因', optPresentCommodityReasonDatas, function(){
                    var optCommInput = Ext.getCmp('opt-commodity-reason-input');
                    if(!$.trim(optCommInput.getValue())){
                        showAlert('提示', '请输入赠送原因');
                        return;
                    }
                    Ext.getCmp('optCommodityReasonView').destroy();
                    record.set('optReason', optCommInput.getValue());
                    syOptionButtonPresented.call(me, shoppingStore, store, record);
                    refreshDoubleScreen(); // 同步副屏数据
                });
            }else {
                syOptionButtonPresented.call(me, shoppingStore, store, record);
            }
			Ext.getCmp('buyCarOptBtn').hide();
		}).catch(function() {});
	} else if(text == "改价") {
		//if(!validatePermission(PERMISSIONS.COMMCHGPRICE)) return;
		validatePermission(PERMISSIONS.COMMCHGPRICE).then(function() {
			syOptionButtonChgPrice.call(me, shoppingStore, store, record);
		});

	}
	refreshDoubleScreen(); // 同步副屏数据
	// syOptionDoubleScreen();
}
/**
 * 是否已经下过单的商品
 * @returns
 */
function isOrderedToCart(orderId) {
	if(!orderId) return false;
	if(orderId.indexOf("ext-record") > -1) return false;
	else return true;
}
/**
 * 选择会员
 */
function selectCustomer() {
	console.log("customer-start", new Date().format("yyyy-MM-dd hh:mm:ss.S"));
	var customerQueryWindow = Ext.getCmp("customerQueryWindow");
	if (!customerQueryWindow) {
		customerQueryWindow =Ext.Viewport.add(Ext.create('Seller.view.customer.Query'));
	}
	showBy(customerQueryWindow,Ext.getCmp('shouyinMainView'));
	Ext.getCmp('customer-query-view').setParentContainer(Ext.getCmp('shouyinMainView'));
	Ext.getCmp('customer-query-view').loadData(Ext.getCmp('shouyinMainView').selectCustomerInfo);
}

/**
 * 弹出购物车操作
 */
var isBuyCarOptClick = false;

/**2017年12月26日前操作栏弹出方法，由于不符合新需求，新写方法。本方法名改为%2 */
function cartOptInterceptor2(record) {
	var dealViewId = ["sy-opt-present","sy-opt-discount","sy-opt-remark"];
	var toggleDisabledView = function(id, isDisabled) {
		var viewCmp = Ext.getCmp(id);
		// disabled
		if(isDisabled === false) {
			viewCmp && viewCmp.setDisabled(false);
			viewCmp && viewCmp.removeCls("cart-disabled-button");
		} else {
			viewCmp && viewCmp.setDisabled(true);
			viewCmp && viewCmp.addCls("cart-disabled-button");
		}
	}
	var toggleHideView = function(id, isHide) {
		var viewCmp = Ext.getCmp(id);
		// hide
		if(isHide === false) {
			viewCmp && viewCmp.setHidden(false);
		} else {
			viewCmp && viewCmp.setHidden(true);
		}
	}
	var isOrdered = isOrderedToCart(record.get("id"));
	// 已下单的商品禁用操作
	for(var diKey in dealViewId) {
		if(dealViewId.hasOwnProperty(diKey)) {
			toggleDisabledView(dealViewId[diKey], isOrdered===true?true:false);
			//toggleHideView(dealViewId[diKey], isOrdered===true?true:false);
		}
	}
	if(isOrdered === true) {
		//Ext.getCmp('buyCarOptBtn').setLeft(70);
	} else Ext.getCmp('buyCarOptBtn').setLeft(0);
}

function cartOptInterceptor(record) {
    var dealViewId = ["sy-opt-delete","sy-opt-number","sy-opt-discount","sy-opt-remark","sy-opt-sub","sy-opt-add","sy-opt-present","sy-opt-chg-price"];
    var toggleDisabledView = function(dealViewIds, isDisableds) {
    	if (dealViewIds.length != isDisableds.length) return;
    	for (var di = 0; di < dealViewIds.length; di++) {
            var viewCmp = Ext.getCmp(dealViewIds[di]);
            if (isDisableds[di] === true) {
                viewCmp && viewCmp.setDisabled(false);
                viewCmp && viewCmp.removeCls("cart-disabled-button");
            } else {
                viewCmp && viewCmp.setDisabled(true);
                viewCmp && viewCmp.addCls("cart-disabled-button");
            }
        }
    };

    if (!record) return;

    var type = record.get('type'); // 1.已下单 2.新增 3.删除
	var sellInfo = Ext.getCmp('shouyinMainView').sellInfo;

    if (sellInfo) {
    	if (type == '0') {
			if (record.get('sellNum') && parseFloat(record.get('sellNum')) >= 0) toggleDisabledView(dealViewId, [true, true, false, false, true, true, false, true]);
			else if (record.get('sellNum') && parseFloat(record.get('sellNum')) < 0) {
                toggleDisabledView(dealViewId, [false, false, false, false, false, false, false, false]);
			}
        }
        if (type == '1') toggleDisabledView(dealViewId, [true, true, true, true, true, true, true, true]);
        if (type == '2') toggleDisabledView(dealViewId, [true, false, false, false, false, false, false, false]);
	} else toggleDisabledView(dealViewId, [true, true, true, true, true, true, true, true]);

    /*if(isOrdered === true) {
    } else Ext.getCmp('buyCarOptBtn').setLeft(0);*/
}

function showBuyCarOpt(top,record) {
	cartOptInterceptor(record);
	Ext.getCmp('buyCarOptBtn').setTop(top);
	Ext.getCmp('buyCarOptBtn').show();
	var shouYinMainView = Ext.getCmp("shouyinMainView");
	var deletePanel = Ext.getCmp("sy-opt-delete");
	var deleteText = "删除";
	if(shouYinMainView && shouYinMainView.sellInfo) {
		if(record && record.get("isDelete") != '1')
			deleteText = "退菜";
	}
	if(deletePanel) deletePanel.setText(deleteText);
}

/**
 * 点击商品。暂没操作
 */
function syCommodityClick(index, commodityId) {

}

/**
 * Deprecated
 * @param callback
 */
function checkCommoditySoldoutDeprecated(callback) {
	var pageStore = getPageStore();
	CommodityDao.loadCommodityInfo(function(success, cmInfo) {
		if(!success || !cmInfo) callback && callback(true);
		if(cmInfo && cmInfo.length > 0) {
			var totalCount = pageStore.getAllCount();
			var cmlen = cmInfo.length;
			for (var i = 0; i < totalCount; i++) {
				var record = pageStore.getAt(i);
				if(!record) continue;
				var recordData = record.getData();
				if(!recordData) continue;
				for (var cmi = 0; cmi < cmlen; cmi++) {
					if (cmInfo[cmi].id == recordData.commodityId) {
						if (!cmInfo[cmi].soldoutStatus || cmInfo[cmi].soldoutStatus != '1') break;
						if (cmInfo[cmi].soldoutNum <= 0) {
							callback && callback(false, "<span style='color:red;'>" + cmInfo[cmi].name + '</span>商品不足!');
							//callback && callback(false);
							return;
						} else if (cmInfo[cmi].soldoutNum < recordData.sellNum) {
							callback && callback(false, "<span style='color:red;'>" + cmInfo[cmi].name + '</span>商品不足!');
							//callback && callback(false);
							return;
						} else {
							if(recordData.isDelete=='1' && (recordData.type == '1' || recordData.type=='2')) // delete
								cmInfo[cmi].soldoutNum = cmInfo[cmi].soldoutNum + recordData.sellNum;
							else if(recordData.type == '1') // add
								cmInfo[cmi].soldoutNum = cmInfo[cmi].soldoutNum - recordData.sellNum;
							break;
						}
					}
				}
			}
			callback && callback(true);
		}
	});
}
function getMainButtonTxt(type) {
	if(type == 1) {
		return '取单(F1)';
	} else if(type == 2) {
		//return '下单(F2)';
		return '选桌下单(F2)';
	} else if(type == 3) {
		return '清空';
	} else if(type == 4) {
		return '取消';
	} else if(type == 5) {
		return "退款";
	} else {
		return "";
	}
}
/**
 * 状态栏等操作按钮
 */
function statusButtonClick(index) {
    var me = Ext.getCmp('shouyinMainView');
	if (Ext.getCmp('shouyinMainView').shouhanMode == '5') {
		return;
	}
	if (index == 1) {
		var text = Ext.getCmp('clearOrTakeBtn').getText();
		if ("清空" == text || "取消" == text) {
			var store = Ext.getCmp('buyCarGridPanel').getStore();  // 查询
			if (store.getAllCount() < 1) {
				return;
			}
			showConfirm('提示', '确定要' + text + '吗?', function(buttonId) {
				if (buttonId == "yes") {
					Ext.getCmp('shouyinMainView').resetData();
					if(sySetting.mode == SYS_TYPE.HOTEL){
						syLeftButtonClick($(".sy-left-button[index="+6+"]")[0], 6);
					}
					if(sySetting.mode === SYS_TYPE.FD){
						if(me.shouhanMode == 0){
							Ext.getCmp('clearOrTakeBtn').setText('清空');
						}
					}
					console.log('操作单据：进行' + text + '购物车操作--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
					showCustomerDisplay(0x30, '0.00');
					//Ext.getCmp('shouyinMainView').resetShoppingPage();
				}
			});
		} else {
			var xtype = "putupqueryafter";
			if (Ext.getCmp('shouyinMainView').shouhanMode == 1) {
				xtype = "putupquerytake";
			} else {
				/*if (setting.defaultMode == 1) {
				 xtype = "putupqueryafter";
				 }*/
			}
			var putupQueryView = null;
			var viewName = xtype + 'view';
			if (Ext.getCmp(viewName)) {
				putupQueryView = Ext.getCmp(viewName);
			} else {
				putupQueryView = addViewport(xtype, viewName, clientWidth, clientHeight, 0, 0);
			}
			showBy(putupQueryView,me);
			putupQueryView.getAt(0).loadData();
			putupQueryView.getAt(0).setParentContainer(putupQueryView);
		}
	} else if (index == 2) {//挂单
		//var extra = getCartDetailExtra();
		var extra = getChangeCartDetailExtra();
		dealCommoditySoldout(extra.store, function(success, message) {
			if(!success) {showAlert("提示",message?message:"操作失败!");return;}
			var store = Ext.getCmp('buyCarGridPanel').getStore();  // 查询
			if (store.getAllCount() > 0) {
				showPutUpInputPanel();
			}
		}, true);
	}else if (index == 7) {
		if(!isSingleStation()) selectCustomer();
	} else if (index == 8) {
		showDiscountPanel();
	} else if (index == 9) {
		var messageView = Ext.Viewport.add({
			xtype : 'panel',
			modal : true,
			hideOnMaskTap : false,
			hidden : true,
			width : 750,
			id : 'messageView',
			height : 480,
			centered : true,
			layout : 'vbox',
			items : [{
				xtype : 'message'
			}]
		});
		showBy(messageView,me);
		Ext.getCmp("message-view").setParentContainer(messageView);
		Ext.getCmp("message-view").loadData();
	} else if (index == 10) {//打印失败
		var printFailView = Ext.getCmp('printfaillistview');
		if (!printFailView) {
			printFailView = Ext.Viewport.add({
				xtype: 'panel',
				modal: true,
				hideOnMaskTap: false,
				hidden: true,
				width: '100%',
				id: 'printfaillistview',
				height: '100%',
				centered: true,
				layout: 'vbox',
				items: [{
					xtype: 'printfaillist'
				}]
			});
		}
        showBy(printFailView,me);
        // Ext.getCmp("message-view").setParentContainer(messageView);
        Ext.getCmp("printfaillist").loadData();
	} else if (index == 11) {
		if (Ext.getCmp('customCommodityShowView')) {
			Ext.getCmp('customCommodityShowView').show();
			Ext.getCmp('commodityTmpEditForm').reset();
			Ext.getCmp("customer-commodity").ktPrintJson = {};
		} else {
			var customCommodityShowView = addViewport('customcommodity', 'customCommodityShowView', 420, 140, (clientWidth - 400) / 2, 300);
			showBy(customCommodityShowView, me);
		}
		Ext.getCmp('customer-commodity').setData();
		if(isAndroidSys()) {
			customCommodityShowView.setTop(30);
		}
	}
}

/**
 * 创建销售单
 * @param {Object} shopSign
 */
function createSellInfo(status, shopSign, subscriptionAmount, remark, callback) {
	var data = {};
	data.shopSign = shopSign;
	data.subscriptionAmount = subscriptionAmount;
	data.remark = remark;
	data.totalAmount = Ext.getCmp('shouyinMainView').totalAmount;
	data.sellAmount = Ext.getCmp('shouyinMainView').sellAmount;
	data.commodityNum = Ext.getCmp('shouyinMainView').commodityNum;
	Ext.getCmp('shouyinMainView').createSellInfo(status, data, callback);
}

/**
 * 创建销售单
 * @param {Object} shopSign
 */
function createSellInfoByPutup(status, shopSign, saleId, saleName, remark, callback) {
	var data = {};
	data.shopSign = shopSign;
	data.saleId = saleId;
	data.saleName = saleName;
	data.remark = remark;
	data.totalAmount = Ext.getCmp('shouyinMainView').totalAmount;
	data.sellAmount = Ext.getCmp('shouyinMainView').sellAmount;
	data.commodityNum = Ext.getCmp('shouyinMainView').commodityNum;
	if (Ext.getCmp('shouyinMainView').selectCustomerInfo) {
		data.customerId = Ext.getCmp('shouyinMainView').selectCustomerInfo.id;
		data.customerName = Ext.getCmp('shouyinMainView').selectCustomerInfo.nmerMobile = Ext.getCmp('shouyinMainView').selectCustomerInfo.mobile;
		data.customerAddress = Ext.getCmp('shouyinMainView').selectCustomerInfo.address;
	}
	Ext.getCmp('shouyinMainView').createSellInfo(status, data, callback);
	//回复收银模式
	//Ext.getCmp('shouyinMainView').choiceShouhanMode(0);
}

/**
 * 创建销售单
 * @param {Object} shopSign
 */
function createSellInfoByPutupTake(status, shopSign, waiterId, waiterName, waiterScale, remark, customerName, customerMobile, customerAddress, discount, callback) {
	var data = {};
	data.shopSign = shopSign;
	data.waiterId = waiterId;
	data.waiterName = waiterName;
	data.waiterScale = waiterScale;
	data.remark = remark;
	data.totalAmount = Ext.getCmp('shouyinMainView').totalAmount;
	data.sellAmount = Ext.getCmp('shouyinMainView').sellAmount;
	data.commodityNum = Ext.getCmp('shouyinMainView').commodityNum;
	data.customerMobile = customerMobile;
	data.customerAddress = customerAddress;
	data.discount = discount ? discount : 100;
	data.busType = '1';
	if (Ext.getCmp('shouyinMainView').selectCustomerInfo) {
		data.customerId = Ext.getCmp('shouyinMainView').selectCustomerInfo.id;
	}
	data.customerName = customerName;
	data.customerMobile = customerMobile;
	data.customerAddress = customerAddress;
	Ext.getCmp('shouyinMainView').createSellInfo(status, data, callback);
}

/**
 * 创建销售单
 */
function createSellInfoByShoukuan(status, data, callback) {
	Ext.getCmp('shouyinMainView').createSellInfo(status, data, callback);
}

var currentLeftButtonIndex = 0;
/**
 * 左边操作栏按钮
 */
function syLeftButtonClick(obj, index) {
	if (currentLeftButtonIndex == index) {
		return;
	}
	var me = Ext.getCmp('shouyinMainView');
	if (index == 2) {
	   checkPermissions("2", true)
	   .then(function() {syLeftButtonClick2(obj, index);})
	   .catch(function() {});
	} else syLeftButtonClick2(obj, index);

	return;
//	new Promise(function(resolve, reject) {
//		if (index == 2) {
//			checkPermissions("2", true)
//			.then(function() {resolve();})
//			.catch(function() {reject();});
//		} else resolve();
//	}).then(function() {
//		syLeftButtonClick2(obj, index);
//	});
}

function syLeftButtonClick2(obj, index) {
	if (currentLeftButtonIndex == index) {
		return;
	}
	var me = Ext.getCmp('shouyinMainView');
	//console.log('index:'+index);
	/*if (index == 2) {
		if (!checkPermissions("2", true)) {
			return;
		}
	}*/
	var store = Ext.getCmp('buyCarGridPanel').getStore();  // 查询
	if (store.getAllCount() > 0 || me.sellInfo) {
		if (me.shouhanMode == 2) {
			showAlert('提示', "请完成当前退货才能切换！");
			return;
		} else if (me.sellInfo) {
			showAlert('提示', "请完成当前交易才能切换！");
			return;
		} else {
			if (index != 0 && index != 1) {
				showAlert('提示', "请完成当前交易才能切换！");
				return;
			}
		}
	}

	if (index == 6) {
		Ext.getCmp('placeView-view').show();
		Ext.getCmp('select-commodity-view').hide();
		Ext.getCmp('placeView-view').loadData();
	} else {
		if (index != 4 && index != 7) { // 微信订单与美团订单都不会变动!
			Ext.getCmp('placeView-view').hide();
			Ext.getCmp('select-commodity-view').show();
		}
	}

	if(index == 5) { // 沽清
		Ext.getCmp('search').setHidden(true);
	} else {
		if(index != 4 && index != 7) // 微信订单与美团订单都不会变动!
		Ext.getCmp('search').setHidden(false);
	}

	if (index == 3) {
		return;
	} else if (index == 4) {
		if (isSingleStation()) return showAlert('提示', '微信点餐功能需要云端版本才支持！');
		var orderMainView=Ext.getCmp('order-main-view');
		if(orderMainView){
			//orderMainView.destroy();
		} else
			orderMainView = Ext.Viewport.add(Ext.create('Seller.view.order.Main'), {});
		showBy(orderMainView,me);
		orderMainView.loadOrderData();
		return;
	}
	if(index == 7) {
	    // 美团
        if (isSingleStation()) return showAlert('提示', '美团功能需要云端版本才支持！');
        var meituanMainView = null;
        if(Ext.getCmp("meituanMainView")) meituanMainView = Ext.getCmp("meituanMainView");
        else meituanMainView = addViewport('meituanMain', 'meituanMainView', clientWidth, clientHeight, 0, 0);
        if(meituanMainView) {
            showBy(meituanMainView, me);
            Ext.getCmp('take-out-meituan-main').loadData();
        }
		return;
    } else if(index == 8) {
    	MTOrderDao.loadOrderPush(function(success, res) {
			if (success) {
				//if (res > 0) {
					setTimeout(function() {
						getMtOrderCount();
					}, 800);
				//}
			}
		});
    	return;
    } else if(index == 9) {
    	OrderDao.loadOrderPush(function(success, res) {
			if (success) {
				if (res > 0) {
					newWxOrderOperatorForExt(res);
					setTimeout(function() {
						getMtOrderCount();
						refreshOrder();
					}, 800);
				}
			}
		});
    	return;
    }
	me.choiceShouhanMode(index);
	if ($(".sy-left-button-select")[0]) {
		changeImg($(".sy-left-button-select")[0], 1);
	}
	changeImg(obj, 2);
	currentLeftButtonIndex = index;
	Ext.query(".sy-left-button-select").forEach(function(element, index, array) {
		Ext.get(element).removeCls('sy-left-button-select');
	});
	Ext.get(obj).addCls('sy-left-button-select');
	changeCommodityRemain();
}

function syLeftButtonMoreClick(obj){
	var moreFeatureView = Ext.getCmp('moreFeatureView');
	if(!moreFeatureView){
		moreFeatureView = Ext.Viewport.add({
			xtype: 'panel',
			id:'moreFeatureView',
			width: 120,
			modal : true,
			layout: {
				type:'vbox',
				align: 'center'
			},
			style: 'top:auto;bottom:0;left:4px;opacity:0;transition: all 0.3s ease;background:#f8f8f8;border-radius:16px;border: 4px solid #e8e8e8;',
			defaults: {
				width: '80%',
				height: 42,
				style: 'margin-top: 10px;border-radius:18px;color:rgba(0, 0, 0, 0.8);background: #e8e8e8;font-size:16px;border:none;-webkit-box-shadow: 1px 1px 5px #ccc inset, -1px -1px 5px #ccc inset'
			},
			items: [{
				xtype: 'ebutton',
				text: '重印小票',
				handler: function() {
					//隐藏视图
					hideMoreFeatureView();
					var reprintTaskListViewWin = Ext.getCmp('reprintTaskListViewWin');
					if (!reprintTaskListViewWin) {
						reprintTaskListViewWin = Ext.Viewport.add({
							xtype: 'panel',
							id: 'reprintTaskListViewWin',
							width: 980,
							height: 590,
							modal: true,
							hideOnMaskTap: false,
							centered: true,
							scrollable: false,
							items: [{
								xtype: 'reprintTaskListView'
							}]
						})
					}
					showBy(reprintTaskListViewWin, Ext.getCmp('shouyinMainView'), 10);
					Ext.getCmp('reprintTaskListView').loadData();
				}
			}, {
				xtype: 'ebutton',
				text: '异常单据',
				hidden: Station.type === Station.SINGLE,
				handler: function() {
					hideMoreFeatureView();
					var abnormalOrderView = Ext.getCmp('abnormal-order-view');
					if (!abnormalOrderView) {
						abnormalOrderView = Ext.Viewport.add(Ext.create('Seller.view.order.AbnormalOrder'));
					} else {
						abnormalOrderView.show();
					}
					abnormalOrderView.loadData();
				}
			}, {
				xtype: 'ebutton',
				text: '设置记录',
				id: 'optPrintSetting-btn',
				hidden: true,
				handler: function() {
					//隐藏视图
					hideMoreFeatureView();
					showOptPrintSettingView();
				}
			}, {
				xtype: 'ebutton',
				text: '返&nbsp;&nbsp;回',
				margin: '20 0 10 0',
				handler: function() {
					//changeImg($('.more-img-btn'),1);
					var moreFeatureView = Ext.getCmp('moreFeatureView');
					$('#moreFeatureView').removeClass('more-move');
					setTimeout(function() {
						moreFeatureView && moreFeatureView.destroy();
					}, 300);
				}
			}]
		});
		//changeImg(obj,2);
		showBy(moreFeatureView,Ext.getCmp('shouyinMainView'),10);
		setTimeout(function(){
			$('#moreFeatureView').addClass('more-move');
		}, 100);

	}
}
function hideMoreFeatureView(){
	//changeImg($('.more-img-btn'),1);
	var moreFeatureView = Ext.getCmp('moreFeatureView');
	$('#moreFeatureView').removeClass('more-move');
	moreFeatureView && moreFeatureView.destroy();
}
function commodityRemainSetting(data) {
	var me = Ext.getCmp('shouyinMainView');
	if(me.shouhanMode == 2) {
		data.isHideSoldout = '1';
		if(data.soldoutStatus == '1')
			data.oldSoldoutStatus = '1';
		else data.oldSoldoutStatus = '0';
		data.soldoutStatus = '0';
	} else {
		data.isHideSoldout = '0';
		if(data.soldoutStatus == '1')
			data.oldSoldoutStatus = '1';
		else data.oldSoldoutStatus = '0';
	}
}
function changeCommodityRemain() {
	var me = Ext.getCmp('shouyinMainView');
	//if(index == 2) {
	if(me.shouhanMode == 2) {
		/*Ext.query('.remainContainer').forEach(function(element, index, array) {
			Ext.get(element).addCls('hideE');
		});*/
		var cmStore = Ext.getStore('showyin-commodity-store');
		var cmlen = cmStore.getCount();
		for(var cmi=0;cmi<cmlen;cmi++) {
			var record = cmStore.getAt(cmi);
			record.set('isHideSoldout', '1');
			if(record.get('soldoutStatus') == '1')
				record.set('oldSoldoutStatus', '1');
			record.set('soldoutStatus', '0');
		}
	} else {
		/*Ext.query('.remainContainer').forEach(function(element, index, array) {
			Ext.get(element).removeCls('hideE');
		});*/
		var cmStore = Ext.getStore('showyin-commodity-store');
		var cmlen = cmStore.getCount();
		for(var cmi=0;cmi<cmlen;cmi++) {
			var record = cmStore.getAt(cmi);
			record.set('isHideSoldout', '0');
			if(record.get('oldSoldoutStatus') == '1')
				record.set('soldoutStatus', '1');
		}
	}
}

function changeImg(obj, index) {
	var img = $(obj).find("img").get(0);
	var imgsrc = img.src;
	imgsrc = imgsrc.substring(imgsrc.indexOf("resources"), imgsrc.indexOf(".png"));
	var l = imgsrc.length;
	var i = imgsrc.substring(l - 1, l);
	imgsrc = imgsrc.substring(0, l - 1);
	img.src = imgsrc + index + ".png";
}

function menuItemHandover() {
	if (!canChangePage()) {
		/*showAlert('提示', '请先完成当前操作才能交接班！');*/
		showConfirm('提示', '是否取消当前交易并进行交接班操作！', function(type){
			jiaojieDialogOperator(type);
		});
		return;
	}
	console.log(new Date().format("yyyy-MM-dd hh:mm:ss.S"));
	var handoverView=Ext.getCmp('handover-main-view');
	if (!handoverView) {
		handoverView=Ext.Viewport.add(Ext.create('Seller.view.handover.Main'));
	}
	showBy(handoverView,Ext.getCmp('shouyinMainView'));
	Ext.getCmp('handover-main-view').loadData();
}
function menuItemSellInfo() {
    console.log(new Date().format("yyyy-MM-dd hh:mm:ss.S"));
	var sellView = Ext.getCmp('sell-main-view');
	if (sellView) {
        //sellView.destroy();
	} else {
        sellView = Ext.Viewport.add(Ext.create('Seller.view.sell.Main'));
    }
	showBy(sellView,Ext.getCmp('shouyinMainView'));
    sellView.loadSellInfo();
	sellView.loadLimitCount();
}
function menuItemLockScreen() {
	var lockView=Ext.getCmp("lock_view");
	if(lockView){
		lockView.destroy();
	}
	lockView = Ext.Viewport.add(Ext.create('Seller.view.shouyin.Lock'));
	showBy(lockView,Ext.getCmp('shouyinMainView'));
	if(Ext.getCmp('suopingPassword'))
		Ext.getCmp('suopingPassword').focus();
	lockView.setParentContainer(lockView);
}
function menuItemUpdateOrSyn() {
	/*if (!canChangePage()) {
		showAlert('提示', '请先完成当前操作才同步数据！');
		return;
	}*/
	if(!canUpdateData){
		showAlert('提示', '20秒内请不要重复同步数据！');
		return;
	}
	var me = this;
	showConfirm('提示', '您确定要同步数据吗?<br/><span style="color:red;font-size:12px;">请清空购物车,防止数据错误</span>', function(buttonId) {
		if (buttonId == "yes") {
			console.log('收银员' + shouYinEmployee.workName + '手动更新数据--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
			task = Ext.create('Ext.util.DelayedTask', function() {
				Ext.Viewport.mask({
					xtype : 'loadmask',
					centered : true,
					showAnimation : 'slideIn',
					transparent : true,
					fullscreen : true,
					message : "正在同步数据，请稍后.."
				});
			}, document.body);
			task.delay(10);
			LoadDataDao.updateData(function(success, message) {
				if (success) {
					LoadDataDao.updateOtherData(function(success2, message2) {
						if (task) {
							task.cancel();
							task = null;
							Ext.Viewport.unmask();
						}
						initKtPrinterSetting();
						if (success2) {
							if(Ext.getCmp('select-commodity-view') && !Ext.getCmp('select-commodity-view').isHidden())
								Ext.getCmp('select-commodity-view').loadData();
							if(Ext.getCmp('placeView-view') && !Ext.getCmp('placeView-view').isHidden()) {
								//Ext.getCmp('placeView-view').loadData();
							}
							showToast('同步成功！');
							sendSyncDataNotice();
							setTimeout(function() {
								specialPriceTask();
							}, 800);
							canUpdateData=false;
							setTimeout(function() {
								canUpdateData=true;
							}, 20*1000);
						} else {
							showAlert('提示', message2 ? message2 : '同步失败！');
							return;
						}
					}, isUpdatePlace=(Ext.getCmp('placeView-view') && !Ext.getCmp('placeView-view').isHidden()));
					updateCommodityImage();
				} else {
					if (task) {
						task.cancel();
						task = null;
						Ext.Viewport.unmask();
					}
					showAlert('提示', message ? message : '同步失败！');
                    return;
				}
			});

		}
	});
}
function menuItemCloseToHandover() {  // 关闭系统进入交接班
	if (!canChangePage()) {
		showConfirm('提示', '是否取消当前交易并进行交接班操作！', function(type){
			jiaojieDialogOperator(type);
		});
		return;
	}
	var handoverView=Ext.getCmp('handover-main-view');
	if (!handoverView) {
		handoverView=Ext.Viewport.add(Ext.create('Seller.view.handover.Main'));
	}
	showBy(handoverView,Ext.getCmp('shouyinMainView'));
	Ext.getCmp('handover-main-view').loadData();
}
// 皮肤
function menuItemPeel() {
	var peelingView = Ext.getCmp('peelingView');
	if (!peelingView)
		peelingView = addViewportCenter('peelingView', 'peeling', 500, 400, true);
	showBy(peelingView, Ext.getCmp('shouyinMainView'));
	Ext.getCmp('peeling_view').initData();
}
// App 下载
function menuItemQrcode() {
	var qrCodeDownView = null;
	if(Ext.getCmp('qrcode-down-view')) {
		qrCodeDownView = Ext.getCmp('qrcode-down-view');
		showBy(qrCodeDownView,Ext.getCmp('shouyinMainView'));
		return;
	}
	qrCodeDownView = Ext.Viewport.add({
		xtype : 'panel',
		id : 'qrcode-down-view',
		modal : true,
		centered : true,
		width : 1000,
		height : 400,
		items : [{
			xtype : 'toolbar',
			docked : 'top',
			title : 'App下载',
			items : [{
				xtype : 'button',
				//cls : 'close-button',
				cls : 'close-button-complete',
				width : 80,
				iconCls : 'close-icon',
				icon : 'resources/icon/public/back.png',
				text : '返回',
				id : 'qrcode-down-view-close'
			}]
		}, {
			xtype : 'container',
			flex : 1,
			layout : 'hbox',
			items : [{   // 点菜宝
				xtype : 'container',
				layout : 'vbox',
				flex : 1,
				height : '100%',
				cls : 'jz-center',
				margin : '0 10',
				items : [{
					xtype : 'label',
					label : '点菜宝',
					width : '100%',
					height : 50,
					cls : 'jz-center',
					style : 'text-align:center;',
					html : '<p>点菜宝</p>'
				}, {
					xtype : 'container',
					layout : 'hbox',
					flex : 1,
					cls : 'jz-center',
					margin : '10 0',
					items : [{// vorder android download
						xtype : 'container',
						layout : 'vbox',
						flex : 1,
						cls : 'jz-center',
						items : [{
							xtype : 'container',
							width : '100%',
							margin : '5 0',
							html : '<div><img width="200" height="200" src="resources/icon/vorder-qrcode-android.png"></div>'
						}, {
							xtype : 'label',
							height : 50,
							style : 'text-align:center;',
							html : '<p>Android 版</p>'
						}]
					}, { // vorder ios download
						xtype : 'container',
						layout : 'vbox',
						flex : 1,
						cls : 'jz-center',
						items : [{
							xtype : 'container',
							width : '100%',
							margin : '5 0',
							html : '<div><img width="200" height="200" src="resources/icon/vorder-qrcode-ios.png"></div>'
						}, {
							xtype : 'label',
							height : 50,
							style : 'text-align:center;',
							html : '<p>IOS 版</p>'
						}]
					}]
				}]
			}, {
				xtype : 'container',
				width : 2,
				height : 360,
				cls : 'jz-center',
				html : '<p style="width:2px;height:300px;border:solid 1px #ccc;margin-top:25px;" class="jz-center"></p>'
			}, {
				xtype : 'container',
				layout : 'vbox',
				flex : 1,
				cls : 'jz-center',
				margin : '0 10',
				//style : 'border:solid 1px #ccc;',
				items : [{
					xtype : 'label',
					label : '云管家',
					width : '100%',
					height : 50,
					cls : 'jz-center',
					style : 'text-align:center;',
					html : '<p>云管家</p>'
				}, {
					xtype : 'container',
					layout : 'hbox',
					flex : 1,
					cls : 'jz-center',
					margin : '10 0',
					items : [{// vorder android download
						xtype : 'container',
						layout : 'vbox',
						flex : 1,
						cls : 'jz-center',
						items : [{
							xtype : 'container',
							width : '100%',
							margin : '5 0',
							html : '<div><img width="200" height="200" src="resources/icon/vboss-qrcode-android.png"></div>'
						}, {
							xtype : 'label',
							height : 50,
							style : 'text-align:center;',
							html : '<p>Android 版</p>'
						}]
					}, { // vorder ios download
						xtype : 'container',
						layout : 'vbox',
						flex : 1,
						cls : 'jz-center',
						items : [{
							xtype : 'container',
							width : '100%',
							margin : '5 0',
							html : '<div><img width="200" height="200" src="resources/icon/vboss-qrcode-ios.png"></div>'
						}, {
							xtype : 'label',
							height : 50,
							style : 'text-align:center;',
							html : '<p>IOS 版</p>'
						}]
					}]
				}]
			}]
		}]
	});
	showBy(qrCodeDownView,Ext.getCmp('shouyinMainView'));
}
/**
 *  收银顶部工具栏按钮点击事件
 */
function menuItemClick(index) {
	if (index == 0) {
		//Ext.getCmp('shouyinMainView').setHidden(true);
		Ext.getCmp('indexView').show();
	} else if (index == 1) { // 交接班
		menuItemHandover();
	} else if (index == 2) { // 云平台
		//console.log('pintai');
		loginSystemManage(shouYinEmployee.workId, shouYinEmployee.password);
	} else if (index == 4) { // 销售单据
		menuItemSellInfo();
	} else if (index == 5) { // 会员
		if (isSingleStation()) return showAlert('提示', '会员功能需要云端版本才支持！');
		selectCustomer();
	} else if (index == 3) { // 锁屏
		menuItemLockScreen();
	} else if (index == 6) { // 钱箱
		checkPermissions("1", true, "当前收银员没有此项权限！")
		.then(function() {
			openCashboxByPrint(function(success){

			}, function(fail){
				showAlert('提示', fail);
			});
		});
		/*if (cashierPermissions && cashierPermissions.indexOf('1') >= 0) {
			openCashboxByPrint();
		} else {
			showAlert('提示', '当前收银员没有此项权限！');
		}*/
	} else if (index == 8) { // 更新或同步
		menuItemUpdateOrSyn();
	} else if (index == 9) { // 系统设置
        console.log("setting-start", new Date().format("yyyy-MM-dd hh:mm:ss.S"));
		var settingView=Ext.getCmp('settingView');
		var isAdd = false;
		if (!settingView) {
			settingView = Ext.Viewport.add(Ext.create('Seller.view.setting.Setting'));
            isAdd = true;
		}
		showBy(settingView,Ext.getCmp('shouyinMainView'));
		var settingCmp = Ext.getCmp("settingView");
        if(isAdd) // 新增时加载数据
			settingCmp && settingCmp.loadData();

        if (Ext.getCmp('setting-left-list') && Ext.getCmp('setting-left-list').getSelection()) {

            // 显示隐藏点菜宝设置
            var storeDatas = Ext.getStore('setting-left-Store').getData();
            for (var si = 0, len = storeDatas.length; si < len; si ++) {
                var item = storeDatas.getAt(si);
                if (item.get('id') === 'setting-order-view') {
                    var indx = si;
                    if (Station.type === Station.SINGLE) {
                        Ext.getCmp('setting-left-list').getItemAt(indx).setHidden(true);
                    } else {
                        Ext.getCmp('setting-left-list').getItemAt(indx).setHidden(false);
                    }
                    break;
                }
            }

            //try {
            var settingLeftListSel = Ext.getCmp('setting-left-list').getSelection();
            if(settingLeftListSel && settingLeftListSel.length>0) {
            	// if(settingLeftListSel[0].get('id') == "setting-printer-view") { // 打印设置界面
                    var curSettingView = settingLeftListSel[0].get('id');
                    var curSettingViewCmp = Ext.getCmp(curSettingView);
                    curSettingViewCmp && curSettingViewCmp.loadData();
                // }
            }
            //} catch(err) {console.log(err);}
        }
	} else if (index == 10) { // 关闭
		menuItemCloseToHandover();
	} else if (index == 11) { // 皮肤
		menuItemPeel();
	} else if(index == 12) { // App下载
		menuItemQrcode();
	} else if(index == 13) { // 刷新
		LoadDataDao.updateDataForForSlave(function(success, message){
        	if(success){
        		if(Ext.getCmp('select-commodity-view') && !Ext.getCmp('select-commodity-view').isHidden()){
        			Ext.getCmp('select-commodity-view').loadData();
        		} else if(Ext.getCmp('select-commodity-view')) {
                    Ext.getCmp('select-commodity-view').loadData();
				}
				// 刷新商家
                LoadDataDao.updateSellerForSlave(function(success, data){
                    if (success && data) {
                        seller.ename    = data[0].ename;
                        seller.location = data[0].location;
                        seller.mobile   = data[0].mobile;
						seller.phone    = data[0].phone;
						seller.isCombineWxOrder = data[0].isCombineWxOrder;
                    }
                });
				initKtPrinterSetting(); // 刷新厨打
				initSettingKtPrinter(); // 刷新厨打机数据
				initBillSetting();
				initAreaPrintData();
        		showToast('刷新成功！');
        	}else{
        		showAlert('提示', message ? message : '刷新失败！');
        	}
        });
		if(isConfigSlave()) {
			initSysTipDetail();
			initSelfDefinePayMap();
		}
    }
}

/**
 * 显示下单面板
 */
function showPutUpInputPanel() {
	var putupShowView;
    var me = Ext.getCmp('shouyinMainView');
	if (Ext.getCmp('shouyinMainView').shouhanMode == 1) {
		putupShowView = Ext.getCmp('putup-take-view');
		if(putupShowView){
			putupShowView.destroy();
		}
		putupShowView=Ext.Viewport.add(Ext.create('Seller.view.putup.EditTake'));
		showBy(putupShowView,me);
	} else if(me.sellInfo || me.selectPlace) {
		if(sysParams) {
			var putupViewData = sysParams.get(getMapKeyBySeperator(["SYS","directOrder"]));
			// 不需要显示下单框
			if(putupViewData && (putupViewData.paramValue==="true" || putupViewData.paramValue===true)) {
				if (me.selectPlace) {
					var selectPlaceData = me.selectPlace.getData();
					selectPlaceData.placeId = selectPlaceData.id;
					if (parseInt(me.personNum)) selectPlaceData.personNum = me.personNum;
					selectPlaceData.teaPrice = parseDigitalDecimal(selectPlaceData.teaPrice); // 茶位费
					submitPutup.call(selectPlaceData, "0");
				} else {
					me.sellInfo.teaPrice = parseDigitalDecimal(me.sellInfo.teaPrice); // 茶位费
					submitPutup.call(me.sellInfo, "0");
				}
				return;
			}
		}
		putupShowView = Ext.getCmp("select-place-view");
		if(putupShowView) {
			//putupShowView.destroy();
			Ext.getCmp("select-waiter-name").setValue('');
			Ext.getCmp('select-place-remark').setValue('');
		} else
			putupShowView = Ext.Viewport.add(Ext.create("Seller.view.shouyin.SelectPlaceView"));
		showBy(putupShowView, me);
		putupShowView.loadData();
	} else {
		putupShowView = Ext.getCmp('putup-edit-view');
		if(!putupShowView){
			putupShowView=Ext.Viewport.add(Ext.create('Seller.view.putup.Edit'));
		}
		showBy(putupShowView,me);
		Ext.getCmp('putup-edit-view').loadData();
	}


}

/**
 * Edit by bobol
 * 刷新页面方法
 */
function refreshCommodityPlaceView(callback){
    if (Ext.getCmp('select-commodity-view'))
        Ext.getCmp('select-commodity-view').loadData();
    if (Ext.getCmp('placeView-view'))
        Ext.getCmp('placeView-view').loadData();
    if (callback) return true;
}
function loadChangeData() {
    /**
	 * Vpos重新数据库去微信订单开关值
     */
    SellerDao.loadSellerById(function (success, data) {
		seller.isWxOrder = data[0].isWxOrder;
    });
}
function refreshAllSpecialPriceTask() {
    SpecialPriceDao.getSpecialPriceNotDel(function (success, special) {
        if (!success || !special || special.length <= 0) return;
        for (var sppi = 0; sppi < special.length; sppi++)
			updateSpecialPriceTask(special[sppi]);
    });
    SpecialPriceDao.getSpecialPriceDel(function (success, special) {
        if (!success || !special || special.length <= 0) return;
        for (var sppi = 0; sppi < special.length; sppi++)
            if (special[sppi].id in spIntervalTask) {
                clearInterval(spIntervalTask[special[sppi].id]);
                CommodityDao.updateCommodity({'isSpecialPrice': null,'specialPrice':null,'specialNorms':null}, special[sppi].commodityId, function (success, info) {
                    if (!success) showAlert('提示', info);
                });
            }
    })
}
/**
 * 显示沽清面板
 */
function showSoldoutPanel(record) {
	var soldoutView = Ext.getCmp('soldoutView');
	if (!soldoutView) {
		soldoutView = addViewportCenter('soldoutView', 'soldout', 320, 200, true);
	}
	showBy(soldoutView,Ext.getCmp('shouyinMainView'));
	Ext.getCmp('soldout-view').setRecord(record);
	Ext.getCmp('soldout-view').setParentContainer(soldoutView);
}

/**
 * 显示整单折扣面板
 */
function showDiscountPanel() {
	checkDiscountPermission.then(function() {
		var store = Ext.getCmp('buyCarGridPanel').getStore(); // 查询
		if (store.getAllCount() <= 0) {
			return;
		}
		showDiscountView();
		var me = Ext.getCmp('shouyinMainView');
		var mainViewStore = getPageStore();
		var notDiscountAmount = calcNotDiscountAmountForStore(mainViewStore);
		Ext.getCmp("allDiscountView").setData(1, parseFloat(me.totalAmount), parseFloat(me.sellAmount), me.discount, notDiscountAmount);
	}).catch(function() {});
	/*if(!checkDiscountPermission()) return;
	var store = Ext.getCmp('buyCarGridPanel').getStore(); // 查询
	if (store.getAllCount() <= 0) {
		return;
	}
	showDiscountView();
	var me = Ext.getCmp('shouyinMainView');
	var mainViewStore = getPageStore();
	var notDiscountAmount = calcNotDiscountAmountForStore(mainViewStore);
	Ext.getCmp("allDiscountView").setData(1, parseFloat(me.totalAmount), parseFloat(me.sellAmount), me.discount, notDiscountAmount);*/
}

/**
 * 显示折扣面板
 */
function showDetailDiscountPanel(record) {
	checkDiscountPermission().then(function(retVal) {
	    if(isOptCommodityReason()){
            var optDiscountCommodityReasonDatas = [
                {reason: '促销活动'},
                {reason: '庆典活动'},
                {reason: '老顾客优惠'},
                {reason: '新品上市优惠'},
                {reason: '消费满额优惠'},
                {reason: '清库存'}
            ];
            showOptCommodityReasonView('折扣原因', optDiscountCommodityReasonDatas, function(){
                var optCommInput = Ext.getCmp('opt-commodity-reason-input');
                if(!$.trim(optCommInput.getValue())){
                    showAlert('提示', '请输入折扣原因');
                    return;
                }
                Ext.getCmp('optCommodityReasonView').destroy();
                showDetailDiscountView();
                record.set('optReason', optCommInput.getValue());
                Ext.getCmp('allDiscountView').loadData(record);
            });
        }else {
            showDetailDiscountView();
            Ext.getCmp('allDiscountView').loadData(record);
        }
	}).catch(function() {});
	/*if(!checkDiscountPermission()) return;

	showDiscountView();
	Ext.getCmp('allDiscountView').loadData(record);*/
}

var curPage = 0;
// var divNum = 7;
// 客户屏上下页操作
/*function showPageUpContent() {
	if (monitors == 2) {
		//var store = Ext.getCmp('buyCarGridPanel').getStore();  // 客显查询
		var store = getPageStore();
		var totalCount = store.getAllCount();
		if (totalCount == '0') {
			return;
		}

		var doubleScreenShowData = [];
		var part = parseInt(totalCount / divNum);
		var mod = totalCount % divNum;
		var k = 0;
		if (curPage - 1 > 0) {
			curPage = curPage - 1;

			for (var i = 0; i < divNum; i++) {

				var record = store.getAt(curPage * divNum + i);

				doubleScreenShowData[k] = {};
				doubleScreenShowData[k].commodityName = record.get('commodityName');
				doubleScreenShowData[k].commodityNum = record.get('sellNum');
				doubleScreenShowData[k].commodityPrice = record.get('sellPrice');
				doubleScreenShowData[k].commodityAmount = record.get('sellAmount');
				k++;
			}
		} else if (curPage - 1 == 0) {
			curPage = 0;
			//var k = 0;
			for (var i = 0; i < divNum; i++) {

				var record = store.getAt(i);

				doubleScreenShowData[k] = {};
				doubleScreenShowData[k].commodityName = record.get('commodityName');
				doubleScreenShowData[k].commodityNum = record.get('sellNum');
				doubleScreenShowData[k].commodityPrice = record.get('sellPrice');
				doubleScreenShowData[k].commodityAmount = record.get('sellAmount');
				k++;
			}
		} else {//curPage - 1 < 0

			if (mod > 0) {
				curPage = part;
			} else {
				curPage = 0;
			}

			var total = (mod > 0) ? mod : divNum;

			for (var i = 0; i < total; i++) {

				var record = store.getAt(curPage * divNum + i);

				doubleScreenShowData[k] = {};
				doubleScreenShowData[k].commodityName = record.get('commodityName');
				doubleScreenShowData[k].commodityNum = record.get('sellNum');
				doubleScreenShowData[k].commodityPrice = record.get('sellPrice');
				doubleScreenShowData[k].commodityAmount = record.get('sellAmount');
				k++;
			}
		}
		//sendMsg2ClrCDCommodityList();
		sendMsg2SetCommodityList(doubleScreenShowData);
		var totalPage = (mod > 0) ? (part + 1) : part;
		sendMsg2SetPageNum(curPage + 1, totalPage);
	}
}*/

/*function showPageDownContent() {
	if (monitors == 2) {
		//var store = Ext.getCmp('buyCarGridPanel').getStore();  // 客显查询
		var store = getPageStore();
		var totalCount = store.getAllCount();
		if (totalCount == '0') {
			return;
		}
		var part = parseInt(totalCount / divNum);
		var mod = totalCount % divNum;

		var doubleScreenShowData = [];
		var k = 0;
		if (curPage + 1 < part) {

			curPage = curPage + 1;

			for (var i = 0; i < divNum; i++) {
				//cout << array[curPage*divNum+i] << endl;
				var record = store.getAt(curPage * divNum + i);

				doubleScreenShowData[k] = {};
				doubleScreenShowData[k].commodityName = record.get('commodityName');
				doubleScreenShowData[k].commodityNum = record.get('sellNum');
				doubleScreenShowData[k].commodityPrice = record.get('sellPrice');
				doubleScreenShowData[k].commodityAmount = record.get('sellAmount');
				k++;
			}
		} else if (curPage + 1 == part) {

			if (mod > 0) {
				curPage = part;
			} else {
				curPage = 0;
			}

			var total = (curPage == 0) ? divNum : mod;
			if (total == '0') {
				return;
			}

			for (var i = 0; i < total; i++) {

				var record = store.getAt(curPage * divNum + i);

				doubleScreenShowData[k] = {};
				doubleScreenShowData[k].commodityName = record.get('commodityName');
				doubleScreenShowData[k].commodityNum = record.get('sellNum');
				doubleScreenShowData[k].commodityPrice = record.get('sellPrice');
				doubleScreenShowData[k].commodityAmount = record.get('sellAmount');
				k++;
			}

		} else {//curPage+1 > part when mod > 0

			curPage = 0;

			for (var i = 0; i < divNum; i++) {
				//cout << array[i] << endl;
				var record = store.getAt(curPage * divNum + i);
				if (!record) {
					continue;
				}

				doubleScreenShowData[k] = {};
				doubleScreenShowData[k].commodityName = record.get('commodityName');
				doubleScreenShowData[k].commodityNum = record.get('sellNum');
				doubleScreenShowData[k].commodityPrice = record.get('sellPrice');
				doubleScreenShowData[k].commodityAmount = record.get('sellAmount');
				k++;
			}

		}

		//sendMsg2ClrCDCommodityList();
		sendMsg2SetCommodityList(doubleScreenShowData);
		var totalPage = (mod > 0) ? (part + 1) : part;
		sendMsg2SetPageNum(curPage + 1, totalPage);
	}

}
*/
function setMinisize() {
	if (window.setWindowMinisize) {
		//setWindowMinisize('爱宝美食云');
		setWindowMinisize(getDocumentTitle());
	}

    if(isAndroidSys()) {
        Keyboard && Keyboard.goHome();
    }
}

/**
 *@收银台首页
 *@Author: lijy
 *@Date: 2015-03-01
 */
Ext.define('Seller.view.shouyin.Main', {
	extend : 'Ext.Container',
	alias : 'widget.shouyinmain',
	requires : ['Ext.ux.BuyCarRemarkEditor', 'Seller.view.shoukuan.ShouKuan', 'Seller.view.discount.Discount', 'Seller.view.shouyin.SelectCommodity', 'Seller.view.putup.PutupQueryAfter', 'Seller.view.putup.PutupQueryTake', 'Seller.view.putup.Edit', 'Seller.view.putup.EditTake', 'Seller.view.handover.Main', 'Seller.view.setting.Setting', 'Seller.view.customer.Add', 'Seller.view.customer.Recharge', 'Seller.view.sell.Main', 'Seller.view.customer.Query', 'Seller.view.shouyin.Lock','Seller.view.shouyin.CallNumber', 'Seller.view.shouyin.Peeling', 'Seller.view.order.Main', 'Seller.view.commodity.CustomCommodity', 'Seller.view.shouyin.Soldout', 'Seller.view.place.PlaceView', 'Seller.view.shouyin.Message','Seller.view.print.PrintTaskFailListview', 'Seller.view.takeout.meituanMain','Seller.view.shoukuan.EraseZero','Seller.view.shouyin.CommodityNum','Seller.view.shouyin.DelCommodityNum', 'Seller.view.shouyin.OptCommodityReason','Seller.view.shouyin.CommodityNorms','Seller.view.shoukuan.ScanQrcodePay','Seller.view.shouyin.CommodityPrice',"Seller.view.shouyin.SelectPlaceView","Ext.ux.CbItem","Ext.ux.CbView","Seller.view.commodity.CommodityKtPrinter",'Seller.view.discount.detailDiscount',"Seller.view.print.ReprintTaskListView", 'Seller.view.shouyin.OptPrintSetting', 'Seller.view.shouyin.FixDataView','Seller.view.shouyin.FixDataManualView', 'Seller.view.order.AbnormalOrder'],
	totalAmount : 0,
	sellAmount : 0,
	roundAmount :0,
	commodityNum : 0,
	discount : 100,
	sellInfo : null,
	personNum : 0,
	menu : null, //弹出 菜单
	shouhanMode : '0', //模式：0收银,1外卖,2退货,3开台,4微信订单,5沽清
	selectCustomerInfo : null,
	doubleScreenShowData : null,
	shoppingPage : new $.PageUtil({
		limitCount : 7
	}),
	shoppingStore : Ext.create('Ext.data.Store', {
		model : 'Seller.model.SellDetail'
	}),
	isGetInStore : false,
	config : {
		id : 'shouyinMainView',
		centered : true,
		modal : true,
		height : '100%',
		width : '100%',
		cls : 'sy-bg',
		layout : 'vbox',
		items : [{
			xtype : 'maintopheaderold'
		}, {
			flex:1,
			xtype : 'container',
			layout : {
				type : 'hbox'
			},
			items : [{
				xtype : 'panel',
				id : 'buyCarListParent',
				layout : {
					type : 'vbox'
				},
				width : 427,
				margin : '0 0 0 0',
				items : [{
					flex : 1,
					xtype : 'container',
					layout : {
						type : 'hbox'
					},
					items : [{
						xtype : 'mainleftnav'
					}, {
						xtype : 'panel',
						id : 'buyCarList',
						layout : {
							type : 'vbox'
						},
						flex : 1,
						margin : '0 0 0 -10',
						items : [{
							xtype : 'container',
							width : 366,
							cls : 'sy-sy-img-main'
						}, {
							xtype : 'container',
							flex : 1,
							cls : 'sy-sy-img-bg',
							layout : 'vbox',
							items : [{
								xtype : 'container',
								cls : 'sy-sy-img-2'
							}, {
								xtype : 'container',
								height : 60,
								width : '100%',
								margin : '0 0 0 0',
								html : '<div class="sy-car-toolbar">' +
								'<div class="sy-car-lbutton jz-center" onclick="statusButtonClick(\'7\')">' +
									'<img src="resources/icon/public/huiyuan2.png" />' +
								'</div>' +
								'<div>' +
									'<span id="sy-car-toolbar-title" class="title text-overflow" ></span>' +
									'<div id="sy-sellercustomer" class="text-overflow" style="display:inline-block;"></div>' +
									'<div class="sy-car-rbutton" onclick="statusButtonClick(\'9\')" id="sy-print-message">' +
										'<img src="resources/icon/public/message.png" id="message-img" />' +
										'<span class="msdiv ordernum" id="messageDiv">0</span>' +
									'</div>' +
									'<div class="sy-car-rbutton ptask" onclick="statusButtonClick(\'10\')" id="sy-ptask-message">' +
										'<img src="resources/icon/public/print-task.png" id="printTask-message-img" />' +
										'<span class="ptdiv ordernum" id="printTask-messageDiv">0</span>' +
									'</div>' +
									'<div class="sy-car-nbutton" style="margin-right:20px;">' +
										'<img src="resources/icon/public/wifi_green.png" id="network-img" />' +
									'</div>' +
								'</div></div>'
							}, {
								xtype : 'container',
								layout : 'vbox',
								flex : 1,
								style : 'margin-left:2px;z-index:9;',
								items : [{
									xtype : 'container',
									height : 36,
									width : 350,
									cls : 'solid-border-top dashed-border-bottom',
									style : 'color:black;',
									html : '<div class="sy-commodity-header" ><div class="name">&nbsp;&nbsp;品名</div><div class="num">数量</div><div class="price">价格</div><div class="sellAmount">小计</div></div>'
								}, {
									xtype : 'list',
									id : 'buyCarGridPanel',
                                    draggable : false,
									style : 'background:transparent;',
									flex : 1,
									width : 350,
                                    scrollable : false,
									margin : '0 0 0 0',
									store : Ext.create("Ext.data.Store", {
										model : "Seller.model.SellDetail",
										autoLoad : false,
										listeners : {
											addrecords : function(listStore, listRecords, eOpts) {
												return;
												if(!listRecords) return;
												var rlen = listRecords.length;
												var pageStore = getPageStore();
												var me = Ext.getCmp('shouyinMainView');
												if(me.isGetInStore) return;
												var cartPage = me.shoppingPage;
												for(var ri=0; ri<rlen; ri++) {
													pageStore.add(listRecords[ri]);
												}
												var tmpCount = pageStore.getCount();
												var sTotalPage = cartPage.getTotalPage();
												var tmpLimitCount = cartPage.getLimitCount();
												var tmpTotalPage = parseInt(tmpCount / tmpLimitCount);
												tmpTotalPage = (tmpCount%tmpLimitCount) > 0 ? tmpTotalPage+1 : tmpTotalPage;
												//cartPage.countPage(tmpCount);
												if(tmpTotalPage > sTotalPage || cartPage.getCurrPage() != sTotalPage) {
													cartPage.setTotalPage(tmpTotalPage);
													me.lastShoppingCommodity();
													curPage++;
												}

												Ext.getCmp('buyCarOptBtn').hide();
											},
											updaterecord : function(listStore, record, newIndex, oldIndex, modifiedFieldNames, modifiedValues, eOpts) {
												//console.log(modifiedFieldNames);
												return;
												var rKey = modifiedFieldNames;
												//if(modifiedValues.hasOwnProperty(rKey)) {
													var pageStore = getPageStore();
													var pageRecord = pageStore.findRecord('id', record.get('id'));
													//pageRecord.set(rKey, modifiedValues[rKey]);
													if(record == pageRecord) {
													} else {
														if(record.get(rKey)) {
															pageRecord.set(rKey, record.get(rKey));
														}
													}
												//}
											},
											removerecords : function(listStore, listRecords, indices, eOpts) {
												return;
												if(!indices) return;
												var ilen = indices.length;
												var pageStore = getPageStore();
												var me = Ext.getCmp('shouyinMainView');
												for(var i=0; i<ilen; i++) {
													pageStore.remove(pageStore.findRecord('id', listRecords[i].get('id')));
													//pageStore.remove(listRecords[i]);
												}
												var count = pageStore.getCount();
												me.shoppingPage.countPage(count);
												me.reSetShoppingPage();
											},
											clear : function(listStore, eOpts) {
												refreshAdsDoubleScreen();
											}
										}
									}),
									selectedCls : 'checkedbg-main',
									itemTpl : new Ext.XTemplate('<div class="sy-cart-commodity-list dashed-border-bottom" style="font-size:16px !important;"><div class="name text-overflow " onclick="syCommodityClick(1,\'{commodityId}\')"><div class="commodityinfo"><div class="text-overflow commodityname" title="{commodityName}"><tpl if="isAlreadyOrder==\'1\'"><span class="alreadyOrderMark"></span></tpl>{commodityName}</div><div class="commodityextra"><tpl if="isSpecialPrice==\'1\'"><div class="special"></div></tpl><tpl if="isPresented==\'1\'"><div class="presented"></div></tpl></div></div><div class="remark text-overflow">{remark}</div></div><div class="num jz-center" onclick="syCommodityClick(1,\'{commodityId}\')">{sellNum}</div><div class="price jz-center" onclick="syCommodityClick(1,\'{commodityId}\')">{sellPrice}</div><div class="sellAmount jz-center">{sellAmount}</div><div class="type{type}"></div><div class="unit jz-center"><div style="width:100%;height:100%;font-size:16px;text-align:center;line-height:30px;">{unit}</div></div><tpl if="isDelete==1"><div class="delete-throught-line"></div></tpl></div>'),
									isAfterrendered : false, //添加一个变量，用于检测afterrender是否已经发生
									listeners : {
										itemtap : function(list, index, target, record, e, eOpts) {
											/*showCustomerDisplay(0x31, parseFloat(record.get('sellPrice')).toFixed(2));
											showBuyCarOpt(e.pageY-60);*/
										},
										itemtouchmove : function(list, index, target, record, e, eOpts) {
											// Ext.getCmp('buyCarOptBtn').hide();
										}
									}
								}, {
									xtype : 'container',
									height : 84,
									//width : 300,
									//width : 350,
									hidden : true,
									id : 'buyCarOptBtn',
									margin : '0 0 0 8',
									modal : false,
									hideOnMaskTap : true,
									top : 45,
									layout : 'vbox',
									items: [{
										xtype: 'container',
										height: 10,
										cls: 'sy-opt-triangleimg'
									}, {
										xtype: 'container',
										height: 40,
										defaults: {
											xtype: 'button',
											cls: 'sy-opt-button jz-center',
											height: '100%',
											labelCls: 'main-cart-small-font',
											pressedCls: 'sy-opt-button-pressed',
											width: 82,
										},
										layout: {
											type: 'hbox',
											align: 'center',
											pack: 'center'
										},
										items: [{
											//width : 55,
											//width : 49,
											text: '删除',
											id: 'sy-opt-delete',
											//handler : syOptionButton,
											margin: '0 0 0 0'
										}, {
											//width : 55,
											//width : 49,
											text: '-',
											id: 'sy-opt-sub',
											//handler : syOptionButton,
											margin: '0 0 0 2'
										}, {
											//width : 55,
											//width : 49,
											text: '+',
											id: 'sy-opt-add',
											//handler : syOptionButton,
											margin: '0 0 0 2'
										}, {
											//width : 49,
											text: '数量',
											id: 'sy-opt-number',
											//handler : syOptionButton,
											margin: '0 0 0 2'
										}, ]
									}, {
										xtype: 'container',
										height: 40,
										margin: '2 0',
										defaults: {
											xtype: 'button',
											cls: 'sy-opt-button jz-center',
											height: '100%',
											labelCls: 'main-cart-small-font',
											pressedCls: 'sy-opt-button-pressed',
											width: 82,
										},
										layout: {
											type: 'hbox',
											align: 'center',
											//pack: 'center'
										},
										items: [{
											//flex : 55,
											//width : 49,
											text: '口味',
											id: 'sy-opt-remark',
											//handler : syOptionButton,
											margin: '0 0 0 0'
										}, {
											//width : 55,
											//width : 49,
											text: '折扣',
											id: 'sy-opt-discount',
											//handler : syOptionButton,
											margin: '0 0 0 2'
										}, {
											//width : 49,
											text: '赠送',
											id: 'sy-opt-present',
											//handler : syOptionButton
											margin: '0 0 0 2'
										}, {
											//width : 49,
											text: "改价",
											id: "sy-opt-chg-price",
											margin: '0 0 0 2'
										}]
									}],
									listeners: {
										// 实现点击购物车菜单外任何地方关闭菜单。
										show: function(currView, eOpts) {
											hideOnTapOutside(currView, null, 'hide');
										}
									}
								}, {
									xtype : 'container',
									layout : 'hbox',
									height : 20,
									margin : '0 0 20 0',
									width : 350,
									style : 'color:#000;',
									items : [{
										xtype : 'button',
										text :'上一页',
										margin : '0 0 0 0',
										height : 30,
										width : 70,
										// disabled : true,
                                        style:'background:transparent;border:0;box-shadow:none;text-align:left;',
                                        disabledCls : 'disabled-color',
										id : "buyCartLeftPage",
										// style :'',
                                        handler : function(){
                                            //Ext.getCmp('shouyinMainView').downShoppingCommodity();
                                        }
									}, {
										xtype : 'panel',
										flex : 1,
										cls : 'jz-center',
										id : 'shoppingPanelId',
										html : '1/1'
									}, {
										xtype : 'button',
										text : '下一页',
										margin : '0 0 0 0',
										height : 30,
										width : 70,
                                        style:'background:transparent;border:0;box-shadow:none;text-align:left;',
										disabled : true,
										disabledCls : 'disabled-color',
										id : "buyCartRightPage",
                                        handler : function(){
                                            //Ext.getCmp('shouyinMainView').upShoppingCommodity();
                                        }
									}]
								}]
							}],
							listeners : {
								painted : function() {
									if (!buyCartDragListener) {
                                        buyCartDragListener = true;
                                        var x1, x2, y1, y2, x, y;
                                        $('#buyCarGridPanel').mousedown(function () {
                                            x1 = window.event.clientX;
                                            y1 = window.event.clientY;
                                        });
                                        $('#buyCarGridPanel').mouseup(function () {
                                            x2 = window.event.clientX;
                                            y2 = window.event.clientY;
                                            x = x2 - x1;
                                            y = y2 - y1;
                                            if (Math.abs(x) > 1.414 * Math.abs(y) && Math.abs(x) > 120) {
                                                if (x < 0 && !Ext.getCmp('buyCartRightPage').isDisabled()) {
                                                    Ext.getCmp('shouyinMainView').upShoppingCommodity();
                                                    return;
                                                } else if (x > 0 && !Ext.getCmp('buyCartLeftPage').isDisabled()) {
                                                    Ext.getCmp('shouyinMainView').downShoppingCommodity();
                                                    return;
                                                }
                                                // alert('滑动成功!\n' + 'x=' + x + '\ny=' + y);
                                                return;
                                            }
                                        });
                                    }
                                }
							}
						}, {
							xtype : 'container',
							height : 35,
							width : '100%',
							layout : 'hbox',
							style : 'vertical-align:bottom;',
							items : [{
								xtype : 'button',
								text: '临时菜',
								width : '20%',
								height : 30,
								id : 'TemporaryTom',
								cls:'jz-center sy-tm-button',
								margin : '5 0 5 2',
                                handler : function(){
                                    //statusButtonClick('11');
								}
							}, {
								xtype : 'ebutton',
								text : '100%',
								width : '20%',
                                height : 30,
                                cls:'jz-center sy-tm-button',
								id :'showyin_discount',
								style : 'padding:0;',
								margin : '5 0 5 5',
								permissionName: "SELLDISCOUNT",
                                handler : function(){
                                    //showDiscountPanel();
                                }
							}, {
								xtype: 'ebutton',
								text: '叫号',
								width: '20%',
								height: 30,
								cls: 'jz-center sy-tm-button',
								id: 'shouyin-call-number',
								hidden: false,
								margin: '5 0 5 5',
								handler: function() {
									// showCallNumberView();
								}
							}, {
								xtype : 'spacer'
							}, {
								xtype : 'container',
								cls : 'jz-center',
								html : '<div class="" style="text-align:right;line-height:35px;height:35px;padding-right:2px;font-size:24px;color:#F6A623;float:right;" id="showyin_commodityNum">0</div><div class="" style="height:35px;line-height:38px;margin-right:12px;font-size:18px;color:#F6A623;float:right;">总数</div>'
							}]
						}, {
							xtype : 'container',
							height : 40,
							width : '100%',
							html : '<div class="jz-center" style="padding-left:10px;float:left;height:45px;">总金额</div><div style="font-size:30px;color:#ffbb02;float:right;padding-right:10px;" id="showyin_totalamount0">￥0.00</div>'
						}, {
							xtype : 'container',
							width : '100%',
							//height : 70,
							height : 64,
							margin : '3 0',
							padding : '0 6',
							defaults : {
								flex : 1,
								xtype : 'button'
							},
							layout : 'hbox',
							items : [{
								text : '取单(F1)',
								margin : '0 6 0 0',
								id : 'clearOrTakeBtn',
								height : 64,
								cls : 'sy-sellinfo-button',
								pressedCls : 'sy-sellinfo-button-pressed',
								handler : function() {
									//statusButtonClick('1');
								}
							}, {
								//text : '下单(F2)',
								text : '选桌下单(F2)',
								//height : 40,
								margin : '0 0 0 6',
								//cls : 'sy-tm-button',
								height : 64,
								cls : 'sy-sellinfo-button',
								pressedCls : 'sy-sellinfo-button-pressed',
								id : 'putup-btn',
								disabled : false,
								handler : function() {
									//statusButtonClick('2');
								},
								listeners : {
									/*show : function(curView, eOpts) {
										Ext.getCmp('clearOrTakeBtn').setMargin('0 6 0 0');
									},
									hide : function(curView, eOpts) {
										Ext.getCmp('clearOrTakeBtn').setMargin('');
									}*/
								}
							}, {
								text : '速结',
								margin : '0 0 0 6',
								//cls : 'sy-tm-button',
								height : 64,
								cls : 'sy-sellinfo-button',
								pressedCls : 'sy-sellinfo-button-pressed',
								id : 'convenient-showyin-amount',
								disabled : false,
								hidden: true,
								handler : function() {

								}
							}]
						}, {
							xtype : 'container',
							width : '100%',
							//height : 70,
							height : 64,
							margin : '3 0',
							padding : '0 6',
							layout : 'hbox',
							defaults : {
								flex : 1
							},
							items : [{
								height : 64,
								xtype : 'button',
								//cls : 'red-button',
								margin : '0 6 0 0',
								cls : 'sy-sellinfo-button2',
								pressedCls : 'sy-sellinfo-button2-pressed',
								id : 'print-pre-shouyin-amount',
								hidden : true,
								text : '预结单',
								handler : function() {
									//dealMainPreShouyin();
								}
							}, {
								height : 64,
								xtype : 'button',
								//cls : 'red-button',
								//margin : '0 3 0 6',
								cls : 'sy-sellinfo-button2',
								pressedCls : 'sy-sellinfo-button2-pressed',
								id : 'showyin-amount-name',
								disabled : false,
								//text : '马上结算',
								text : '收款',
								handler : function() {
									//showShoukuanView();
								}
							}]
						}]
					}]
				}]
			}, {
				xtype : 'container',
				flex : 3,
				margin : '5 0 0 0',
				layout : {
					type : 'vbox'
				},
				items : [{
					xtype : 'mainheader'
				}, {
					xtype : 'container',
					margin : '0 0 0 0',
					cls : 'sy-header-border',
					layout : 'hbox',
					width : '100%',
					hidden : true,
					defaults : {
						//height : 80,
						height : 84,
						//margin : '0 0 0 26',
						margin : '0 0 0 16',
						xtype : 'container',
						flex : 1
					},
					items : [{
						hidden : true,
						html : '<div class="sy-header-button2 jz-center"><div class="sy-header-logo"></div></div>'
					}, {
                        html : '<div class="sy-header-button-size jz-center" onclick="menuItemClick(3)"><div class="sy-right-header-suoping"></div></div>'
					}, {
						html : '<div class="sy-header-button-size jz-center" onclick="setMinisize()"><div class="sy-right-header-zhuomian"></div></div>'
					}, {
						html : '<div class="sy-header-button-size jz-center" onclick="menuItemClick(5)"><div class="sy-right-header-huiyuan"></div></div>'
					}, {
						html : '<div class="sy-header-button-size jz-center" onclick="menuItemClick(6)"><div class="sy-right-header-qianxiang"></div></div>'
					}, {
						html : '<div class="sy-header-button-size jz-center" onclick="menuItemClick(1)"><div class="sy-right-header-button-size sy-right-header-jiaojie"></div></div>'
					}, {
						html : '<div class="sy-header-button-size jz-center" onclick="menuItemClick(4)"><div class="sy-right-header-button-size sy-right-header-danju"></div></div>'
					}, {
						html : '<div class="sy-header-button-size jz-center" onclick="menuItemClick(2)"><div class="sy-right-header-pingtai"></div></div>'
					}, {
						html : '<div class="sy-header-button-size jz-center" onclick="menuItemClick(9)"><div class="sy-right-header-shezhi"></div></div>'
					}, {
						html : '<div class="sy-header-button-size jz-center" onclick="menuItemClick(8)"><div class="sy-right-header-tongbu"></div></div>'
					}, {
						html : '<div class="sy-header-button-size jz-center" onclick="menuItemClick(10)"><div class="sy-right-header-guanbi"></div></div>'
					}, {
						xtype : 'spacer'
					},  {
						margin : '0 0 0 0',
						html : '<div class="skin-btn" onclick="menuItemClick(11)"><img style="width:30px;margin-left:15px;" class="sy-skin-img" src="resources/icon/public/skin.png"></div><div class="skin-btn jz-center" onclick="menuItemClick(12)"><img class="sy-app-download" src="resources/icon/public/app-download.png" /></div>'
					}]
				}, {
					xtype : 'selectcommodity',
					data : {
						parentContainerId : 'shouyinMainView'
					},
					flex : 1
				}, {
					xtype : 'placeview',
					hidden : true,
					//height : clientHeight - 120,
					data : {
						parentContainerId : 'shouyinMainView'
					},
					flex : 1
				}]
			}]
		}]
	},
	initialize : function(panel, eOpts) {
		var me = this;
		var heght = document.body.clientHeight;
		setTimeout(function() {
			me.setTitle();
			if (setting.defaultMode) {
				//var obj = $(".sy-left-button[index="+setting.defaultMode+"]")[0];
				//syLeftButtonClick(obj, setting.defaultMode);
			}

			if (setting.ticketPrinter || setting.tagPrinter || setting.kitchenPrinter) {
				if (setting.ticketPrinter) {
					$("#sy-print-status1").css("display", "block");
				}
				if (setting.tagPrinter) {
					$("#sy-print-status2").css("display", "block");
				}
				if (setting.kitchenPrinter) {
					$("#sy-print-status3").css("display", "block");
				}
			} else {
				//$("#sy-print-setting").css("display", "block");
			}
			$("#masterSlaveTxt").text(isConfigSlave()?"副机":"主机");
			//checkPrintStatus();

			Ext.getCmp('buyCarOptBtn').element.on({
				tap : function(e) {
					isBuyCarOptClick = true;
				}
			});

			Ext.getCmp('shouyinMainView').element.on({
				tap : function(e) {
					if (isBuyCarOptClick == false) {
						Ext.getCmp('buyCarOptBtn').hide();
					}
					isBuyCarOptClick = false;
				}
			});
            refreshleftNavIpLabel();
			//初始化顾客显示页面
			if (monitors == 2) {
				sendMsg2SetShopInfo(seller.ename, seller.phone);
			}
		}, 200);
		if(sySetting.mode === SYS_TYPE.FD){//收银模式隐藏下单
			Ext.getCmp('putup-btn').hide();
			Ext.getCmp('convenient-showyin-amount').show();
		}
		if (isConfigSlaveSelfService() && !isShowMainHeader()) {
			Ext.getCmp('main-header-id').setHidden(true);
		}
        if (isSingleStation()) {
            setTimeout(function(){
                $('#sy-print-message').hide();
            }, 20);
        }
        //副机自助收银
        if (isConfigSlaveSelfService()) {
            Ext.getCmp('showyin_discount').setHidden(true);
            Ext.getCmp('sy-opt-discount').setHidden(true);
            Ext.getCmp('sy-opt-present').setHidden(true);
            Ext.getCmp('sy-opt-chg-price').setHidden(true);
        }
		//搜索宝贝框自动获取焦点
		/*var $viewportBody;
		var initMaskZIndex = 1;
		var $search;
		if(!isAndroid()) { /!* 只有非安卓才需要焦点 *!/
            setInterval(function () {
                if (!$viewportBody || !$search) {
                    $viewportBody = $('#ext-viewport').children('.x-body');
                    $search = $('#search');
                }
                var isSearchInputFocus = true;
                $viewportBody.children().each(function () {
                    var $this = $(this);
                    if ($this.css('display') != 'none' && $this.css('zIndex') != 'auto') {
                        if ($this.hasClass('x-mask')) {
                            if (!initMaskZIndex) {
                                initMaskZIndex = $this.css('zIndex');
                            }
                            ;
                            if ($this.css('zIndex') > initMaskZIndex) {
                                isSearchInputFocus = false;
                                return false;//结束循环
                            }
                        }
                    }
                });
                if (isSearchInputFocus) {
                    $search.find('input').focus();
                } else {
                    $search.find('input').blur();
                }
            }, 1000 * 3);
        }*/
		me.resetShoppingPage();
	},
	setShoppingPageSize : function() {
		var me = this;
		var count = 6;
		//if(getScreenDimensions() === SCREEN_H.BIGGER) count=12;
		//else if(getScreenDimensions() === SCREEN_H.BIG) count=10;
		//else if(getScreenDimensions() === SCREEN_H.MID) count=8;
		// resolve 2
		var gridPanelCmp = Ext.getCmp("buyCarGridPanel");
		if(gridPanelCmp) {
			var gridPanelItemHeight = 56;
			//getHtmlElementHeight("#buyCarGridPanel .sy-cart-commodity-list");//gridPanelCmp.getItemHeight();
			if(gridPanelItemHeight > 0)
				count = calcListMaxContainNumEle({id:"buyCarGridPanel", itemHeight:gridPanelItemHeight, defaultVal : count});
		}
		me.shoppingPage = new $.PageUtil({limitCount : count});
	},
	resetShoppingPage : function() {
		var me = this;
		me.shoppingPage.reset();
		me.setShoppingPageSize();
		me.shoppingPage.setTotalPage(1);
		me.shoppingStore.removeAll();
		me.refreshShoppingPage();
	},
	refreshShoppingPage : function() {
		var me = this;
		var totalPage = me.shoppingPage.getTotalPage();
		var curPage = me.shoppingPage.getCurrPage();
		var shoppingTag = $('#shoppingPanelId');
		if(shoppingTag && shoppingTag[0]) shoppingTag[0].innerHTML = curPage + '/' + totalPage;
		me.upDownBtnStatus();
	},
	reSetShoppingPage : function() {
		var me = this;
		var totalPage = me.shoppingPage.getTotalPage();
		var _curPage = me.shoppingPage.getCurrPage();
		if(_curPage > totalPage) {
			Ext.getCmp('buyCarOptBtn').hide();
			_curPage = totalPage;
			me.shoppingPage.setCurrPage(_curPage);
			curPage--;
		}

		var startPage = me.shoppingPage.getOffset()*me.shoppingPage.getLimitCount();
		var endPage = startPage + me.shoppingPage.getLimitCount();
		me.showShoppingPageContent(startPage, endPage);
		me.refreshShoppingPage();
	},
	showShoppingPageContent : function(startPage, endPage) {
		var me = this;
		var carStore = Ext.getCmp('buyCarGridPanel').getStore();  // 查询store页内容
		carStore.removeAll();
		me.isGetInStore = true;
		for(;startPage < endPage; startPage++) {
			var record = me.shoppingStore.getAt(startPage);
			if(record) carStore.add(record);
		}
		me.isGetInStore = false;
	},
	lastShoppingCommodity : function() {
		var me = this;
		var totalPage = me.shoppingPage.getTotalPage();
		var curPage = me.shoppingPage.getCurrPage();
		var shoppingStore = me.shoppingStore;
		if(curPage >= totalPage) return;
		me.shoppingPage.setCurrPage(totalPage);
		var count = shoppingStore.getCount();
		var limitCount = me.shoppingPage.getLimitCount();
		var startPage = me.shoppingPage.getOffset() * limitCount;
		var endPage = startPage + limitCount;
		endPage = endPage > count ? count : endPage;
		//console.log('up : ' + startPage + '...' + endPage);
		var carStore = Ext.getCmp('buyCarGridPanel').getStore();  // 查询store页内容
		carStore.removeAll();
		me.isGetInStore = true;
		for(;startPage < endPage; startPage++) {
			var record = shoppingStore.getAt(startPage);
			if(record) {
				//console.log(startPage);
				carStore.add(record);
			}
		}
		me.isGetInStore = false;
		me.refreshShoppingPage();
	},
	upShoppingCommodity2 : function() {  // increment
		var me = this;
		var totalPage = me.shoppingPage.getTotalPage();
		var curPage = me.shoppingPage.getCurrPage();
		var shoppingStore = me.shoppingStore;
		if(curPage >= totalPage) return;
		me.shoppingPage.up();
		var count = shoppingStore.getCount();
		var limitCount = me.shoppingPage.getLimitCount();
		var startPage = me.shoppingPage.getOffset() * limitCount;
		var endPage = startPage + limitCount;
		endPage = endPage > count ? count : endPage;
		//console.log('up : ' + startPage + '...' + endPage);
		var carStore = Ext.getCmp('buyCarGridPanel').getStore();
		carStore.removeAll();
		me.isGetInStore = true;
		for(;startPage < endPage; startPage++) {
			var record = shoppingStore.getAt(startPage);
			if(record) {
				//console.log(startPage);
				carStore.add(record);
			}
		}
		me.isGetInStore = false;
		me.refreshShoppingPage();
	},
	upDownBtnStatus : function() {
		/* 上下页按钮 */
		var me = this;
		if(me.shoppingPage.getCurrPage() <= 1) {
			Ext.getCmp('buyCartLeftPage').setDisabled(true);
		} else {
			Ext.getCmp('buyCartLeftPage').setDisabled(false);
		}
		if(me.shoppingPage.getTotalPage() > me.shoppingPage.getCurrPage()) {
			Ext.getCmp('buyCartRightPage').setDisabled(false);
		} else
			Ext.getCmp('buyCartRightPage').setDisabled(true);
	},
	downShoppingCommodity : function() {
		//上一页
		var me = this;
		var operator = function(startPage, endPage) {
			var shoppingStore = me.shoppingStore;
			var carStore = Ext.getCmp('buyCarGridPanel').getStore();
			carStore.removeAll(true);
			me.isGetInStore = true;
			for(; startPage < endPage; startPage++) {
				var record = shoppingStore.getAt(startPage);
				if(record) {
					//console.log(startPage);
					carStore.add(record);
				}
			}
			me.isGetInStore = false;
			me.refreshShoppingPage();
			// showPageUpContent(); // 上一页操作同步副屏数据
			refreshDoubleScreen(); // 同步副屏数据
		};
		downThingPage(me.shoppingPage, operator);
	},
    upShoppingCommodity : function() {
        //下一页
        var me = this;
        var operator = function(startPage, endPage) {
            var shoppingStore = me.shoppingStore;
            var count = shoppingStore.getCount();
            endPage = endPage > count ? count : endPage;
            var carStore = Ext.getCmp('buyCarGridPanel').getStore();
            carStore.removeAll(true);
            me.isGetInStore = true;
            for(;startPage < endPage; startPage++) {
                var record = shoppingStore.getAt(startPage);
                if(record) {
                    //console.log(startPage);
                    carStore.add(record);
                }
            }
            me.isGetInStore = false;
            me.refreshShoppingPage();
            // showPageDownContent();// 下一页操作同步副屏数据
            refreshDoubleScreen(); // 同步副屏数据
        };
        upThingPage(this.shoppingPage, operator);
    },
	gotoShoppingCommodity : function(position){
		// 跳到指定页
		var me = this;
		var operator = function(startPage, endPage) {
			var shoppingStore = me.shoppingStore;
			var count = shoppingStore.getCount();
			endPage = endPage > count ? count : endPage;
			var carStore = Ext.getCmp('buyCarGridPanel').getStore();
			carStore.removeAll(true);
			me.isGetInStore = true;
			for(;startPage < endPage; startPage++) {
				var record = shoppingStore.getAt(startPage);
				if(record) {
					//console.log(startPage);
					carStore.add(record);
				}
			}
			me.isGetInStore = false;
			me.refreshShoppingPage();
			// showPageDownContent();下一页操作同步副屏数据
			refreshDoubleScreen(); // 同步副屏数据
		};

		gotoThingPage(this.shoppingPage, operator, position);
	},
	upDownBtnStatus : function() {
		/* 上下页按钮 */
		var me = this;
		if(me.shoppingPage.getCurrPage() <= 1) {
			Ext.getCmp('buyCartLeftPage').setDisabled(true);
		} else {
			Ext.getCmp('buyCartLeftPage').setDisabled(false);
		}
		if(me.shoppingPage.getTotalPage() > me.shoppingPage.getCurrPage()) {
			Ext.getCmp('buyCartRightPage').setDisabled(false);
		} else
			Ext.getCmp('buyCartRightPage').setDisabled(true);
	},
	downShoppingCommodity2 : function() { // decrement
		var me = this;
		var totalPage = me.shoppingPage.getTotalPage();
		var curPage = me.shoppingPage.getCurrPage();
		var shoppingStore = me.shoppingStore;
		if(curPage <= 1) return;
		me.shoppingPage.down();
		var count = shoppingStore.getCount();
		var limitCount = me.shoppingPage.getLimitCount();
		var startPage = me.shoppingPage.getOffset() * limitCount;
		var endPage = startPage + limitCount;
		//console.log('down : ' + startPage + '...' + endPage);
		var carStore = Ext.getCmp('buyCarGridPanel').getStore();
		carStore.removeAll();
		me.isGetInStore = true;
		for(; startPage < endPage; startPage++) {
			var record = shoppingStore.getAt(startPage);
			if(record) {
				//console.log(startPage);
				carStore.add(record);
			}
		}
		me.isGetInStore = false;
		me.refreshShoppingPage();
	},
	initViewData : function() {
		var isMaster = isConfigMaster();
		if(Ext.getCmp("sy-header-pingtai")) {
			Ext.getCmp("sy-header-pingtai").setHidden(!isMaster ? true : false);
		}
		if(Ext.getCmp("sy-header-tongbu"))
			//Ext.getCmp("sy-header-tongbu").setHidden(!isMaster ? true : false);
			Ext.getCmp("sy-header-tongbu").setHidden(true);
		//Ext.getCmp("sy-header-tongbu").setHidden(!isMaster ? true : false);
		if(Ext.getCmp("sy-header-shuaxin")) {
			Ext.getCmp("sy-header-shuaxin").setHidden(isMaster ? true : false);
		}
		if(Ext.getCmp("left-button-meituan"))
			Ext.getCmp("left-button-meituan").setHidden(!isMaster ? true : false);
		if(Ext.getCmp("left-button-soldout"))
			Ext.getCmp("left-button-soldout").setHidden(!isMaster ? true : false);
	},
	loadData : function() {
		this.initViewData();
		if (task) {
			task.cancel();
			task = null;
		}
		Ext.Viewport.unmask();
		Ext.getCmp('select-commodity-view').loadData();
		this.resetData();
		//收银模式默认选中状态
		if(sySetting.mode === SYS_TYPE.HOTEL){
			var obj = $(".sy-left-button[index="+6+"]")[0];
			Ext.getCmp('sy-left-button-6').show();
			syLeftButtonClick(obj, 6);
			Ext.getCmp('shouyin-call-number').hide();
		}else if(sySetting.mode === SYS_TYPE.FD){
			var obj = $(".sy-left-button[index="+0+"]")[0];
			syLeftButtonClick(obj, 0);
			Ext.getCmp('clearOrTakeBtn').setText('清空');
			Ext.getCmp('sy-left-button-6').hide();//隐藏餐桌
			if (mealSetting.isUse == 'true' || mealSetting.isUse == true)
				Ext.getCmp('shouyin-call-number').show();
			else
				Ext.getCmp('shouyin-call-number').hide();
			if (Application.FEtype == Application.SLAVESELFSERVICE) {
				Ext.getCmp('convenient-showyin-amount').hide();
			}
		}
        // 副机自助收银
        if (Application.FEtype == Application.SLAVESELFSERVICE) {
            if ( !Ext.getDom('slave-selfservice-text') ) {
                $('#master-slave-txt-box').height(54);
                $('#masterSlaveTxt').after('<div id="slave-selfservice-text" style="text-align: center;">自助收银</div>');
                Ext.getCmp('sy-left-button-6').setHidden(true);
            }
            // 选中收银
            var obj = $(".sy-left-button[index="+0+"]")[0];
            syLeftButtonClick(obj, 0);
        }

		OrderDao.loadOrderPush(function(success, res) {
            if (success) {
                OrderDao.getOrderTotalCount('', 0, function(success, orderLength) {
                    if (success && orderLength) {
                    	var alertText = '你有 ' + orderLength + ' 条微信订单未处理！';
                    	if (res > 0) alertText += '<br>其中有 ' + res + ' 条为新订单，请注意查收！';
                        showToast(alertText);
                    }
                });
			}
            setTimeout(function() {
            	getOrderCount();
            }, 1000);
        });

		getMessageCount();
		getPrintTaskCount();
		MTOrderDao.loadOrderPush(function(success) {
			getMtOrderCount();
		});
		SettingDao.getSetting(function(success, res) {
			var me = Ext.getCmp('shouyinMainView');
			if(res && res.isShowPettyCash=="false"){
		        /**帮助快速开启MPos*/
		        setTimeout(function () {
		            //autoLoginManageSystem(shouYinEmployee.workId, shouYinEmployee.password);
		        },1);
			}else{
				var pettyCashSetting = Ext.Viewport.add(Ext.create('Seller.view.shouyin.PettyCashSetting'));
				showBy(pettyCashSetting,me,10);
				setTimeout(function() {
				   if(res&&res.defaultPettyCash){
						Ext.getCmp('pettyCashInputField').setValue(parseDigitalDecimal(res.defaultPettyCash)); // 备用金
				   }
				   Ext.getCmp('pettyCashInputField').focus();
				}, 10);
				openCashboxByPrint(function(success){

				}, function(fail){
					showAlert('提示', fail);
				}); // 启用备用金时打开钱箱
				/*setTimeout(function() {
				   console.log(document.activeElement.id);
				}, 3000);*/
			}
		});
		sendTrue(EVENT_TYPE.VBOOKERCONNECT, {});
		refreshleftNavIpLabel();
		$("#employeeName")[0].innerHTML = shouYinEmployee.workName;
        $('#sellerUserName2').text(seller.userName);
	},
	createSellInfo : function(status, data, callback) {
		var me = this;
		//SellDao.createSellInfo(status, data, function(success, msg, codeUrl, sellId) {
		var extra = getCartDetailExtra();
		data.status = status;
		combineSellInfoByView(data, getShouyinViewData());
		var middleCondition = [];  //[sellInfoSoldoutMiddle, sellInfoPlaceMiddle]
		if(Ext.getCmp('shouyinMainView').shouhanMode == 2) { // 退货模式
			//middleCondition.push(sellInfoPlaceMiddle);
		} else {
			middleCondition.push(sellInfoSoldoutMiddle);
			middleCondition.push(sellInfoPlaceMiddle);
		}
		if(!data.notDiscountAmount)
			data.notDiscountAmount = parseFloat(calcNotDiscountAmountForDetails(extra.store)).toFixed(2);
		if(!data.discountAmount) {
			data.discountAmount = parseFloat(calcDiscountAmountForDetails(extra.store)).toFixed(2);
			var discount = getDiscountValueRange(data.discount);
			var tmpDiscountAmount = parseFloat(parseFloat(data.discountAmount) * (parseFloat(discount)/100));
			data.alreadyDiscountAmount = parseFloat(parseFloat(data.discountAmount) - parseFloat(tmpDiscountAmount)).toFixed(2);
		}
		sellInfoExecutor(data, extra.store, middleCondition, function(success, msg, codeUrl, sellId) {
			callback && callback.apply(null, arguments);
		});
		/*createSellInfoByData(data, function(success, sellInfo) {
			var sellDetails = createSellDetailsByData(extra.store, sellInfo);
			dealCommoditySoldout(sellDetails, function(success, message) {
				if(success) {
					SellDao.createSellInfoByData(sellInfo, sellDetails, function (success, msg, codeUrl, sellId) {
						if (success) {
							finishCommoditySoldout && finishCommoditySoldout(function (soldoutInfo) {
								refreshCommodityViewBySoldout(soldoutInfo);
							});
						}
						callback && callback(success, msg, codeUrl, sellId);
					});
				} else {
					callback && callback(false, message);
				}
			});
		});
        SellDao.createSellInfoByCommodityInfo(status, data, function(success, msg, codeUrl, sellId) {
			if (success) {
				if (callback) {
					callback(success, msg, codeUrl, sellId);
				}
				me.finishCommoditySoldout();
			} else {
				if (callback) {
					callback(false, msg);
				}
			}
		});*/
	},
	finishCommoditySoldout : function(cmInfo) {
		cmInfo = cmInfo ? cmInfo : {};
		var commodityStore = Ext.getCmp('showyin-commodity-list').getStore();
		var commodityCount = commodityStore.getCount();
		for (var chKey in cmInfo) {
			if (cmInfo.hasOwnProperty(chKey)) {
				//console.log(chKey + ' __ ' + cmInfo[chKey]);
				for (var cmi = 0; cmi < commodityCount; cmi++) {
					var commodityRecord = commodityStore.getAt(cmi);
					if (commodityRecord.get('id') == chKey) {
						commodityRecord.set('soldoutNum', parseFloat(cmInfo[chKey]).toFixed(2));
						commodityRecord.set('remainNum', parseFloat(cmInfo[chKey]).toFixed(2));
						break;
					}
				}
				CommodityDao.updateCommodity({
					'soldoutNum' : parseFloat(cmInfo[chKey]).toFixed(2),
					syned : '0'
				}, chKey, function(success) {
					if (success)
						sendCommodityUpdate();
					console.log(arguments);
				});
			}
		}
	},
	/**
	 * 清空数据
	 */
	resetData : function() {
		var me = this;
        me.totalAmount = 0;
        me.sellAmount = 0;
		me.roundAmount = 0;
		me.allDiscountafter = 0;
        me.commodityNum = 0;
        me.discount = 100;
        me.selectCustomerInfo = null;
        me.sellInfo = null;
        me.personNum = 0;
        me.costAmount = 0;
        //me.pledgeAmount = 0;
        //me.openPlaceRemark = '';
		var store = Ext.getCmp('buyCarGridPanel').getStore();
		store.removeAll();
		me.resetShoppingPage();
		if (this.shouhanMode != 2) { /* 非退货 */
			Ext.getCmp('clearOrTakeBtn').setText('取单(F1)');
			if(this.shouhanMode == '0')
				Ext.getCmp('clearOrTakeBtn').setText('清空');
		}
		if(this.shouhanMode == 1){//外卖
			Ext.getCmp('putup-btn').setText("下单(F2)");
		}else{
			Ext.getCmp('putup-btn').setText("选桌下单(F2)");
		}
		document.getElementById('showyin_commodityNum').innerHTML = '0';
		document.getElementById('showyin_discount').innerHTML = '100%';
		document.getElementById('showyin_totalamount0').innerHTML = "￥0.00";

		if (monitors == 2) {
			curPage = 0;
			sendMsg2ClrCommodityList();
			sendMsg2SetTotalAmount("0.00");
			sendMsg2SetTotalNum(0);
			//sendMsg2SetDiscount(100);
			sendMsg2SetPageNum('1/1');
		}
		document.getElementById('sy-sellercustomer').innerHTML = '';
        me.selectPlace = null;
		setTimeout(function() {
			me.resetCommodityNum();
		}, 100);
		if(Ext.getCmp('print-pre-shouyin-amount')) {
			Ext.getCmp('print-pre-shouyin-amount').setHidden(true);
			Ext.getCmp('showyin-amount-name').setMargin('0');
		}
		this.setTitle();
	},
	countStore : function() {
		var sellAmount = 0;
		var commodityNum = 0;
		//var store = Ext.getCmp('buyCarGridPanel').getStore();
		var store = getPageStore();
		var totalCount = store.getAllCount();
		// var mod = totalCount % divNum;
		// var part = parseInt(totalCount / divNum);
		var notDiscountAmount = 0;
		var costAmount = 0;
		if(!this.sellInfo) {
			if (totalCount <= 0) {
				// if (this.shouhanMode == '0') {
					Ext.getCmp('clearOrTakeBtn').setText('取单(F1)');
				// }
				//this.discount = 100;
			}
		}
		for (var i = 0; i < totalCount; i++) {
			var record = store.getAt(i);

			sellAmount += parseFloat(record.get('sellAmount'));
			//commodityNum += parseInt(record.get('sellNum'));
			commodityNum += parseFloat(record.get('sellNum'));
			var tmpCostAmount = record.get("costAmount");
			if(isValidDigital(tmpCostAmount)) {
				costAmount = parseFloat(costAmount) + parseFloat(parseFloat(tmpCostAmount).toFixed(2));
			}

			if(record.get('isDiscount') != '1') {
				notDiscountAmount += parseFloat(record.get('sellAmount'));
			} else if(record.get('isSpecialPrice') == '1') {
				notDiscountAmount += parseFloat(record.get('sellAmount'));
			}
		}
		this.costAmount = costAmount;
		if(commodityNum == 0) this.costAmount = 0;
		this.totalAmount = sellAmount;
		this.commodityNum = parseFloat(commodityNum).toFixed(2);
		//this.sellAmount = (parseFloat(sellAmount) * parseFloat(this.discount) / 100).toFixed(2);
		this.sellAmount = ((parseFloat(sellAmount) - parseFloat(notDiscountAmount)) * parseFloat(this.discount)/100 + parseFloat(notDiscountAmount)).toFixed(2);

		if(this.totalAmount < 0){
			this.totalAmount = 0;
		}
		if(this.sellAmount < 0){
			this.sellAmount= 0;
		}

		//document.getElementById('showyin_totalamount0').innerHTML = "￥" + this.sellAmount;
		document.getElementById('showyin_totalamount0').innerHTML = "￥" + roundByUnit(this.sellAmount, roundSetting.unit);
		document.getElementById('showyin_commodityNum').innerHTML = this.commodityNum;
		document.getElementById('showyin_discount').innerHTML = parseFloat(this.discount).toFixed(2) + "%";
		// refreshOptionDoubleScreen();
		refreshDoubleScreen(); // 同步副屏数据
	},
	setButtonStatus : function(isDisabled) {
		if(Ext.getCmp('showyin-amount-name')) {
			Ext.getCmp('showyin-amount-name').setDisabled(isDisabled);
		}
		if(Ext.getCmp('putup-btn')) {
			Ext.getCmp('putup-btn').setDisabled(isDisabled);
		}
	},
	getCartDataByCommodity : function(record, normsName, normsPrice) {
		var cartData = {};  // backup commodity data
		//console.log('add a commodity to buycar');
		cartData.id = record.id;
		cartData.name = record.name + ( normsName ? ("(" + normsName + ")") : "");
		cartData.price = normsPrice ? normsPrice : record.price;
		cartData.barCode = record.barCode;
		cartData.typeId = record.typeId;
		cartData.isTimecard = record.isTimecard;
		cartData.timeNum = record.timeNum;
		cartData.commodityTypeId = record.typeId;
		cartData.kitchenPrint = record.kitchenPrint;
		cartData.labelPrint = record.labelPrint;
		cartData.expectedTime = record.expectedTime ? record.expectedTime: null;
		cartData.iskitchenprint = record.iskitchenprint;
		cartData.kitchenPrintJson = record.kitchenPrintJson;
		cartData.specialNorms = record.specialNorms;  // 规格特价
		cartData.isWeight = record.isWeight == '1' ? '1' : '0';
		cartData.category = record.category;
		cartData.isSpecialNorms = '0';
		if(cartData.specialNorms) {
			cartData.specialNorms = Ext.JSON.decode(cartData.specialNorms);
			if(cartData && cartData.specialNorms && cartData.specialNorms[normsName] == normsPrice) cartData.isSpecialNorms = '1';
		}
		//cartData.sellNum = record.sellNum > 0 ? record.sellNum : 1;
		cartData.sellCommNum = record.sellCommNum > 0 ? record.sellCommNum : 1;
		cartData.isTimePrice = record.isTimePrice == '1' ? '1' : '0';
		cartData.isSpecialPrice = record.isSpecialPrice ? record.isSpecialPrice : '0';
		cartData.isDiscount = record.isDiscount ? record.isDiscount : '0';
		if(cartData && cartData.isSpecialPrice == '1') { // 特价菜
			if (normsPrice) {
				cartData.isSpecialPrice = cartData.isSpecialNorms;
			} else cartData.price = record.specialPrice;
			if(cartData && cartData.isSpecialPrice == '1')
				cartData.isDiscount = '0';
		}
		cartData.price = parseFloat(cartData.price).toFixed(2);
		cartData.commodityPrice = cartData.price;
		cartData.discount = 100;
        cartData.unit = record.unit ? record.unit : '例';
        cartData.costPrice = record.costPrice;
        if(isValidDigital(cartData.costPrice))
	        cartData.costAmount = parseFloat(cartData.costPrice) * parseFloat(cartData.sellCommNum);
        record.sellNum = 0;
		return cartData;
	},
	addCommodityByDataNum : function(record, normsName, normsPrice, isOpenPlace) {
		var resultRecord;
		var me = this;
		if (this.shouhanMode == '5') {
			showSoldoutPanel(record);
			return;
		} else if (record.soldoutStatus == '1' && parseFloat(record.soldoutNum) <= 0) {
			return;
		}

		var buyCarGridPanel = Ext.getCmp('buyCarGridPanel');
		var store = buyCarGridPanel.getStore();
		//record.set("define4", "1");

		var cartData = me.getCartDataByCommodity(record, normsName, normsPrice);
		var recordObj = initCartColSellDetailByCommodity(cartData);

		if(me.sellInfo) {
			var sellId = this.sellInfo.id;
			recordObj.type = '1';
		} else {
			if (!Ext.getCmp('shouyinMainView').sellInfo) {
				Ext.getCmp('clearOrTakeBtn').setText('清空');
			}
		}
		//开启累加商品模式
		var shouyinShoppingStore = Ext.getCmp('shouyinMainView').shoppingStore;
		var storeLength = shouyinShoppingStore.getAllCount();
		var isCommodityAddup = setting.isCommodityAddup + '';
		if(recordObj.type == '1'){//取单模式
			for(var j = 0, sLen = storeLength; j < sLen; j++){
				var _record = shouyinShoppingStore.getAt(j);
				if(_record.get('isAlreadyOrder') == '1' || _record.get('isDelete') == '1'){
					storeLength--;
				}
			}
		}
		if(storeLength > 0 && (isCommodityAddup.indexOf('true') != -1)){
			var storeLength1 = shouyinShoppingStore.getAllCount();
			var currentRecordId = record.id;
			var isAddupSellNum = false;
			var currentRecordPos = 0;//当前记录索引位置
			for(var ri = 0; ri < storeLength1; ri++){
				var storeRecord = shouyinShoppingStore.getAt(ri);
				var storeId = storeRecord.get('commodityId');
				if((currentRecordId == storeId) && (storeRecord.get('isAlreadyOrder') != '1') && (storeRecord.get('isDelete') != '1')){
					if(normsName){//规格商品累加
						currentCommodityName = record.name +'('+normsName+')';
					}else{
						currentCommodityName = record.name;
					}
					if(storeRecord.get('commodityName') == currentCommodityName){
						currentRecordPos = ri;
						Ext.getCmp('shouyinMainView').gotoShoppingCommodity(currentRecordPos);//根据索引位置跳到指定页
						buyCarGridPanel.select(storeRecord, true, false);//选择当前记录

						var currentSellNum = recordObj.sellNum;
						var oldSellNum = storeRecord.get('sellNum');
						var newSellNum = (parseFloat(currentSellNum) + parseFloat(oldSellNum)).toFixed(2);

						var discount = parseFloat(storeRecord.get('discount'))/100;//商品折扣
						var remarkPrice = parseFloat(storeRecord.get('remarkPrice'));//加口味总价格;
						remarkPrice = (typeof remarkPrice == 'number') ? remarkPrice : 0;

						//改价格操作
						if(!!storeRecord.get('changePrice')){
							var changePrice = parseFloat(storeRecord.get('changePrice'));
							if(record.isTimePrice == '1'){//时价菜按时价累加
								changePrice = parseFloat(record.price);
							}
							var commodityPrice = (changePrice * discount + remarkPrice).toFixed(2);
						}else{
							var commodityPrice = (parseFloat(recordObj.sellPrice) * discount + remarkPrice).toFixed(2);
						}

						storeRecord.set({'sellNum': newSellNum});
						storeRecord.set({'sellPrice': commodityPrice});
						if(storeRecord.get('isWeight') == '1'){
							var wPrice0 = changePrice ? changePrice : parseFloat(recordObj.sellPrice);
							var newPrice = (wPrice0 * discount) * parseFloat(newSellNum) + remarkPrice;
						}else{
							var newPrice = parseFloat(commodityPrice * newSellNum);
						}
						storeRecord.set({'sellAmount': newPrice.toFixed(2)});


						//计算单条记录总价格totalAmount
						if(storeRecord.get('isWeight') == '1'){//称重商品计算价格
							var wPrice = changePrice ? changePrice : parseFloat(recordObj.sellPrice);
							var storeTotalAmount = (wPrice * discount) * parseFloat(storeRecord.get('sellNum')) + remarkPrice;
						}else {
							var storeTotalAmount = parseFloat(storeRecord.get('sellNum')) * commodityPrice;
						}
						storeRecord.set({'totalAmount': storeTotalAmount});

						isAddupSellNum = true;
						/* 累加商品 */
						me.showCartOperator(storeRecord);
						break;
					}
				}
			}
			if(!isAddupSellNum){
				var records = addCartStore(recordObj);
				resultRecord = records[0];
				buyCarGridPanel.select(resultRecord, true, false);//选择当前记录
				me.showCartOperator(resultRecord);
			}
		}else {
			var records = addCartStore(recordObj);
			resultRecord = records[0];//用于返回增加的那条记录
			buyCarGridPanel.select(resultRecord, true, false);//选择当前记录
			me.showCartOperator(resultRecord);
		}

		if(cartData.sellCommNum < 1 && cartData.sellCommNum > 0) {
			if(cartData.isDiscount == '0' || cartData.isSpecialPrice=='1')
				me.addCommodityCountDot(cartData.price, cartData.sellCommNum, '0');
			else me.addCommodityCountDot(cartData.price, cartData.sellCommNum);
		} else if(cartData.sellCommNum - parseInt(cartData.sellCommNum) > 0) {
			var tmpCalcNum = parseInt(cartData.sellCommNum);
			for(var tci=0;tci<tmpCalcNum;tci++) {
				if(cartData.isDiscount == '0' || cartData.isSpecialPrice=='1')
					me.addCommodityCount(cartData.price, '0');
				else me.addCommodityCount(cartData.price);
			}
			tmpCalcNum = cartData.sellCommNum - parseInt(cartData.sellCommNum);
			if(tmpCalcNum < 1 && tmpCalcNum > 0) {
				if(cartData.isDiscount == '0' || cartData.isSpecialPrice=='1')
					me.addCommodityCountDot(cartData.price, tmpCalcNum, '0');
				else me.addCommodityCountDot(cartData.price, tmpCalcNum);
			}
		} else {
			for(var si=0;si<cartData.sellCommNum;si++) {
				//特价菜不打折
				if(cartData.isDiscount == '0' || cartData.isSpecialPrice=='1')
					me.addCommodityCount(cartData.price, '0');
				else me.addCommodityCount(cartData.price);
			}
		}
		showCustomerDisplay(0x31, cartData.price);
		me.addCommodityNum(cartData.id, cartData.commodityTypeId, cartData.sellCommNum);
		me.calcAddCashierData(cartData);
		// 增加商品 '点' 图片
		var commStore = Ext.getStore('showyin-commodity-store');
		if(isOpenPlace && commStore) { // 餐桌中点击开台
			var storeCount = commStore.getCount();
			for(var si=0;si<storeCount;si++) {
				var commRecord = commStore.getAt(si);
				if(commRecord.get('id') == cartData.id) {
					if(commRecord.get('define4') != '1') {
						commRecord.set('define4', '1');
						break;
					}
				}
			}
		}
		return resultRecord;
	},
	/* 显示购物车列表项操作栏 */
	showCartOperator : function(optRecord) {
		try {
			var buyCarGridPanel = Ext.getCmp('buyCarGridPanel');
			var gridStore = buyCarGridPanel.getStore();
			var storeIdx = gridStore.indexOf(optRecord);
			//var gridY = buyCarGridPanel.element.getY();
			showBuyCarOpt((storeIdx+1) * 56 + 20, optRecord);
		} catch(err) {}
	},
	/**
	 * 占击商品增加到grid
	 * @param {Object} id
	 * @param {Object} name
	 * @param {Object} price
	 */
	addCommodityByData : function(record, normsName, normsPrice, isOpenPlace) {
		var me = this;
		if (this.shouhanMode == '5') {//沽清
			showSoldoutPanel(record);
			return;
		} else if (record.soldoutStatus == '1' && parseFloat(record.soldoutNum) <= 0) {
			//沽清数量为0
			return;
		} else if (record.soldoutStatus == '1' && parseFloat(record.soldoutNum) < 1 && parseFloat(record.soldoutNum) > 0) {
			// 沽清数量小于 1 大于 0
			//record.sellNum = parseFloat(record.soldoutNum);
			record.sellCommNum = parseFloat(record.soldoutNum);
		} else if(record.soldoutStatus == '1' && parseFloat(record.define3) < 1 && parseFloat(record.define3) > 0) {
			//record.sellNum = parseFloat(record.define3);
			record.sellCommNum = parseFloat(record.define3);
		} else ; //record.sellNum = 0;
		/*else if(record.soldoutStatus == '1' && parseFloat(record.remainNum) < 1 && parseFloat(record.remainNum) > 0) {
			record.sellNum = parseFloat(record.remainNum);
		}*/
		//if(record.sellNum > 0) return this.addCommodityByDataNum(record, normsName, normsPrice, isOpenPlace);
		if(record.sellCommNum > 0) return this.addCommodityByDataNum(record, normsName, normsPrice, isOpenPlace);
		var resultRecord;

		var buyCarGridPanel = Ext.getCmp('buyCarGridPanel');
		var store = buyCarGridPanel.getStore();

		var cartData = me.getCartDataByCommodity(record, normsName, normsPrice);
		//cartData.sellNum = 1;
		cartData.sellCommNum = 1;
		var recordObj = initCartColSellDetailByCommodity(cartData);

		if(me.sellInfo) {
			var sellId = this.sellInfo.id;
			recordObj.type = '1';
		} else {
			if (!Ext.getCmp('shouyinMainView').sellInfo) {
				Ext.getCmp('clearOrTakeBtn').setText('清空');
			}
		}

		//开启累加商品模式
		var shouyinShoppingStore = Ext.getCmp('shouyinMainView').shoppingStore;
		var storeLength = shouyinShoppingStore.getAllCount();
		var isCommodityAddup = setting.isCommodityAddup + '';
		if(recordObj.type == '1'){//取单模式
			for(var j = 0, sLen = storeLength; j < sLen; j++){
				var _record = shouyinShoppingStore.getAt(j);
				if(_record.get('isAlreadyOrder') == '1' || _record.get('isDelete') == '1'){
					storeLength--;
				}
			}
		}
		if(storeLength > 0 && (isCommodityAddup.indexOf('true') != -1)){
			var storeLength1 = shouyinShoppingStore.getAllCount();
			var currentRecordId = record.id;
			var isAddupSellNum = false;
			var currentRecordPos = 0;//当前记录索引位置
			for(var ri = 0; ri < storeLength1; ri++){
				var storeRecord = shouyinShoppingStore.getAt(ri);
				var storeId = storeRecord.get('commodityId');
				if((currentRecordId == storeId) && (storeRecord.get('isAlreadyOrder') != '1') && (storeRecord.get('isDelete') != '1')){
					if(normsName){//规格商品累加
						currentCommodityName = record.name +'('+normsName+')';
					}else{
						currentCommodityName = record.name;
					}
					if(storeRecord.get('commodityName') == currentCommodityName){
						currentRecordPos = ri;
						Ext.getCmp('shouyinMainView').gotoShoppingCommodity(currentRecordPos);//根据索引位置跳到指定页
						buyCarGridPanel.select(storeRecord, true, false);//选择当前记录
						var oldSellNum = parseFloat(storeRecord.get('sellNum'));

						var discount = parseFloat(storeRecord.get('discount'))/100;//商品折扣
						var remarkPrice = parseFloat(storeRecord.get('remarkPrice'));//加口味总价格;
						remarkPrice = (typeof remarkPrice == 'number') ? remarkPrice : 0;

						//改价格操作
						if(!!storeRecord.get('changePrice')){
							var changePrice = parseFloat(storeRecord.get('changePrice'));
							var commodityPrice = (changePrice*discount + remarkPrice).toFixed(2);
						}else{
							var commodityPrice = (parseFloat(recordObj.sellPrice)*discount + remarkPrice).toFixed(2);
						}

						storeRecord.set({'sellNum': ++oldSellNum});
						storeRecord.set({'sellPrice': commodityPrice});
						var newPrice = parseFloat(commodityPrice * oldSellNum).toFixed(2);
						storeRecord.set({'sellAmount': newPrice});

						//计算单条记录总价格totalAmount
						var storeTotalAmount = parseFloat(storeRecord.get('sellNum')) * commodityPrice;
						storeRecord.set({'totalAmount': storeTotalAmount});

						isAddupSellNum = true;
						/* 累加商品 */
						resultRecord = storeRecord;// 搜索-估清商品-返回的值
						me.showCartOperator(storeRecord);
						break;
					}
				}
			}
			if(!isAddupSellNum){
				var records = addCartStore(recordObj);
				resultRecord = records[0];
				buyCarGridPanel.select(resultRecord, true, false);//选择当前记录
				me.showCartOperator(resultRecord);
			}
		}else  {
			//var records = store.add(recordObj);
			var records = addCartStore(recordObj);
			resultRecord = records[0];//用于返回增加的那条记录
			buyCarGridPanel.select(resultRecord, true, false);//选择当前记录
			me.showCartOperator(resultRecord);
		}

		if(cartData.isDiscount == '0' || cartData.isSpecialPrice == '1')//更新商品总价格
			me.addCommodityCount(cartData.price, '0');
		else
			me.addCommodityCount(cartData.price);

		showCustomerDisplay(0x31, cartData.price);
		me.addCommodityNum(cartData.id, cartData.commodityTypeId, 1);//增加商品分类右上角的数量
		me.calcAddCashierData(cartData);
		//me.setButtonStatus(false);
		// 增加商品 '点' 图片
		var commStore = Ext.getStore('showyin-commodity-store');
		if(commStore) { // 餐桌中点击开台
			var storeCount = commStore.getCount();
			for(var si=0;si<storeCount;si++) {
				var commRecord = commStore.getAt(si);
				if(commRecord.get('id') == cartData.id) {
					if(commRecord.get('define4') != '1') {
						commRecord.set('define4', '1');
						break;
					}
				}
			}
		}
		return resultRecord;
	},
	addCommodityTypePrint : function(recordData, normsName, normsPrice) {
		recordData.iskitchenprint = false;
		recordData.kitchenPrintJson = Ext.JSON.encode([0, 0, 0, 0, 0, 0]);
		if (recordData.typeId) {
			CommodityDao.getCommodityTypeById(recordData.typeId, function(success, items) {
				if (success && items) {
					console.log(items);
					recordData.iskitchenprint = items.iskitchenprint;
					recordData.kitchenPrintJson = items.kitchenPrintJson;
					return Ext.getCmp('shouyinMainView').addCommodityByData(recordData, normsName, normsPrice);
				} else {
					return Ext.getCmp('shouyinMainView').addCommodityByData(recordData, normsName, normsPrice);
				}
			});
		} else {
			return this.addCommodityByData(recordData, normsName, normsPrice);
		}
	},
	addCommodityInterceptorBackup : function(recordData, normsName, normsPrice) {
		var me = this;
		var args = [].slice.call(arguments);
		if (isKtTransToCommodityType) {
			recordData.iskitchenprint = false;
			//recordData.kitchenPrintJson = Ext.JSON.encode([0, 0, 0, 0, 0, 0]);
            recordData.kitchenPrintJson = Ext.JSON.encode({});
            recordData.isDiscount = '0';
			if (recordData.typeId) {
				CommodityDao.getCommodityTypeById(recordData.typeId, function(success, items) {
					if (success && items) {
						recordData.kitchenPrint = items.iskitchenprint;
						recordData.iskitchenprint = items.iskitchenprint;
						recordData.kitchenPrintJson = items.kitchenPrintJson;
						recordData.isDiscount = nvlValue(items.isDiscount,'0');
						//return Ext.getCmp('shouyinMainView').addCommodityByData(recordData, normsName, normsPrice);
						return Ext.getCmp('shouyinMainView').addCommodityByData.apply(me, args);
					} else {
						//return Ext.getCmp('shouyinMainView').addCommodityByData(recordData, normsName, normsPrice);
						//return Ext.getCmp('shouyinMainView').addCommodityByData.call(me, args);
						return Ext.getCmp('shouyinMainView').addCommodityByData.apply(me, args);
					}
				});
			}
		} else {
			//return this.addCommodityByData(recordData, normsName, normsPrice);
			return this.addCommodityByData.apply(me, args);
		}
	},
	addCommodityInterceptor : function(recordData, normsName, normsPrice, uuid) {
		var me = this;
		var args = [].slice.call(arguments);
		if (isKtTransToCommodityType) {
			if (recordData.typeId) {
				var commodityTypeStore = Ext.getStore("showyin-commoditytype-store");
				var findRecord = commodityTypeStore.findRecord('id', recordData.typeId);
				if(findRecord) {
					recordData.iskitchenprint = '0';
		            recordData.kitchenPrintJson = Ext.JSON.encode({});
		            recordData.isDiscount = '0';
					recordData.kitchenPrint = findRecord.get('iskitchenprint');
					recordData.iskitchenprint = findRecord.get('iskitchenprint');
					recordData.kitchenPrintJson = findRecord.get('kitchenPrintJson');
					recordData.isDiscount = nvlValue(findRecord.get('isDiscount'), "0");
					retVal = me.addCommodityByData.apply(me, args);
				} else {
					if(recordData.isSearchCommodity) {
						delete recordData.isSearchCommodity;
						retVal = me.addCommodityByData.apply(me, args);
					} else { // 查不到再查数据库
						recordData.iskitchenprint = '0';
						recordData.kitchenPrintJson = Ext.JSON.encode({});
						recordData.isDiscount = '0';
						CommodityDao.getCommodityTypeById(recordData.typeId, function(success, items) {
							if (success && items) {
								recordData.kitchenPrint = items.iskitchenprint;
								recordData.iskitchenprint = items.iskitchenprint;
								recordData.kitchenPrintJson = items.kitchenPrintJson;
								recordData.isDiscount = nvlValue(items.isDiscount,'0');
								//return Ext.getCmp('shouyinMainView').addCommodityByData(recordData, normsName, normsPrice);
								return Ext.getCmp('shouyinMainView').addCommodityByData.apply(me, args);
							} else {
								//return Ext.getCmp('shouyinMainView').addCommodityByData(recordData, normsName, normsPrice);
								//return Ext.getCmp('shouyinMainView').addCommodityByData.call(me, args);
								return Ext.getCmp('shouyinMainView').addCommodityByData.apply(me, args);
							}
						});
					}
				}
				//var retVal = me.addCommodityByData.apply(me, args);
				me.setShouYinBtnDisabled(false, uuid);
				return retVal;
				CommodityDao.getCommodityTypeById(recordData.typeId, function(success, items) {
					if (success && items) {
						recordData.kitchenPrint = items.iskitchenprint;
						recordData.iskitchenprint = items.iskitchenprint;
						recordData.kitchenPrintJson = items.kitchenPrintJson;
						recordData.isDiscount = nvlValue(items.isDiscount,'0');
						return Ext.getCmp('shouyinMainView').addCommodityByData.apply(me, args);
					} else {
						return Ext.getCmp('shouyinMainView').addCommodityByData.apply(me, args);
					}
				});
			}
		} else {
			//return this.addCommodityByData.apply(me, args);
			var retVal = this.addCommodityByData.apply(me, args);
			this.setShouYinBtnDisabled(false, uuid);
			return retVal;
		}
	},
	/**
	 * 统计数据
	 */
	statisticsCashierData : function() {

	},
	calcAddCashierData : function(newRecordData) {
		/* 计算添加收银数据 */
		if(!isValidDigital(this.costAmount)) this.costAmount = 0;
		if(isValidDigital(newRecordData.costAmount))
			this.costAmount = parseFloat(this.costAmount) + newRecordData.costAmount;  // 成本统计
	},
	/**
	 * 占击商品增加到grid
	 * @param {Object} id
	 * @param {Object} name
	 * @param {Object} price
	 */
	addCommodity : function(record, normsName, normsPrice) {
		this.addCommodityAfterOpt(record);
		return this.addCommodityInterceptor(record.getData(), normsName, normsPrice, this.disableId);
	},
	addCommodityAfterOpt : function(record) {
		this.setShouYinBtnDisabled(true);
		var genId = new Ext.data.identifier.Uuid().generate();
		this.disableId = genId;
		//抛物线
		if(isAndroidSys());
		else
		    new ParabolaUtil(parabolaX, parabolaY, record.get("name")).init();
		record.set("define4", "1");
	},
	addCommodityForSearch : function(record, normsName, normsPrice) {
		this.addCommodityAfterOpt(record);
		var recordData = record.getData();
		//recordData.isSearchCommodity = true;
		return this.addCommodityInterceptor(recordData, normsName, normsPrice, this.disableId);
	},
	setShouYinBtnDisabled : function(isDisabled, uuid) {
		if(isDisabled==false && this.disableId != uuid) {
			return;
		} else if(isDisabled == false) {
			this.disableId = null;
			this.disableNum = 0;
		}
		if(Ext.getCmp('showyin-amount-name')) Ext.getCmp('showyin-amount-name').setDisabled(isDisabled);
	},
	setCommodityNum : function(commodityId, commodityTypeId, num, oldNum) {
		setTimeout(function() {
			var obj = $("#commoditytype" + commodityTypeId + " .numspan")[0];
			$("#commoditytype" + commodityTypeId + " .numdiv").addClass('num');
			//$("#commodity" + commodityId).addClass('conselect');
			//alert(commodityId+":"+commodityTypeId)
			//alert(obj)
			if (obj) {
				var objnum = obj.innerHTML;
				if (!objnum) {
					objnum = 0;
				}
				//obj.innerHTML = parseInt(objnum) + num;
				//obj.innerHTML = parseFloat(parseFloat(objnum) - parseFloat(oldNum) + parseFloat(num)).toFixed(2);
				obj.innerHTML = parseInt(objnum) - parseInt(oldNum) + parseInt(num);
			}
		}, 100);
	},
	/**
	 * 增加商品分类右上角的数量
	 */
	addCommodityNum : function(commodityId, commodityTypeId, num) {
		setTimeout(function() {
			var obj = $("#commoditytype" + commodityTypeId + " .numspan")[0];
			$("#commoditytype" + commodityTypeId + " .numdiv").addClass('num');
			//$("#commodity" + commodityId).addClass('conselect');
			//alert(commodityId+":"+commodityTypeId)
			//alert(obj)
			if (obj) {
				var objnum = obj.innerHTML;
				if (!objnum) {
					objnum = 0;
				}
				//obj.innerHTML = parseInt(objnum) + num;
				//obj.innerHTML = parseFloat(parseFloat(objnum) - parseFloat(oldNum) + parseFloat(num)).toFixed(2);
				/*if(parseFloat(num)>0 && parseFloat(num) < 1){
					obj.innerHTML = parseFloat(objnum) + 1;
				} else {
					obj.innerHTML = parseInt(objnum) + parseInt(num);
				}*/
				try {
                    obj.innerHTML = parseInt(objnum) + parseInt(num) + Math.ceil(parseFloat(num)-parseInt(num));
                } catch(err) {console.log("商品分类数量计算错误...");}
			}
		}, 100);
	},
	/**
	 * 删除商品分类右上角的数量样式
	 */
	removeCommodityNum : function(commodityId, commodityTypeId) {
		$("#commoditytype" + commodityTypeId + " .numdiv").removeClass('num');
		$("#commoditytype" + commodityTypeId + " .numspan").html('');
	},
	isContainCommodity : function(commodityId) {
		//var store = Ext.getCmp('buyCarGridPanel').getStore();
		var store = getPageStore();
		for (var i = 0, len = store.getAllCount(); i < len; i++) {
			var record = store.getAt(i);
			if (commodityId == record.get('commodityId')) {
				return true;
			}
		}
		return false;
	},
	isContainCommodityType : function(commodityTypeId) {
		//var store = Ext.getCmp('buyCarGridPanel').getStore();
		var store = getPageStore();
		for (var i = 0, len = store.getAllCount(); i < len; i++) {
			var record = store.getAt(i);
			if (commodityTypeId == record.get('commodityTypeId')) {
				return true;
			}
		}
		return false;
	},
	/**
	 * 重置商品分类右上角的数量
	 */
	resetCommodityNum : function() {
		$(".commoditytype-button .num").removeClass('num');
		$(".commoditytype-button .numspan").html('');
		//$(".con span").removeClass('conselect');
		var store = Ext.getStore('showyin-commodity-store');
		for (var i = 0, len = store.getAllCount(); i < len; i++) {
			var record = store.getAt(i);
			record.set("define4", "");
			if(record.get('soldoutStatus') == '1') {
				record.set('remainNum', record.get('soldoutNum'));
			}
		}
	},
	/**
	 * 增加商品时进行计算(小数)
	 */
	addCommodityCountDot : function(price, sellNum, isDiscount) {
		//var me = this;
		isDiscount = isDiscount ? isDiscount : '1';

		//商品累加模式下计算总数
		var isCommodityAddup = setting.isCommodityAddup + '';
		if(isCommodityAddup.indexOf('true') != -1){
			//商品累加模式下计算总数
			var shouyinShoppingStore = Ext.getCmp('shouyinMainView').shoppingStore;
			var storeLength          = shouyinShoppingStore.getAllCount();
			this.commodityNum        = 0;
			this.totalAmount         = 0;
			this.sellAmount          = 0;
			for(var k = 0;k < storeLength; k++){
				var storeRecord = shouyinShoppingStore.getAt(k);
				this.commodityNum += parseFloat(storeRecord.get('sellNum'));
				this.totalAmount  += parseFloat(storeRecord.get('sellAmount'));
				if(isDiscount == '1') {
					this.sellAmount += (storeRecord.get('sellAmount') * parseFloat(this.discount) / 100);
				} else {
					this.sellAmount += parseFloat(storeRecord.get('sellAmount'));
				}
			}
		}else{
		    //非商品累加模式下计算总数
			this.commodityNum = parseFloat(parseFloat(this.commodityNum) + sellNum);
			var dotPrice = parseFloat(price * sellNum);
			this.totalAmount = parseFloat(this.totalAmount) + parseFloat(dotPrice);
			if(isDiscount == '1')
				this.sellAmount = parseFloat(this.sellAmount) + (parseFloat(dotPrice) * parseFloat(this.discount) / 100);
			else
				this.sellAmount = parseFloat(this.sellAmount) + (parseFloat(dotPrice));
		}


		document.getElementById('showyin_totalamount0').innerHTML = "￥" +roundByUnit(this.sellAmount, roundSetting.unit);
		document.getElementById('showyin_commodityNum').innerHTML = parseFloat(this.commodityNum).toFixed(2);

		if ((monitors == 2) && (!Ext.getCmp('select-commodity-view').isLongTimeClick)) {
			refreshDoubleScreen(); // 同步副屏数据

			/*var store = Ext.getCmp('buyCarGridPanel').getStore();

			var doubleScreenShowData = [];
			var total = store.getAllCount();
			var k = 0;
			for (var i = 0; i < total; i++) {
				var record = store.getAt(i);
				doubleScreenShowData[k] = {};
				doubleScreenShowData[k].commodityName = record.get('commodityName');
				doubleScreenShowData[k].commodityNum = record.get('sellNum');
				doubleScreenShowData[k].commodityPrice = record.get('sellPrice');
				doubleScreenShowData[k].commodityAmount = record.get('sellAmount');
				k++;
			}
			this.doubleScreenShowData = doubleScreenShowData;
			sendMsg2SetCommodityList(this.doubleScreenShowData);
			//console.log(this.commodityNum);
			//sendMsg2SetTotalNum(this.commodityNum);
			sendMsg2SetTotalAmount(this.sellAmount);
			var part = parseInt(total / divNum);
			var mod = k % divNum;
			var totalPage = (mod > 0) ? part + 1 : part;
			sendMsg2SetPageNum(1, totalPage);*/
		}
	},
	/**
	 * 增加商品时进行计算
	 */
	addCommodityCount : function(price, isDiscount) {
		//var me = this;
		isDiscount = isDiscount ? isDiscount : '1';

		//商品累加模式下计算总数
		var isCommodityAddup = setting.isCommodityAddup + '';
		if(isCommodityAddup.indexOf('true') != -1){
			//商品累加模式下计算总数
			var shouyinShoppingStore = Ext.getCmp('shouyinMainView').shoppingStore;
			var storeLength          = shouyinShoppingStore.getAllCount();
			this.commodityNum        = 0;
			this.totalAmount         = 0;
			this.sellAmount          = 0;
			for(var k = 0;k < storeLength; k++){
				var storeRecord = shouyinShoppingStore.getAt(k);
				this.commodityNum += parseFloat(storeRecord.get('sellNum'));
				this.totalAmount  += parseFloat(storeRecord.get('sellAmount'));
				if(isDiscount == '1') {
					this.sellAmount += (storeRecord.get('sellAmount') * parseFloat(this.discount) / 100);
				} else {
					this.sellAmount += parseFloat(storeRecord.get('sellAmount'));
				}
			}
		}else {
			//非商品累加模式下计算总数
			this.totalAmount = parseFloat(this.totalAmount) + parseFloat(price);
			this.commodityNum = parseFloat(this.commodityNum) + 1;
			if(isDiscount == '1')
				this.sellAmount = parseFloat(this.sellAmount) + (parseFloat(price) * parseFloat(this.discount) / 100);
			else
				this.sellAmount = parseFloat(this.sellAmount) + (parseFloat(price));
		}


		document.getElementById('showyin_totalamount0').innerHTML = "￥" +roundByUnit(this.sellAmount, roundSetting.unit);
		document.getElementById('showyin_commodityNum').innerHTML = parseFloat(this.commodityNum).toFixed(2);

		if ((monitors == 2) && (!Ext.getCmp('select-commodity-view').isLongTimeClick)) {
			refreshDoubleScreen(); // 同步副屏数据

			/*var store = Ext.getCmp('buyCarGridPanel').getStore();

			var doubleScreenShowData = [];
			var total = store.getAllCount();
			var k = 0;
			for (var i = 0; i < total; i++) {
				var record = store.getAt(i);
				doubleScreenShowData[k] = {};
				doubleScreenShowData[k].commodityName = record.get('commodityName');
				doubleScreenShowData[k].commodityNum = record.get('sellNum');
				doubleScreenShowData[k].commodityPrice = record.get('sellPrice');
				doubleScreenShowData[k].commodityAmount = record.get('sellAmount');
				k++;
			}
			this.doubleScreenShowData = doubleScreenShowData;
			sendMsg2SetCommodityList(this.doubleScreenShowData);
			//console.log(this.commodityNum);
			//sendMsg2SetTotalNum(this.commodityNum);
			sendMsg2SetTotalAmount(this.sellAmount);
			var part = parseInt(total / divNum);
			var mod = k % divNum;
			var totalPage = (mod > 0) ? part + 1 : part;
			sendMsg2SetPageNum(1, totalPage);*/
		}
	},
	/**
	 * 选择收款模式
	 * @param {Object} shouhanMode
	 */
	choiceShouhanMode : function(shouhanMode) {
		Ext.getCmp('shouyinMainView').shouhanMode = shouhanMode;
		if (shouhanMode == 2) {
			document.getElementById('sy-car-toolbar-title').innerHTML = "退货模式";
			Ext.getCmp('showyin-amount-name').setText("退款");
			//设置成退货模式
			Ext.getCmp('putup-btn').hide();
			Ext.getCmp('convenient-showyin-amount').hide();//速结按钮隐藏
			Ext.getCmp('clearOrTakeBtn').setText('清空');
		} else {
			document.getElementById('sy-car-toolbar-title').innerHTML = "";
			//Ext.getCmp('showyin-amount-name').setText("马上结算");
			Ext.getCmp('showyin-amount-name').setText("收款");
			if(sySetting.mode === SYS_TYPE.HOTEL){//酒楼模式
			   Ext.getCmp('putup-btn').show();
			}else if(sySetting.mode === SYS_TYPE.FD){
				Ext.getCmp('convenient-showyin-amount').show();
				if(shouhanMode == 0){
					Ext.getCmp('clearOrTakeBtn').setText('清空');
				}
				if(shouhanMode == 1){
					Ext.getCmp('clearOrTakeBtn').setText('取单(F1)');
				}
				Ext.getCmp('putup-btn').hide();
			}
			document.getElementById('clearOrTakeBtn').style.display = "";
			//var store = Ext.getCmp('buyCarGridPanel').getStore();
			var store = getPageStore();
			if (store.getAllCount() < 1) {
				if(sySetting.mode === SYS_TYPE.HOTEL){
					Ext.getCmp('clearOrTakeBtn').setText('取单(F1)');
				}
			} else {
				Ext.getCmp('clearOrTakeBtn').setText('清空');
			}
		}
		if(shouhanMode == 1) { // 外卖
			Ext.getCmp('putup-btn').setText("下单(F2)");
			Ext.getCmp('putup-btn').show();
			Ext.getCmp('convenient-showyin-amount').hide();
		} else {
			var me =Ext.getCmp('shouyinMainView');
			if(me.sellInfo || me.selectPlace) {
				Ext.getCmp('putup-btn').setText("下单(F2)");
			} else
				Ext.getCmp('putup-btn').setText("选桌下单(F2)");
		}
		/*if(shouhanMode == 0){//收银模式
			Ext.getCmp('putup-btn').hide();
		}*/
		this.setTitle();
	},
	setTitle : function() {
		var title;
		if (this.shouhanMode == 2) {
			title = "退货模式";
		} else if (this.shouhanMode == 1) {
			title = "外卖模式";
		} else {
			title = "收银模式";
		}
		if (this.selectCustomerInfo) {
			title = this.selectCustomerInfo.name + ",余额：" + parseFloat(nvlValue(this.selectCustomerInfo.balanceAmount, 0)).toFixed(2);
			/*if (monitors == 2) {
				sendMsg2SetMemberInfo(this.selectCustomerInfo.name, this.selectCustomerInfo.balanceAmount);
			}*/
		}
		// 更新副屏显示会员信息
		if(monitors == 2){
			if (this.selectCustomerInfo) {
				sendMsg2SetMemberInfo(this.selectCustomerInfo.cardNum, this.selectCustomerInfo.balanceAmount);
			} else {
				sendMsg2SetMemberInfo();
			}
		}
		if (Ext.getCmp('shouyinMainView').sellInfo && Ext.getCmp('shouyinMainView').sellInfo.placeName) {
			title += "(桌号:" + Ext.getCmp('shouyinMainView').sellInfo.placeName + ")";
		} else if (Ext.getCmp('shouyinMainView').selectPlace) {
		    if(Ext.getCmp('shouyinMainView').selectPlace.get('status') == '1') { // 已开台
                var selectPlace = Ext.getCmp('shouyinMainView').selectPlace;
                /*if(selectPlace.get('placeName').indexOf('-') <= -1) {
                    selectPlace.set('placeName', selectPlace.get('placeName') + '-1');
                    selectPlace.set('id', selectPlace.get('id') + '-1');
                }*/
                title += "(桌号:" + selectPlace.get("placeName") + ")";
            } else
                title += "(桌号:" + Ext.getCmp('shouyinMainView').selectPlace.get("placeName") + ")";
		}
		document.getElementById('sy-car-toolbar-title').innerHTML = title;
	},
	addCustomer : function(customerInfo) {
		this.selectCustomerInfo = customerInfo;
		if (Ext.getCmp('addCustomerView')) {
			Ext.getCmp('addCustomerView').destroy();
		}

		if (Ext.getCmp('shouyinMainView').sellInfo) {
			if (customerInfo) {
				SellDao.updateSellInfo({
					customerId : customerInfo.id,
					customerName : customerInfo.name,
					customerMobile : customerInfo.mobile,
					customerAddress : customerInfo.address,
					syned : '0'
				}, Ext.getCmp('shouyinMainView').sellInfo.id);
			} else {
				SellDao.updateSellInfo({
					customerId : '',
					customerName : '',
					customerMobile : '',
					customerAddress : '',
					syned : '0'
				}, Ext.getCmp('shouyinMainView').sellInfo.id);
			}
		}
		var discount = 100;
		if (this.selectCustomerInfo) {
			discount = this.selectCustomerInfo.discount==0 ? 0 : (this.selectCustomerInfo.discount ? this.selectCustomerInfo.discount : 100);
		}

		Ext.getCmp('shouyinMainView').discount = parseFloat(discount);
		Ext.getCmp('shouyinMainView').countStore();
		this.setTitle();
	},
	loadDataBySellIdPage : function(sellInfo, sellerCustomerId) {
		var me = this;
		if (this.shouhanMode === 6) {// 餐桌模式-->取单-->收银模式
			syLeftButtonClick($("#syLeftButton_sy")[0], 0);
		}
		this.resetCommodityNum();
		Ext.getCmp('shouyinMainView').resetData();
		this.sellInfo = sellInfo;
		Ext.getCmp('shouyinMainView').discount = parseFloat(sellInfo.discount);
		//Ext.getCmp('shouyinMainView').pledgeAmount = nvlValue(sellInfo.pledgeAmount, 0);
		//Ext.getCmp('shouyinMainView').openPlaceRemark = nvlValue(sellInfo.openPlaceRemark, '');
		Ext.getCmp('clearOrTakeBtn').setText('取消');
		Ext.getCmp('putup-btn').setText("下单(F2)");
		me.shoppingStore.removeAll();
		/*me.shoppingPage = new $.PageUtil({
			limitCount : 8
		});*/
		me.shoppingPage.reset();
		var carStore = Ext.getCmp('buyCarGridPanel').getStore();
		SellDao.loadSellDetail(sellInfo.id, function(success, res) {
			if (!success) {
				return;
			}
			if (res.length > 0) {
				for (var i = 0, len = res.length; i < len; i++) {
					var sellDetail = res[i];
					var tSellDetail = {
							id : sellDetail.id,
							commodityId : sellDetail.commodityId,
							commodityName : sellDetail.commodityName,
							commodityTypeId : sellDetail.commodityTypeId,
							sellAmount : parseFloat(sellDetail.sellAmount).toFixed(2),
							sellPrice : parseFloat(sellDetail.sellPrice).toFixed(2),
							totalAmount : parseFloat(sellDetail.totalAmount).toFixed(2),
							sellNum: parseDigitalDecimal(sellDetail.sellNum),
							sellId : sellDetail.sellId,
							discount : sellDetail.discount,
							commodityPrice : sellDetail.commodityPrice,
							barCode : sellDetail.barCode,
							isDelete : sellDetail.isDelete,
							createTime : sellDetail.createTime,
							remark : sellDetail.remark,
							remarkPrice : sellDetail.remarkPrice,
							remarkAmount : sellDetail.remarkAmount,
							remarkIds : sellDetail.remarkIds,
							//type : sellDetail.type ? sellDetail.type : '0',
							type : '0',
							kitchenPrint : sellDetail.kitchenPrint,
							labelPrint : sellDetail.labelPrint,
							iskitchenprint : sellDetail.iskitchenprint,
							kitchenPrintJson : sellDetail.kitchenPrintJson,
							isTimePrice : sellDetail.isTimePrice,
                            orderByTime : sellDetail.orderByTime,
							isDiscount : sellDetail.isDiscount,
							isSpecialPrice : sellDetail.isSpecialPrice,
							unit : sellDetail.unit,
							isPresented : sellDetail.isPresented,
							hasChangePrice : sellDetail.hasChangePrice,
							changePrice : sellDetail.changePrice,
							chgPriceOperator : sellDetail.chgPriceOperator,
						    isAlreadyOrder: sellDetail.isDelete == '1' ? '0' : '1',
							category: sellDetail.category
						};
					if(isValidDigital(sellDetail.costAmount))
						tSellDetail.costAmount = parseFloat(sellDetail.costAmount).toFixed(2);
					else tSellDetail.costAmount = sellDetail.costAmount;
					if(isValidDigital(sellDetail.costPrice))
						tSellDetail.costPrice = parseFloat(sellDetail.costPrice).toFixed(2);
					else tSellDetail.costPrice = sellDetail.costPrice;
					if(sellInfo.status == '-1'){
						//挂单状态，不显示已下单
						tSellDetail.isAlreadyOrder = '0';
					}
					/*if(i < me.shoppingPage.getLimitCount()) {
						addCartStore(carStore.add(tSellDetail)[0]);
					} else {
						addCartPageStore(tSellDetail);
					}*/
					addCartPageStore(tSellDetail);
					// collection store
					/*if(me.shoppingStore) {
						me.shoppingStore.add(tSellDetail);
						var tmpCount = me.shoppingStore.getCount();
						var sTotalPage = me.shoppingPage.getTotalPage();
						var tmpLimitCount = me.shoppingPage.getLimitCount();
						var tmpTotalPage = parseInt(tmpCount / tmpLimitCount);
						tmpTotalPage = (tmpCount%tmpLimitCount) > 0 ? tmpTotalPage+1 : tmpTotalPage;
						me.shoppingPage.countPage(tmpCount);
					}*/
					if (sellDetail.isDelete != '1') {
						me.addCommodityNum(sellDetail.commodityId, sellDetail.commodityTypeId, parseInt(sellDetail.sellNum));
					}
				}
				me.reSetShoppingPage(); /* 加载末页数据 */
				curPage = me.shoppingPage.getTotalPage() -1;
				//Ext.getCmp('buyCarGridPanel').select(store.getAt(0), true, false);
				setTimeout(function() {
					Ext.getCmp('select-commodity-view').fillSelectCommodity();
				}, 100);
				if (sellInfo.customerId) {
					showLoading('正在加载会员信息，请稍后...');
					nativePostRequest('/loaddata/getSellerCustomerInfo?time=' + new Date().getTime(), {
						sellerCustomerId : sellInfo.customerId
					}, function(result) {
						if (result.success && result.customer) {
							Ext.getCmp('shouyinMainView').addCustomer(result.customer);
							if(sellInfo.discount) {
								Ext.getCmp('shouyinMainView').discount = sellInfo.discount;
								me.countStore();
							}
						}
						closeLoading();
					}, function(msg) {
						closeLoading();
						showAlert('提示', msg ? msg : '加载会员信息出错！');
					});
				} else {
					me.countStore();
				}

				refreshDoubleScreen(); // 同步副屏数据
                /*if (monitors == 2) {
                    var doubleScreenShowData = [];
                    var doubleScreenSellAmount = 0.00;
                    var _store = getPageStore();
                    var total = _store.getAllCount();//carStore.getAllCount();
                    console.log(total);
                    var k = 0;
                    for (var i = 0; i < total; i++) {
                        var record = _store.getAt(i);

                        //doubleScreenShowData[k] = {};
                        //doubleScreenShowData[k].commodityName = record.get('commodityName');
                        //doubleScreenShowData[k].commodityNum = record.get('sellNum');
                        //doubleScreenShowData[k].commodityPrice = record.get('sellPrice');
                        //doubleScreenShowData[k].commodityAmount = record.get('sellAmount');
                        doubleScreenSellAmount += parseFloat(record.get('sellAmount'));
                        //k++;
                    }
                    var _carStore = carStore;
                    var _carTotal = _carStore.getAllCount();
                    for (var i = 0; i < _carTotal; i++) {
                        var _record = _carStore.getAt(i);

                        doubleScreenShowData[k] = {};
                        doubleScreenShowData[k].commodityName = _record.get('commodityName');
                        doubleScreenShowData[k].commodityNum = _record.get('sellNum');
                        doubleScreenShowData[k].commodityPrice = _record.get('sellPrice');
                        doubleScreenShowData[k].commodityAmount = _record.get('sellAmount');

                        k++;
                    }
                    sendMsg2SetCommodityList(doubleScreenShowData);
                    sendMsg2SetTotalAmount(doubleScreenSellAmount.toFixed(2));
                    var part = parseInt(total / divNum);
                    var mod = k % divNum;
                    var totalPage = (mod > 0) ? part + 1 : part;
                    sendMsg2SetPageNum(1, totalPage);
                    refreshAdsDoubleScreen();
                }*/
				return;
			}
			me.countStore();
		});
		if(Ext.getCmp('print-pre-shouyin-amount')) {
			Ext.getCmp('print-pre-shouyin-amount').setHidden(false);
			Ext.getCmp('showyin-amount-name').setMargin('0 0 0 6');
		}
		me.setTitle();
	},
	loadDataBySellId : function(sellInfo, sellerCustomerId, callback) {
		var me = this;
		if (this.shouhanMode === 6) {// 餐桌模式-->取单-->收银模式
			syLeftButtonClick($("#syLeftButton_sy")[0], 0);
		}
		this.resetCommodityNum();
		Ext.getCmp('shouyinMainView').resetData();
		this.sellInfo = sellInfo;
		Ext.getCmp('shouyinMainView').discount = parseFloat(sellInfo.discount);
		Ext.getCmp('clearOrTakeBtn').setText('取消');
		Ext.getCmp('putup-btn').setText("下单(F2)");
		var store = Ext.getCmp('buyCarGridPanel').getStore();
		SellDao.loadSellDetail(sellInfo.id, function(success, res) {
			if (!success) {
				callback && callback();
				return;
			}
			if (res.length > 0) {
				for (var i = 0, len = res.length; i < len; i++) {
					var sellDetail = res[i];
					//var storeRecords = store.add({
					var tSellDetail = {
							id : sellDetail.id,
							commodityId : sellDetail.commodityId,
							commodityName : sellDetail.commodityName,
							commodityTypeId : sellDetail.commodityTypeId,
							sellAmount : parseFloat(sellDetail.sellAmount).toFixed(2),
							sellPrice : parseFloat(sellDetail.sellPrice).toFixed(2),
							totalAmount : parseFloat(sellDetail.totalAmount?sellDetail.totalAmount:0).toFixed(2),
							//totalAmount : parseFloat(sellDetail.totalAmount).toFixed(2),
							sellNum : sellDetail.sellNum,
							sellId : sellDetail.sellId,
							discount : sellDetail.discount,
							commodityPrice : sellDetail.commodityPrice,
							barCode : sellDetail.barCode,
							isDelete : sellDetail.isDelete,
							createTime : sellDetail.createTime,
							remark : sellDetail.remark,
							remarkPrice : sellDetail.remarkPrice,
							remarkAmount : sellDetail.remarkAmount,
							remarkIds : sellDetail.remarkIds,
	                        orderByTime : sellDetail.orderByTime,
							//type : sellDetail.type ? sellDetail.type : '0',
							type : '0',
							kitchenPrint : sellDetail.kitchenPrint,
							labelPrint : sellDetail.labelPrint,
							iskitchenprint : sellDetail.iskitchenprint,
							kitchenPrintJson : sellDetail.kitchenPrintJson,
							unit : sellDetail.unit,
							isSpecialPrice : sellDetail.isSpecialPrice,
							isTimePrice : sellDetail.isTimePrice,
							isDiscount : sellDetail.isDiscount,
							isPresented : sellDetail.isPresented,
							hasChangePrice : sellDetail.hasChangePrice,
							changePrice : sellDetail.changePrice,
							chgPriceOperator : sellDetail.chgPriceOperator,
						    isAlreadyOrder: '1'
						};
					if(isValidDigital(sellDetail.costAmount))
						tSellDetail.costAmount = parseFloat(sellDetail.costAmount).toFixed(2);
					else tSellDetail.costAmount = sellDetail.costAmount;
					if(isValidDigital(sellDetail.costPrice))
						tSellDetail.costPrice = parseFloat(sellDetail.costPrice).toFixed(2);
					else tSellDetail.costPrice = sellDetail.costPrice;
					addCartPageStore(tSellDetail);
					//addCartPageStore(storeRecords[0]);
					if (sellDetail.isDelete != '1') {
						//setTimeout(function() {
						//alert(sellDetail.commodityTypeId);
						me.addCommodityNum(sellDetail.commodityId, sellDetail.commodityTypeId, parseInt(sellDetail.sellNum));
						//}, 100);
					}
				}
				me.reSetShoppingPage(); /* 加载末页数据 */
				Ext.getCmp('buyCarGridPanel').select(store.getAt(0), true, false);
				setTimeout(function() {
					Ext.getCmp('select-commodity-view').fillSelectCommodity();
				}, 100);
				if (sellInfo.customerId) {
					nativePostRequest('/loaddata/getSellerCustomerInfo?time=' + new Date().getTime(), {
						sellerCustomerId : sellInfo.customerId
					}, function(result) {
						if (result.success && result.customer) {
							Ext.getCmp('shouyinMainView').addCustomer(result.customer);
							if(sellInfo.discount) {
								Ext.getCmp('shouyinMainView').discount = sellInfo.discount;
								me.countStore();
							}
						}
					}, function(msg) {
						showAlert('提示', msg ? msg : '加载会员信息出错！');
					});
				} else {
					me.countStore();
				}
				callback && callback();
				refreshAdsDoubleScreen();
				return;
			}
			me.countStore();
			callback && callback();
		});
		if(Ext.getCmp('print-pre-shouyin-amount')) {
			Ext.getCmp('print-pre-shouyin-amount').setHidden(false);
			Ext.getCmp('showyin-amount-name').setMargin('0 0 0 6');
		}
		me.setTitle();
	},
	addCustomCommodity : function(name, num, price, printerData) {
		// 临时菜
		var store = Ext.getCmp('buyCarGridPanel').getStore();
		var recordObj = {
			discount : 100,
			isTimePrice : '0',
			price : price,
			sellPrice : price,
			commodityPrice : price,
			/*commodityId : '',
			commodityName : name + "",*/
			id : null,
			typeId : null,
			name : name + "",
			remarkPrice : 0,
			barCode : "",
			sellNum : num,
			totalAmount : price,
			sellAmount : price,
			remarkAmount : 0,
			createTime : new Date().format("yyyy-MM-dd hh:mm:ss"),
			orderByTime : new Date().getTime(),
			type : '0',
			remark : '',
			iskitchenprint : printerData.iskitchenprint ? printerData.iskitchenprint : '0',
			kitchenPrint : printerData.iskitchenprint ? printerData.iskitchenprint : '0',
			kitchenPrintJson : printerData.kitchenPrintJson ? printerData.kitchenPrintJson : "{}",
			unit : printerData.unit ? printerData.unit : '例',
			isDiscount : '1'
		};

		if (this.sellInfo) {
			//var sellId = this.sellInfo.id;
			recordObj.type = "1";
			/*var records = store.add(recordObj);
			var record = records[0];
			setTimeout(function() {
				Ext.getCmp('buyCarGridPanel').scrollToRecord(record, false, false);
			}, 100);
			Ext.getCmp('shouyinMainView').totalAmount = (parseFloat(Ext.getCmp('shouyinMainView').totalAmount) + parseFloat(price)).toFixed(2);
			Ext.getCmp('clearOrTakeBtn').setText('清空');
			Ext.getCmp('shouyinMainView').countStore();*/
		} else {
			//Ext.getCmp('buyCarGridPanel').select(record, true, false);
		}
		var cartData = this.getCartDataByCommodity(recordObj);
		var commodityObj = initCartColSellDetailByCommodity(cartData);
		//var records = store.add(commodityObj);
		if(this.sellInfo) commodityObj.type = '1';
		var records = addCartStore(commodityObj);
		var record = records[0];
		showCustomerDisplay(0x31, cartData.price);
		setTimeout(function() {
			Ext.getCmp('buyCarGridPanel').scrollToRecord(record, false, false);
		}, 100);
		Ext.getCmp('buyCarGridPanel').select(record, true, false);//选择当前记录
		Ext.getCmp('shouyinMainView').showCartOperator(record);

		Ext.getCmp('shouyinMainView').totalAmount = (parseFloat(Ext.getCmp('shouyinMainView').totalAmount) + parseFloat(price)).toFixed(2);
		Ext.getCmp('clearOrTakeBtn').setText('清空');
		Ext.getCmp('shouyinMainView').countStore();
	},
	getChangeRecord : function() {
		var details = [];
		var k = 0;
		//var store = Ext.getCmp('buyCarGridPanel').getStore();
		var store = getPageStore();
		store.findBy(function(re, id) {
			if ("1" == re.get("type")) {
				details[k++] = copyCommodityProperty(re);
			} else if ("2" == re.get("type")) {
				details[k++] = copyCommodityProperty(re);
			} else if('1' == re.get('isOperatored')) {
				details[k++] = copyCommodityProperty(re);
			}
		});
        //console.log(details);
		return details;
	},
	/**
	 * @param operatorData 需要操作的信息
	 * @param nodeInfo  节点信息Deprecated
	 */
	refreshChgData : function(operatorData, nodeInfo) {
		var me = this;
		var sellId = null;
		var sellInfo = me.sellInfo;
		var skCmp = Ext.getCmp("shoukuan_view");
        getOrderCount();
		if(skCmp && !skCmp.isHidden()) return;
		if(!sellInfo) return;
		if(Ext.isObject(operatorData)) {
			if(operatorData.sellId == sellInfo.id && operatorData.isFinish === true) {
				me.resetData();
				return;
			} else sellId = operatorData.sellId;
		} else sellId = operatorData;
		if(sellInfo && sellInfo.id == sellId) {
			me.loadDataBySellId(sellInfo);
		}
	},
	clearShouyinCart : function(operatorData) {
		/* 清空收银购物车 */
		var me = this;
		if(operatorData && operatorData.sellId) {
			if(me.sellInfo && me.sellInfo.id === operatorData.sellId)  // 相同的销售ID
            	me.resetData();
        }

	}
});

function getShouyinViewData() {
	var viewData = {};
	viewData.commodityNum = Ext.getCmp('shouyinMainView').commodityNum;
	var sellType = '0';
	if (Ext.getCmp('shouyinMainView').shouhanMode == 1) {
		viewData.sellType = "1";
	} else if (Ext.getCmp('shouyinMainView').shouhanMode == 2) {
		viewData.sellType = "2";
	} else viewData.sellType = '0';
	return viewData;
}
function getChangeCartDetailExtra() {
	var store = getPageStore();
	var extra = {};
	extra.store = [];
	var sCount = store.getCount();
	for(var si=0; si<sCount; si++) {
		var cartRecord = store.getAt(si);
		if(cartRecord.get('type') == '1' || cartRecord.get('type') == '2')
			extra.store.push(store.getAt(si).getData());
	}
	extra.shouhanMode = Ext.getCmp('shouyinMainView').shouhanMode;
	var commodityStore = Ext.getCmp('showyin-commodity-list').getStore();
	var cCount = commodityStore.getCount();
	extra.commStore = [];
	for(var ci=0; ci<cCount; ci++) {
		var commRecord = commodityStore.getAt(ci);
		extra.commStore.push(commRecord.getData());
	}

	return extra;
}
function getCartDetailExtra() {
	var store = getPageStore();
	var extra = {};
	extra.store = [];
	var sCount = store.getCount();
	for(var si=0; si<sCount; si++) {
		extra.store.push(store.getAt(si).getData());
	}
	extra.shouhanMode = Ext.getCmp('shouyinMainView').shouhanMode;
	var commodityStore = Ext.getCmp('showyin-commodity-list').getStore();
	var cCount = commodityStore.getCount();
	extra.commStore = [];
	for(var ci=0; ci<cCount; ci++) {
		extra.commStore.push(commodityStore.getAt(ci).getData());
	}

	return extra;
}/* 处理预结单的打印 */
function dealMainPreShouyin() {
	var me = Ext.getCmp('shouyinMainView');
	var pageStore = getPageStore();
	//var tmpSellAmount = calcSellAmount(tmpSellInfo, pageStore);
	var tmpSellDetails = store2Data(pageStore);
	var teaAmount = parseFloat(me.sellInfo.teaAmount);
	var tmpSellInfo = Ext.clone(me.sellInfo);
	tmpSellInfo.totalAmount = me.totalAmount;
	tmpSellInfo.discount = me.discount;
	tmpSellInfo.sellAmount = me.sellAmount;
	tmpSellInfo.teaAmount = teaAmount;
	tmpSellInfo.commodityNum = me.commodityNum;
	// 预结算
	var sourceType = tmpSellInfo.sourceType;
	/* 从数据库取满减值计算 */
	CouponCompute.computeCouponTypeFromDB(sourceType, tmpSellDetails, function(tmpCoupon) {
		dealPreShouyin(tmpSellInfo, tmpSellDetails, me.selectCustomerInfo);
	});
}
function dealPreShouyin(sellInfo, sellDetails, selectCustomerInfo, callback) {
	var notDiscountAmount = calcNotDiscountAmountForDetails(sellDetails);
	sellInfo.notDiscountAmount = notDiscountAmount;
	var tmpSellAmount = calcSellAmountForDetails(sellInfo, sellDetails);
	sellInfo.preSellAmount = tmpSellAmount;
	sellInfo.notDiscountAmount = notDiscountAmount;
	sellInfo.selectCustomerInfo = selectCustomerInfo;
	sellInfo.endTime = new Date().format('yyyy-MM-dd hh:mm:ss');
	sellInfo.discountAmount = parseFloat(calcDiscountAmountForDetails(sellDetails)).toFixed(2);
	var discount = getDiscountValueRange(sellInfo.discount);
	var tmpDiscountAmount = parseFloat(parseFloat(sellInfo.discountAmount) * (parseFloat(discount)/100));
	sellInfo.alreadyDiscountAmount = parseFloat(parseFloat(sellInfo.discountAmount) - parseFloat(tmpDiscountAmount)).toFixed(2);
	console.log('操作单据：订单号为' + sellInfo.id + '的订单进行预结单操作--' + new Date().format('yyyy-MM-dd hh:mm:ss'));
	//console.log(sellInfo);
	SellerDao.loadSellerById(function (success, res) {
		var sellerInfo = null;
        if (success && res) {
            sellerInfo = res[0];
        }
		for (var ti = 0, tlen = sellDetails.length; ti < tlen; ti++) {
			console.log('打印明细：' + sellDetails[ti].sellNum + sellDetails[ti].unit + sellDetails[ti].commodityName);
		}
        PrintDao.printPreShouyin(sellInfo, sellDetails, selectCustomerInfo, sellerInfo, callback);
	});
}
function calcSellAmountForDetails(sellInfo, details, callback) {
	// 计算总额
	var subtractMoney = 0;
	sellInfo.notDiscountAmount = sellInfo.notDiscountAmount ? sellInfo.notDiscountAmount : 0;
	sellInfo.discount = sellInfo.discount ? sellInfo.discount : 100;
	var tmpSellAmount = ((parseFloat(sellInfo.totalAmount) - parseFloat(sellInfo.notDiscountAmount)) * parseFloat(sellInfo.discount)/100)
								+ parseFloat(sellInfo.notDiscountAmount) + parseFloat(sellInfo.teaAmount);
	var sellAmount = tmpSellAmount;
	if(sellInfo.notDiscountAmount+parseFloat(sellInfo.teaAmount) >= tmpSellAmount) {
		console.log('不可打折金额与总额一致,任何折扣都要计算满减!');
	} else if(sellInfo.discount < 100) {
		console.log('打折之后不计算满减');
		return tmpSellAmount;
	}
	var sourceType = '1';
	var tmpCoupon = null;
	if(sellInfo) {
		if(!sellInfo.sourceType || sellInfo.sourceType == '0') { // 收银台
			tmpCoupon = CouponCompute.computeCouponType('1', details);
		} else if(sellInfo.sourceType == '1') // 微信
			tmpCoupon = CouponCompute.computeCouponType('2', details);
		else tmpCoupon = CouponCompute.computeCouponType('0', details);  // 点菜宝
	} else tmpCoupon = CouponCompute.computeCouponType('1', details);
	if(tmpCoupon) {
		sellInfo.isCoupon = '1';
		sellInfo.couponMoney = tmpCoupon.subtractMoney;
		sellInfo.couponId = tmpCoupon.id;
		sellInfo.couponName = tmpCoupon.couponName;
		if(tmpCoupon.subtractMoney >= 0) {
			tmpSellAmount = tmpSellAmount - tmpCoupon.subtractMoney;
		}
	}
	return tmpSellAmount;
}
function calcSellAmount(sellInfo, dataStore, callback) {
	var details = store2Data(dataStore);
	if(!details) return 0;
	return calcSellAmountForDetails(sellInfo, details, callback);
}
function showShoukuanView() {
    /* 显示结算框 */
    var me = Ext.getCmp('shouyinMainView');
    var store = getPageStore();
    if (store.getAllCount() <= 0) {
        return;
    }
    var shoukuanView = Ext.getCmp('shoukuan_view');
    if (!shoukuanView) {
        shoukuanView = Ext.Viewport.add(Ext.create('Seller.view.shoukuan.ShouKuan'));
        showLoading('正在首次初始化收款框...');
    }
    var teaAmount = 0;
    if (me.sellInfo) {
        shoukuanView.setSellId(Ext.getCmp('shouyinMainView').sellInfo.id);
        teaAmount = parseFloat(me.sellInfo.teaAmount);
        /*var personNum = 0;
        var teaPrice = 0;
        if(isValidDigital(me.sellInfo.personNum)) personNum = parseFloat(me.sellInfo.personNum);
        if(isValidDigital(me.sellInfo.teaPrice)) teaPrice = parseFloat(me.sellInfo.teaPrice);
        teaAmount = personNum * teaPrice;*/
    } else {
        shoukuanView.setSellId(null);
    }
    shoukuanView.setNotDiscountAmount(calcNotDiscountAmount());
    // optimized
    var shoukuanData = {
        totalAmount: parseFloat(me.totalAmount).toFixed(2),
        sellAmount: parseFloat(me.sellAmount).toFixed(2),
        //discount: parseFloat(me.discount).toFixed(2),
        discount: parseFloat(me.discount).toFixed(4),
        teaAmount: teaAmount,
		alreadyDiscountAmount: parseFloat(me.alreadyDiscountAmount).toFixed(2),
		roundAmount: me.roundAmount,
        selectCustomerInfo: me.selectCustomerInfo
        //pledgeAmount: me.pledgeAmount,
        //openPlaceRemark: me.openPlaceRemark
    };
    if (isValidDigital(me.costAmount))
        shoukuanData.costAmount = parseFloat(me.costAmount).toFixed(2);
    shoukuanView.loadData(shoukuanData, function (success, isPrePayDef) {
        closeLoading();
        /*if (Ext.getCmp('shoukuan_view').getZIndex() <= Ext.getCmp('shouyinMainView').getZIndex()) {
            Ext.getCmp('shoukuan_view').setZIndex(Ext.getCmp('shouyinMainView').getZIndex()+1);
        }*/
        showBy(shoukuanView, Ext.getCmp('shouyinMainView'),10);
        if (isPrePayDef) {
            selectType(Ext.get('sk-paytype-prepayAmount'), '2');
		}
        if (isConfigSlaveSelfService()) {
            // 副机自助收银支付方式
            $("#sk-payType-cach").hide();
            //禁用抹零折扣
			Ext.getCmp('pay-eraseZero-btn').setDisabled(true);
			Ext.getCmp('pay-discount-btn').setDisabled(true);
			Ext.getCmp('pay-customer-btn').setHidden(true);
        }
    });
}

// 点击交接班弹出Dialog时操作函数
function jiaojieDialogOperator(type){
	if(type == 'yes'){
		Ext.getCmp('shouyinMainView').resetData();
		showCustomerDisplay(0x30, '0.00');
		var handoverView=Ext.getCmp('handover-main-view');
		if (!handoverView) {
			handoverView=Ext.Viewport.add(Ext.create('Seller.view.handover.Main'));
		}
		showBy(handoverView,Ext.getCmp('shouyinMainView'));
		Ext.getCmp('handover-main-view').loadData();
	}
}

//快速结算
function convenientShowkuanWay(){
    var store = getPageStore();
    if (store.getAllCount() <= 0) {
        return;
    }
	var shouyinMainView = Ext.getCmp('shouyinMainView');
	if (!shouyinMainView) return;
	// if(shouyinMainView){
	var totalAmount = parseFloat(shouyinMainView.totalAmount).toFixed(2);
	var sellAmount = parseFloat(shouyinMainView.sellAmount).toFixed(2);
	var alreadyDiscountAmount = (totalAmount - sellAmount).toFixed(2);
	var costAmount = parseFloat(shouyinMainView.costAmount).toFixed(2); // 进货价
	var discount = shouyinMainView.discount;
	// 计算四舍五入金额
	var sellAmountRound = roundByUnit(sellAmount, roundSetting.unit);
	var gainAmount = parseFloat(parseFloat(sellAmountRound) - parseFloat(costAmount)).toFixed(2); // 利润
	if (parseFloat(sellAmount) > parseFloat(sellAmountRound)) {
		var roundAmount = '-' + roundByUnit((sellAmount - sellAmountRound), '2');
	} else {
		var roundAmount = roundByUnit((sellAmountRound - sellAmount), '2');
	}
	// }
	if(isShouKuanSubmiting){
		return;
	}
	isShouKuanSubmiting=true;
	var shoukuanView = Ext.getCmp('shoukuan_view');
	if(shoukuanView){
		shoukuanView.destroy();
	}

	var sellInfo = {
		alipayAmount: 0,
		alipayOnlineAmount: 0,
		alreadyDiscountAmount: alreadyDiscountAmount,
		cashAmount: sellAmountRound,
		cashierId: shouYinEmployee.id,
		cashierName: shouYinEmployee.workName,
		// costAmount: 0,
		costAmount: costAmount ? costAmount : 0, // 进货价
		customerAmount: 0,
		customerId: "",
		//combinationAmount: sellAmount,
		discount: discount,
		discountAmount: sellAmountRound,
		employeeId: shouYinEmployee.id,
		eraseZeroAmount: 0,
		factAmount: sellAmountRound,
		freeAmount: 0,
		// gainAmount: sellAmountRound,
		gainAmount: gainAmount ? gainAmount : sellAmountRound,// 利润
		isComboPay: false,
		notDiscountAmount: 0,
		payType: "1",
		prepayAmount: 0,
		saleId: "",
		saleName: "",
		saleScale: null,
		saleWorkId: "",
		sellAmount: sellAmountRound,
		shopSign: "",
		sourceType: "0",
		surplusAmount: 0,
		syned: "0",
		totalAmount: totalAmount,
		roundAmount: roundAmount,
		unionpayAmount: 0,
		wxpayAmount: 0,
		wxpayOnlineAmount: 0,
		extra: {
			comboPayList: ["1"],
			groupAmount: 0,
			isComboPay: false,
			selectCustomerInfo: null,
			singlePayAmount: sellAmountRound
		}
	};
	function submitconfirm(sellId, isPayed) {
	    var payTaskUtil = null;
		var sellInfoExtra = Ext.clone(sellInfo.extra);
		delete sellInfo.extra;
		if((sellInfo.payType && sellInfo.payType.indexOf("1") != -1) || sellInfoExtra.comboPayList.indexOf('1') != -1) {
			//console.log("openCashBoxByPrint submitconfirm");
			openCashboxByPrint(function(success){

			}, function(fail){
				showAlert('提示', fail);
			});
		}

		var dealSellInfoCallback = function() {
			//SellDao.submitById(Ext.getCmp('shoukuan_view').sellId);
			setTimeout(HandoverDao.countHandover(), 100);
			setTimeout(pushUpdateSellInfo(Ext.getCmp('shoukuan_view').sellId), 100);
			dealPlaceBySellId(Ext.getCmp('shoukuan_view').sellId);
			Ext.getCmp('shoukuan_view').printById(Ext.getCmp('shoukuan_view').sellId);
			Ext.getCmp('shouyinMainView').resetData();
			Ext.getCmp('shoukuan_view').resetData();
			Ext.getCmp('shoukuan_view').finishShouKuan();
			////openCashboxByPrint();
		};
		var submitConfirmPay = function(sellId, isPayed) { // 已下单的在线支付完成操作
	        var groupAmount = 0;
	        var singleAmount = sellAmountRound;
			sellInfo.status = '1';
			sellInfo.isHandover = '0';
			if (sellInfo.payType == '8') {
				if (getPayTypebyLabel('1') == '8') {
					sellInfo.wxpayOnlineAmount = singleAmount;
				} else if (getPayTypebyLabel('2') == '8') {
					sellInfo.wxpayOnlineAmount = groupAmount;
	            }
			} else if (sellInfo.payType == '9') {
	            if (getPayTypebyLabel('1') == '9') {
	                sellInfo.alipayOnlineAmount = singleAmount;
	            } else if (getPayTypebyLabel('2') == '9') {
	                sellInfo.alipayOnlineAmount = groupAmount;
	            }
			}
	        sellInfo.cashierName = shouYinEmployee.workName;
	        sellInfo.cashierId = shouYinEmployee.id;
	        dealShouKuanBySellInfoPay(sellInfo);
			submitConfirmFinishPay = null;
		};
		var submitConfirmPayNotSellInfo = function(sellId, isPayed) { // 未下单的在线支付完成操作
	        var groupAmount = '0';
	        var singleAmount = sellAmountRound;
			sellInfo.status = '1';
	        if (sellInfo.payType == '8') {
	            if (getPayTypebyLabel('1') == '8') {
	                sellInfo.wxpayOnlineAmount = singleAmount;
	            } else if (getPayTypebyLabel('2') == '8') {
	                sellInfo.wxpayOnlineAmount = groupAmount;
	            }
	        } else if (sellInfo.payType == '9') {
	            if (getPayTypebyLabel('1') == '9') {
	                sellInfo.alipayOnlineAmount = singleAmount;
	            } else if (getPayTypebyLabel('2') == '9') {
	                sellInfo.alipayOnlineAmount = groupAmount;
	            }
	        }
			//dealShouKuanEnd(sellId);//打印单据
			//打印单据方法
			console.log('收银员' + shouYinEmployee.workName + '在收银台(' + seller.deviceId + ')' + '进行速结---' + new Date().format('yyyy-MM-dd hh:mm:ss'));
			console.log('打印明细：订单' + sellId + '，明细数量：' + sellInfo.commodityNum + '，实收款：' + sellInfo.sellAmount);
			PrintDao.printShouyinById(sellId, null, function(message){
				if (message){
					showAlert('提示', message);
				}
			});
			//console.log('速结打印');
			Ext.getCmp('shouyinMainView').resetData();
			dealShouKuanScreen();
			submitConfirmFinishPay = null;
			submitConfirmPayNotSellInfo = null;
		};
		var submitShouKuanHasSellInfo = function() {
	        var groupAmount = 0;
	        var singleAmount = sellAmountRound;
			sellInfo.status = '1';
			if (sellInfo.payType == '8') {
				if (getPayTypebyLabel('1') == '8') {
	                sellInfo.wxpayOnlineAmount = singleAmount;
	            } else if (getPayTypebyLabel('2') == '8') {
	                sellInfo.wxpayOnlineAmount = groupAmount;
	            }
			} else if (sellInfo.payType == '9') {
				if (getPayTypebyLabel('1') == '9') {
	                sellInfo.alipayOnlineAmount = singleAmount;
	            } else if (getPayTypebyLabel('2') == '9') {
	                sellInfo.alipayOnlineAmount = groupAmount;
	            }
			}
			setCashierInfo(sellInfo);
			SellDao.updateSellInfo(sellInfo, Ext.getCmp('shoukuan_view').sellId, function(success) {
				dealShouKuanCallback(sellInfo);
			});
			closeLoading();
			submitConfirmFinishPay = null;
			submitShouKuanHasSellInfo = null;
		};

		sellInfo.endTime = new Date().format("yyyy-MM-dd hh:mm:ss");
		/*if((sellInfoExtra.comboPayList.indexOf('8') != -1 && parseFloat(sellInfo.wxpayOnlineAmount) == 0) || (sellInfoExtra.comboPayList.indexOf('9') != -1 && parseFloat(sellInfo.alipayOnlineAmount) == 0)) {
			closeLoading();
			showAlert('提示', '在线支付不支持零元结算!');
			isShouKuanSubmiting=false;
			return;
		}*/
		//创建订单
		sellInfo.id = sellInfo.id ? sellInfo.id : sellId;
		var status = "1";
        sellInfo.orderClerkName= shouYinEmployee.workName;
        sellInfo.orderClerkId= shouYinEmployee.id;
		/*if (!isPayed && isInArray(sellInfoExtra.comboPayList, ['8','9'], 'one')) {
			status = "0";
			// 还未支付完成时不赋值
            sellInfo = clearOnlinePayAmount(sellInfo, sellInfoExtra);
		}*/
		Ext.getCmp('shouyinMainView').createSellInfo(status, sellInfo, function(success, msg, codeUrl, sellId) {
			if (success) {
                sellInfo = getOnlinePayAmount(sellInfo, sellInfoExtra);
				if(!skDealPay(isPayed, sellId, sellInfo, sellInfoExtra)) {
					submitConfirmFinishPay = submitConfirmPay;
					isShouKuanSubmiting=false;
					return;
				}
				else{
					sellInfo = clearOnlinePayAmount(sellInfo, sellInfoExtra);
				}
				submitConfirmPayNotSellInfo(sellId);
				console.log('操作单据：订单' + sellId + '进行速结--' + new Date().format('yyyy-MM-dd hh:mm:ss'))
			} else {
				showAlert('提示', msg ? msg : '收款失败！');
			}
			isShouKuanSubmiting=false;
			closeLoading();
		});
	}
	submitconfirm(null);
}

function isShowMainHeader() {
    if (sysParams.get('SYS_isShowMainHeader') && sysParams.get('SYS_isShowMainHeader').paramValue === 'T'){
        return true;
    }
    return false;
}

// 显示叫号弹框--2018.12.27
function showCallNumberView(){
	if (!(dinCardSetting.isDinnerCard == 'true' || dinCardSetting.isDinnerCard == true)) {
		showAlert('提示','请先开启牌号功能');
		return;
	}
	var callNumberView = Ext.getCmp('shouyin-call-number-view');
	if (callNumberView)
		callNumberView.show();
	else
		callNumberView = Ext.Viewport.add(Ext.create('Seller.view.shouyin.CallNumber'));
	callNumberView.loadData();
}